10  ' CALENDAR
20  ' Program by Marty Smith, 310 Cinnamon Oak Lane, Houston, TX 77079
30  ' (713) 464-6737 (home)  (713) 661-1241 (office)
40  ' SOURCE ST2259  COMPUSERVE 72155,1214
50  KEY OFF : CLS
60  PRINT "CALENDAR"
70  PRINT :PRINT "Can print monthly calendars from January, 1583 to December, 4046."
75  PRINT "The Gregorian calendar we use comes from Pope Gregory XIII."
76  PRINT "He made the day after October 4, 1582 into October 15, 1582."
77  PRINT "Years divisible by 100 are NOT leap years, unless they are divisible by 400."
80  PRINT :PRINT "Output to Screen, Printer or Disk."
90  PRINT "Most options will default to the last entered." : PRINT
100  DEFINT A-Z
110  TRUE=-1 : FALSE=0 : I=0 : J=0 : X=0 : Y=0 : Z=0 : IR=0 : RANGE=1
120  SYEAR=365 : LYEAR=366 : SORRY=FALSE : DAYS=0 : V$="|" : YEARONE=1980
125  STARTONE=2 : LEAP=TRUE : YEAR=0 : START=0 : WID=2 : HERE=0 : NOW=0 : MARG=8
130  FS$="calendar.dat" : TS$="" : I$="" : J$="" : K$="" : PGB=3 : BIG=FALSE
140  F1$="|------+------+------+------+------+------+------|"
142  F2$="|----------+----------+----------+----------+----------+----------+----------|"
144  F0$="|----+----+----+----+----+----+----|"
145  S1$="+------+------+------+------+------+------+------+"
146  S2$="+----------+----------+----------+----------+----------+----------+----------+"
147  S0$="+----+----+----+----+----+----+----+"
150  L1$="|      |      |      |      |      |      |      |"
152  L2$="|          |          |          |          |          |          |          |"
154  L0$="|    |    |    |    |    |    |    |"
160  D1$="| SUN  | MON  | TUES | WEDS | THUR | FRI  | SAT  |"
162  D2$="|  SUNDAY  |  MONDAY  |  TUESDAY | WEDNESDAY| THURSDAY |  FRIDAY  | SATURDAY |"
164  D0$="|SUN |MON |TUES|WEDS|THUR|FRI |SAT |"
170  N1$="      !" : Y1$="  ##  !"
172  N2$="          !" : Y2$="    ##    !"
174  N0$="    !" : Y0$=" ## !"
180  DIM MONTH(15),MONTH$(15),DAY$(7)
190  DATA 31,28,31,30,31,30,31,31,30,31,30,31
200  DATA JANUARY,FEBRUARY,MARCH,APRIL,MAY,JUNE,JULY,AUGUST,SEPTEMBER,OCTOBER,NOVEMBER,DECEMBER
220  FOR I=1 TO 12 : READ MONTH(I) : NEXT
230  FOR I=1 TO 12 : READ MONTH$(I) : NEXT
250  GOTO 1000
300  ' find days from jan 1 1980
305  YEARONE=1980 : STARTONE=2
310  IF YEAR < YEARONE THEN YEARONE=1583 : STARTONE=6 : IF YEAR < YEARONE THEN SORRY=TRUE : RETURN
312  IF (YEAR-YEARONE) > 2066 THEN SORRY=TRUE : PRINT "Algorithm starts to fall apart past 4046." : RETURN
320  IF YEAR = YEARONE THEN 400
330  FOR I=YEARONE TO YEAR-1
340     IF (I MOD 4) <> 0 THEN DAYS=DAYS+SYEAR : GOTO 390
350     IF (I MOD 400) = 0 THEN DAYS=DAYS+LYEAR : GOTO 390
360     IF (I MOD 100) = 0 THEN DAYS=DAYS+SYEAR : GOTO 390
370     DAYS=DAYS+LYEAR
390  DAYS=DAYS MOD 7 : NEXT
400  ' find days in current year
410  IF (YEAR MOD 4) <> 0 THEN LEAP=FALSE : GOTO 450
420  IF (YEAR MOD 400) = 0 THEN LEAP=TRUE : GOTO 450
430  IF (YEAR MOD 100) = 0 THEN LEAP=FALSE : GOTO 450
440  LEAP=TRUE
450  IF LEAP=TRUE THEN MONTH(2)=29 ELSE MONTH(2)=28
460  IF THEMONTH=1 THEN 500
470  FOR I=1 TO THEMONTH -1
480    DAYS=DAYS+MONTH(I)
490  NEXT
500  THEDAYS=MONTH(THEMONTH)
510  START=(DAYS + STARTONE) MOD 7
520  RETURN
600  ' make all caps
610  FOR I=1 TO LEN(CAP$) : IF MID$(CAP$,I,1)>="a" AND MID$(CAP$,I,1)<="z" THEN MID$(CAP$,I,1)=CHR$(ASC(MID$(CAP$,I,1))-32)
620  NEXT : RETURN
700  ' find month from string
710  CAP$=M$ : GOSUB 600 : M$=CAP$
720  X=FALSE
730  FOR I=1 TO 12
740     IF INSTR(MONTH$(I),M$) THEN THEMONTH=I : I=12 : X=TRUE
750  NEXT
760  IF X=FALSE THEN THEMONTH=FALSE
770  RETURN
800  ' make all lower
810  FOR I=1 TO LEN(CAP$) : IF MID$(CAP$,I,1)>="A" AND MID$(CAP$,I,1)<="Z" THEN MID$(CAP$,I,1)=CHR$(ASC(MID$(CAP$,I,1))+32)
820  NEXT : RETURN
1000  ' Make a calendar for a month
1010  PRINT : INPUT "Please enter the Month, or End.";M$
1015  IF LEFT$(M$,1)="E" OR LEFT$(M$,1)="e" THEN CLS : KEY ON : END
1020  INPUT "Please enter the Year";YEAR : IF YEAR=0 THEN KEY ON : END
1025  PRINT "Please enter width (1=36, 2=50, 3=78 characters) ";
1026  LOCATE ,,1:I$=INKEY$:IF I$="" THEN 1026 ELSE PRINT I$ :Y=VAL(I$)
1028  IF (Y>0 AND Y<4) THEN WID=Y
1030  THEMONTH=VAL(M$) : IF THEMONTH<0 THEN PRINT "Huh?" : GOTO 1000
1040  IF THEMONTH=0 THEN GOSUB 700
1050  IF THEMONTH=FALSE OR THEMONTH > 12 THEN PRINT "Can't figure what month, try again." : GOTO 1000
1060  DAYS=0 : SORRY=FALSE : GOSUB 300 : IF SORRY=TRUE THEN PRINT "Program limits are Jan, 1583 to December 4046." : GOTO 1000
1070  PRINT "<P>rinter, <D>isk, or <S>creen output? ";
1080  LOCATE ,,1: I$=INKEY$ : IF I$="" THEN 1080 ELSE PRINT I$
1090  CAP$=I$ : GOSUB 600 : I$=CAP$
1100  INPUT "Number of months to print";RANGE : IF RANGE < 1 THEN RANGE=1
1110  PRINT "BIG or little? BIG uses 4 lines per date, little uses 2. (B/L) ";
1120  LOCATE ,,1: J$=INKEY$ : IF J$="" THEN 1120 ELSE PRINT J$
1130  CAP$=J$ : GOSUB 600 : J$=CAP$
1140  IF J$="B" THEN BIG=TRUE ELSE BIG=FALSE
1150  IF I$="P" THEN INPUT "Printer margin";K$ : IF K$<>"" THEN MARG=VAL(K$)
1160  IF I$="P" THEN INPUT "Page break (defaults to 2 for BIG, 3 for little)";K$
1165  IF VAL(K$)<>0 THEN PGB=VAL(K$) ELSE IF BIG THEN PGB=2 ELSE PGB=3
1170  IF I$="D" THEN LINE INPUT "Filename for output. Data is appended to an existing file >";TS$ : IF TS$<>"" THEN FS$=TS$
1180  PRINT "Hit ESCape to stop."
2000  ' print a calendar
2010  IF WID=1 THEN D$=D0$:F$=F0$:N$=N0$:Y$=Y0$:L$=L0$:S$=S0$:Z=19
2020  IF WID=2 THEN D$=D1$:F$=F1$:N$=N1$:Y$=Y1$:L$=L1$:S$=S1$:Z=26
2030  IF WID=3 THEN D$=D2$:F$=F2$:N$=N2$:Y$=Y2$:L$=L2$:S$=S2$:Z=40
2040  IF I$="D" THEN OPEN FS$ FOR APPEND AS #1
2050  FOR IR=1 TO RANGE
2060    IF I$="P" THEN GOSUB 3000 ELSE IF I$="D" THEN GOSUB 4000 ELSE GOSUB 2110
2065    IF IR=RANGE THEN 2090
2070    THEMONTH=THEMONTH+1 : IF THEMONTH=13 THEN THEMONTH=1 : YEAR=YEAR+1
2080    DAYS=0 : GOSUB 300 : IF SORRY=TRUE THEN IR=RANGE
2085    IF I$="P" THEN IF (IR MOD PGB=0) THEN LPRINT CHR$(12);
2090  NEXT : IF I$="D" THEN CLOSE #1
2095  GOTO 1000
2100  ' screen output
2105  PRINT :PRINT
2110  X=(LEN(MONTH$(THEMONTH))+5)/2 : PRINT TAB(Z-X) MONTH$(THEMONTH);YEAR : PRINT
2120  PRINT D$ : PRINT F$ : IF BIG THEN PRINT L$
2130  NOW=1 : HERE=0
2140  PRINT V$;
2150  FOR I=0 TO 6
2160    IF I<START THEN PRINT USING N$; V$; ELSE PRINT USING Y$;NOW,V$; : NOW=NOW+1
2170  NEXT : PRINT : IF BIG THEN PRINT L$ : PRINT F$ ELSE PRINT F$
2180  HERE=THEDAYS-NOW : HERE=HERE\7
2190  FOR I=1 TO HERE : IF BIG THEN PRINT L$
2195  ESC$=INKEY$ : IF ESC$=CHR$(27) THEN IR=RANGE : GOTO 2310
2200  PRINT V$;
2210     FOR J=1 TO 7
2220     PRINT USING Y$;NOW,V$; : NOW=NOW+1
2230     NEXT : PRINT : IF BIG THEN PRINT L$ : PRINT F$ ELSE PRINT F$
2240  NEXT
2250  IF THEDAYS-NOW = -1 THEN 2310
2255  IF BIG THEN PRINT L$
2260  PRINT V$;
2270  FOR I=0 TO 6
2280     IF NOW>THEDAYS THEN PRINT USING N$;V$; ELSE PRINT USING Y$;NOW,V$; : NOW=NOW+1
2290  NEXT
2300  PRINT : IF BIG THEN PRINT L$ : PRINT S$ ELSE PRINT S$
2310  RETURN
3000  ' to printer
3010  WIDTH "lpt1:", 80+MARG
3020  PRINT "Printing ";MONTH$(THEMONTH);YEAR
3100  LPRINT :LPRINT
3110  X=(LEN(MONTH$(THEMONTH))+5)/2 : LPRINT TAB(Z-X+MARG) MONTH$(THEMONTH);YEAR : LPRINT
3120  LPRINT TAB(MARG)D$ : LPRINT TAB(MARG)F$ : IF BIG THEN LPRINT TAB(MARG)L$
3130  NOW=1 : HERE=0
3140  LPRINT TAB(MARG)V$;
3150  FOR I=0 TO 6
3160    IF I<START THEN LPRINT USING N$; V$; ELSE LPRINT USING Y$;NOW,V$; : NOW=NOW+1
3170  NEXT : LPRINT : IF BIG THEN LPRINT TAB(MARG)L$:LPRINT TAB(MARG)F$ ELSE LPRINT TAB(MARG)F$
3180  HERE=THEDAYS-NOW : HERE=HERE\7
3190  FOR I=1 TO HERE : IF BIG THEN LPRINT TAB(MARG)L$
3195  ESC$=INKEY$ : IF ESC$=CHR$(27) THEN IR=RANGE : GOTO 3310
3200  LPRINT TAB(MARG)V$;
3210     FOR J=1 TO 7
3220     LPRINT USING Y$;NOW,V$; : NOW=NOW+1
3230     NEXT : LPRINT : IF BIG THEN LPRINT TAB(MARG)L$:LPRINT TAB(MARG)F$ ELSE LPRINT TAB(MARG)F$
3240  NEXT
3250  IF THEDAYS-NOW = -1 THEN 3310
3255  IF BIG THEN LPRINT TAB(MARG)L$
3260  LPRINT TAB(MARG)V$;
3270  FOR I=0 TO 6
3280     IF NOW>THEDAYS THEN LPRINT USING N$;V$; ELSE LPRINT USING Y$;NOW,V$; : NOW=NOW+1
3290  NEXT
3300  LPRINT : IF BIG THEN LPRINT TAB(MARG)L$:LPRINT TAB(MARG)S$ ELSE LPRINT TAB(MARG)S$
3310  RETURN
4000  ' disk output
4010  ' OPEN FS$ FOR APPEND AS #1
4020  PRINT "Writing ";MONTH$(THEMONTH);YEAR
4100  PRINT #1,"" : PRINT #1,""
4110  X=(LEN(MONTH$(THEMONTH))+5)/2 : PRINT #1,SPACE$(Z-X);MONTH$(THEMONTH);YEAR : PRINT #1,""
4120  PRINT #1,D$ : PRINT #1,F$ : IF BIG THEN PRINT #1,L$
4130  NOW=1 : HERE=0
4140  PRINT #1,V$;
4150  FOR I=0 TO 6
4160    IF I<START THEN PRINT #1,USING N$; V$; ELSE PRINT #1,USING Y$;NOW,V$; : NOW=NOW+1
4170  NEXT : PRINT #1,"": IF BIG THEN PRINT #1,L$ :PRINT #1,F$ ELSE PRINT #1,F$
4180  HERE=THEDAYS-NOW : HERE=HERE\7
4190  FOR I=1 TO HERE : IF BIG THEN PRINT #1,L$
4195  ESC$=INKEY$ : IF ESC$=CHR$(27) THEN IR=RANGE : GOTO 4310
4200  PRINT #1,V$;
4210     FOR J=1 TO 7
4220     PRINT #1,USING Y$;NOW,V$; : NOW=NOW+1
4230     NEXT : PRINT #1,"": IF BIG THEN PRINT #1,L$:PRINT #1,F$ ELSE PRINT #1,F$
4240  NEXT
4250  IF THEDAYS-NOW = -1 THEN 4310
4255  IF BIG THEN PRINT #1,L$
4260  PRINT #1,V$;
4270  FOR I=0 TO 6
4280     IF NOW>THEDAYS THEN PRINT #1,USING N$;V$; ELSE PRINT #1,USING Y$;NOW,V$; : NOW=NOW+1
4290  NEXT
4300  PRINT #1,"": IF BIG THEN PRINT #1,L$:PRINT #1,S$ ELSE PRINT #1,S$
4310  ' CLOSE #1
4320  RETURN
