100  REM ALPHAPER Program.
110  REM Prints an Alphabetic List of Persons
120  REM Copyright (c) 1983 - 1987 by: Melvin O. Duke.
130  DEFINT A-Z
600  REM Titles
610  TITLE$ = "Alphabetic Person Name Listing"
620  TITLE$ = TITLE$ + " ON DISPLAY"
700  REM Terminate if not called from the Menu
710  IF DD.MENU$ <> "" THEN 770
720  COLOR 7,0 : KEY ON : CLS : LOCATE 15,1
730  PRINT "Cannot run the"
740  PRINT TITLE$
750  PRINT "Program, unless selected from the MENU"
760  END
770  REM OK
900  REM Dimension Statements
910  DIM IDX$(MAX.PER), WHERE(MAX.PER)
1000  REM Produce the first screen
1010  KEY ON : CLS : KEY OFF
1020  REM Draw the outer double box
1030  R1 = 1 : C1 = 1 : R2 = 24 : C2 = 79 : GOSUB 1300
1040  REM Find the title location
1050  TITLE.POS = 40 - INT(LEN(TITLE$)/2)
1060  REM Draw the title box
1070  R1=3:C1=TITLE.POS-2:R2=6:C2=TITLE.POS+LEN(TITLE$)+1:GOSUB 1500
1080  REM Print the title
1090  LOCATE 4,TITLE.POS : PRINT TITLE$
1100  LOCATE 5,40-INT(LEN(VERSION$)/2) :  PRINT VERSION$;
1230  REM Draw the Copyright box
1240  R1 = 19 : C1 = 21 : R2 = 22 : C2 = 59 : GOSUB 1300
1250  REM Print the Copyright
1260  LOCATE 20,40-INT(LEN(COPY1$)/2) :  PRINT COPY1$;
1270  LOCATE 21,40-INT(LEN(COPY2$)/2) :  PRINT COPY2$;
1280  GOTO 1700
1300  REM subroutine to print a double box
1310  COLOR P
1320  FOR I = R1 + 1 TO R2 - 1
1330   LOCATE I, C1 : PRINT CHR$(186);
1340   LOCATE I, C2 : PRINT CHR$(186);
1350  NEXT I
1360   LOCATE R1, C1+1 : PRINT STRING$(C2-C1-1,205);
1390   LOCATE R2, C1+1 : PRINT STRING$(C2-C1-1,205);
1400   LOCATE R1, C1 : PRINT CHR$(201);
1410   LOCATE R1, C2 : PRINT CHR$(187);
1420   LOCATE R2, C1 : PRINT CHR$(200);
1430   LOCATE R2, C2 : PRINT CHR$(188);
1440  COLOR W
1450  RETURN
1500  REM subroutine to print a single box
1510  COLOR B
1520  FOR I = R1 + 1 TO R2 - 1
1530   LOCATE I, C1 : PRINT CHR$(179);
1540   LOCATE I, C2 : PRINT CHR$(179);
1550  NEXT I
1560   LOCATE R1, C1+1 : PRINT STRING$(C2-C1-1,196);
1590   LOCATE R2, C1+1 : PRINT STRING$(C2-C1-1,196);
1600   LOCATE R1, C1 : PRINT CHR$(218);
1610   LOCATE R1, C2 : PRINT CHR$(191);
1620   LOCATE R2, C1 : PRINT CHR$(192);
1630   LOCATE R2, C2 : PRINT CHR$(217);
1640  COLOR W
1650  RETURN
1700  REM ask user to press a key to continue
1710  LOCATE 25,1
1720  PRINT "Have Data Diskette(s) in Place, then Press any key to continue.";
1730  K$ = INKEY$ : IF K$ = "" THEN 1730
1740  KEY ON : CLS : KEY OFF
2000  REM ALPHAPER Program Starts Here.
2010  OPEN DD.PERS$+"persfile" AS #1 LEN = 256
2020  FIELD 1, 5 AS F1$, 20 AS F2$, 30 AS F3$, 2 AS F4$, 5 AS F5$, 5 AS F6$, 5 AS F7$, 11 AS F8$, 18 AS F9$, 16 AS F10$, 16 AS F11$, 11 AS F12$, 18 AS F13$, 16 AS F14$, 16 AS F15$, 11 AS F16$, 18 AS F17$, 16 AS F18$, 16 AS F19$
2030  KEY ON : CLS : KEY OFF
2040  REM Read all records, and print the actual ones
2050  N.ACT = 1
2060  FOR I = 1 TO MAX.PER
2070  GET #1, I
2080  LOCATE 23,1 : PRINT "Processing Record:";I,"Freespace:";FRE(0)
2090  REM Extract Information from the File
2100   TEMP! = CVS(F1$) : WHERE(N.ACT) = TEMP!
2110   IF WHERE(N.ACT) < 1 THEN 2470
2120   T2$ = F2$  'Surname
2130   REM Convert to Upper Case
2140   ONE$ = LEFT$(T2$,1)
2150   ONE = ASC(ONE$)
2160   IF ONE >= 97 AND ONE <= 122 THEN ONE = ONE - 32
2170   ONE$ = CHR$(ONE)
2180   REM Test if out of range
2190   IF ONE$ < BEGIN.LTR$ OR ONE$ > END.LTR$ THEN 2470
2200   REM Right-trim t2$
2210   FOR J = 1 TO LEN(F2$)-1
2220    IF RIGHT$(T2$,1)=" "THEN T2$=LEFT$(T2$,LEN(T2$)-1) ELSE J=LEN(F2$)-1
2230   NEXT J
2240   T3$ = F3$  'Given Names
2250   REM Right-trim t3$
2260   FOR J = 1 TO LEN(F3$)-1
2270    IF RIGHT$(T3$,1)=" "THEN T3$=LEFT$(T3$,LEN(T3$)-1) ELSE J=LEN(F3$)-1
2280   NEXT J
2290   T8$ = F8$  'Birthdate
2300   REM convert to yyyymmdd
2310   TEMP$ = RIGHT$(T8$,4)
2320   IF MID$(T8$,4,3)="Jan" THEN TEMP$=TEMP$+"01"
2330   IF MID$(T8$,4,3)="Feb" THEN TEMP$=TEMP$+"02"
2340   IF MID$(T8$,4,3)="Mar" THEN TEMP$=TEMP$+"03"
2350   IF MID$(T8$,4,3)="Apr" THEN TEMP$=TEMP$+"04"
2360   IF MID$(T8$,4,3)="May" THEN TEMP$=TEMP$+"05"
2370   IF MID$(T8$,4,3)="Jun" THEN TEMP$=TEMP$+"06"
2380   IF MID$(T8$,4,3)="Jul" THEN TEMP$=TEMP$+"07"
2390   IF MID$(T8$,4,3)="Aug" THEN TEMP$=TEMP$+"08"
2400   IF MID$(T8$,4,3)="Sep" THEN TEMP$=TEMP$+"09"
2410   IF MID$(T8$,4,3)="Oct" THEN TEMP$=TEMP$+"10"
2420   IF MID$(T8$,4,3)="Nov" THEN TEMP$=TEMP$+"11"
2430   IF MID$(T8$,4,3)="Dec" THEN TEMP$=TEMP$+"12"
2440   TEMP$=TEMP$+LEFT$(T8$,2)  'add day
2450   IDX$(N.ACT) = T2$+" "+T3$+TEMP$
2460   N.ACT = N.ACT + 1
2470  NEXT I
2480  N.ACT = N.ACT - 1
2490  LOCATE 23,1 : PRINT SPACE$(79)
2500  REM Sort the index into ascending sequence
2510  KEY ON : CLS : KEY OFF
2520  FOR I = 1 TO 6
2530   B(I) = B(I-1)*4+1
2540   IF B(I) <= N.ACT/2 THEN K1 = I
2550  NEXT I
2560  B(K1) = INT(N.ACT/5) +1
2570  B(1) = 1
2580  LOCATE 21,1 : PRINT "Total Records:";N.ACT;
2590  FOR I = K1 TO 1 STEP -1
2600   LOCATE 23,1 : PRINT "Sorting Group:";I
2610   K1 = B(I)
2620   FOR J = K1 TO N.ACT
2630    LOCATE 23,20 : PRINT "J:";J;
2640    K2$ = IDX$(J) : K3 = WHERE(J)
2650    FOR K = J-K1 TO 0 STEP -K1
2660     LOCATE 23,30 : PRINT "Freespace:";FRE(0)
2670     IF K2$ >= IDX$(K) THEN 2700
2680     IDX$(K+K1) = IDX$(K) : WHERE(K+K1) = WHERE(K)
2690    NEXT K
2700    IDX$(K+K1) = K2$ : WHERE(K+K1) = K3
2710   NEXT J
2720  NEXT I
2730  LOCATE 24,1 : PRINT SPACE$(79);
2740  LOCATE 23,1 : PRINT SPACE$(79);
2750  LOCATE 23,1 : PRINT "Printing the Alphabetical List"
2760  GOSUB 2780
2770  GOTO 2830
2780  LPRINT "     Alphabetic Listing of the Persons File   ";DATE$;"  ";TIME$
2790  LPRINT
2800  LPRINT "  REC    SURNAME              GIVEN-NAMES";TAB(62);"BIRTHDATE"
2810  LPRINT "  ---    -------              -----------";TAB(62);"---------"
2820  RETURN
2830  REM Read all records, and print the actual ones
2840  K = 0
2850  KEY ON : CLS : KEY OFF
2860  LOCATE 21,1 : PRINT "There are";N.ACT;"records."
2870  FOR I = 1 TO N.ACT
2880   GET #1, ABS(WHERE(I))
2890   LOCATE 23,1 : PRINT "Printing Record:"; I, "Freespace:";FRE(0)
2900   REM Print the information in Alphabetical Order.
2910   T1 = CVS(F1$)
2920   IF T1 < 1 THEN 3000
2930   K = K + 1
2940   T2$ = F2$
2950   T3$ = F3$
2960   T8$ = F8$
2970   IF K MOD 55 = 0 THEN LPRINT FORM.FEED$;: GOSUB 2780
2980   LPRINT USING "#####";T1,
2990   LPRINT TAB(10); T2$; " "; T3$; TAB(62); T8$
3000  NEXT I
3010  LPRINT FORM.FEED$;
3020  KEY ON : CLS : KEY OFF
3030  LOCATE 24,1 : PRINT "y (yes) or n (no)";
3040  LOCATE 23,1 : INPUT "Would you like another copy"; REPLY$
3050  IF LEFT$(REPLY$,1) = "y" OR LEFT$(REPLY$,1) = "Y" THEN 2730
3060  CLOSE #1
3070  KEY ON : CLS : KEY OFF : LOCATE 21,1
3080  PRINT "End of Program"
3090  RUN DD.MENU$+"menu"
