100  REM FAMILY Program.
110  REM Prints Family Group Sheets
120  REM Copyright (c) 1983 - 1987 by: Melvin O. Duke.
130  DEFINT A-Z
600  REM Titles
610  TITLE$ = "Family Group Sheet"
620  TITLE$ = TITLE$ + " ON DISPLAY"
700  REM Terminate if not called from the Menu
710  IF DD.MENU$ <> "" THEN 770
720  COLOR 7,0 : KEY ON : CLS : LOCATE 15,1
730  PRINT "Cannot run the"
740  PRINT TITLE$
750  PRINT "Program, unless selected from the MENU"
760  END
770  REM OK
900  REM Dimension Statements
940  DIM PERS(2), FORM$(49)
1000  REM Produce the first screen
1010  KEY ON : CLS : KEY OFF
1020  REM Draw the outer double box
1030  R1 = 1 : C1 = 1 : R2 = 24 : C2 = 79 : GOSUB 1300
1040  REM Find the title location
1050  TITLE.POS = 40 - INT(LEN(TITLE$)/2)
1060  REM Draw the title box
1070  R1=3:C1=TITLE.POS-2:R2=6:C2=TITLE.POS+LEN(TITLE$)+1:GOSUB 1500
1080  REM Print the title
1090  LOCATE 4,TITLE.POS : PRINT TITLE$
1100  LOCATE 5,40-INT(LEN(VERSION$)/2) :  PRINT VERSION$;
1230  REM Draw the Copyright box
1240  R1 = 19 : C1 = 21 : R2 = 22 : C2 = 59 : GOSUB 1300
1250  REM Print the Copyright
1260  LOCATE 20,40-INT(LEN(COPY1$)/2) :  PRINT COPY1$;
1270  LOCATE 21,40-INT(LEN(COPY2$)/2) :  PRINT COPY2$;
1280  GOTO 1700
1300  REM subroutine to print a double box
1310  COLOR 5
1320  FOR I = R1 + 1 TO R2 - 1
1330   LOCATE I, C1 : PRINT CHR$(186);
1340   LOCATE I, C2 : PRINT CHR$(186);
1350  NEXT I
1360   LOCATE R1, C1+1 : PRINT STRING$(C2-C1-1,205);
1390   LOCATE R2, C1+1 : PRINT STRING$(C2-C1-1,205);
1400   LOCATE R1, C1 : PRINT CHR$(201);
1410   LOCATE R1, C2 : PRINT CHR$(187);
1420   LOCATE R2, C1 : PRINT CHR$(200);
1430   LOCATE R2, C2 : PRINT CHR$(188);
1440  COLOR 7
1450  RETURN
1500  REM subroutine to print a single box
1510  COLOR 3
1520  FOR I = R1 + 1 TO R2 - 1
1530   LOCATE I, C1 : PRINT CHR$(179);
1540   LOCATE I, C2 : PRINT CHR$(179);
1550  NEXT I
1560   LOCATE R1, C1+1 : PRINT STRING$(C2-C1-1,196);
1590   LOCATE R2, C1+1 : PRINT STRING$(C2-C1-1,196);
1600   LOCATE R1, C1 : PRINT CHR$(218);
1610   LOCATE R1, C2 : PRINT CHR$(191);
1620   LOCATE R2, C1 : PRINT CHR$(192);
1630   LOCATE R2, C2 : PRINT CHR$(217);
1640  COLOR 7
1650  RETURN
1700  REM ask user to press a key to continue
1710  LOCATE 25,1
1720  PRINT "Have Data Diskette(s) in Place, then Press any key to continue.";
1730  K$ = INKEY$ : IF K$ = "" THEN 1730
1740  KEY ON : CLS : KEY OFF
2000  REM FAMILY Program Starts Here.
2010  REM Routine to obtain Printer Information
2020  LOCATE 21,1 : PRINT "Make sure that the Printer is On and Ready"
2030  LOCATE 22,1 : PRINT "Make sure that the correct Diskette(s) are in place."
2040  LOCATE 23,1 : PRINT "Then press any key"
2050  A$ = INKEY$ : IF A$ = "" THEN 2050
2060  KEY ON : CLS : KEY OFF
2070  REM Set for Wide Printing.
2080  WIDTH "lpt1:",132  'For printing Genealogy Forms
2090  IF WIDE   = 0 THEN WIDE   = 1
2100  IF LENGTH = 0 THEN LENGTH = 2
2110  IF FORMS  = 0 THEN FORMS  = 1
2120  REM Read the Parent/Child Index
2130  OPEN DD.PCIDX$+"pcindex" FOR INPUT AS #1
2140  LOCATE 4,1 : PRINT "Open the Parent/Child Index";
2150  INPUT #1, PC.COUNT
2160  DIM PA.ID(PC.COUNT), CH.ID(PC.COUNT)
2170  FOR I = 1 TO PC.COUNT
2180  LOCATE 5,1 : PRINT "Reading Index Record #:";I;
2190   INPUT #1, PA.ID(I), CH.ID(I)
2200  NEXT I
2210  CLOSE #1
2220  REM Read the Marriage Index
2230  LOCATE 7,1 : PRINT "Open the Marriage Index";
2240  OPEN DD.MARIDX$+"mindex" FOR INPUT AS #2
2250  INPUT #2, M.COUNT
2260  DIM PERS.NO(M.COUNT), M.NO(M.COUNT)
2270  FOR I = 1 TO M.COUNT
2280  LOCATE 8,1 : PRINT "Reading Marriage Index Record #:";I:
2290   INPUT #2,PERS.NO(I), M.NO(I)
2300  NEXT I
2310  CLOSE #2
2320  REM Open the Persons File
2330  LOCATE 10,1 : PRINT "Open the Persons File"
2340  OPEN DD.PERS$+"persfile" AS #1 LEN = 256
2350  FIELD 1, 5 AS F1$, 20 AS F2$, 30 AS F3$, 2 AS F4$, 5 AS F5$, 5 AS F6$, 5 AS F7$, 11 AS F8$, 18 AS F9$, 16 AS F10$, 16 AS F11$, 11 AS F12$, 18 AS F13$, 16 AS F14$, 16 AS F15$, 11 AS F16$, 18 AS F17$, 16 AS F18$, 16 AS F19$
2360  REM open the Marriages File
2370  LOCATE 12,1 : PRINT "Open the Marriage File"
2380  OPEN DD.MARR$+"marrfile" AS #2 LEN = 128
2390  FIELD 2, 5 AS M1$, 5 AS M2$, 5 AS M3$, 5 AS M4$, 11 AS M5$, 18 AS M6$, 16 AS M7$, 16 AS M8$, 45 AS M9$
2400  REM Open the Ordinance File
2410  IF DD.ORD$ = "no" THEN 2450
2420  LOCATE 14,1 : PRINT "Open the Ordinances File";
2430  OPEN DD.ORD$+"ordfile" AS #3 LEN = 256
2440  FIELD 3,5ASO1$,11ASO2$,11ASO3$,11ASO4$,5ASO5$,5ASO6$,11ASO7$,11ASO8$,11ASO9$,11ASO10$,11ASO11$,5ASO12$,11ASO13$,11ASO14$,11ASO15$,11ASO16$,11ASO17$,11ASO18$,11ASO19$,11ASO20$,11ASO21$,11ASO22$,11ASO23$,26ASO24$
2450  REM Obtain a Person Record from the User
2460  LOCATE 20,1
2470  INPUT "Enter the Record-number of a Marriage (0 to quit)";REPLY$
2480  IF REPLY$ = "0" THEN 6580
2490  MARRIAGE = VAL(REPLY$)
2500  IF MARRIAGE < 1 OR MARRIAGE > MAX.MAR THEN KEY ON : CLS : LOCATE 19,1 : PRINT "Number is out of range;" : KEY OFF : GOTO 2470
2510  GOSUB 2520 : GOTO 3400
2520  REM Reset the Printer Characterisitcs for next page if required.
2530  IF FORMS = 1 THEN 2570  'Don't stop if forms are continuous
2540  REM Process Single Sheets
2550  PRINT "Press any key when next form is ready"
2560  A$ = INKEY$ : IF A$ = "" THEN 2560
2570  REM Reset paper sensing if required
2580  IF FORMS = 2 THEN LPRINT PAP.SEN.OFF$;
2590  REM Reset paper length if required
2600  IF LENGTH = 1 THEN LPRINT PAP.SHORT$;
2610  REM Reset Condensed Printing if required
2620  IF WIDE = 1 THEN LPRINT COMPR.ON$;
2630  RETURN
2640  REM Routine to do a Right-trim
2650  FOR J = 1 TO LEN(TEMP1$)
2660   IF RIGHT$(TEMP2$,1) = " " THEN TEMP2$ = LEFT$(TEMP2$,LEN(TEMP2$)-1) ELSE J = LEN(TEMP1$)
2670  NEXT J
2680  RETURN
2690  REM Routine to Extract Personal Information
2700  T1! = CVS(F1$) : T1 = T1!
2710  TEMP1$ = F2$ : TEMP2$ = F2$ : GOSUB 2640
2720  T2$ = TEMP2$
2730  REM Prefix the Record Number to the Surname
2740  GOSUB 8000
2750  TEMP1$ = F3$ : TEMP2$ = F3$ : GOSUB 2640
2760  T3$ = TEMP2$
2770  T4$ = " "
2780  IF LEFT$(F4$,1) = MALE.LTR$   THEN T4$ = MALE.LTR$
2790  IF LEFT$(F4$,1) = FEMALE.LTR$ THEN T4$ = FEMALE.LTR$
2800  T6! = CVS(F6$) : T6 = T6!
2810  T7! = CVS(F7$) : T7 = T7!
2820  RETURN
2830  TEMP1$ = F8$ : TEMP2$ = F8$ : GOSUB 2640
2840  T8$ = TEMP2$ 'Birthdate
2850  TEMP1$ = F9$ : TEMP2$ = F9$ : GOSUB 2640
2860  T9$ = TEMP2$
2870  TEMP1$ = F10$ : TEMP2$ = F10$ : GOSUB 2640
2880  T10$ = TEMP2$
2890  TEMP1$ = F11$ : TEMP2$ = F11$ : GOSUB 2640
2900  T11$ = TEMP2$
2910  TEMP1$ = F12$ : TEMP2$ = F12$ : GOSUB 2640
2920  T12$ = TEMP2$ 'Death Date
2930  RETURN
2940  TEMP1$ = F13$ : TEMP2$ = F13$ : GOSUB 2640
2950  T13$ = TEMP2$
2960  TEMP1$ = F14$ : TEMP2$ = F14$ : GOSUB 2640
2970  T14$ = TEMP2$
2980  TEMP1$ = F15$ : TEMP2$ = F15$ : GOSUB 2640
2990  T15$ = TEMP2$
3000  TEMP1$ = F16$ : TEMP2$ = F16$ : GOSUB 2640
3010  T16$ = TEMP2$
3020  TEMP1$ = F17$ : TEMP2$ = F17$ : GOSUB 2640
3030  T17$ = TEMP2$
3040  TEMP1$ = F18$ : TEMP2$ = F18$ : GOSUB 2640
3050  T18$ = TEMP2$
3060  TEMP1$ = F19$ : TEMP2$ = F19$ : GOSUB 2640
3070  T19$ = TEMP2$
3080  RETURN
3090  REM Routine to Extract Ordinance Information
3100  U1! = CVS(O1$) : U1 = U1!
3110  IF U1 = 0 THEN GOSUB 7910 : GOTO 3250
3120  TEMP1$ = O2$ : TEMP2$ = O2$ : GOSUB 2640
3130  U2$ = TEMP2$  'Christening Date
3140  TEMP1$ = O4$ : TEMP2$ = O4$ : GOSUB 2640
3150  U4$ = TEMP2$  'Sealed to Parents
3160  TEMP1$ = O7$ : TEMP2$ = O7$ : GOSUB 2640
3170  U7$ = TEMP2$  'Baptism
3180  TEMP1$ = O10$ : TEMP2$ = O10$ : GOSUB 2640
3190  U10$ = TEMP2$  'Endowment
3200  TEMP1$ = O11$ : TEMP2$ = O11$ : GOSUB 2640
3210  U11$ = TEMP2$  'Sealed to Spouse
3220  U12 = CVS(O12$)
3230  TEMP1$ = O24$ : TEMP2$ = O24$ : GOSUB 2640
3240  U24$ = TEMP2$  'Occupation
3250  RETURN
3260  REM Extraction of Marriage Information
3270  TT1! = CVS(M1$) : TT1 = TT1! 'Rec.no
3280  TT2! = CVS(M2$) : TT2 = TT2! 'Husband
3290  TT3! = CVS(M3$) : TT3 = TT3! 'Wife
3300  TEMP1$ = M5$ : TEMP2$ = M5$ : GOSUB 2640
3310  TT5$ = TEMP2$  'Marriage Date
3320  RETURN
3330  TEMP1$ = M6$ : TEMP2$ = M6$ : GOSUB 2640
3340  TT6$ = TEMP2$   'City
3350  TEMP1$ = M7$ : TEMP2$ = M7$ : GOSUB 2640
3360  TT7$ = TEMP2$   'County
3370  TEMP1$ = M8$ : TEMP2$ = M8$ : GOSUB 2640
3380  TT8$ = TEMP2$   'State
3390  RETURN
3400  REM Routine to Fill with Spaces
3410  IF X.CHILD$ = "no" AND LAST.MARR = MARRIAGE THEN 3460
3420  FOR I = 1 TO 49
3430   FORM$(I) = SPACE$(132)
3440  NEXT I
3450  IF DD.ORD$ = "no" THEN FA.COL = 10 : GOTO 3470
3460  IF WIDE = 2 AND FORMS = 2 AND DD.ORD$ <> "no" THEN FA.COL = 12 ELSE FA.COL = 10
3470  IF X.CHILD$ = "no" AND LAST.MARR = MARRIAGE THEN GOSUB 6450 : GOTO 2450
3480  X.CHILD$ = "no"
3490  IF DD.ORD$ = "no" THEN GOSUB 6700 : GOTO 3510
3500  IF WIDE = 2 AND FORMS = 2 AND DD.ORD$ <> "no" THEN 3510 ELSE GOSUB 6700
3510  REM Routine to Produce a Family Group Sheet
3520  REM get the marriage record
3530  GET #2, MARRIAGE
3540  PRINT "Obtaining Marriage Record"
3550  GOSUB 3260 : GOSUB 3330 'Extract Marriage Information
3560  HUSB = TT2 : WIFE = TT3
3570  REM Verify that record contains information
3580  IF HUSB = 0 OR WIFE = 0 THEN 6350
3590  REM
3600  REM Marriage Information onto line 4
3610  PRINT "Locate Marriage Information"
3620  MID$(FORM$(4),7,LEN(TT5$)) = TT5$
3630  IF TT6$ = "" AND TT7$ = "" AND TT8$ = "" THEN 3650
3640  MID$(FORM$(4),28,LEN(TT6$+TT7$+TT8$)+4) = TT6$+", "+TT7$+", "+TT8$
3650  REM
3660  GET #1, HUSB
3670  PRINT "Obtaining Husband's Information"
3680  GOSUB 2690 : GOSUB 2830 : GOSUB 2940  'Extract Husband's Information
3690  REM Move the Husband's Information
3700  IF T2$ = "" AND T3$ = "" THEN 3740
3710  MID$(FORM$(1),FA.COL-2,LEN(T2$+T3$)+2) = T2$ + ", " + T3$
3720  IF DD.ORD$ = "no" THEN 3740
3730  MID$(FORM$(1),84,LEN(T2$+T3$)+9) = T2$+", "+T3$+" ("+RIGHT$(T8$,4)+")"
3740  MID$(FORM$(2),7,LEN(T8$)) = T8$
3750  IF T9$ = "" AND T10$ = "" AND T11$ = "" THEN 3770
3760  MID$(FORM$(2),28,LEN(T9$+T10$+T11$)+4) = T9$+", "+T10$+", "+T11$
3770  MID$(FORM$(5),7,LEN(T12$)) = T12$
3780  IF T13$ = "" AND T14$ = "" AND T15$ = "" THEN 3800
3790  MID$(FORM$(5),28,LEN(T13$+T14$+T15$)+4) = T13$+", "+T14$+", "+T15$
3800  MID$(FORM$(6),7,LEN(T16$)) = T16$
3810  IF T17$ = "" AND T18$ = "" AND T19$ = "" THEN 3830
3820  MID$(FORM$(6),28,LEN(T17$+T18$+T19$)+4) = T17$+", "+T18$+", "+T19$
3830  FATHER = T6 : MOTHER = T7
3840  IF FATHER = 0 THEN 3900
3850  GET #1, FATHER
3860  PRINT "Obtaining Husband's Father"
3870  GOSUB 2690  'Extract Father's Information
3880  IF T2$ = "" AND T3$ = "" THEN 3900
3890  MID$(FORM$(7),FA.COL,LEN(T2$+T3$)+2) = LEFT$(T2$+", "+T3$,38)
3900  IF MOTHER = 0 THEN 3960
3910  GET #1, MOTHER
3920  PRINT "Obtaining Husband's Mother"
3930  GOSUB 2690  'Extract Mother's Information
3940  IF T2$ = "" AND T3$ = "" THEN 3960
3950  MID$(FORM$(7),58,LEN(T2$+T3$)+2) = LEFT$(T2$ + ", " + T3$,38)
3960  REM
3970  REM Look for Husband's Other Wives
3980  PRINT "Look for Other Wives"
3990  XWIFE.COL = 0
4000  REM Establish Skip-ahead Start-value and Delta
4010  START.AT = 1 : DELTA = INT(M.COUNT/10) : IF DELTA = 0 THEN 4060
4020  REM Add delta and test if too far
4030  START.AT = START.AT + DELTA
4040  IF START.AT > 9 * DELTA THEN 4060
4050  IF HUSB > PERS.NO(START.AT) THEN 4030
4060  START.AT = START.AT - DELTA
4070  REM Search Routine
4080  FOR W = START.AT TO M.COUNT
4090   IF HUSB > PERS.NO(W) THEN 4230  'next w
4100   IF HUSB < PERS.NO(W) THEN W = M.COUNT : GOTO 4230
4110   REM found a wife, skip if wife of this marriage
4120   IF M.NO(W) = 0 THEN 4230
4130   GET #2, M.NO(W)
4140   GOSUB 3260  'extract marriage info
4150   IF WIFE = TT3 THEN 4230  'skip if same
4160   REM found another wife
4170   IF TT3 = 0 THEN 4230
4180   GET #1, TT3  'get wife's information
4190   GOSUB 2690  'extract personal info.
4200   IF T2$ = "" AND T3$ = "" THEN 4230  'skip if empty
4210   MID$(FORM$(8),FA.COL-1+XWIFE.COL,LEN(T2$+T3$)+2) = T2$+", "+T3$
4220   XWIFE.COL = XWIFE.COL + LEN(T2$+T3$)+4
4230  NEXT W
4240  REM
4250  GET #1, WIFE
4260  PRINT "Obtaining Wife's Information"
4270  GOSUB 2690 : GOSUB 2830 : GOSUB 2940  'Extract Wife's Information
4280  REM Move the Wife's Information
4290  IF T2$ = "" AND T3$ = "" THEN 4330
4300  MID$(FORM$(10),FA.COL-2,LEN(T2$+T3$)+2) = T2$ + ", " + T3$
4310  IF DD.ORD$ = "no" THEN 4330
4320  MID$(FORM$(2),84,LEN(T2$+T3$)+9) = T2$+", "+T3$+" ("+RIGHT$(T8$,4)+")"
4330  MID$(FORM$(11),7,LEN(T8$)) = T8$
4340  IF T9$ = "" AND T10$ = "" AND T11$ = "" THEN 4360
4350  MID$(FORM$(11),28,LEN(T9$+T10$+T11$)+4) = T9$+", "+T10$+", "+T11$
4360  MID$(FORM$(13),7,LEN(T12$)) = T12$
4370  IF T13$ = "" AND T14$ = "" AND T15$ = "" THEN 4390
4380  MID$(FORM$(13),28,LEN(T13$+T14$+T15$)+4) = T13$+", "+T14$+", "+T15$
4390  MID$(FORM$(14),7,LEN(T16$)) = T16$
4400  IF T17$ = "" AND T18$ = "" AND T19$ = "" THEN 4420
4410  MID$(FORM$(14),28,LEN(T17$+T18$+T19$)+4) = T17$+", "+T18$+", "+T19$
4420  FATHER = T6 : MOTHER = T7
4430  IF FATHER = 0 THEN 4490
4440  GET #1, FATHER
4450  PRINT "Obtaining Wife's Father"
4460  GOSUB 2690  'Extract Father's Information
4470  IF T2$ = "" AND T3$ = "" THEN 4490
4480  MID$(FORM$(15),FA.COL,LEN(T2$+T3$)+2) = LEFT$(T2$+", "+T3$,38)
4490  IF MOTHER = 0 THEN 4550
4500  GET #1, MOTHER
4510  PRINT "Obtaining Wife's Mother"
4520  GOSUB 2690  'Extract Mother's Information
4530  IF T2$ = "" AND T3$ = "" THEN 4550
4540  MID$(FORM$(15),58,LEN(T2$+T3$)+2) = LEFT$(T2$ + ", " + T3$,38)
4550  REM
4560  REM
4570  REM Look for Wife's Other Husbands
4580  PRINT "Look for Other Husbands"
4590  XHUSB.COL = 0
4600  REM Establish Skip-ahead Start-value and Delta
4610  START.AT = 1 : DELTA = INT(M.COUNT/10) : IF DELTA = 0 THEN 4660
4620  REM Add delta and test if too far
4630  START.AT = START.AT + DELTA
4640  IF START.AT > 9 * DELTA THEN 4660
4650  IF WIFE > PERS.NO(START.AT) THEN 4630
4660  START.AT = START.AT - DELTA
4670  REM Search Routine
4680  FOR H = START.AT TO M.COUNT
4690   IF WIFE > PERS.NO(H) THEN 4830  'next h
4700   IF WIFE < PERS.NO(H) THEN H = M.COUNT : GOTO 4830
4710   REM found a husband.  Skip if husband of this marriage
4720   IF M.NO(H) = 0 THEN 4830
4730   GET #2, M.NO(H)
4740   GOSUB 3260  'extract marriage info
4750   IF HUSB = TT2 THEN 4830  'skip if same
4760   REM found another husband
4770   IF TT2 = 0 THEN 4830
4780   GET #1, TT2  'get husband's information
4790   GOSUB 2690  'extract personal info.
4800   IF T2$ = "" AND T3$ = "" THEN 4830  'skip if empty
4810   MID$(FORM$(16),12+XHUSB.COL,LEN(T2$+T3$)+2) = T2$+", "+T3$
4820   XHUSB.COL = XHUSB.COL + LEN(T2$+T3$)+4
4830  NEXT H
4840  REM Obtain Husband's Ordinances
4850  IF DD.ORD$ = "no" THEN 5130
4860  PRINT "Obtaining Husband's Ordinances"
4870  IF HUSB = 0 THEN 4990
4880  GET #3, HUSB
4890  GOSUB 3090  'Extract Ordinances
4900  MID$(FORM$(3),7,LEN(U2$)) = U2$
4910  REM Location of Baptism & Endowment
4920  IF WIDE = 2 AND FORMS = 2 THEN WH1 = 100 : WH2 = 111 ELSE WH1 = 98 : WH2 = 110
4930  MID$(FORM$(17),WH1,LEN(U7$)) = U7$
4940  MID$(FORM$(17),WH2,LEN(U10$)) = U10$
4950  REM get Husband's Occupation
4960  PRINT "Obtaining Husband's Occupation"
4970  IF U24$ = "" THEN 5010
4980  MID$(FORM$(1),55,LEN(U24$)+2) = "("+U24$+")"
4990  REM Obtain Wife's Ordinances
5000  IF WIFE = 0 THEN 5130
5010  GET #3, WIFE
5020  PRINT "Obtaining Wife's Ordinances"
5030  GOSUB 3090  'Extract Ordinances
5040  MID$(FORM$(12),7,LEN(U2$)) = U2$
5050  MID$(FORM$(19),WH1,LEN(U7$)) = U7$
5060  MID$(FORM$(19),WH2,LEN(U10$)) = U10$
5070  IF U12 <> HUSB THEN 5090 'Sealed to another
5080  MID$(FORM$(17),122,LEN(U11$)) = U11$
5090  REM get Wife's Occupation
5100  PRINT "Obtaining Wife's Occupation"
5110  IF U24$ = "" THEN 5130
5120  MID$(FORM$(10),55,LEN(U24$)+2) = "("+U24$+")"
5130  REM Now obtain the information about the Children
5140  CHILD.COUNT = 0
5150  REM Search the Parent/Child Index
5160  PRINT "Look for Children"
5170  XMARRCT = 0
5180  REM Establish Skip-ahead Start-value and Delta
5190  START.AT = 1 : DELTA = INT(PC.COUNT/10) : IF DELTA = 0 THEN 5240
5200  REM Add delta and test if too far
5210  START.AT = START.AT + DELTA
5220  IF START.AT > 9 * DELTA THEN 5240
5230  IF HUSB > PA.ID(START.AT) THEN 5210
5240  START.AT = START.AT - DELTA
5250  REM Search Routine
5260  FOR LL = START.AT TO PC.COUNT
5270   IF HUSB > PA.ID(LL) THEN 6340
5280   IF HUSB < PA.ID(LL) THEN LL = PC.COUNT : GOTO 6340
5290   REM found a child
5300   IF CH.ID(LL) = 0 THEN 6320
5310   GET #1, CH.ID(LL)
5320   GOSUB 2690 : GOSUB 2830  'Extract Child's Info.
5330   REM verify that Mother is the same
5340   IF WIFE <> T7 THEN 6340
5350   REM Found a valid child
5360   CHILD.COUNT = CHILD.COUNT + 1
5370   SHOW.COUNT = CHILD.COUNT
5380   X11 = 0
5390   X11 = X11 + 11
5400   IF CHILD.COUNT > X11 THEN SHOW.COUNT = CHILD.COUNT - X11 : GOTO 5390
5410   REM test for more than 11 children
5420   IF CHILD.COUNT = 1 THEN 5590
5430   IF (CHILD.COUNT-1) MOD 11 = 0 THEN 5440 ELSE 5590
5440   GOSUB 6360 'print the current form, then blank out children
5450   FOR II = 20 TO 49
5460    FORM$(II) = SPACE$(132)
5470   NEXT II
5480   X.CHILD$ = "yes"
5490   GOSUB 2520  'Next form
5500   SHOW.COUNT = 1
5510   XMARRCT = 0
5520  IF DD.ORD$ = "no" THEN 5540
5530  IF WIDE = 2 AND FORMS = 2 AND DD.ORD$ <> "no" THEN 5590
5540  REM Redraw Partial Form
5550  FOR II = 21 TO 41 STEP 2
5560   FORM$(II) = STRING$(132,95)
5570  NEXT II
5580  GOSUB 6940  'Redraw vertical separators
5590   SEX$ = T4$
5600   PRINT "Processing Child #";CHILD.COUNT
5610   MID$(FORM$(19+(2*SHOW.COUNT)),2,1) = T4$
5620   CH.FM = 1
5630   IF DD.ORD$ = "no" THEN 5650
5640   IF WIDE = 2 AND FORMS = 2 AND DD.ORD$ <> "no" THEN 5690
5650   FORM.NO$ = STR$(CHILD.COUNT)
5660   CH.FM = LEN(FORM.NO$)-1
5670   FORM.NO$ = RIGHT$(FORM.NO$,CH.FM)
5680   MID$(FORM$(18+(2*SHOW.COUNT)),2,CH.FM) = FORM.NO$
5690   MID$(FORM$(18+(2*SHOW.COUNT)),3+CH.FM,LEN(T2$)+1) = LEFT$(T2$+",",25-CH.FM)
5700   MID$(FORM$(19+(2*SHOW.COUNT)),5,LEN(T3$)) = T3$
5710   '
5720   REM Position Birthdate if Drawing the Form
5730   IF DD.ORD$ = "no" THEN VV = 29 : GOTO 5750
5740   IF WIDE = 2 AND FORMS = 2 AND DD.ORD$ <> "no" THEN VV = 28 ELSE VV = 29
5750   MID$(FORM$(18+(2*SHOW.COUNT)),VV,LEN(T8$)) = T8$
5760   MID$(FORM$(18+(2*SHOW.COUNT)),41,LEN(T9$)) = T9$
5770   '
5780   REM Set Width of County and State
5790   IF DD.ORD$ = "no" THEN V = 5 : GOTO 5810
5800   IF WIDE = 2 AND FORMS = 2 AND DD.ORD$ <> "no" THEN V = 4 ELSE V = 5
5810   MID$(FORM$(18+(2*SHOW.COUNT)),60,V) = LEFT$(T10$,V)
5820   MID$(FORM$(18+(2*SHOW.COUNT)),66,V) = LEFT$(T11$,V)
5830   MID$(FORM$(18+(2*SHOW.COUNT)),85,LEN(T12$)) = T12$
5840   REM Now get Child's Ordinances
5850  IF DD.ORD$ = "no" THEN 5920
5860   GET #3, CH.ID(LL)
5870   PRINT "Obtain Child's Ordinances"
5880   GOSUB 3090  'Extract Ordinances
5890   MID$(FORM$(18+(2*SHOW.COUNT)),WH1,LEN(U7$)) = U7$
5900   MID$(FORM$(18+(2*SHOW.COUNT)),WH2,LEN(U10$)) = U10$
5910   MID$(FORM$(18+(2*SHOW.COUNT)),122,LEN(U4$)) = U4$
5920   REM Now look for Child's Marriage
5930   PRINT "Look for Child's Marriage"
5940  FOUND = 0
5950  REM Establish Skip-ahead Start-value and Delta
5960  START.AT = 1 : DELTA = INT(M.COUNT/10) : IF DELTA = 0 THEN 6010
5970  REM Add delta and test if too far
5980  START.AT = START.AT + DELTA
5990  IF START.AT > 9 * DELTA THEN 6010
6000  IF CH.ID(LL) > PERS.NO(START.AT) THEN 5980
6010  START.AT = START.AT - DELTA
6020  REM Search Routine
6030  FOR L = START.AT TO M.COUNT
6040    IF CH.ID(LL) > PERS.NO(L) THEN 6330
6050    IF CH.ID(LL) < PERS.NO(L) THEN L = M.COUNT : GOTO 6330
6060    REM Found a Marriage
6070    IF M.NO(L) = 0 THEN 6320
6080    FOUND = FOUND + 1
6090    GET #2, M.NO(L)
6100    GOSUB 3260  'Extract Marriage Information
6110    IF FOUND <> 1 THEN 6130
6120    MID$(FORM$(19+(2*SHOW.COUNT)-1),72,LEN(TT5$)) = TT5$
6130    REM get spouse
6140    SPOUSE = 0
6150    IF SEX$ = MALE.LTR$   THEN SPOUSE = TT3
6160    IF SEX$ = FEMALE.LTR$ THEN SPOUSE = TT2
6170    IF SPOUSE = 0 THEN 6320
6180    GET #1, SPOUSE
6190    GOSUB 2690  'Extract Spouse's Information
6200    IF FOUND = 1 THEN 6300
6210    XMARRCT = XMARRCT + 1
6220    IF XMARRCT > 7 THEN 6320
6230    CH$ = SPACE$(2)
6240    RSET CH$ = RIGHT$((STR$(CHILD.COUNT)),2)
6250    MID$(FORM$(42+XMARRCT),60,4) = CH$+" -"
6260    IF T2$ = " " AND T3$ = " " THEN 6290
6270    MID$(FORM$(42+XMARRCT),77,LEN(T2$+T3$)+2) = T2$+", "+T3$
6280    MID$(FORM$(42+XMARRCT),65,LEN(TT5$)) = TT5$
6290    GOTO 6320
6300    IF T2$ = " " AND T3$ = " " THEN 6320
6310    MID$(FORM$(19+(2*SHOW.COUNT)),72,LEN(T2$+T3$)+2) = T2$+", "+T3$
6320   REM finished with this child
6330   NEXT L
6340  NEXT LL
6350  GOSUB 6360 : GOTO 6570
6360  REM enter sources
6370  COMM$ = "Genealogy ON DISPLAY Computerized Data Base"
6380  MID$(FORM$(43),2,LEN(COMM$)) = COMM$
6390  MAR.NUM$ = STR$(MARRIAGE)
6400  MAR.NUM$ = RIGHT$(MAR.NUM$,LEN(MAR.NUM$)-1)
6410  MAR.DATA$ = "Marriage Record: " + MAR.NUM$
6420  MID$(FORM$(44),2,LEN(MAR.DATA$)) = MAR.DATA$
6430  MID$(FORM$(45),2,21) = "Prepared:  " + DATE$
6440  MID$(FORM$(46),2,19) = "At (time): " + TIME$
6450  PRINT "Ready to Print"
6460  LPRINT
6470  REM Print the Family Group Sheet
6480  IF LEFT.SPACE < 1 THEN LEFT.SPACE = 1
6490  FOR I = 1 TO 49
6500  PRINT "Printing line: ";I
6510   IF DD.ORD$ = "no" THEN LPRINT TAB(LEFT.SPACE); LEFT$(FORM$(I),133-2*LEFT.SPACE)  ELSE LPRINT FORM$(I);
6520  NEXT I
6530  LAST.MARR = MARRIAGE
6540  KEY ON : CLS : KEY OFF
6550  LPRINT FORM.FEED$;
6560  RETURN
6570  GOTO 2450  'for Next Group Sheet
6580  REM Wrapup
6590  LPRINT COMPR.OFF$;     'Normal Printing
6600  LPRINT PAP.SEN.ON$;    'Paper Sensing ON
6610  LPRINT PAP.LONG$;      'Normal Page of 66 Lines
6620  CLOSE #1
6630  CLOSE #2
6640  IF DD.ORD$ = "no" THEN 6660
6650  CLOSE #3
6660  WIDTH "lpt1:",80       'Reset for narrow paper
6670  KEY ON : CLS : KEY OFF : LOCATE 21,1
6680  PRINT "End of Program"
6690  RUN DD.MENU$+"menu"
6700  REM Draw the Form Itself
6710  PRINT "Preparing the Form."
6720  '
6730  PRINT "Drawing the Horizontal Lines in Rows:"
6740  FOR II = 1 TO 8
6750   PRINT II;
6760   FORM$(II) = STRING$(132,95)
6770  NEXT II
6780  PRINT
6790  IF DD.ORD$ = "no" THEN 6820
6800  MID$(FORM$(1),83,1) = CHR$(124)
6810  MID$(FORM$(2),83,1) = CHR$(124)
6820  FOR II = 10 TO 16
6830   PRINT II;
6840   FORM$(II) = STRING$(132,95)
6850  NEXT II
6860  MID$(FORM$(9),98,35) = STRING$(35,95)
6870  MID$(FORM$(16),98,35) = SPACE$(35)
6880  PRINT
6890  FOR II = 17 TO 41 STEP 2
6900   PRINT II;
6910   FORM$(II) = STRING$(132,95)
6920  NEXT II
6930  PRINT
6940  '
6950  PRINT "Drawing the Vertical Lines in Rows:"
6960  FOR II = 18 TO 41
6970   PRINT II;
6980   MID$(FORM$(II),1,1) = CHR$(124)
6990   MID$(FORM$(II),3,1) = CHR$(124)
7000   MID$(FORM$(II),28,1) = CHR$(124)
7010   MID$(FORM$(II),40,1) = CHR$(124)
7020   MID$(FORM$(II),59,1) = CHR$(124)
7030   MID$(FORM$(II),65,1) = CHR$(124)
7040   MID$(FORM$(II),71,1) = CHR$(124)
7050   MID$(FORM$(II),97,1) = CHR$(124)
7060  NEXT II
7070  PRINT
7080  FOR II = 42 TO 49
7090   PRINT II;
7100   MID$(FORM$(II),1,1) = CHR$(124)
7110   MID$(FORM$(II),59,1) = CHR$(124)
7120   IF DD.ORD$ <> "no" THEN 7140
7130   MID$(FORM$(II),97,1) = CHR$(124)
7140  NEXT II
7150  PRINT
7160  PRINT "Drawing Boxes in Rows:"
7170  FOR II = 18 TO 40 STEP 2
7180  PRINT II;
7190   MID$(FORM$(II),72,25) = STRING$(25,95)
7200  NEXT II
7210  PRINT
7220  FOR II = 18 TO 40 STEP 2
7230   PRINT II;
7240   MID$(FORM$(II),84,1) = CHR$(124)
7250  NEXT II
7260  PRINT
7270  REM Put the titles in place
7280  PRINT "Preparing Titles and Numbers"
7290  MID$(FORM$(18),11,8) = "CHILDREN"
7300  MID$(FORM$(18),30,9) = "WHEN BORN"
7310  MID$(FORM$(18),56,10) = "WHERE BORN"
7320  MID$(FORM$(18),72,11) = "1st MARRIED"
7330  MID$(FORM$(18),86,9) = "WHEN DIED"
7340  MID$(FORM$(19),4,20) = "SURNAME, Given Names"
7350  MID$(FORM$(19),29,11) = "DA MON YEAR"
7360  MID$(FORM$(19),45,5) = "TOWN"
7370  MID$(FORM$(19),60,4) = "CNTY"
7380  MID$(FORM$(19),66,4) = "STA."
7390  MID$(FORM$(19),72,15) = "TO WHOM MARRIED"
7400  MID$(FORM$(42),2,22) = "SOURCES OF INFORMATION"
7410  MID$(FORM$(42),60,15) = "OTHER MARRIAGES"
7420  MID$(FORM$( 1),1,5) = "HUSB:"
7430  MID$(FORM$(2), 1,5) = "Born:"
7440  MID$(FORM$(2),20,6) = "Place:"
7450  MID$(FORM$(3), 1,4) = "Chr:"
7460  MID$(FORM$(3),20,6) = "Place:"
7470  MID$(FORM$(4), 1,5) = "Marr:"
7480  MID$(FORM$(4),20,6) = "Place:"
7490  MID$(FORM$(5), 1,5) = "Died:"
7500  MID$(FORM$(5),20,6) = "Place:"
7510  MID$(FORM$(6), 1,4) = "Bur:"
7520  MID$(FORM$(6),20,6) = "Place:"
7530  MID$(FORM$(7), 1,7) = "Father:"
7540  MID$(FORM$(7),49,7) = "Mother:"
7550  MID$(FORM$(8), 1,6) = "Wives:"
7560  MID$(FORM$(10),1,5) = "WIFE:"
7570  MID$(FORM$(11),1,5) = "Born:"
7580  MID$(FORM$(11),20,6) = "Place:"
7590  MID$(FORM$(12), 1,4) = "Chr:"
7600  MID$(FORM$(12),20,6) = "Place:"
7610  MID$(FORM$(13), 1,5) = "Died:"
7620  MID$(FORM$(13),20,6) = "Place:"
7630  MID$(FORM$(14), 1,4) = "Bur:"
7640  MID$(FORM$(14),20,6) = "Place:"
7650  MID$(FORM$(15), 1,7) = "Father:"
7660  MID$(FORM$(15),49,7) = "Mother:"
7670  MID$(FORM$(16), 1,9) = "Husbands:"
7680  FOR II = 3 TO 17
7690   MID$(FORM$(II),97,1) = CHR$(124)
7700  NEXT II
7710  IF DD.ORD$ <> "no" THEN 7740
7720   MID$(FORM$(1),97,1) = CHR$(124)
7730   MID$(FORM$(2),97,1) = CHR$(124)
7740  REM Put in the Descriptions
7750  IF DD.ORD$ = "no" THEN 7900
7760  MID$(FORM$(14),106,19) = "LDS ORDINANCE DATA"
7770  REM Draw Ordinance Separators
7780  FOR II = 15 TO 41
7790   MID$(FORM$(II),109,1) = CHR$(124)
7800   MID$(FORM$(II),121,1) = CHR$(124)
7810  NEXT II
7820  MID$(FORM$(15), 99,8) = "BAPTIZED"
7830  MID$(FORM$(15),111,7) = "ENDOWED"
7840  MID$(FORM$(15),123,6) = "SEALED"
7850  MID$(FORM$(16),106,7) = "HUSBAND"
7860  MID$(FORM$(16),123,10) = "WIFE/HUSB."
7870  MID$(FORM$(18),107,4) = "WIFE"
7880  MID$(FORM$(18),123,8) = "CHILDREN"
7890  MID$(FORM$(19),123,6) = "SEALED"
7900  RETURN
7910  REM Blank Ordinances if No Ord Record
7920  U2$  = "" : U3$  = "" : U4$  = ""
7930  U5   = 0  : U6   = 0  : U12  = 0
7940  U7$  = "" : U8$  = "" : U9$  = "" : U10$ = ""
7950  U11$ = "" : U13$ = "" : U14$ = "" : U15$ = ""
7960  U16$ = "" : U17$ = "" : U18$ = "" : U19$ = ""
7970  U20$ = "" : U21$ = "" : U22$ = "" : U23$ = ""
7980  U24$ = ""
7990  RETURN
8000  REM Routine to Obtain a Usable Person Number for the Chart
8010  REM Skip if LDS Wide, Single Sheet Forms
8020  IF DD.ORD$ = "no" THEN 8040
8030  IF WIDE = 2 AND FORMS = 2 THEN 8150  'return
8040  IF CHART.NOS$ <> "n" THEN 8150
8050  REM Convert the Person Number to a String
8060  PNUM$ = STR$(T1)
8070  REM Find the Length of the String
8080  PLEN = LEN(PNUM$)
8090  REM Get rid of the leading space for algebraic sign
8100  PNUM$ = RIGHT$(PNUM$,PLEN-1)
8110  REM Surround with Quotes and add a Trailing Space
8120  PNUM$ = "(" + PNUM$ + ") "
8130  REM Prefix Person Number to Surname
8140  T2$ = PNUM$ + T2$
8150  RETURN
8160  REM Clean User Input Area
8170  LOCATE 19,1 : PRINT SPACE$(79);
8180  LOCATE 20,1 : PRINT SPACE$(79);
8190  LOCATE 21,1 : PRINT SPACE$(79);
8200  LOCATE 22,1 : PRINT SPACE$(79);
8210  LOCATE 23,1 : PRINT SPACE$(79);
8220  RETURN
