100  REM LISTMAR Program.
110  REM Prints a List of Marriages
120  REM Copyright (c) 1983 - 1987 by: Melvin O. Duke.
130  DEFINT A-Z
600  REM Titles
610  TITLE$ = "List the Marriages File"
620  TITLE$ = TITLE$ + " ON DISPLAY"
700  REM Terminate if not called from the Menu
710  IF DD.MENU$ <> "" THEN 770
720  COLOR 7,0 : KEY ON : CLS : LOCATE 15,1
730  PRINT "Cannot run the"
740  PRINT TITLE$
750  PRINT "Program, unless selected from the MENU"
760  END
770  REM OK
1000  REM Produce the first screen
1010  KEY ON : CLS : KEY OFF
1020  REM Draw the outer double box
1030  R1 = 1 : C1 = 1 : R2 = 24 : C2 = 79 : GOSUB 1300
1040  REM Find the title location
1050  TITLE.POS = 40 - INT(LEN(TITLE$)/2)
1060  REM Draw the title box
1070  R1=3:C1=TITLE.POS-2:R2=6:C2=TITLE.POS+LEN(TITLE$)+1:GOSUB 1500
1080  REM Print the title
1090  LOCATE 4,TITLE.POS : PRINT TITLE$
1100  LOCATE 5,40-INT(LEN(VERSION$)/2) :  PRINT VERSION$;
1230  REM Draw the Copyright box
1240  R1 = 19 : C1 = 21 : R2 = 22 : C2 = 59 : GOSUB 1300
1250  REM Print the Copyright
1260  LOCATE 20,40-INT(LEN(COPY1$)/2) :  PRINT COPY1$;
1270  LOCATE 21,40-INT(LEN(COPY2$)/2) :  PRINT COPY2$;
1280  GOTO 1700
1300  REM subroutine to print a double box
1310  COLOR P
1320  FOR I = R1 + 1 TO R2 - 1
1330   LOCATE I, C1 : PRINT CHR$(186);
1340   LOCATE I, C2 : PRINT CHR$(186);
1350  NEXT I
1360   LOCATE R1, C1+1 : PRINT STRING$(C2-C1-1,205);
1390   LOCATE R2, C1+1 : PRINT STRING$(C2-C1-1,205);
1400   LOCATE R1, C1 : PRINT CHR$(201);
1410   LOCATE R1, C2 : PRINT CHR$(187);
1420   LOCATE R2, C1 : PRINT CHR$(200);
1430   LOCATE R2, C2 : PRINT CHR$(188);
1440  COLOR W
1450  RETURN
1500  REM subroutine to print a single box
1510  COLOR B
1520  FOR I = R1 + 1 TO R2 - 1
1530   LOCATE I, C1 : PRINT CHR$(179);
1540   LOCATE I, C2 : PRINT CHR$(179);
1550  NEXT I
1560   LOCATE R1, C1+1 : PRINT STRING$(C2-C1-1,196);
1590   LOCATE R2, C1+1 : PRINT STRING$(C2-C1-1,196);
1600   LOCATE R1, C1 : PRINT CHR$(218);
1610   LOCATE R1, C2 : PRINT CHR$(191);
1620   LOCATE R2, C1 : PRINT CHR$(192);
1630   LOCATE R2, C2 : PRINT CHR$(217);
1640  COLOR W
1650  RETURN
1700  REM ask user to press a key to continue
1710  LOCATE 25,1
1720  PRINT "Have Data Diskette(s) in Place, then Press any key to continue.";
1730  K$ = INKEY$ : IF K$ = "" THEN 1730
1740  KEY ON : CLS : KEY OFF
2000  REM LISTMAR Program Starts Here.
2010  REM Open the Persons File
2020  OPEN DD.PERS$+"persfile" AS #1 LEN = 256
2030  FIELD 1, 5 AS F1$, 20 AS F2$, 30 AS F3$, 2 AS F4$, 5 AS F5$, 5 AS F6$, 5 AS F7$, 11 AS F8$, 18 AS F9$, 16 AS F10$, 16 AS F11$, 11 AS F12$, 18 AS F13$, 16 AS F14$, 16 AS F15$, 11 AS F16$, 18 AS F17$, 16 AS F18$, 16 AS F19$
2040  REM open the Marriages File
2050  OPEN DD.MARR$+"marrfile" AS #2 LEN = 128
2060  FIELD 2, 5 AS M1$, 5 AS M2$, 5 AS M3$, 5 AS M4$, 11 AS M5$, 18 AS M6$, 16 AS M7$, 16 AS M8$, 45 AS M9$
2070  REM Read the Marriage Records
2080  KEY ON : CLS : KEY OFF : LOCATE 21,1
2090  PRINT "Listing the Records in the Marriages File"
2100  REC.COUNT = 0
2110  GOSUB 2130
2120  GOTO 2200
2130  LPRINT "  List of the Records in the Marriages File  ";DATE$;"  ";TIME$
2140  LPRINT
2150  LPRINT " REC   No.  MALE SPOUSE";
2160  LPRINT TAB(42);" No.  FEMALE SPOUSE"
2170  LPRINT " ---   ---  -------------------------";
2180  LPRINT TAB(42);" ---  -------------------------"
2190  RETURN
2200  IF START.MAR < 1 THEN START.MAR = 1
2210  FOR I = START.MAR TO MAX.MAR
2220   GET #2,I
2230   REM verify if valid record
2240   TT1! = CVS(M1$) : TT1 = TT1!
2250   LOCATE 23,1 : PRINT "Listing Record:";  I;
2260   IF TT1 < 1 THEN 2440
2270   REC.COUNT = REC.COUNT + 1
2280   LPRINT USING "####"; TT1;
2290   REM Male Spouse
2300   TT2! = CVS(M2$) : TT2 = TT2!
2310   IF TT2 = 0 THEN GOSUB 2570 ELSE GET #1, TT2 : GOSUB 2460
2320   REM Print the Male Spouse
2330   LPRINT TAB(7);
2340   LPRINT USING "####"; TT2;
2350   LPRINT LEFT$("  "+T2$+", "+T3$,30);
2360   REM Female Spouse
2370   TT3! = CVS(M3$) : TT3 = TT3!
2380   IF TT3 = 0 THEN GOSUB 2570 ELSE GET #1, TT3 : GOSUB 2460
2390   REM Print the Female Spouse
2400   LPRINT TAB(42);
2410   LPRINT USING "####"; TT3;
2420   LPRINT LEFT$("  "+T2$+", "+T3$,30)
2430   IF REC.COUNT MOD 55 = 0 THEN LPRINT FORM.FEED$;: GOSUB 2130
2440  NEXT I
2450  GOTO 2620
2460  REM Routine to Extract Personal Information
2470  T1! = CVS(F1$) : T1 = T1!
2480  T2$ = F2$
2490  FOR J = 1 TO LEN(F2$) -1
2500   IF RIGHT$(T2$,1)=" " THEN T2$ = LEFT$(T2$,LEN(T2$)-1) ELSE J = LEN(F2$)-1
2510  T3$ = F3$
2520  NEXT J
2530  FOR J = 1 TO LEN(F3$) -1
2540   IF RIGHT$(T3$,1)=" " THEN T3$ = LEFT$(T3$,LEN(T3$)-1) ELSE J = LEN(F3$)-1
2550  NEXT J
2560  RETURN
2570  REM Blank out a Record
2580  T1 = 0
2590  T2$ = ""
2600  T3$ = ""
2610  RETURN
2620  LPRINT FORM.FEED$;
2630  CLOSE #1
2640  CLOSE #2
2650  KEY ON : CLS : KEY OFF : LOCATE 21,1
2660  PRINT "End of Program"
2670  RUN DD.MENU$+"menu"
