100  REM UPDATMAR Program
110  REM Data Entry to the Marriages File
120  REM Copyright (c) 1983 - 1987 by: Melvin O. Duke.
130  DEFINT A-Z
600  REM Titles
610  TITLE$ = "Update the Marriages File"
620  TITLE$ = TITLE$ + " ON DISPLAY"
700  REM Terminate if not called from the Menu
710  IF DD.MENU$ <> "" THEN 770
720  COLOR 7,0 : KEY ON : CLS : LOCATE 15,1
730  PRINT "Cannot run the"
740  PRINT TITLE$
750  PRINT "Program, unless selected from the MENU"
760  END
770  REM OK
1000  REM Produce the first screen
1010  KEY ON : CLS : KEY OFF
1020  REM Draw the outer double box
1030  R1 = 1 : C1 = 1 : R2 = 24 : C2 = 79 : GOSUB 1300
1040  REM Find the title location
1050  TITLE.POS = 40 - INT(LEN(TITLE$)/2)
1060  REM Draw the title box
1070  R1=3:C1=TITLE.POS-2:R2=6:C2=TITLE.POS+LEN(TITLE$)+1:GOSUB 1500
1080  REM Print the title
1090  LOCATE 4,TITLE.POS : PRINT TITLE$
1100  LOCATE 5,40-INT(LEN(VERSION$)/2) :  PRINT VERSION$;
1230  REM Draw the Copyright box
1240  R1 = 19 : C1 = 21 : R2 = 22 : C2 = 59 : GOSUB 1300
1250  REM Print the Copyright
1260  LOCATE 20,40-INT(LEN(COPY1$)/2) :  PRINT COPY1$;
1270  LOCATE 21,40-INT(LEN(COPY2$)/2) :  PRINT COPY2$;
1280  GOTO 1700
1300  REM subroutine to print a double box
1310  COLOR P
1320  FOR I = R1 + 1 TO R2 - 1
1330   LOCATE I, C1 : PRINT CHR$(186);
1340   LOCATE I, C2 : PRINT CHR$(186);
1350  NEXT I
1360   LOCATE R1, C1+1 : PRINT STRING$(C2-C1-1,205);
1390   LOCATE R2, C1+1 : PRINT STRING$(C2-C1-1,205);
1400   LOCATE R1, C1 : PRINT CHR$(201);
1410   LOCATE R1, C2 : PRINT CHR$(187);
1420   LOCATE R2, C1 : PRINT CHR$(200);
1430   LOCATE R2, C2 : PRINT CHR$(188);
1440  COLOR W
1450  RETURN
1500  REM subroutine to print a single box
1510  COLOR B
1520  FOR I = R1 + 1 TO R2 - 1
1530   LOCATE I, C1 : PRINT CHR$(179);
1540   LOCATE I, C2 : PRINT CHR$(179);
1550  NEXT I
1560   LOCATE R1, C1+1 : PRINT STRING$(C2-C1-1,196);
1590   LOCATE R2, C1+1 : PRINT STRING$(C2-C1-1,196);
1600   LOCATE R1, C1 : PRINT CHR$(218);
1610   LOCATE R1, C2 : PRINT CHR$(191);
1620   LOCATE R2, C1 : PRINT CHR$(192);
1630   LOCATE R2, C2 : PRINT CHR$(217);
1640  COLOR W
1650  RETURN
1700  REM ask user to press a key to continue
1710  LOCATE 25,1
1720  PRINT "Have Data Diskette(s) in Place, then Press any key to continue.";
1730  K$ = INKEY$ : IF K$ = "" THEN 1730
1740  KEY ON : CLS : KEY OFF
2000  REM UPDATMAR Program Starts Here.
2010  REM Open the Marriages File
2020  OPEN DD.MARR$+"marrfile" AS #2 LEN = 128
2030  REM Open the Persons File
2040  OPEN DD.PERS$+"persfile" AS #1 LEN = 256
2050  FIELD 1, 5 AS F1$, 20 AS F2$, 30 AS F3$, 2 AS F4$, 5 AS F5$, 5 AS F6$, 5 AS F7$, 11 AS F8$, 18 AS F9$, 16 AS F10$, 16 AS F11$, 11 AS F12$, 18 AS F13$, 16 AS F14$, 16 AS F15$, 11 AS F16$, 18 AS F17$, 16 AS F18$, 16 AS F19$
2060  FIELD 2, 5 AS M1$, 5 AS M2$, 5 AS M3$, 5 AS M4$, 11 AS M5$, 18 AS M6$, 16 AS M7$, 16 AS M8$, 45 AS M9$
2070  REM ask the user for input
2080  LOCATE 23,1 : PRINT SPACE$(79);
2090  LOCATE 23,1 : PRINT "(0 to quit, ? to locate unused record)";
2100  LOCATE 22,1 : PRINT SPACE$(79) : LOCATE 22,1
2110  LINE INPUT "Enter Record Number of Marriage to Update: "; REPLY$
2120  IF REPLY$ <> "?" THEN 2270
2130  REM Locate an unused record
2140  FOUND = 0 : IF REC.NO = 0 THEN REC.NO = 1
2150  FOR LOOK = REC.NO TO MAX.MAR
2160   GET #2, LOOK
2170   LOCATE 15,1 : PRINT "Searching Record";LOOK;
2180   TT1 = CVS(M1$)
2190   IF TT1 > 0 THEN 2210
2200   FOUND = 1 : REC.NO = LOOK : LOOK = MAX.MAR
2210  NEXT LOOK
2220  IF FOUND = 1 THEN 2360
2230  PRINT "Unable to find an unused record above record";REC.NO
2240  PRINT "Either start from record 1 or extend the file"
2250  PRINT "Press any key to continue"
2260  GOTO 2070
2270  IF REPLY$ = "0" THEN 4900
2280  REC.NO = VAL(REPLY$)
2290  IF REC.NO < 1 OR REC.NO > MAX.MAR THEN 2300 ELSE 2350
2300  PRINT : PRINT "Number is out of range"
2310  PRINT "Press any key to continue"
2320  A$ = INKEY$ : IF A$ = "" THEN 2320
2330  KEY ON : CLS : KEY OFF
2340  GOTO 2070
2350  GET #2, REC.NO
2360  REM Extract information from the file for use
2370  TT1! = CVS(M1$) : TT1 = TT1!
2380  REM Disallow Update if Rec.no is Zero (never Created)
2390  IF TT1 <> 0 THEN 2460
2400  LOCATE 22,1 : PRINT SPACE$(79);
2410  LOCATE 23,1 : PRINT SPACE$(79); : LOCATE 22,1
2420  PRINT "Record Number is Zero.  Must run the CREATMAR Program First."
2430  LOCATE 25,1 : PRINT "Press any key to continue";
2440  A$ = INKEY$ : IF A$ = "" THEN 2440
2450  GOTO 4900  'Close the Files and return to the Menu
2460  TT2! = CVS(M2$) : TT2 = TT2!
2470  TT3! = CVS(M3$) : TT3 = TT3!
2480  TT4! = CVS(M4$)
2490  TT5$ = M5$
2500  TT6$ = M6$
2510  TT7$ = M7$
2520  TT8$ = M8$
2530  TT9$ = M9$
2540  KEY ON : CLS : KEY OFF
2550  R1 = 1 : C1 = 1 : R2 = 21 : C2 = 79 : GOSUB 1300  'Double box
2560  R1 = 3 : C1 = 1 : R2 = 3 : C2 = 79 : GOSUB 3310  'Horizontal double
2570  R1 = 19 : C1 = 1 : R2 = 19 : C2 = 79 : GOSUB 3310  'Horizontal double
2580  LOCATE  2,33 : PRINT "Marriage Record"
2590  LOCATE  5, 3 : COLOR O : PRINT "Marriage Record-number:";
2600  LOCATE  7, 3 : PRINT "Male Spouse:";
2610  LOCATE  8, 3 : PRINT "Male Spouse's Name:";
2620  LOCATE 10, 3 : PRINT "Female Spouse:";
2630  LOCATE 11, 3 : PRINT "Female Spouse's Name:";
2640  LOCATE 20, 3 : PRINT "Comments:";
2650  LOCATE  5,42 : PRINT "Marriage Code:";
2660  LOCATE 13, 3 : COLOR N : PRINT "Marriage Statistics:"; : COLOR O
2670  LOCATE 14, 3 : PRINT "Marriage-date:";
2680  LOCATE 15, 3 : PRINT "Marriage-city:";
2690  LOCATE 16, 3 : PRINT "Marriage-county:";
2700  LOCATE 17, 3 : PRINT "State/Country:";
2710  GOSUB 2730 'To print the current information
2720  GOTO 3380 'For User Input
2730  REM Print the Information Currently Present
2740  LOCATE  5,27 : PRINT SPACE$(5);
2750  LOCATE  5,27 : COLOR G : PRINT TT1;
2760  LOCATE  7,27 : PRINT SPACE$(5);
2770  LOCATE  7,27 : COLOR G : PRINT TT2;
2780  LOCATE  8,27 : PRINT SPACE$(51);
2790  REM Obtain the Husband's Record
2800  IF TT2 = 0 THEN GOSUB 5170 : GOTO 2960 ELSE GET #1, TT2 : GOSUB 5050
2810  REM Disallow if not Male
2820  IF LEFT$(T4$,1) = MALE.LTR$ THEN 2960
2830  COLOR W
2840  LOCATE 23,1 : PRINT SPACE$(79);
2850  LOCATE 24,1 : PRINT SPACE$(70);
2860  REM Test for Undefined Sex
2870  IF LEFT$(T4$,1) <> " " THEN 2900
2880  LOCATE 22,1 : PRINT "The Sex of the Male Spouse is Undefined"
2890  GOTO 2910
2900  LOCATE 22,1 : PRINT "The Sex of the Male Spouse is shown as: "; T4$;
2910  LOCATE 23,1 : PRINT "Cannot Save this Marriage Record";
2920  KEY OFF : LOCATE 25,1 : PRINT "Press any key to continue";
2930  A$ = INKEY$ : IF A$ = "" THEN 2930
2940  REM Blank the Record and start over
2950  TT1 = -TT1 : GOSUB 4950 : GOSUB 2730 : GOTO 3380
2960  LOCATE  8,27 : COLOR G : PRINT LEFT$(T3$+" "+T2$,51);
2970  LOCATE 10,27 : PRINT SPACE$(5);
2980  LOCATE 10,27 : COLOR G : PRINT TT3;
2990  LOCATE 11,27 : PRINT SPACE$(51);
3000  REM Obtain the Wife's Record
3010  IF TT3 = 0 THEN GOSUB 5170 : GOTO 3170 ELSE GET #1, TT3 : GOSUB 5050
3020  REM Disallow if not Female
3030  IF LEFT$(T4$,1) = FEMALE.LTR$ THEN 3170
3040  COLOR W
3050  LOCATE 23,1 : PRINT SPACE$(79);
3060  LOCATE 24,1 : PRINT SPACE$(70);
3070  REM Test for Undefined Sex
3080  IF LEFT$(T4$,1) <> " " THEN 3110
3090  LOCATE 22,1 : PRINT "The Sex of the Female Spouse is Undefined"
3100  GOTO 3120
3110  LOCATE 22,1 : PRINT "The Sex of the Female Spouse is shown as: "; T4$;
3120  LOCATE 23,1 : PRINT "Cannot Save this Marriage Record";
3130  KEY OFF : LOCATE 25,1 : PRINT "Press any key to continue";
3140  A$ = INKEY$ : IF A$ = "" THEN 3140
3150  REM Blank the Record and start over
3160  TT1 = -TT1 : GOSUB 4950 : GOSUB 2730 : GOTO 3380
3170  LOCATE 11,27 : COLOR G : PRINT LEFT$(T3$+" "+T2$,51);
3180  LOCATE  5,57 : PRINT SPACE$(15);
3190  LOCATE  5,57 : COLOR G : PRINT TT4!;
3200  LOCATE 14,28 : PRINT SPACE$(11);
3210  LOCATE 14,28 : COLOR G : PRINT TT5$;
3220  LOCATE 15,28 : PRINT SPACE$(18);
3230  LOCATE 15,28 : COLOR G : PRINT TT6$;
3240  LOCATE 16,28 : PRINT SPACE$(16);
3250  LOCATE 16,28 : COLOR G : PRINT TT7$;
3260  LOCATE 17,28 : PRINT SPACE$(16);
3270  LOCATE 17,28 : COLOR G : PRINT TT8$;
3280  LOCATE 20,20 : PRINT SPACE$(45);
3290  LOCATE 20,20 : COLOR G : PRINT TT9$; : COLOR W
3300  RETURN
3310  REM Subroutine to draw a double horizontal line.  Attach to double.
3320  COLOR P
3330  LOCATE R1,C1+1 : PRINT STRING$(C2-C1-1,205);
3340  LOCATE R1,C1 : PRINT CHR$(204);
3350  LOCATE R1,C2 : PRINT CHR$(185);
3360  COLOR W
3370  RETURN
3380  REM Routines to Obtain information from the User
3390  LOCATE 22,1 : PRINT SPACE$(79);
3400  LOCATE 23,1 : PRINT SPACE$(79);
3410  LOCATE 24,1 : PRINT SPACE$(79);
3420  KEY ON
3430  LOCATE 24,1 : PRINT "('enter' to leave alone, '/ enter' to end record, or reply as shown)";
3440  LOCATE 23,1
3450  LINE INPUT "Enter the Record Number: ";REPLY$
3460  IF REPLY$ = "/" THEN 4530
3470  IF REPLY$ = "" THEN 3580
3480  IF ABS(VAL(REPLY$)) = ABS(TT1) THEN 3550 ELSE 3490
3490  REM Prevent Change of Rec.no
3500  LOCATE 24,1 : PRINT SPACE$(79); : LOCATE 22,1
3510  PRINT "Cannot Change the Record Number to another number.";
3520  KEY OFF : LOCATE 25,1 : PRINT "Press any key to continue";
3530  A$ = INKEY$ : IF A$ = "" THEN 3530
3540  GOTO 3380
3550  TT1 = VAL(REPLY$)
3560  IF TT1 < 1 THEN GOSUB 4950 : GOSUB 2730 : GOTO 4530  'Null Record
3570  GOSUB 2730
3580  LOCATE 23,1 : PRINT SPACE$(79);
3590  REM Terminate record update if negative
3600  IF TT1 < 1 THEN 4530
3610  LOCATE 23,1 : COLOR W
3620  LINE INPUT "Enter the Male Spouse's Record-Number: ";REPLY$
3630  IF REPLY$ = "/" THEN 4530
3640  IF REPLY$ = "" THEN 3700
3650  TT2 = VAL(REPLY$)
3660  IF TT2 >= 0 AND TT2 <= MAX.PER THEN 3680
3670  LOCATE 22,1 : PRINT "Number out of range"; : GOTO 3580
3680  LOCATE 22,1 : PRINT SPACE$(79);
3690  GOSUB 2760
3700  LOCATE 23,1 : PRINT SPACE$(79);
3710  REM Disallow if Male Spouse's Record-number is zero
3720  IF TT2 <> 0 THEN 3800
3730  COLOR W : LOCATE 24,1 : PRINT SPACE$(79);
3740  LOCATE 22,1 : PRINT "Male Spouse's Record Number Cannot be Zero";
3750  LOCATE 23,1 : PRINT "Cannot Save this Marriage Record";
3760  LOCATE 25,1 : PRINT "Press any key to continue";
3770  A$ = INKEY$ : IF A$ = "" THEN 3770
3780  REM Blank the Record and start over
3790  TT1 = -TT1 : GOSUB 4950 : GOSUB 2730 : GOTO 3380
3800  LOCATE 23,1 : PRINT SPACE$(79);
3810  LOCATE 23,1 : COLOR W
3820  LINE INPUT "Enter the Female Spouse's Record-Number: ";REPLY$
3830  IF REPLY$ = "/" THEN 4530
3840  IF REPLY$ = "" THEN 3900
3850  TT3 = VAL(REPLY$)
3860  IF TT3 >= 0 AND TT3 <= MAX.PER THEN 3880
3870  LOCATE 22,1 : PRINT "Number out of range"; : GOTO 3800
3880  LOCATE 22,1 : PRINT SPACE$(79);
3890  GOSUB 2970
3900  LOCATE 23,1 : PRINT SPACE$(79);
3910  REM Disallow if Female Spouse's Record-number is zero
3920  IF TT3 <> 0 THEN 4000
3930  COLOR W : LOCATE 24,1 : PRINT SPACE$(79);
3940  LOCATE 22,1 : PRINT "Female Spouse's Record Number Cannot be Zero";
3950  LOCATE 23,1 : PRINT "Cannot Save this Marriage Record";
3960  KEY OFF : LOCATE 25,1 : PRINT "Press any key to continue";
3970  A$ = INKEY$ : IF A$ = "" THEN 3970
3980  REM Blank the Record and start over
3990  TT1 = -TT1 : GOSUB 4950 : GOSUB 2730 : GOTO 3380
4000  LOCATE 23,1 : COLOR W
4010  LINE INPUT "Enter the Marriage Code: ";REPLY$
4020  IF REPLY$ = "/" THEN 4530
4030  IF REPLY$ = "" THEN 4060
4040  TT4! = VAL(REPLY$)
4050  GOSUB 3180
4060  LOCATE 23,1 : PRINT SPACE$(79);
4070  LOCATE 23,1 : COLOR W
4080  PRINT "Enter the Marriage-Date as: dd Mmm yyyy: ";
4090  LINE INPUT REPLY$
4100  IF REPLY$ = CHR$(34)+" "+CHR$(34) THEN REPLY$ = " "
4110  IF REPLY$ = "/" THEN 4530
4120  IF REPLY$ = "" THEN 4160
4130  REPLY$ = LEFT$(REPLY$,11)
4140  RSET TT5$ = REPLY$
4150  GOSUB 3200
4160  LOCATE 23,1 : PRINT SPACE$(79);
4170  LOCATE 23,1 : COLOR 7
4180  PRINT "Enter the Marriage-City: ";
4190  LINE INPUT REPLY$
4200  IF REPLY$ = CHR$(34)+" "+CHR$(34) THEN REPLY$ = " "
4210  IF REPLY$ = "/" THEN 4530
4220  IF REPLY$ = "" THEN 4250
4230  TT6$ = LEFT$(REPLY$,18)
4240  GOSUB 3220
4250  LOCATE 23,1 : PRINT SPACE$(79);
4260  LOCATE 23,1 : COLOR 7
4270  PRINT "Enter the Marriage-County: ";
4280  LINE INPUT REPLY$
4290  IF REPLY$ = CHR$(34)+" "+CHR$(34) THEN REPLY$ = " "
4300  IF REPLY$ = "/" THEN 4530
4310  IF REPLY$ = "" THEN 4340
4320  TT7$ = LEFT$(REPLY$,16)
4330  GOSUB 3240
4340  LOCATE 23,1 : PRINT SPACE$(79);
4350  LOCATE 23,1 : COLOR 7
4360  PRINT "Enter the Marriage-State or Country: ";
4370  LINE INPUT REPLY$
4380  IF REPLY$ = CHR$(34)+" "+CHR$(34) THEN REPLY$ = " "
4390  IF REPLY$ = "/" THEN 4530
4400  IF REPLY$ = "" THEN 4430
4410  TT8$ = LEFT$(REPLY$,16)
4420  GOSUB 3260
4430  LOCATE 23,1 : PRINT SPACE$(79);
4440  LOCATE 23,1 : COLOR 7
4450  PRINT "Enter any Comments: ";
4460  LINE INPUT REPLY$
4470  IF REPLY$ = CHR$(34)+" "+CHR$(34) THEN REPLY$ = " "
4480  IF REPLY$ = "/" THEN 4530
4490  IF REPLY$ = "" THEN 4520
4500  TT9$ = LEFT$(REPLY$,45)
4510  GOSUB 3280
4520  REM
4530  REM Completed this Record
4540  LOCATE 24,1 : PRINT SPACE$(79);
4550  LOCATE 23,1 : PRINT SPACE$(79);
4560  LOCATE 23,1 : COLOR W
4570  LINE INPUT "Type s (save), m (more), or f (forget): ";REPLY$
4580  IF LEFT$(REPLY$,1) = "m" THEN LOCATE 23,1 : PRINT SPACE$(79); : GOTO 3380
4590  IF LEFT$(REPLY$,1) = "M" THEN LOCATE 23,1 : PRINT SPACE$(79); : GOTO 3380
4600  IF LEFT$(REPLY$,1) = "f" THEN KEY ON : CLS : KEY OFF : GOTO 2070
4610  IF LEFT$(REPLY$,1) = "F" THEN KEY ON : CLS : KEY OFF : GOTO 2070
4620  IF LEFT$(REPLY$,1) = "s" THEN LOCATE 23,1 : PRINT SPACE$(79); : GOTO 4660
4630  IF LEFT$(REPLY$,1) = "S" THEN LOCATE 23,1 : PRINT SPACE$(79); : GOTO 4660
4640  LOCATE 22,1 : PRINT "Error in reply";
4650  GOTO 4550
4660  REM Routine to SAVE the newly updated record
4670  REM Prevent saving of Person/non-Person Marriage
4680  IF TT1 < 0 THEN 4780  'ok if empty
4690  IF TT2 = 0 OR TT3 = 0 THEN 4700 ELSE 4780
4700  LOCATE 22,1 : PRINT SPACE$(79);
4710  LOCATE 22,1
4720  PRINT "Cannot s (save) unless both spouses have numbers that are not zero."
4730  REM Ask for More or Forget, but not Save
4740  LOCATE 23,1 : PRINT SPACE$(79);
4750  LOCATE 23,1 : COLOR W
4760  LINE INPUT "Type m (more), or f (forget): "; REPLY$
4770  GOTO 4580
4780  TT1! = TT1 : LSET M1$  = MKS$(TT1!)
4790  TT2! = TT2 : LSET M2$  = MKS$(TT2!)
4800  TT3! = TT3 : LSET M3$  = MKS$(TT3!)
4810  LSET M4$  = MKS$(TT4!)
4820  RSET M5$  = TT5$
4830  LSET M6$  = TT6$
4840  LSET M7$  = TT7$
4850  LSET M8$  = TT8$
4860  LSET M9$  = TT9$
4870  PUT #2, REC.NO
4880  KEY ON : CLS : KEY OFF
4890  GOTO 2070
4900  CLOSE #2
4910  CLOSE #1
4920  KEY ON : CLS : KEY OFF : LOCATE 21,1
4930  PRINT "End of Program"
4940  RUN DD.MENU$+"menu"
4950  REM Blank a Negative Record
4960  TT2 = 0
4970  TT3 = 0
4980  TT4! = 0
4990  TT5$ = SPACE$(11)
5000  TT6$ = ""
5010  TT7$ = ""
5020  TT8$ = ""
5030  TT9$ = ""
5040  RETURN
5050  REM Routine to Extract Personal Information
5060  T1! = CVS(F1$) : T1 = T1!
5070  T2$ = F2$
5080  FOR J = 1 TO LEN(F2$) -1
5090   IF RIGHT$(T2$,1)=" " THEN T2$ = LEFT$(T2$,LEN(T2$)-1) ELSE J = LEN(F2$)-1
5100  T3$ = F3$
5110  NEXT J
5120  FOR J = 1 TO LEN(F3$) -1
5130   IF RIGHT$(T3$,1)=" " THEN T3$ = LEFT$(T3$,LEN(T3$)-1) ELSE J = LEN(F3$)-1
5140  NEXT J
5150  T4$ = F4$
5160  RETURN
5170  REM Blank out a Record
5180  T1 = 0
5190  T2$ = ""
5200  T3$ = ""
5210  T4$ = ""
5220  RETURN
