100  REM Documentation for the Genealogy ON DISPLAY Programs
110  REM All data is in the form of DATA statements.
120  REM By:  Melvin O. Duke.  Updated June 1986.
130  DATA Notes and Sources
140  DATA User's Manual
150  DATA -5
160  DATA 1
170  INDENT = 0
180  REM Printer Definitions
190  FORM.FEED$  = CHR$(12)
200  COMPR.OFF$  = CHR$(18)     : COMPR.ON$ = CHR$(15)
210  BOLD.OFF$   = CHR$(27)+"F" : BOLD.ON$ = CHR$(27)+"E"
220  EXPAND.OFF$ = CHR$(18)     : EXPAND.ON$ = CHR$(14)
230  DASHES$ = "+"+STRING$(54,45)+"+"
240  TRIM.LINE$ = "(Trim-line)"
250  REM Program begins here
260  READ TITLE$, DOC.NAME$, PAGE.NO, LINE.NO
270  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
280  GOSUB 920  'For trim line and heading space
290  FOR I = 1 TO 6 : LPRINT : NEXT I
300  LPRINT BOLD.ON$;     'Set Emphasized mode
310  LPRINT EXPAND.ON$;   'Set Expanded Print
320  LPRINT TAB(TAB.POS-5);TITLE$
330  LPRINT EXPAND.OFF$;  'Return to normal
340  LPRINT BOLD.OFF$;    'Return to normal
350  FOR I = 1 TO 3 : LPRINT : NEXT I
360  LPRINT BOLD.ON$;     'Set Emphasized mode
370  LPRINT TAB(TAB.POS+12);"ON DISPLAY"
380  LPRINT BOLD.OFF$;    'Return to normal
390  LPRINT : LPRINT : LPRINT
400  LPRINT TAB(TAB.POS+11);"Version 1.1"
410  FOR I = 1 TO 11 : LPRINT : NEXT I
420  LPRINT TAB(TAB.POS+10); DOC.NAME$
430  LINE.NO = LINE.NO + 27
440  '
450  READ REPLY$
460  REM First, change tildes to quotes
470  FOR Q = 1 TO LEN(REPLY$)
480   IF MID$(REPLY$,Q,1)="~"THEN MID$(REPLY$,Q,1)=CHR$(34)
490  NEXT Q
500  IF LEFT$(REPLY$,1) = "." THEN GOSUB 1270: GOTO 450
510  IF LINE.NO > 44 THEN GOSUB 1030
520  REM Print the line if not a command
530  LPRINT TAB(TAB.POS);REPLY$
540  LINE.NO = LINE.NO + 1
550  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
560  GOTO 450
570  DATA ".pa"
580  REM   Data for the Copyright Page
590  DATA "Anyone may request a copy of Notes and"
600  DATA "Sources ON DISPLAY, for trial, by sending"
610  DATA "an unformatted, double-sided, double-"
620  DATA "density, 5-1/4 inch diskette to the"
630  DATA "author of the programs."
640  DATA ".sp"
650  DATA "An addressed, postage-paid return"
660  DATA "mailer must accompany the diskette (no"
670  DATA "exceptions, please).
680  DATA ".sp"
690  DATA "A copy of the programs with documenta-"
700  DATA "tion will be sent by return mail."
710  DATA ".vt 2"
720  DATA "Users are encouraged to copy and share"
730  DATA "the programs with others."
740  DATA ".vt 2"
750  DATA "If you are using this program, you are"
760  DATA "expected to become a Registered User,"
770  DATA "by making a contribution to the author"
780  DATA "of the program ($30.00 suggested for"
790  DATA "Registered Users of Genealogy ON DIS-"
800  DATA "PLAY, otherwise, $45.00 suggested)."
810  DATA ".sp"
820  DATA "Melvin O. Duke"
830  DATA "P. O. Box 20836"
840  DATA "San Jose, CA  95160"
850  DATA "(408) 268-6637"
860  DATA ".vt 3"
870  DATA "Copyright (c) 1986, by:"
880  DATA "Melvin O. Duke."
890  DATA ".sp"
900  DATA "All rights reserved."
910  '
920  REM Top of each page routine
930  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
940  LPRINT
950  LPRINT TAB(30); TRIM.LINE$
960  LPRINT DASHES$ 'Dashes
970  FOR I = 1 TO 6
980   LPRINT
990  NEXT I
1000  LINE.NO = LINE.NO + 6
1010  RETURN
1020  '
1030  REM Bottom of each page Routine
1040  IF PAGE.NO < 1 THEN LPRINT : LPRINT : LPRINT : GOTO 1160
1050  LPRINT TAB(TAB.POS); STRING$(40,45)  'on line 46
1060  LPRINT TAB(TAB.POS+0); TITLE$+" ON DISPLAY.  Vers. 1.1" 'on line 47
1070  IF PAGE.NO MOD 2 = 1 THEN 1110
1080  LPRINT TAB(TAB.POS);"Page";PAGE.NO;
1090  LPRINT TAB(TAB.POS+27);"User's Manual"
1100  GOTO 1160
1110  LPRINT TAB(TAB.POS); "User's Manual";
1120  IF PAGE.NO < 10 THEN DELTA = 34
1130  IF PAGE.NO >  9 THEN DELTA = 33
1140  IF PAGE.NO > 99 THEN DELTA = 32
1150  LPRINT TAB(TAB.POS+DELTA); "Page"; PAGE.NO  'on line 48
1160  LPRINT : LPRINT : LPRINT
1170  LPRINT DASHES$ 'dashes after 51
1180  LPRINT TAB(30); TRIM.LINE$
1190  LPRINT FORM.FEED$;
1200  PAGE.NO = PAGE.NO + 1
1210  LINE.NO = 1
1220  IF REPLY$ = ".eof" THEN 1240  'Bypass after last page
1230  GOSUB 920  'For top of next page
1240  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1250  RETURN
1260  '
1270  REM Command Processor
1280  IF LEFT$(REPLY$,3) = ".h1" THEN 1390
1290  IF LEFT$(REPLY$,3) = ".h2" THEN 1550
1300  IF LEFT$(REPLY$,3) = ".h3" THEN 1660
1310  IF LEFT$(REPLY$,3) = ".sp" THEN 1770
1320  IF LEFT$(REPLY$,4) = ".eof" THEN 1820
1330  IF LEFT$(REPLY$,3) = ".pa" THEN 1850
1340  IF LEFT$(REPLY$,3) = ".pn" THEN PAGE.NO = VAL(RIGHT$(REPLY$,LEN(REPLY$)-3)) : RETURN
1350  IF LEFT$(REPLY$,3) = ".vt" THEN 1920
1360  IF LEFT$(REPLY$,3) = ".pk" THEN 2030
1370  IF LEFT$(REPLY$,3) = ".in" THEN 2160
1380  STOP
1390  REM Head 1 Processor
1400  FOR I = LINE.NO TO 44
1410   LPRINT
1420  NEXT I
1430  GOSUB 1030  'Bottom of page Routine
1440  IF PAGE.NO MOD 2 = 0 THEN GOSUB 1850  'For h1 on Odd pages
1450  LPRINT BOLD.ON$;     'Set emphasized print
1460  LPRINT EXPAND.ON$;   'Set expanded print
1470  IF PAGE.NO MOD 2 = 0 THEN ADJUST = -2 ELSE ADJUST = -5
1480  LPRINT TAB(TAB.POS+ADJUST); RIGHT$(REPLY$,LEN(REPLY$)-4)
1490  LPRINT EXPAND.OFF$;  'Return to normal
1500  LPRINT BOLD.OFF$;    'Return to non-bold
1510  LINE.NO = LINE.NO+1
1520  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1530  RETURN
1540  '
1550  REM Head 2 Processor
1560  IF LINE.NO = 7 THEN 1580 'skip spacing if at top of page
1570  IF LINE.NO > 43 THEN GOSUB 1850 ELSE LPRINT:LPRINT:LINE.NO = LINE.NO+2
1580  LPRINT BOLD.ON$;  'Set emphasized print
1590  LPRINT TAB(TAB.POS+1); RIGHT$(REPLY$,LEN(REPLY$)-4)
1600  LPRINT BOLD.OFF$; 'Return to normal
1610  LPRINT
1620  LINE.NO = LINE.NO + 2
1630  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1640  RETURN
1650  '
1660  REM Head 3 Processor
1670  IF LINE.NO = 7 THEN 1690 'skip spacing if at top of page
1680  IF LINE.NO > 43 THEN GOSUB 1850 ELSE LPRINT:LPRINT:LINE.NO = LINE.NO+2
1690  LPRINT BOLD.ON$;  'Set emphasized print
1700  LPRINT TAB(TAB.POS+1); RIGHT$(REPLY$,LEN(REPLY$)-4)
1710  LPRINT BOLD.OFF$; 'Return to normal
1720  LPRINT
1730  LINE.NO = LINE.NO + 2
1740  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1750  RETURN
1760  '
1770  REM Single Space Processor
1780  IF LINE.NO = 7 THEN 1800
1790  IF LINE.NO > 44 THEN GOSUB 1850 ELSE LPRINT : LINE.NO = LINE.NO + 1
1800  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1810  RETURN
1820  REM End of File Processor
1830  GOSUB 1850 'Bottom of Page
1840  GOTO 6930
1850  REM Page Eject Processor
1860  FOR I = LINE.NO TO 44
1870   LPRINT
1880   LINE.NO = LINE.NO + 1
1890  NEXT I
1900  GOSUB 1030  'Bottom of Page Processing
1910  RETURN
1920  REM Vertical Tab Processor
1930  IF LINE.NO = 7 THEN 2020
1940  IF LINE.NO > 44 THEN GOSUB 1030  'End of page
1950  QTY = VAL(RIGHT$(REPLY$,LEN(REPLY$)-3))
1960  FOR I = 1 TO QTY
1970   LPRINT
1980   LINE.NO = LINE.NO + 1
1990   IF LINE.NO > 44 THEN I = QTY
2000  NEXT I
2010  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
2020  RETURN
2030  REM Pack Processor
2040  IF LINE.NO > 44 THEN GOSUB 1030
2050  IF TAB.POS = 8 THEN ADJUST = 4
2060  IF TAB.POS = 13 THEN ADJUST = 7
2070  TAB.POS = TAB.POS + ADJUST + INDENT
2080  WIDTH "lpt1:", 132 'set condensed width
2090  LPRINT COMPR.ON$;  'Packed printing
2100  LPRINT TAB(TAB.POS); RIGHT$(REPLY$,LEN(REPLY$)-3)
2110  LPRINT COMPR.OFF$; 'Return to normal
2120  WIDTH "lpt1:", 80  'return to normal
2130  LINE.NO = LINE.NO + 1
2140  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
2150  RETURN
2160  REM Indent Processor
2170  INDENT = VAL(RIGHT$(REPLY$,LEN(REPLY$)-3))
2180  RETURN
3000  DATA ".h1 GENERAL INFORMATION"
3010  DATA ".pn 9"
3020  DATA ".h2 DATA ACCESS REQUIREMENT"
3030  DATA "All of the data files used by Notes and"
3040  DATA "Sources ON DISPLAY must be available to"
3050  DATA "the program when it is running.  This"
3060  DATA "includes the Persons File from Genealogy"
3070  DATA "ON DISPLAY.  In addition, no file can be"
3080  DATA "split across different drives."
3090  DATA ".h2 DESCRIPTION OF FUNCTIONS"
3100  DATA ".h3 Formatting the Note File."
3110  DATA "Two functions within the program are"
3120  DATA "provided to permit the user to format"
3130  DATA "the Note File.  The first function de-"
3140  DATA "letes any existing Note File, and for-"
3150  DATA "mats 100 new records, with numbers"
3160  DATA "where numbers should be, and letters"
3170  DATA "where letters should be."
3180  DATA ".sp"
3190  DATA "The second function within the program"
3200  DATA "extends the Note File by 100 (and anoth-"
3210  DATA "er 100, and another 100, etc.) records,"
3220  DATA "as the user needs them."
3230  DATA ".pa"
3240  DATA ".h3 Personalization of Files."
3250  DATA "Two functions within the program provide"
3260  DATA "for personalization of the user's files."
3270  DATA "The first provides for personalization"
3280  DATA "of the Sources which he is using, and"
3290  DATA "the second provides for personalization"
3300  DATA "of the Types of notes he is keeping."
3310  DATA ".sp"
3320  DATA "Up to 252 Sources, and 252 Types of data"
3330  DATA "can be described by a user.  (The 252"
3340  DATA "represents 21 Screen-lists of 12 values"
3350  DATA "each.)  In addition, the program limits"
3360  DATA "the size of each Source or Type thus"
3370  DATA "defined to 32 characters each (to fit"
3380  DATA "nicely on the screen)."
3390  DATA ".sp"
3400  DATA "If these two files are not already full,"
3410  DATA "the user may extend his descriptions (up"
3420  DATA "to the 252 limit) at any time.  Thus, if"
3430  DATA "the user decides to define additional"
3440  DATA "Sources or Types, he may do so."
3450  DATA ".h2 Data Entry and Update"
3460  DATA "One function within the program provides"
3470  DATA "the ability to enter or update his notes."
3480  DATA "When he does, he enters that information"
3490  DATA "that is unique (e.g. Dates, and the Note"
3500  DATA "itself), and chooses the other informa-"
3510  DATA "tion for his Note-record from the list"
3520  DATA "of Persons from his Persons File, and"
3530  DATA "from his personalized lists of Sources"
3540  DATA "and Types."
3550  DATA ".pa"
3560  DATA ".h2 Inquiry for Display or Printing"
3570  DATA "One function within the program provides"
3580  DATA "the ability to make inquiries into the"
3590  DATA "user's Note File.  Once again, using the"
3600  DATA "same lists that were used when entering"
3610  DATA "data, the user is able to choose either"
3620  DATA "one (or all) Person(s), one (or all)"
3630  DATA "Source(s), and one (or all) Type(s)."
3640  DATA ".sp"
3650  DATA "Having made the selection, the user may"
3660  DATA "then ask that the results of the inquiry"
3670  DATA "be displayed on the screen, or printed"
3680  DATA "on the printer."
3690  DATA ".pa"
3700  DATA ".h2 DEFINITION OF TERMS"
3710  DATA ".h3 Sources"
3720  DATA "Sources are those places where records"
3730  DATA "may be found, which can verify informa-"
3740  DATA "tion.  This includes, but is not limit-"
3750  DATA "ed to, Governmental Agencies, Churches,"
3760  DATA "Cemeteries, Educational Institutions,"
3770  DATA "Books, Newspapers, etc., etc."
3780  DATA ".sp"
3790  DATA "This also includes Personal Knowledge,"
3800  DATA "Family Traditions, etc."
3810  DATA ".h3 Types"
3820  DATA "Types of information include Birth"
3830  DATA "Records, Death Records, Burial Records,"
3840  DATA "Census Records, Deeds, Wills, Probates,"
3850  DATA "etc., etc."
3860  DATA ".sp"
3870  DATA "Any record (usually written), which"
3880  DATA "shows information about one or more"
3890  DATA "persons, can be thought of as a Type"
3900  DATA "of information."
3910  DATA ".pa"
3920  DATA ".h3 Notes"
3930  DATA "Notes contain information that you want"
3940  DATA "to keep about a Person.  They can"
3950  DATA "identify where the information was"
3960  DATA "obtained, such as on a specific line"
3970  DATA "on a specific page of an identified"
3980  DATA "record book.  They may contain just a"
3990  DATA "Number, such as a Military Service"
4000  DATA "Number, or they may contain other"
4010  DATA "information."
4020  DATA ".sp"
4030  DATA "They may also be more personal comments,"
4040  DATA "such as the Color of Hair, favorite"
4050  DATA "food, Name of a Pet.  They are simply"
4060  DATA "the information that you want to keep."
4070  DATA ".h3 Lists"
4080  DATA "Three lists are used by Notes and"
4090  DATA "Sources ON DISPLAY, to assist in your"
4100  DATA "record-keeping.  The first is the list"
4110  DATA "of Persons from your Genealogy ON"
4120  DATA "DISPLAY Persons File.  The second is"
4130  DATA "your own (personalized) list of your"
4140  DATA "Sources.  The third is your own"
4150  DATA "(personalized) list of your Types."
4160  DATA ".sp"
4170  DATA "Portions of these lists are often shown"
4180  DATA "on the display screen whenever you are"
4190  DATA "entering information, or whenever you"
4200  DATA "are making inquiries."
4210  DATA ".pa"
4220  DATA ".h3 Data Entry or Update"
4230  DATA "Data Entry or Update is when you are"
4240  DATA "entering information about some person."
4250  DATA "For each note that you want to keep,"
4260  DATA "this means that you are choosing a"
4270  DATA "Person, choosing a Source, choosing a"
4280  DATA "Type, entering dates, and entering"
4290  DATA "the note itself."
4300  DATA ".h3 Inquiry for Display or Printing"
4310  DATA "When you are making an inquiry, you are"
4320  DATA "identifying the characteristics of the"
4330  DATA "information that you want to recall."
4340  DATA ".sp"
4350  DATA "This includes identifying either one"
4360  DATA "specific person or all persons, one"
4370  DATA "specific source, or all sources, one"
4380  DATA "specific type, or all types.  It also"
4390  DATA "includes identifying whether you want"
4400  DATA "the information presented on your"
4410  DATA "display screen, or printed or your"
4420  DATA "printer."
4430  DATA ".pa"
4440  DATA ".h2 EXPLANATION OF GENERAL CONCEPTS"
4450  DATA "Genealogical Notes and Sources are the"
4460  DATA "details, which provide not only the"
4470  DATA "'proof' that an event occurred, but"
4480  DATA "identify precisely where that informa-"
4490  DATA "tion was found.  This permits others"
4500  DATA "to verify that the information is"
4510  DATA "correct, without having to re-do the"
4520  DATA "original research themselves."
4530  DATA ".sp"
4540  DATA "Notes and Sources are much more than"
4550  DATA "proofs, however.  They may (and often"
4560  DATA "do) contain much more personal infor-"
4570  DATA "mation about individuals.  They may"
4580  DATA "indicate physical characteristics, such"
4590  DATA "as the color of the person's hair."
4600  DATA "They may indicate where a person lived,"
4610  DATA "what he accomplished, what his hobbies"
4620  DATA "were, what education he had received,"
4630  DATA "etc.  Thus, it is information that"
4640  DATA "shows the person to be a living,"
4650  DATA "breathing, human-being."
4660  DATA ".h3 Notes and Sources ON DISPLAY"
4670  DATA "Notes and Sources ON DISPLAY assists"
4680  DATA "in keeping track of information by"
4690  DATA "helping to form Note Records of most"
4700  DATA "of the user's important information."
4710  DATA ".pa"
4720  DATA "In addition to permitting a user to"
4730  DATA "enter specific information, Notes"
4740  DATA "and Sources ON DISPLAY presents the"
4750  DATA "user with personalized lists of his"
4760  DATA "own Sources and Types, to go with his"
4770  DATA "list of Persons from Genealogy ON"
4780  DATA "DISPLAY."
4790  DATA ".sp"
4800  DATA "Since much of the information in any"
4810  DATA "note may be repeated elsewhere, any"
4820  DATA "information that is not unique to the"
4830  DATA "note itself is separated from that in-"
4840  DATA "formation which is truly unique, and"
4850  DATA "carried in the note as a number, which"
4860  DATA "'points' to the non-unique information."
4870  DATA ".sp"
4880  DATA "Thus, a Type, such as 'Birth Record',"
4890  DATA "may be identified by a number, such as"
4900  DATA "1, rather than requiring a user to"
4910  DATA "type 'Birth Record' for every record"
4920  DATA "of birth that he wants to keep."
4930  DATA ".sp"
4940  DATA "In essence, wherever possible, Notes"
4950  DATA "and Sources ON DISPLAY separates the"
4960  DATA "information, and keeps the non-unique"
4970  DATA "information in lists, while retaining"
4980  DATA "the unique information with the note"
4990  DATA "itself."
5000  DATA ".sp"
5010  DATA "These lists can then be used during both"
5020  DATA "Data Entry, and Inquiry, to present the"
5030  DATA "user with exactly the same information"
5040  DATA "whatever task the user is performing."
5050  DATA ".pa"
5060  DATA "Using numbers, rather than actual data"
5070  DATA "in the note-records, wherever possible,"
5080  DATA "reduces the size of each note-record, so"
5090  DATA "that hundreds and hundreds of notes may"
5100  DATA "be kept on a single diskette."
5110  DATA ".sp"
5120  DATA "The use of Personalized Lists makes the"
5130  DATA "program extremely easy to use, since the"
5140  DATA "information is always consistent, and"
5150  DATA "the user does not have to type all re-"
5160  DATA "petitive information over and over"
5170  DATA "again.  The spellings are ALWAYS the"
5180  DATA "same, whether it be in Persons' names,"
5190  DATA "Sources, or Types of information."
5200  DATA ".pa"
5210  DATA ".h3 The Notefile"
5220  DATA "The notefile contains the actual notes"
5230  DATA "and dates.  It also contains the Note-"
5240  DATA "number, the identification of the Per-"
5250  DATA "son, the identification of the Source,"
5260  DATA "and the identification of the Type."
5270  DATA ".sp"
5280  DATA "Its format and content are:"
5290  DATA ".sp"
5300  DATA "Size  Content"
5310  DATA "----  --------------------------"
5320  DATA "  8   Note Number"
5330  DATA "  2   Person Number"
5340  DATA "  2   Source Number"
5350  DATA "  2   Type Number"
5360  DATA " 11   Event Date"
5370  DATA " 11   Research Date"
5380  DATA " 72   Content of the Note"
5390  DATA ".sp"
5400  DATA "The length of the note itself, at 72"
5410  DATA "characters, was specifically chosen to"
5420  DATA "to permit it to be shown as one line on"
5430  DATA "a display screen, or on one line on a"
5440  DATA "printed page."
5450  DATA ".pa"
5460  DATA ".h3 The Sources File"
5470  DATA "The Sources File provides the user with"
5480  DATA "the ability to identify up to 252 dif-"
5490  DATA "ferent sources where his information"
5500  DATA "was found.  The content of this file"
5510  DATA "may be (and probably always will be)"
5520  DATA "personalized by each user, to coincide"
5530  DATA "with his own sources."
5540  DATA ".sp"
5550  DATA "Each source may be up to 32 characters"
5560  DATA "in length (to let it fit nicely on the"
5570  DATA "display screen)."
5580  DATA ".h3 The Types File"
5590  DATA "The Types File provides the user with"
5600  DATA "the ability to identify up to 252 dif-"
5610  DATA "ferent types of data which he wants to"
5620  DATA "use.  The content of this file may be"
5630  DATA "(and probably always will be) personal-"
5640  DATA "ized by each user, to coincide with the"
5650  DATA "types of data that he wants to keep."
5660  DATA ".sp"
5670  DATA "Each type may be up to 32 characters in"
5680  DATA "length (to let it fit nicely on the"
5690  DATA "display screen)."
5700  DATA ".pa"
5710  DATA ".h2 BEFORE YOU START"
5720  DATA ".h3 Introduction to Personalization"
5730  DATA "When Notes and Sources ON DISPLAY is"
5740  DATA "shipped, it contains a file of Sources"
5750  DATA "and a file of Types.  These are pro-"
5760  DATA "vided to illustrate what the content"
5770  DATA "of the files should be like.  However,"
5780  DATA "you will probably want to change them,"
5790  DATA "to use your own Sources and your own"
5800  DATA "Types of Information."
5810  DATA ".sp"
5820  DATA "To make your own, personalized lists,"
5830  DATA "you should do the following:"
5840  DATA ".h3 List of Note Types"
5850  DATA "Begin by making a list which contains"
5860  DATA "the Types of notes which you wish to"
5870  DATA "keep."
5880  DATA ".sp"
5890  DATA "While you may wish to arrange your list"
5900  DATA "in alphabetical order, it is better to"
5910  DATA "arrange it so that the types of notes"
5920  DATA "that you will use the most are at the"
5930  DATA "top of the list."
5940  DATA ".sp"
5950  DATA "When you begin entering data and making"
5960  DATA "inquiries, you will see that the first"
5970  DATA "entries on your list are often shown,"
5980  DATA "so that you may make your selection."
5990  DATA ".pa"
6000  DATA "Of course, you may see other parts of"
6010  DATA "your list, but it will take more time"
6020  DATA "to do so.  Thus, it is better to have"
6030  DATA "your list arranged with those notes"
6040  DATA "which you will use the most at the top"
6050  DATA "of the list."
6060  DATA ".sp"
6070  DATA "After arranging the list, it may look"
6080  DATA "somewhat like the following:"
6090  DATA ".sp"
6100  DATA "No.  Note Type"
6110  DATA "---  --------------------"
6120  DATA "  1  Birth Records"
6130  DATA "  2  Marriage Records"
6140  DATA "  3  Census Records"
6150  DATA "  4  Deeds"
6160  DATA "  5  Land Records"
6170  DATA "  6  Wills"
6180  DATA "  7  Probates"
6190  DATA "  8  Death Records"
6200  DATA "  9  Obituaries"
6210  DATA " 10  Funeral Records"
6220  DATA " 11  Burial Records"
6230  DATA " 12  Cemeteries"
6240  DATA " 13  Awards"
6250  DATA " 14  Bar Mitzvahs"
6260  DATA " 15  Business Trips"
6270  DATA " 16  Circumcision"
6280  DATA " 17  Clothing"
6290  DATA " 18  Communion (First)"
6300  DATA " 19  Degrees and Diplomas"
6310  DATA " 20  Diseases"
6320  DATA " 21  Military Rank"
6330  DATA " 22  Newspaper Articles"
6340  DATA " 23  Passports"
6350  DATA " 24  Pets"
6360  DATA " 25  Promotions"
6370  DATA " 26  Publications"
6380  DATA " 27  Residences"
6390  DATA " 28  Ship Manifests"
6400  DATA " 29  Traditions (Family)"
6410  DATA " 30  Transportation"
6420  DATA " 31  Town Meetings"
6430  DATA " 32  Trophies"
6440  DATA " 33  Vacations"
6450  DATA ".pa"
6460  DATA ".h3 List of Sources"
6470  DATA "Make a second list which contains the"
6480  DATA "Sources of information for the notes"
6490  DATA "which you wish to keep."
6500  DATA ".sp"
6510  DATA "While you may wish to arrange your list"
6520  DATA "in alphabetical order, it is better to"
6530  DATA "arrange it so that the types of sources"
6540  DATA "that you will use the most, are at the"
6550  DATA "top of the list."
6560  DATA ".sp"
6570  DATA "When you begin entering data and making"
6580  DATA "inquiries, you will see that the first"
6590  DATA "entries on your list are often shown,"
6600  DATA "so that you may make your selection."
6610  DATA "Of course, you may see other parts of"
6620  DATA "your list, but it will take more time"
6630  DATA "to do so.  Thus, it is better to have"
6640  DATA "your list arranged with those sources"
6650  DATA "which you will use the most at the top"
6660  DATA "of the list."
6670  DATA ".sp"
6680  DATA "After arranging the list, it may look"
6690  DATA "somewhat like the following:"
6700  DATA ".sp"
6710  DATA "  1  Church"
6720  DATA "  2  State of California"
6730  DATA "  3  State of New York"
6740  DATA "  4  State of Ohio"
6750  DATA "  5  State of Utah"
6760  DATA "  6  State of Virginia"
6770  DATA "  7  Albany County, New York"
6780  DATA "  8  Salt Lake County, Utah"
6790  DATA "  9  Wasatch County, Utah"
6800  DATA " 10  United States"
6810  DATA " 11  England"
6820  DATA " 12  Germany"
6830  DATA " 13  Denmark"
6840  DATA " 14  City of San Jose"
6850  DATA " 15  Employers"
6860  DATA " 16  Fraternal Organizations"
6870  DATA " 17  High School"
6880  DATA " 18  Medical/Dental"
6890  DATA " 19  Personal"
6900  DATA " 20  Sports League"
6910  DATA " 21  University"
6920  DATA ".eof"
6930  END
