100  REM Documentation for the Genealogy ON DISPLAY Programs
110  REM All data is in the form of DATA statements.
120  REM By:  Melvin O. Duke.  Updated June 1986.
130  DATA Notes and Sources
140  DATA User's Manual
150  DATA -5
160  DATA 1
170  INDENT = 0
180  REM Printer Definitions
190  FORM.FEED$  = CHR$(12)
200  COMPR.OFF$  = CHR$(18)     : COMPR.ON$ = CHR$(15)
210  BOLD.OFF$   = CHR$(27)+"F" : BOLD.ON$ = CHR$(27)+"E"
220  EXPAND.OFF$ = CHR$(18)     : EXPAND.ON$ = CHR$(14)
230  DASHES$ = "+"+STRING$(54,45)+"+"
240  TRIM.LINE$ = "(Trim-line)"
250  REM Program begins here
260  READ TITLE$, DOC.NAME$, PAGE.NO, LINE.NO
270  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
280  GOSUB 920  'For trim line and heading space
290  FOR I = 1 TO 6 : LPRINT : NEXT I
300  LPRINT BOLD.ON$;     'Set Emphasized mode
310  LPRINT EXPAND.ON$;   'Set Expanded Print
320  LPRINT TAB(TAB.POS-5);TITLE$
330  LPRINT EXPAND.OFF$;  'Return to normal
340  LPRINT BOLD.OFF$;    'Return to normal
350  FOR I = 1 TO 3 : LPRINT : NEXT I
360  LPRINT BOLD.ON$;     'Set Emphasized mode
370  LPRINT TAB(TAB.POS+12);"ON DISPLAY"
380  LPRINT BOLD.OFF$;    'Return to normal
390  LPRINT : LPRINT : LPRINT
400  LPRINT TAB(TAB.POS+11);"Version 1.1"
410  FOR I = 1 TO 11 : LPRINT : NEXT I
420  LPRINT TAB(TAB.POS+10); DOC.NAME$
430  LINE.NO = LINE.NO + 27
440  '
450  READ REPLY$
460  REM First, change tildes to quotes
470  FOR Q = 1 TO LEN(REPLY$)
480   IF MID$(REPLY$,Q,1)="~"THEN MID$(REPLY$,Q,1)=CHR$(34)
490  NEXT Q
500  IF LEFT$(REPLY$,1) = "." THEN GOSUB 1270: GOTO 450
510  IF LINE.NO > 44 THEN GOSUB 1030
520  REM Print the line if not a command
530  LPRINT TAB(TAB.POS);REPLY$
540  LINE.NO = LINE.NO + 1
550  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
560  GOTO 450
570  DATA ".pa"
580  REM   Data for the Copyright Page
590  DATA "Anyone may request a copy of Notes and"
600  DATA "Sources ON DISPLAY, for trial, by sending"
610  DATA "an unformatted, double-sided, double-"
620  DATA "density, 5-1/4 inch diskette to the"
630  DATA "author of the programs."
640  DATA ".sp"
650  DATA "An addressed, postage-paid return"
660  DATA "mailer must accompany the diskette (no"
670  DATA "exceptions, please).
680  DATA ".sp"
690  DATA "A copy of the programs with documenta-"
700  DATA "tion will be sent by return mail."
710  DATA ".vt 2"
720  DATA "Users are encouraged to copy and share"
730  DATA "the programs with others."
740  DATA ".vt 2"
750  DATA "If you are using this program, you are"
760  DATA "expected to become a Registered User,"
770  DATA "by making a contribution to the author"
780  DATA "of the program ($30.00 suggested for"
790  DATA "Registered Users of Genealogy ON DIS-"
800  DATA "PLAY, otherwise, $45.00 suggested)."
810  DATA ".sp"
820  DATA "Melvin O. Duke"
830  DATA "P. O. Box 20836"
840  DATA "San Jose, CA  95160"
850  DATA "(408) 268-6637"
860  DATA ".vt 3"
870  DATA "Copyright (c) 1986, by:"
880  DATA "Melvin O. Duke."
890  DATA ".sp"
900  DATA "All rights reserved."
910  '
920  REM Top of each page routine
930  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
940  LPRINT
950  LPRINT TAB(30); TRIM.LINE$
960  LPRINT DASHES$ 'Dashes
970  FOR I = 1 TO 6
980   LPRINT
990  NEXT I
1000  LINE.NO = LINE.NO + 6
1010  RETURN
1020  '
1030  REM Bottom of each page Routine
1040  IF PAGE.NO < 1 THEN LPRINT : LPRINT : LPRINT : GOTO 1160
1050  LPRINT TAB(TAB.POS); STRING$(40,45)  'on line 46
1060  LPRINT TAB(TAB.POS+0); TITLE$+" ON DISPLAY.  Vers. 1.1" 'on line 47
1070  IF PAGE.NO MOD 2 = 1 THEN 1110
1080  LPRINT TAB(TAB.POS);"Page";PAGE.NO;
1090  LPRINT TAB(TAB.POS+27);"User's Manual"
1100  GOTO 1160
1110  LPRINT TAB(TAB.POS); "User's Manual";
1120  IF PAGE.NO < 10 THEN DELTA = 34
1130  IF PAGE.NO >  9 THEN DELTA = 33
1140  IF PAGE.NO > 99 THEN DELTA = 32
1150  LPRINT TAB(TAB.POS+DELTA); "Page"; PAGE.NO  'on line 48
1160  LPRINT : LPRINT : LPRINT
1170  LPRINT DASHES$ 'dashes after 51
1180  LPRINT TAB(30); TRIM.LINE$
1190  LPRINT FORM.FEED$;
1200  PAGE.NO = PAGE.NO + 1
1210  LINE.NO = 1
1220  IF REPLY$ = ".eof" THEN 1240  'Bypass after last page
1230  GOSUB 920  'For top of next page
1240  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1250  RETURN
1260  '
1270  REM Command Processor
1280  IF LEFT$(REPLY$,3) = ".h1" THEN 1390
1290  IF LEFT$(REPLY$,3) = ".h2" THEN 1550
1300  IF LEFT$(REPLY$,3) = ".h3" THEN 1660
1310  IF LEFT$(REPLY$,3) = ".sp" THEN 1770
1320  IF LEFT$(REPLY$,4) = ".eof" THEN 1820
1330  IF LEFT$(REPLY$,3) = ".pa" THEN 1850
1340  IF LEFT$(REPLY$,3) = ".pn" THEN PAGE.NO = VAL(RIGHT$(REPLY$,LEN(REPLY$)-3)) : RETURN
1350  IF LEFT$(REPLY$,3) = ".vt" THEN 1920
1360  IF LEFT$(REPLY$,3) = ".pk" THEN 2030
1370  IF LEFT$(REPLY$,3) = ".in" THEN 2160
1380  STOP
1390  REM Head 1 Processor
1400  FOR I = LINE.NO TO 44
1410   LPRINT
1420  NEXT I
1430  GOSUB 1030  'Bottom of page Routine
1440  IF PAGE.NO MOD 2 = 0 THEN GOSUB 1850  'For h1 on Odd pages
1450  LPRINT BOLD.ON$;     'Set emphasized print
1460  LPRINT EXPAND.ON$;   'Set expanded print
1470  IF PAGE.NO MOD 2 = 0 THEN ADJUST = -2 ELSE ADJUST = -5
1480  LPRINT TAB(TAB.POS+ADJUST); RIGHT$(REPLY$,LEN(REPLY$)-4)
1490  LPRINT EXPAND.OFF$;  'Return to normal
1500  LPRINT BOLD.OFF$;    'Return to non-bold
1510  LINE.NO = LINE.NO+1
1520  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1530  RETURN
1540  '
1550  REM Head 2 Processor
1560  IF LINE.NO = 7 THEN 1580 'skip spacing if at top of page
1570  IF LINE.NO > 43 THEN GOSUB 1850 ELSE LPRINT:LPRINT:LINE.NO = LINE.NO+2
1580  LPRINT BOLD.ON$;  'Set emphasized print
1590  LPRINT TAB(TAB.POS+1); RIGHT$(REPLY$,LEN(REPLY$)-4)
1600  LPRINT BOLD.OFF$; 'Return to normal
1610  LPRINT
1620  LINE.NO = LINE.NO + 2
1630  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1640  RETURN
1650  '
1660  REM Head 3 Processor
1670  IF LINE.NO = 7 THEN 1690 'skip spacing if at top of page
1680  IF LINE.NO > 43 THEN GOSUB 1850 ELSE LPRINT:LPRINT:LINE.NO = LINE.NO+2
1690  LPRINT BOLD.ON$;  'Set emphasized print
1700  LPRINT TAB(TAB.POS+1); RIGHT$(REPLY$,LEN(REPLY$)-4)
1710  LPRINT BOLD.OFF$; 'Return to normal
1720  LPRINT
1730  LINE.NO = LINE.NO + 2
1740  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1750  RETURN
1760  '
1770  REM Single Space Processor
1780  IF LINE.NO = 7 THEN 1800
1790  IF LINE.NO > 44 THEN GOSUB 1850 ELSE LPRINT : LINE.NO = LINE.NO + 1
1800  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1810  RETURN
1820  REM End of File Processor
1830  GOSUB 1850 'Bottom of Page
1840  GOTO 4970
1850  REM Page Eject Processor
1860  FOR I = LINE.NO TO 44
1870   LPRINT
1880   LINE.NO = LINE.NO + 1
1890  NEXT I
1900  GOSUB 1030  'Bottom of Page Processing
1910  RETURN
1920  REM Vertical Tab Processor
1930  IF LINE.NO = 7 THEN 2020
1940  IF LINE.NO > 44 THEN GOSUB 1030  'End of page
1950  QTY = VAL(RIGHT$(REPLY$,LEN(REPLY$)-3))
1960  FOR I = 1 TO QTY
1970   LPRINT
1980   LINE.NO = LINE.NO + 1
1990   IF LINE.NO > 44 THEN I = QTY
2000  NEXT I
2010  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
2020  RETURN
2030  REM Pack Processor
2040  IF LINE.NO > 44 THEN GOSUB 1030
2050  IF TAB.POS = 8 THEN ADJUST = 4
2060  IF TAB.POS = 13 THEN ADJUST = 7
2070  TAB.POS = TAB.POS + ADJUST + INDENT
2080  WIDTH "lpt1:", 132 'set condensed width
2090  LPRINT COMPR.ON$;  'Packed printing
2100  LPRINT TAB(TAB.POS); RIGHT$(REPLY$,LEN(REPLY$)-3)
2110  LPRINT COMPR.OFF$; 'Return to normal
2120  WIDTH "lpt1:", 80  'return to normal
2130  LINE.NO = LINE.NO + 1
2140  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
2150  RETURN
2160  REM Indent Processor
2170  INDENT = VAL(RIGHT$(REPLY$,LEN(REPLY$)-3))
2180  RETURN
3000  DATA ".h1 INTRODUCTION"
3010  DATA ".pn 1"
3020  DATA ".h2 OVERVIEW"
3030  DATA "The Notes and Sources ON DISPLAY pro-"
3040  DATA "gram lets you enter your Genealogical"
3050  DATA "Notes, and the Sources of your informa-"
3060  DATA "tion, and to make inquiries into those"
3070  DATA "notes for displaying on your screen or"
3080  DATA "for printing on your printer."
3090  DATA ".h2 Personalized Information"
3100  DATA "With Notes and Sources ON DISPLAY, you"
3110  DATA "are able to use your own names for the"
3120  DATA "types of information which you are keep-"
3130  DATA "ing, and the sources from whence they"
3140  DATA "came (e.g. Birth Certificate from the"
3150  DATA "State of New York)."
3160  DATA ".h2 Integrated Approach"
3170  DATA "Notes and Sources ON DISPLAY not only"
3180  DATA "lets you enter data, but it lets you"
3190  DATA "make inquiries about the notes that are"
3200  DATA "already stored.  You can inquire about"
3210  DATA "one Person, one Type of data, or one"
3220  DATA "Source.  Your inquiries can contain"
3230  DATA "mixtures, such as one person AND one"
3240  DATA "Type of Data AND one Source, etc."
3250  DATA ".pa"
3260  DATA ".h2 Multiple-Choices"
3270  DATA "When you are entering data, you select"
3280  DATA "from multiple-choice lists of personal-"
3290  DATA "ized information, by picking the number"
3300  DATA "of one Person, one Source, and one Type"
3310  DATA "of data.  You do not have to type all of"
3320  DATA "the information over and over again."
3330  DATA "You just make a series of choices."
3340  DATA ".sp"
3350  DATA "Similarly, when you make an inquiry, you"
3360  DATA "again select from multiple-choice lists"
3370  DATA "of information, picking the number of"
3380  DATA "one Person, one Source, and one Type of"
3390  DATA "Information (or you can pick ~all~ from"
3400  DATA "any of the lists).  Again, you do not"
3410  DATA "have to type the information, just pick"
3420  DATA "its number."
3430  DATA ".sp"
3440  DATA "When you make an inquiry, you can see"
3450  DATA "your infomation on the display screen,"
3460  DATA "or you can have it printed on your"
3470  DATA "printer.  The choice is up to you."
3480  DATA ".sp"
3490  DATA "With this multiple-choice approach, you"
3500  DATA "do not have to type the same informa-"
3510  DATA "tion over and over again.  You pick a"
3520  DATA "number, rather than typing the words"
3530  DATA "for Persons, Sources, and Types of In-"
3540  DATA "formation."
3550  DATA ".pa"
3560  DATA ".h2 CAPABILITIES"
3570  DATA "Following are the capabilities of the"
3580  DATA "Notes and Sources ON DISPLAY Program."
3590  DATA ".sp"
3600  DATA ".h3 Format a Note File."
3610  DATA "A new ~NOTEFILE~, for your Notes and"
3620  DATA "Sources, may be created, by selecting"
3630  DATA "this function from the menu.  This pre-"
3640  DATA "pares a file of 100 empty notes, with"
3650  DATA "numbers where numbers should be, and"
3660  DATA "with letters where letters should be."
3670  DATA "Each of these note-records is then"
3680  DATA "available for your use, to record"
3690  DATA "your own information."
3700  DATA ".h3 Extend the Note File."
3710  DATA "Your file of note-records may be exten-"
3720  DATA "ded at any time (by another 100 note-"
3730  DATA "records).  You may do this over and"
3740  DATA "again, whenever you wish."
3750  DATA ".sp"
3760  DATA "In this way, your file of notes can"
3770  DATA "grow as you require it, without being"
3780  DATA "larger than you need it.  By having"
3790  DATA "a file of notes only as large as you"
3800  DATA "need it, the time to search through"
3810  DATA "your notes can be minimized."
3820  DATA ".pa"
3830  DATA ".h3 Personalize the Sources."
3840  DATA "You can personalize your sources of"
3850  DATA "information, so that wherever your"
3860  DATA "research takes you, you can identify"
3870  DATA "those sources, in your own list."
3880  DATA ".sp"
3890  DATA "You can add to your list of sources"
3900  DATA "whenever you uncover another source, or"
3910  DATA "whenever you want to keep track of some"
3920  DATA "other kind of information (e.g. Medical"
3930  DATA "and Dental Information, Personal Char-"
3940  DATA "acteristics, etc.)."
3950  DATA ".h3 Personalize the Types of Data."
3960  DATA "You can personalize the types of data"
3970  DATA "that you are keeping, to meet your own"
3980  DATA "needs."
3990  DATA ".sp"
4000  DATA "You may also add to your list of types,"
4010  DATA "whenever you want, in order to keep"
4020  DATA "track of some other types of informa-"
4030  DATA "tion (e.g. Education, Diseases, Awards,"
4040  DATA "Businesss Trips, etc.)."
4050  DATA ".h3 Enter or Update Notes."
4060  DATA "You may enter your notes whenever you"
4070  DATA "desire, choosing the person from your"
4080  DATA "Genealogy ON DISPLAY Persons File,"
4090  DATA "choosing a Source from your personalized"
4100  DATA "list of sources, and choosing a Type,
4110  DATA "from your personalized list of types."
4120  DATA ".pa"
4130  DATA "You may also enter the date that the in-"
4140  DATA "formation was researched, and the date"
4150  DATA "of the event itself."
4160  DATA ".sp"
4170  DATA "Then, you enter the content of the note"
4180  DATA "(up to 72 characters)."
4190  DATA ".h3 Inquiry for Display or Printing."
4200  DATA "Whenever you want, you can inquire into"
4210  DATA "your notes, for some specific informa-"
4220  DATA "tion that you want.  For example you"
4230  DATA "may want to inquire into all Birth Rec-"
4240  DATA "ords that you have found in the State"
4250  DATA "of Ohio."
4260  DATA ".sp"
4270  DATA "You may want all of the information"
4280  DATA "about one person.  You may want all of"
4290  DATA "the Cemetary Records that you have ever"
4300  DATA "found, no matter where those cemetaries"
4310  DATA "were located, or who was buried there."
4320  DATA ".sp"
4330  DATA "With the inquiry capability, you can"
4340  DATA "decide on the spur of the moment just"
4350  DATA "what information you would like to see."
4360  DATA ".pa"
4370  DATA ".h2 BENEFITS/ADVANTAGES"
4380  DATA "The Notes and Sources ON DISPLAY pro-"
4390  DATA "gram provides an organized and cohesive"
4400  DATA "approach to permit users to create"
4410  DATA "their own personalized set of notes,"
4420  DATA "and to inquire into those notes when-"
4430  DATA "ever the user desires."
4440  DATA ".sp"
4450  DATA "A major advantage of the approach is"
4460  DATA "that common information, such as indi-"
4470  DATA "vidual sources, types, and persons'"
4480  DATA "names do not have to be typed over and"
4490  DATA "over again."
4500  DATA ".sp"
4510  DATA "A user operates from his own persona-"
4520  DATA "lized lists, which he enters only"
4530  DATA "once.  Thus, the names of sources and"
4540  DATA "types are always the same, without"
4550  DATA "differences in spellings."
4560  DATA ".sp"
4570  DATA "Since the Persons File from the Gene-"
4580  DATA "alogy ON DISPLAY programs is used, the"
4590  DATA "names of individuals are always the"
4600  DATA "same, as well."
4610  DATA ".h2 RESULTS"
4620  DATA "The final result is a well organized"
4630  DATA "set of notes, which permit a user to"
4640  DATA "keep track of whatever information"
4650  DATA "that he desires, using his personal-"
4660  DATA "izied lists of sources and types,"
4670  DATA "together with the names (and birth-"
4680  DATA "dates) of persons from his Genealogy"
4690  DATA "ON DISPLAY Persons File."
4700  DATA ".h2 REQUIREMENTS"
4710  DATA ".h3 Hardware Requirements."
4720  DATA ".sp"
4730  DATA "IBM PCjr, PC, PC/XT or PC/AT with:"
4740  DATA ".sp"
4750  DATA "  One Double-sided Diskette Drive."
4760  DATA ".sp"
4770  DATA "  Either the IBM Matrix Printer, the"
4780  DATA "  IBM Proprinter (or equivalents)."
4790  DATA ".sp"
4800  DATA "  At least 96K of Memory (128 K is"
4810  DATA "  recommended)."
4820  DATA ".sp"
4830  DATA "  Either the IBM Color Display,"
4840  DATA "  the IBM Monochrome Display (or"
4850  DATA "  equivalents)."
4860  DATA ".pa"
4870  DATA ".h3 Software Requirements."
4880  DATA ".sp"
4890  DATA "IBM PC-DOS."
4900  DATA "  Version 2.1 or later (or Version"
4910  DATA "    2.0 on the other members of the"
4920  DATA "    IBM PC Family of Computers)."
4930  DATA ".sp"
4940  DATA "BASIC"
4950  DATA "  (on Cartridge or Diskette)."
4960  DATA ".eof"
4970  END
