100  REM NOTESAND Program
110  REM Notes and Sources ON DISPLAY
120  REM By: Melvin O. Duke.    Last Updated 23 June 1986
200  REM Screen Definitions
210  S1 = 0      'Set Text Mode
220  S2 = 1      'Enable Color
230  S3 = 0      'Active Page
240  S4 = 0      'Visual Page
250  WIDTH "scrn:",80
260  SCREEN S1, S2, S3, S4
300  REM Color Definitions
310  K = 0       'blacK
320  N = 1       'blue (Navy or uNderline)
330  G = 2       'Green
340  B = 3       'cyan (light Blue)
350  RED = 4     'Red
360  P = 5       'magenta (Purple)
370  O = 6       'brown (Orange)
380  W = 7       'white
400  REM Disk Definitions
410  DD.VERI$ = "a:"     'Verify /s:256
420  DD.NOTE$ = "a:"     'Note File
430  DD.PERS$ = "a:"     'Persons File
440  DD.SOUR$ = "a:"     'Sources
450  DD.TYPE$ = "a:"     'Types
460  DD.HIGH$ = "a:"     'Highest Note-record
500  REM Printer Definitions
510  PAGE.EJECT$ = CHR$(12)        'Skip to Top of Next Page
600  REM Maximums
610  MAX.PER = 500   'Same as Genealogy ON DISPLAY Persons File
620  LDIM = 0
630  UDIM = 12
640  VSCR = 21
650  PSCR = INT(MAX.PER/12)+1
700  REM Titles
710  TITLE$ = "Notes and Sources ON DISPLAY"
720  VERSION$ = "Version 1.1"
730  COPY1$ = "Copyright (c) 1986,"
740  COPY2$ = "by: Melvin O. Duke"
750  COPY3$ = "All Rights Reserved"
800  REM Make sure that BASIC was invoked with /s:256
810  ON ERROR GOTO 870
820  OPEN DD.VERI$+"verifile" AS #2 LEN = 256
830  ON ERROR GOTO 0
840  FIELD 2, 128 AS DUMY1$, 128 AS DUMY2$
850  CLOSE #2
860  GOTO 1000
870  IF ERR = 5 THEN 880 ELSE ON ERROR GOTO 0 : GOTO 820
880  REM File Buffer less than 256 bytes
890  KEY ON : CLS : LOCATE 10,1 : COLOR R,B
900  PRINT "BASIC must be brought up with /s:256, for Genealogy Records."
910  PRINT "Program has been Terminated."
920  PRINT "Enter CONT to return to DOS"
930  COLOR W,K : STOP
940  CLOSE #1
950  SYSTEM
1000  REM Dimension Statements for Messages and Vectors
1010  DIM MSG$(39)
1020  DIM VECT2$(UDIM*VSCR), VECT3$(UDIM*VSCR)
1100  REM Messages
1110  MSG$(1) = "Persons"
1120  MSG$(2) = "Types"
1130  MSG$(5) = "Sources"
1140  MSG$(6) = "Researched :"
1150  MSG$(7) = "Person     :"
1160  MSG$(10) = "Source     :"
1170  MSG$(12) = "Type       :"
1180  MSG$(13) = "Event Date :"
1190  MSG$(15) = "Note:"
1200  MSG$(16) = "Notes and Sources"
1210  MSG$(18) = "Research"
1220  MSG$(19) = "Persons"
1230  MSG$(20) = "Source"
1240  MSG$(22) = "Type"
1250  MSG$(23) = "Event Date"
1260  MSG$(24) = "Note"
1270  MSG$(25) = "Event"
1280  MSG$(29) = "Are "
1290  MSG$(30) = "Source is "
1300  MSG$(31) = "Person is "
1310  MSG$(33) = "Type is "
1320  MSG$(34) = "Person: "
1330  MSG$(35) = "Source: "
1340  MSG$(37) = "Type  : "
1350  MSG$(38) = "Note : "
1400  REM Produce the first screen
1410  KEY OFF : CLS
1420  REM Draw the outer double box
1430  R1 = 1 : C1 = 1 : R2 = 24 : C2 = 79 : GOSUB 12030
1440  REM Find the title location
1450  TITLE.POS = 40 - INT(LEN(TITLE$)/2)
1460  REM Draw the title box
1470  R1=2:C1=TITLE.POS-2:R2=5:C2=TITLE.POS+LEN(TITLE$)+1:GOSUB 12200
1480  REM Print the Program Title and Version
1490  LOCATE 3,TITLE.POS : PRINT TITLE$
1500  LOCATE 4,39-INT(LEN(VERSION$)/2) :  PRINT VERSION$;
1510  '
1520  REM Draw the Box to Identify the Collection of Programs
1530  R1 = 6 : C1 =  5 : R2 = 18 : C2 = 75 : GOSUB 12030
1540  REM Fill in the Box with Descriptions
1550  LOCATE  8,10
1560  PRINT " If you are using this program, you are expected to become a"
1570  LOCATE  9,10
1580  PRINT "Registered User, by making a contribution to the author of the"
1590  LOCATE 10,10
1600  PRINT "program ($30.00 suggested for Registered Users of Genealogy ON"
1610  LOCATE 11,10
1620  PRINT "           DISPLAY, otherwise, $45.00 suggested)."
1630  REM Draw the Box to Identify the Use, and Fill it in
1640  R1 = 12 : C1 = 28 : R2 = 17 : C2 = 52 : GOSUB 12200
1650  LOCATE 13,33 : PRINT "Melvin O. Duke"
1660  LOCATE 14,33 : PRINT "P.O. Box 20836"
1670  LOCATE 15,31 : PRINT "San Jose, CA  95160"
1680  LOCATE 16,33 : PRINT "(408) 268-6637"
1690  '
1700  REM Draw the Copyright box
1710  R1 = 19 : C1 = 24 : R2 = 23 : C2 = 56 : GOSUB 12030
1720  REM Print the Copyright
1730  LOCATE 20,40-INT(LEN(COPY1$)/2) :  PRINT COPY1$;
1740  LOCATE 21,40-INT(LEN(COPY2$)/2) :  PRINT COPY2$;
1750  LOCATE 22,40-INT(LEN(COPY3$)/2) :  PRINT COPY3$;
1760  '
1770  REM ask user to press a key to continue
1780  LOCATE 25,1
1790  PRINT "Press any key to continue.";
1800  K$ = INKEY$ : IF K$ = "" THEN 1800
1810  '
1820  REM Establish the Data File and its Appearance
1830  GOSUB 1850  'To Open the File and Set the Field
1840  GOTO 1880
1850  OPEN DD.NOTE$+"notefile" AS #1 LEN = 108
1860  FIELD 1, 8 AS F1$, 2 AS F2$, 2 AS F5$, 2 AS F7$, 11 AS F8$, 11 AS F10$, 72 AS F11$
1870  RETURN
1880  CLOSE #1
1890  '
1900  KEY ON : CLS : KEY OFF
1910  LOCATE 23,1
1920  '
1930  REM Access the Persons File
1940  PRINT "Preparing ";MSG$(1)
1950  GOSUB 1960 : GOTO 1990
1960  OPEN DD.PERS$+"persfile" AS #2 LEN = 256
1970  FIELD 2, 5 AS P1$, 20 AS P2$, 30 AS P3$, 2 AS P4$, 5 AS P5$, 5 AS P6$, 5 AS P7$, 11 AS P8$, 18 AS P9$, 16 AS P10$, 16 AS P11$, 11 AS P12$, 18 AS P13$, 16 AS P14$, 16 AS P15$, 11 AS P16$, 18 AS P17$, 16 AS P18$, 16 AS P19$
1980  RETURN
1990  CLOSE #2
2000  '
2010  REM Obtain The Record Types
2020  PRINT "Preparing ";MSG$(2)
2030  OPEN DD.TYPE$+"typefile" FOR INPUT AS #2
2040  FOR CT = LDIM TO VSCR*UDIM
2050   LINE INPUT #2, VECT3$(CT)
2060  NEXT CT
2070  CLOSE #2
2080  '
2090  REM Obtain The Sources
2100  PRINT "Preparing ";MSG$(5)
2110  OPEN DD.SOUR$+"sourfile" FOR INPUT AS #2
2120  FOR CT = LDIM TO VSCR*UDIM
2130   LINE INPUT #2, VECT2$(CT)
2140  NEXT CT
2150  CLOSE #2
2160  '
2170  PRINT "Preparing Current Limits of Records"
2180  OPEN DD.HIGH$+"high" FOR INPUT AS #3
2190   INPUT #3, MAX.REC
2200   INPUT #3, HIGH.REC
2210  CLOSE #3
2220  '
2230  REM Draw the Menu of available user actions.
2240  KEY ON : CLS : KEY OFF
2250  REM Draw the Outer Double Box.
2260  R1 = 1 : C1 = 1 : R2 = 19 : C2 = 79 : GOSUB 12030
2270  REM Draw the Heading Separator.
2280  R1 = 3 : C1 = 1 : R2 = 3 : C2 = 79 : GOSUB 12470
2290  REM Draw the Vertical Separators.
2300  R1 = 1 : C1 = 6 : R2 = 19 : C2 = 6 : GOSUB 12670
2310  REM Attach the intersections
2320  COLOR P,K
2330  LOCATE 3, 6 : PRINT CHR$(197);
2340  '
2350  REM Print the content of the menu.
2360  COLOR K,W
2370  LOCATE 2,3 : PRINT "No";
2380  LOCATE 2,8 : PRINT "Available Functions in " + TITLE$
2390  COLOR K,W : LOCATE  5,3 : PRINT " 1"; : COLOR RED,K
2400  LOCATE  5,  8 : PRINT "Create a New ";MSG$(24);" File.";
2410  COLOR K,W : LOCATE  7,3 : PRINT " 2"; : COLOR RED,K
2420  LOCATE  7,  8 : PRINT "Extend the ";MSG$(24);" File by 100 records.";
2430  COLOR K,W : LOCATE  9,3 : PRINT " 3"; : COLOR G,K
2440  LOCATE  9,  8 : PRINT "Personalize or Redefine the ";MSG$(5);
2450  COLOR K,W : LOCATE 11,3 : PRINT " 4"; : COLOR G,K
2460  LOCATE 11,  8 : PRINT "Personalize or Redefine the ";MSG$(2);
2470  COLOR K,W : LOCATE 13,3 : PRINT " 5"; : COLOR O,K
2480  LOCATE 13,  8 : PRINT "Enter or Update ";MSG$(24);" Information."
2490  COLOR K,W : LOCATE 15,3 : PRINT " 6"; : COLOR O,K
2500  LOCATE 15,  8 : PRINT "Inquiry for Display or Printing."
2510  COLOR K,W : LOCATE 17,3 : PRINT " 7"; : COLOR W,K
2520  LOCATE 17, 8 : PRINT "Menu of Functions in " + TITLE$ + " (This screen)."
2530  '
2540  REM Now obtain User Response
2550  LOCATE 23,1
2560  LINE INPUT "Type a Function Number (0 to quit), and press the 'enter' key: ", REPLY$
2570  IF REPLY$ = "0" THEN 12770
2580  REPLY = VAL(REPLY$)
2590  IF REPLY > 0 AND REPLY < 8 THEN 2680
2600  LOCATE 22,1 : PRINT "Function Number is Out of Range";
2610  LOCATE 25,1 : PRINT "Press any key to continue";
2620  A$ = INKEY$ : IF A$ = "" THEN 2620
2630  GOSUB 12830
2640  GOSUB 12840
2650  GOSUB 12850
2660  GOSUB 12860
2670  GOTO 2540
2680  IF REPLY =  1 THEN 2770  'Create a New File
2690  IF REPLY =  2 THEN 3400  'Extend the File by 100 Records
2700  IF REPLY =  3 THEN 7970  'Update Sources
2710  IF REPLY =  4 THEN 7540  'Update Types
2720  IF REPLY =  5 THEN 3530  'Update the Note Records
2730  IF REPLY =  6 THEN 8400  'Inquiry Routine
2740  IF REPLY =  7 THEN 2230  'Re-draw the Menu
2750  LOCATE 22,1 : PRINT "Function Number must be a whole number"; : GOTO 2610
2760  '
2770  REM Routine to Write a New File
2780  REM First, produce a Warning Message before writing new file.
2790  KEY ON : CLS : KEY OFF
2800  REM Draw the outer double box
2810  R1 = 1 : C1 = 1 : R2 = 21 : C2 = 79 : GOSUB 12030
2820  COLOR RED,K
2830  LOCATE 8,10
2840  PRINT "          ***  WARNING ***"
2850  LOCATE 10,3
2860  PRINT "This function creates a new ";MSG$(24);" File by completely"
2870  LOCATE 11,3
2880  PRINT "removing the old file (if one exists), and by writing 100 new,"
2890  LOCATE 12,3
2900  PRINT "empty records.  Only the new file will now exist."
2910  COLOR G,K
2920  LOCATE 14,3
2930  PRINT "If this is REALLY what you want to do,"
2940  LOCATE 15,3
2950  PRINT "type y (yes), and press the 'enter' key."
2960  LOCATE 17,3
2970  PRINT "Otherwise, type n (no), and press the 'enter' key."
2980  COLOR W,K
2990  LOCATE 23,1
3000  LINE INPUT "Enter your desired action: ",REPLY$
3010  IF LEFT$(REPLY$,1) = "y" THEN 3100
3020  IF LEFT$(REPLY$,1) = "Y" THEN 3100
3030  PRINT
3040  PRINT "File was NOT Created."
3050  PRINT
3060  PRINT "Press any key to continue"
3070  A$ = INKEY$ : IF A$ = "" THEN 3070
3080  GOTO 2230  'return to the menu
3090  '
3100  REM Routine to Create a Data File
3110  KILL DD.NOTE$+"notefile"  'Get rid of any old file that exists
3120  GOSUB 1850  'To Open the File and Set the Field
3130  LOCATE 23,1 : PRINT SPACE$(79)
3140  LOCATE 23,1 : PRINT "Writing Record Number:";
3150  MAX.REC = 100  'Set size of new Data File
3160  GOSUB 3210     'To write 100 Records
3170  HIGH.REC = 0   'Set new Highest Record used
3180  GOSUB 12880    'To file the new maximums
3190  GOTO 2230      'Return to the Main Menu
3200  '
3210  REM Routine to Write 100 new Data Records
3220  FOR I = MAX.REC - 99 TO MAX.REC
3230   TEMP = -I
3240   TEMP$ = MKD$(TEMP)
3250   LSET F1$ = TEMP$       'record number
3260   TEMP$ = " "
3270   TEMP = 0
3280   LSET F2$ = MKI$(TEMP)  'Person Number
3290   LSET F5$ = MKI$(TEMP)  'Source Number
3300   LSET F7$ = MKI$(TEMP)  'Type Number
3310   LSET F8$ = TEMP$       'Event Date
3320   LSET F10$ = TEMP$      'Research Date
3330   LSET F11$ = TEMP$      'Description
3340   LOCATE 23,24 : PRINT I;
3350   PUT #1, I
3360  NEXT I
3370  CLOSE #1
3380  RETURN
3390  '
3400  REM Routine to Extend the Data File by Another 100 Records
3410  IF HIGH.REC >=0 THEN 3450
3420  KEY ON : CLS : KEY OFF
3430  LOCATE 21,1 : PRINT "Cannot Extend a File that Has not Yet Been Created.";
3440  GOTO 3580
3450  GOSUB 1850  'To Open the File and Set the Field
3460  GOSUB 12840
3470  LOCATE 23,1 : PRINT "Writing Record Number:";
3480  MAX.REC = MAX.REC + 100
3490  GOSUB 3210   'To write 100 more records
3500  GOSUB 12880  'To file the new maximums
3510  GOTO 2230    'Return to the Main Menu
3520  '
3530  REM Routine to Enter or Update Data File Records
3540  REM Test to see that the File has been Created
3550  IF HIGH.REC >=0 THEN 3630
3560  KEY ON : CLS : KEY OFF
3570  LOCATE 21,1 : PRINT "Cannot Update a File that Has not Yet Been Created.";
3580  LOCATE 22,1 : PRINT "Select the Creation of a New File from the Menu.";
3590  LOCATE 24,1 : PRINT "Press any key to continue";
3600  A$ = INKEY$ : IF A$ = "" THEN 3600
3610  GOTO 2230  'Main menu
3620  '
3630  REM Open the File and draw the Screen
3640  Q1 = 0 : Q2$ = ""
3650  Q3$ = "" : Q8$ = ""
3660  GOSUB 1850  'To Open the File and Set the Field
3670  REC.NO = 1 : Q1 = 0
3680  KEY ON : CLS : KEY OFF  'Screen Refresh returns here
3690  REM Reset all Variables
3700  T1 = 0 : TQ1 = 0 : TQ2$ = " " : TQ3$ = " " : TQ8$ = " "
3710  GOSUB 3720 : GOTO 3810
3720  REM Draw the Outer Box
3730  R1 = 1 : C1 = 1 : R2 = 21 : C2 = 79 : GOSUB 12030
3740  REM Draw the Heading Separator
3750  R1 = 3 : C1 = 1 : R2 = 3 : C2 = 79 : GOSUB 12370
3760  REM Draw the Vertical Separator
3770  R1 = 3 : C1 = 40 : R2 = 17 : C2 = 40 : GOSUB 12570
3780  R1 = 17 : C1 = 1 : R2 = 17 : C2 = 40 : GOSUB 12370
3790  COLOR P,K : LOCATE 17,40 : PRINT CHR$(188); : COLOR W,K
3800  RETURN
3810  LOCATE 2,3 : PRINT MSG$(24) + " Entry or Update";
3820  LOCATE 23,1
3830  LINE INPUT "Enter Note Number to Update (0 to quit, ? next available): ",REPLY$
3840  REM test for validity of record number
3850  IF REPLY$ = "?" THEN 3870 ELSE 4190
3860  '
3870  REM Routine to Locate an Empty Record
3880  SWITCH = 0
3890  FOR LOOK = REC.NO TO MAX.REC
3900   LOCATE 22,1 : PRINT "Searching Note Record"; LOOK;
3910   REM Obtain the Next Record
3920   GET #1, LOOK
3930   REM Extract the Data
3940   T1 = CVD(F1$)
3950   IF T1 > 0 THEN 4000  'Bypass if Positive
3960   GOSUB 6980  'to Extract the pertinent data
3970   REM If Negative, then found an empty
3980   IF T1 < 0 THEN REC.NO = LOOK : LOOK = MAX.REC : GOTO 4130
3990   '
4000   REM Test for Top-of-file condition
4010   IF LOOK < MAX.REC THEN 4130
4020   IF LOOK = MAX.REC AND T1 > 0 THEN 4030 ELSE 4130
4030   SWITCH = 1
4040   GOSUB 12830 : LOCATE 22,1
4050   PRINT "No empty notes at the top of the file.";
4060   GOSUB 12840 : LOCATE 23,1
4070   PRINT "File must be extended.";
4080   GOSUB 12850 : LOCATE 24,1
4090   PRINT "Select #2, Extend the File, from the main menu.";
4100   GOSUB 12860 : LOCATE 25,1
4110   PRINT "Press any key to continue.";
4120   A$ = INKEY$ : IF A$ = "" THEN 4120
4130  NEXT LOOK
4140  '
4150  REM Test if no records available
4160  IF SWITCH = 1 THEN CLOSE #1 : GOTO 2230  'Return to menu
4170  GOTO 4240
4180  '
4190  REM Test Validity of User-specified Record-number
4200  IF REPLY$ = "0" THEN CLOSE #1 : GOTO 2230  'Return to main menu
4210  REC.NO = VAL(REPLY$)
4220  IF REC.NO < 1 OR REC.NO > MAX.REC THEN 6670 ELSE 4240
4230  '
4240  REM obtain the record
4250  GET #1, REC.NO
4260  GOSUB 6980  'to Extract the pertinent data
4270  GOSUB 4300  'to draw the right half of the screen
4280  GOTO 4770  'to continue the program
4290  '
4300  REM Routine to Draw the Right Half of the Screen
4310  LOCATE  2,67 : PRINT "Note:";
4320  LOCATE  2,74 : PRINT SPACE$(5);
4330  LOCATE  2,74 : PRINT T1;
4340  LOCATE  4,55 : COLOR K,W : PRINT "Descriptions";
4350  LOCATE  6,42 : COLOR O,K : PRINT MSG$(6);
4360  LOCATE  6,55 : PRINT SPACE$(23);
4370  LOCATE  6,55 : COLOR G,K : PRINT T10$;
4380  LOCATE  8,42 : COLOR O,K : PRINT MSG$(7);
4390  LOCATE  8,55 : PRINT SPACE$(5);
4400  IF T2 = 0 THEN NM$ = " " : GOTO 4500
4410  GOSUB 1960 'Open
4420  GET #2, T2
4430  TQ1  = CVS(P1$)
4440  TQ2$ = P2$
4450  RTRM$ = TQ2$ : GOSUB 12950 : TQ2$ = RTRM$
4460  TQ3$ = P3$
4470  RTRM$ = TQ3$ : GOSUB 12950 : TQ3$ = RTRM$
4480  TQ8$ = P8$
4490  CLOSE #2
4500  LOCATE  8,55 : COLOR G,K : PRINT TQ1;
4510  LOCATE  9,46 : PRINT SPACE$(30);
4520  LOCATE  9,46 : COLOR G,K : PRINT LEFT$(TQ3$,30);
4530  LOCATE 10,46 : PRINT SPACE$(20);
4540  LOCATE 10,46 : COLOR G,K : PRINT LEFT$(TQ2$,20);
4550  LOCATE 11,46 : PRINT SPACE$(11);
4560  LOCATE 11,46 : COLOR G,K : PRINT LEFT$(TQ8$,11);
4570  LOCATE 13,42 : COLOR O,K : PRINT MSG$(10);
4580  LOCATE 13,55 : PRINT SPACE$(6);
4590  LOCATE 13,55 : COLOR G,K : PRINT T5;
4600  LOCATE 14,46 : PRINT SPACE$(32);
4610  LOCATE 14,46 : COLOR G,K : PRINT VECT2$(T5);
4620  LOCATE 15,42 : COLOR O,K : PRINT MSG$(12);
4630  LOCATE 15,55 : PRINT SPACE$(6);
4640  LOCATE 15,55 : COLOR G,K : PRINT T7;
4650  LOCATE 16,46 : PRINT SPACE$(32);
4660  LOCATE 16,46 : COLOR G,K : PRINT VECT3$(T7);
4670  LOCATE 17,42 : COLOR O,K : PRINT MSG$(13);
4680  LOCATE 17,55 : PRINT SPACE$(23);
4690  LOCATE 17,55 : COLOR G,K : PRINT T8$;
4700  LOCATE 18,3  : PRINT SPACE$(15);
4710  LOCATE 18,3  : COLOR O,K : PRINT MSG$(38);
4720  LOCATE 20,3  : PRINT SPACE$(72);
4730  LOCATE 20,3  : COLOR G,K : PRINT LEFT$(T11$,72);
4740  COLOR W,K
4750  RETURN
4760  '
4770  REM Obtain User Input
4780  REM blank the left-side of the screen
4790  FOR R = LDIM TO UDIM
4800   LOCATE 4+R,3 : PRINT SPACE$(37);
4810  NEXT R
4820  LOCATE 24,1 : PRINT "('enter' to leave alone, '/ enter' to end description,)";
4830  LOCATE 25,1 : PRINT "(or reply as shown.)";
4840  REM Obtain the Note Number
4850  GOSUB 12830
4860  GOSUB 12840 : LOCATE 23,1
4870  LINE INPUT "Enter the Note Number: ", REPLY$
4880  TT1 = VAL(REPLY$)
4890  IF ABS(TT1) = ABS(T1) THEN 5000
4900  '
4910  REM Validate the Note-number
4920  IF REPLY$ = "" AND T1 > 0 THEN 5000
4930  IF REPLY$ = "/" THEN 5000
4940  LOCATE 23,1 : PRINT "Cannot Change the Note Number Value, or leave negative.";
4950  GOSUB 12860
4960  LOCATE 25,1 : PRINT "Press any key to continue";
4970  A$ = INKEY$ : IF A$ = "" THEN 4970
4980  GOTO 3670   'Data File Update
4990  '
5000  REM Accept the Note Number
5010  IF REPLY$ = "" THEN 5150
5020  IF REPLY$ = "/" THEN 6360
5030  IF TT1 >= 0 THEN 5120  'To continue
5040  '
5050  REM Blank Note with Negative Number
5060  T1 = TT1 : T2 = 0 : T5 = 0 : T6 = 0 : T7 = 0
5070  T8$ = " " : T10$ = " " : T11$ = " "
5080  TQ1 = 0 : TQ2$ = " " : TQ3$ = " " : TQ8$ = " "
5090  GOSUB 4300  'to reprint
5100  GOTO 6360  'for save, more, or forget
5110  '
5120  T1 = TT1
5130  GOSUB 4300  'to reprint
5140  '
5150  REM Obtain the Researched Date
5160  GOSUB 12840 : LOCATE 23,1
5170  PRINT "Enter the ";MSG$(18);" date as: 18 Nov 1986, or t (for today): ";
5180  LINE INPUT "", REPLY$
5190  IF REPLY$ = CHR$(34)+" "+CHR$(34) THEN REPLY$ = " "
5200  IF REPLY$ = "" THEN 5260
5210  IF REPLY$ = "/" THEN 6360
5220  IF REPLY$ = "t" THEN GOSUB 6790 : REPLY$ = C$
5230  IF REPLY$ = "T" THEN GOSUB 6790 : REPLY$ = C$
5240  T10$ = SPACE$(11) : RSET T10$ = REPLY$
5250  GOSUB 4300  'to reprint
5260  '
5270  REM Obtain Vector 1 Number
5280  VT = 1 : VSCR = PSCR
5290  MESSV$ = MSG$(19)
5300  GOSUB 5330
5310  IF REPLY$ = "/" THEN CLOSE #2 : GOTO 6360
5320  GOTO 5940 'After Vectors
5330  REM Obtain any Vector Number
5340  LOCATE 4,8 : COLOR K,W : PRINT "Choices"; : COLOR W,K
5350  ADJUST = -UDIM : GOTO 5600
5360  GOSUB 1960  'Open the Persons File
5370  FOR R = LDIM + 1 TO UDIM
5380   IF R+ADJUST > MAX.PER THEN R = UDIM : GOTO 5580
5390   LOCATE 4+R, 3 : PRINT SPACE$(37);
5400   NMBR$ = SPACE$(4)
5410   COLOR K,W
5420   RSET NMBR$ = RIGHT$(STR$(R+ADJUST),4)
5430   LOCATE 4+R,3 : PRINT NMBR$;
5440   COLOR G,K
5450   PRINT " ";
5460   IF VT = 1 THEN 5470 ELSE 5560
5470   REM Get a Person from the Genealogy File
5480   GET #2, R+ADJUST
5490   Q2$ = P2$
5500   RTRM$ = Q2$ : GOSUB 12950 : Q2$ = RTRM$
5510   Q3$ = P3$
5520   RTRM$ = Q3$ : GOSUB 12950 : Q3$ = RTRM$
5530   NM$ = Q3$+" "+Q2$
5540   NM$ = LEFT$(NM$,32)
5550   PRINT NM$
5560   IF VT = 2 THEN PRINT VECT2$(R+ADJUST);
5570   IF VT = 3 THEN PRINT VECT3$(R+ADJUST);
5580  NEXT R
5590  CLOSE #2
5600  COLOR W,K
5610  GOSUB 12830 : GOSUB 12860
5620  IF ADJUST >= (VSCR-1)*UDIM THEN LOCATE 25,1:PRINT "(or reply as shown.)";
5630  IF ADJUST >= (VSCR-1)*UDIM THEN 5650 'bypass last one
5640  LOCATE 25,1 : PRINT "('\ enter' for partial list, or reply as shown.)";
5650  GOSUB 12840 : LOCATE 23,1
5660  PRINT "Enter the ";MESSV$;" Number: ";
5670  LINE INPUT "", REPLY$
5680  IF REPLY$ = "" THEN 5910
5690  IF REPLY$ = "/" THEN 5910
5700  IF REPLY$ <> "\" THEN 5740
5710  ADJUST = ADJUST + UDIM
5720  IF ADJUST >= VSCR * UDIM THEN REPLY$ = "" : GOTO 5910
5730  GOTO 5360 'For more choices
5740  TX = VAL(REPLY$)
5750  '
5760  REM Validate the User Response
5770  IF TX > MAX.PER THEN 5790
5780  IF TX >  LDIM AND TX <= VSCR*UDIM THEN 5860
5790  LOCATE 22,1 : PRINT "Error in Reply";
5800  GOSUB 12860 : LOCATE 25,1 : PRINT "Press any key to continue";
5810  A$ = INKEY$ : IF A$ = "" THEN 5810
5820  IF VT = 1 THEN T2 = 0
5830  IF VT = 2 THEN T5 = 0
5840  IF VT = 3 THEN T7 = 0
5850  GOTO 5610   'for better reply
5860  REM Store the Values
5870  IF VT = 1 THEN T2 = TX
5880  IF VT = 2 THEN T5 = TX
5890  IF VT = 3 THEN T7 = TX
5900  GOSUB 4300  'to reprint
5910  LOCATE 25,1 : PRINT SPACE$(79);
5920  RETURN
5930  '
5940  REM after Vectors
5950  '
5960  REM Obtain Source Number
5970  VT = 2 : VSCR = 21
5980  MESSV$ = MSG$(20)
5990  GOSUB 6100 : GOSUB 5330
6000  IF REPLY$ = "/" THEN 6360
6010  '
6020  REM Obtain Note Number
6030  VT = 3 : VSCR = 21
6040  MESSV$ = MSG$(22)
6050  GOSUB 6100 : GOSUB 5330
6060  IF REPLY$ = "/" THEN 6360
6070  '
6080  REM Obtain the Event Date
6090  GOSUB 6100 : GOTO 6140
6100  FOR R = LDIM +1 TO UDIM
6110   LOCATE 4+R, 3 : PRINT SPACE$(37);
6120  NEXT R
6130  RETURN
6140  LOCATE 25,1 : PRINT "(or reply as shown.)";
6150  GOSUB 12840 : LOCATE 23,1
6160  PRINT "Enter the ";MSG$(23);" as: 11 Nov 1948 (or 't' for today): ";
6170  LINE INPUT "", REPLY$
6180  IF REPLY$ = CHR$(34)+" "+CHR$(34) THEN REPLY$ = " "
6190  IF REPLY$ = "" THEN 6260
6200  IF REPLY$ = "/" THEN 6360
6210  IF REPLY$ = "t" THEN GOSUB 6790 : REPLY$ = C$
6220  IF REPLY$ = "T" THEN GOSUB 6790 : REPLY$ = C$
6230  RSET T8$= REPLY$
6240  GOSUB 4300  'to reprint
6250  '
6260  '
6270  REM Obtain the Note
6280  GOSUB 12840 : LOCATE 23,1
6290  LINE INPUT "Note: ", REPLY$
6300  IF REPLY$ = CHR$(34)+" "+CHR$(34) THEN REPLY$ = " "
6310  IF REPLY$ = "" THEN 6360
6320  IF REPLY$ = "/" THEN 6360
6330  T11$= LEFT$(REPLY$,72)
6340  GOSUB 4300  'to reprint
6350  '
6360  REM Let User decide whether to save, ignore, or do some more
6370  GOSUB 12830
6380  GOSUB 12850 : GOSUB 12860
6390  GOSUB 12840 : LOCATE 23,1
6400  LINE INPUT "Type s (save), m (more), or f (forget), and press the 'enter' key: ", REPLY$
6410  IF LEFT$(REPLY$,1) = "m" THEN GOSUB 12840 : GOTO 4770
6420  IF LEFT$(REPLY$,1) = "M" THEN GOSUB 12840 : GOTO 4770
6430  IF LEFT$(REPLY$,1) = "f" THEN REC.NO = ABS(T1) : GOTO 3680
6440  IF LEFT$(REPLY$,1) = "F" THEN REC.NO = ABS(T1) : GOTO 3680
6450  IF LEFT$(REPLY$,1) = "s" THEN GOSUB 12840 : GOTO 6500
6460  IF LEFT$(REPLY$,1) = "S" THEN GOSUB 12840 : GOTO 6500
6470  LOCATE 22,1 : PRINT "Error in Reply"
6480  GOTO 6380  'For better reply
6490  '
6500  REM Save has been indicated
6510   REC.NO = ABS(T1)
6520   LSET F1$  = MKD$(T1)  'Note Number
6530   LSET F2$  = MKI$(T2)  'Person Number
6540   LSET F5$  = MKI$(T5)  'Source Number
6550   LSET F7$  = MKI$(T7)  'Type Number
6560   RSET F8$  = T8$       'Event Date
6570   RSET F10$ = T10$      'Research Date
6580   LSET F11$ = T11$      'Description
6590   PUT #1, ABS(T1)
6600  IF T1 <= HIGH.REC THEN 6650
6610  '
6620  REM File the new Maximums
6630  HIGH.REC = T1
6640  GOSUB 12880  'To File the Maximums
6650  GOTO 3680  'for next record
6660  '
6670  REM Error in User-specified Note Number
6680  LOCATE 22,1 : PRINT "Note Number is out of range";
6690  LOCATE 24,1 : PRINT "Press any key to continue";
6700  A$ = INKEY$ : IF A$ = "" THEN 6700
6710  GOTO 3670  'for screen refresh
6720  '
6730  REM Subroutines Follow
6740  REM Routine to establish user action
6750  LOCATE 24,1 : PRINT "('enter to leave alone, '/ enter' to end description,)';
6760  LOCATE 25,1 : PRINT "('\ enter' to continue list, or reply as shown.)';
6770  RETURN
6780  '
6790  REM Routine to change the System Date to a Genealogical Date
6800  B$ = DATE$
6810  C$ = MID$(B$,4,2) + " "
6820  IF LEFT$(B$,2) = "01" THEN C$ = C$ + "Jan "
6830  IF LEFT$(B$,2) = "02" THEN C$ = C$ + "Feb "
6840  IF LEFT$(B$,2) = "03" THEN C$ = C$ + "Mar "
6850  IF LEFT$(B$,2) = "04" THEN C$ = C$ + "Apr "
6860  IF LEFT$(B$,2) = "05" THEN C$ = C$ + "May "
6870  IF LEFT$(B$,2) = "06" THEN C$ = C$ + "Jun "
6880  IF LEFT$(B$,2) = "07" THEN C$ = C$ + "Jul "
6890  IF LEFT$(B$,2) = "08" THEN C$ = C$ + "Aug "
6900  IF LEFT$(B$,2) = "09" THEN C$ = C$ + "Sep "
6910  IF LEFT$(B$,2) = "10" THEN C$ = C$ + "Oct "
6920  IF LEFT$(B$,2) = "11" THEN C$ = C$ + "Nov "
6930  IF LEFT$(B$,2) = "12" THEN C$ = C$ + "Dec "
6940  C$ = C$ + RIGHT$(B$,4)
6950  IF LEFT$(C$,1) = "0" THEN MID$(C$,1,1) = " "
6960  RETURN
6970  '
6980  REM Routine to Extract Data from a Data Record
6990  T1 = CVD(F1$)  'Note Number
7000  T2 = CVI(F2$)  'Person Number
7010  T5 = CVI(F5$)  'Source Number
7020  T7 = CVI(F7$)  'Type Number
7030  T8$ = F8$      'Event Date
7040  T10$ = F10$    'Research Date
7050  T11$ = F11$    'Description
7060  RETURN
7070  '
7080  REM Personalization Occurs Here
7090  FOR ISC = 0 TO NSCR-1
7100   LOW = LDIM+1 : TOP = UDIM
7110   GOSUB 7130  'to Print
7120   GOTO 7270  'to Obtain User Input
7130   FOR JSC = LOW TO TOP
7140    THISONE = (ISC*UDIM)+JSC
7150    LOCATE 4+JSC,3 : PRINT SPACE$(37);
7160    NMBR$ = SPACE$(3)
7170    COLOR K,W
7180    RSET NMBR$ = RIGHT$(STR$(THISONE),3)
7190    LOCATE 4+JSC,3 : PRINT NMBR$;
7200    COLOR G,K
7210    PRINT " ";
7220    IF VT = 2 THEN PRINT VECT2$(THISONE);
7230    IF VT = 3 THEN PRINT VECT3$(THISONE);
7240   NEXT JSC
7250   COLOR W,K
7260   RETURN
7270   FOR KSC = LDIM+1 TO UDIM
7280    THATONE = (ISC*UDIM)+KSC
7290    GOSUB 12840 : LOCATE 23,1
7300    PRINT "Enter the ";MESSB$;THATONE;"Description: ";
7310    LINE INPUT "", REPLY$
7320    IF REPLY$ = CHR$(34)+" "+CHR$(34) THEN REPLY$ = " "
7330    REPLY$ = LEFT$(REPLY$,32)
7340    IF REPLY$ = "/" THEN KSC = UDIM : ISC = NSCR-1 : GOTO 7400
7350    IF REPLY$ = "\" THEN KSC = UDIM : GOTO 7400
7360    IF REPLY$ = "" THEN 7390
7370    IF VT = 2 THEN VECT2$(THATONE) = REPLY$
7380    IF VT = 3 THEN VECT3$(THATONE) = REPLY$
7390    LOW = (KSC +1 MOD UDIM) -1 : TOP = LOW : GOSUB 7130  'to Print
7400   NEXT KSC
7410  NEXT ISC
7420  RETURN
7430  '
7440  REM
7450  REM Draw the Form
7460  GOSUB 3720
7470  LOCATE 2,3 : PRINT "Update the ";MESSB$;" Descriptions";
7480  COLOR K,W : LOCATE 4, 7 : PRINT MESSB$;" Descriptions";
7490  COLOR W,K
7500  LOCATE 24,1 : PRINT "('enter' to leave alone, '/ enter' to end description,)";
7510  LOCATE 25,1 : PRINT "('\ enter' for partial list, or reply as shown.)";
7520  RETURN
7530  '
7540  REM Routine to Update Vector3
7550  KEY ON : CLS : KEY OFF
7560  MESSA$ = MSG$(2) : MESSB$ = MSG$(22)
7570  GOSUB 7450 'To draw the boxes
7580  VT = 3 : AR = 0 : NSCR = VSCR
7590  GOSUB 7080  'For Personalization
7600  GOTO 7620
7610  '
7620  REM Let User decide whether to save, ignore, or do some more
7630  GOSUB 12830
7640  GOSUB 12850 : GOSUB 12860
7650  GOSUB 12840 : LOCATE 23,1
7660  LINE INPUT "Type s (save), m (more), or f (forget), and press the 'enter' key: ", REPLY$
7670  IF LEFT$(REPLY$,1) = "m" THEN GOSUB 7490 : GOTO 7580
7680  IF LEFT$(REPLY$,1) = "M" THEN GOSUB 7490 : GOTO 7580
7690  IF LEFT$(REPLY$,1) = "f" THEN 7760
7700  IF LEFT$(REPLY$,1) = "F" THEN 7760
7710  IF LEFT$(REPLY$,1) = "s" THEN 7860
7720  IF LEFT$(REPLY$,1) = "S" THEN 7860
7730  LOCATE 22,1 : PRINT "Error in Reply"
7740  GOTO 7640  'For better Response
7750  '
7760  REM User wants to Forget
7770  REM Refresh the File
7780  OPEN DD.TYPE$+"typefile" FOR INPUT AS #2
7790  FOR R = LDIM TO VSCR*UDIM
7800   LOCATE 22,1 : PRINT "Refreshing the ";MESSB$;R;"description.";
7810   LINE INPUT #2, VECT3$(R)
7820  NEXT R
7830  CLOSE #2
7840  GOTO 7940  'to complete types
7850  '
7860  REM the User Wants the new Types Saved
7870  OPEN DD.TYPE$+"typefile" FOR OUTPUT AS #2
7880  FOR R = LDIM TO VSCR*UDIM
7890   LOCATE 22,1 : PRINT "Saving the ";MESSB$;R;"description.";
7900   PRINT #2, VECT3$(R)
7910  NEXT R
7920  CLOSE #2
7930  '
7940  REM Completed Types Update.
7950  GOTO 2230  'Return to Main Menu
7960  '
7970  REM Routine to Update the Sources
7980  KEY ON : CLS : KEY OFF
7990  MESSA$ = MSG$(5) : MESSB$ = MSG$(20)
8000  GOSUB 7450 'To draw the boxes
8010  VT = 2 : AR = 0 : NSCR = VSCR
8020  GOSUB 7080  'For Personalization
8030  GOTO 8050
8040  '
8050  REM Let User decide whether to save, ignore, or do some more
8060  GOSUB 12830
8070  GOSUB 12850 : GOSUB 12860
8080  GOSUB 12840 : LOCATE 23,1
8090  LINE INPUT "Type s (save), m (more), or f (forget), and press the 'enter' key: ", REPLY$
8100  IF LEFT$(REPLY$,1) = "m" THEN GOSUB 7490 : GOTO 8010
8110  IF LEFT$(REPLY$,1) = "M" THEN GOSUB 7490 : GOTO 8010
8120  IF LEFT$(REPLY$,1) = "f" THEN 8190
8130  IF LEFT$(REPLY$,1) = "F" THEN 8190
8140  IF LEFT$(REPLY$,1) = "s" THEN 8290
8150  IF LEFT$(REPLY$,1) = "S" THEN 8290
8160  LOCATE 22,1 : PRINT "Error in Reply"
8170  GOTO 8070  'for better reply
8180  '
8190  REM User wants to Forget
8200  REM Refresh the File
8210  OPEN DD.SOUR$+"sourfile" FOR INPUT AS #2
8220  FOR R = LDIM TO VSCR*UDIM
8230   LOCATE 22,1 : PRINT "Refreshing the ";MESSB$;R;"description.";
8240   LINE INPUT #2, VECT2$(R)
8250  NEXT R
8260  CLOSE #2
8270  GOTO 8370  'to complete Sources
8280  '
8290  REM the User Wants the new Sources Saved
8300  OPEN DD.SOUR$+"sourfile" FOR OUTPUT AS #2
8310  FOR R = LDIM TO VSCR*UDIM
8320   LOCATE 22,1 : PRINT "Saving the ";MESSB$;R;"description.";
8330   PRINT #2, VECT2$(R)
8340  NEXT R
8350  CLOSE #2
8360  '
8370  REM Completed Sources Update.
8380  GOTO 2230  'Return to Main Menu
8390  '
8400  REM Routine to Obtain the Inquiry from the User
8410  KEY ON : CLS : KEY OFF
8420  REM Draw the Form
8430  GOSUB 3720
8440  LOCATE 2,3 : PRINT "Request for Notes to be Displayed or Printed";
8450  '
8460  REM Establish all inquiry selections as a -1
8470  SHOW0 = -1 : SHOW1 = -1 : SHOW2 = -1
8480  SHOW3 = -1 : SHOW4 = -1 : SHOW5 = -1
8490  Q1  = 0  : Q2$ = ""
8500  Q3$ = "" : Q8$ = ""
8510  '
8520  REM Determine whether to print all of select
8530  COLOR K,W : LOCATE 4, 42 : PRINT "Choices" : COLOR W,K
8540  GOSUB 12840 : LOCATE 23,1
8550  LINE INPUT "Type a (all) or s (some) notes, and press the 'enter' key: ",REPLY$
8560  IF LEFT$(REPLY$,1) = "a" THEN 8630
8570  IF LEFT$(REPLY$,1) = "A" THEN 8630
8580  IF LEFT$(REPLY$,1) = "s" THEN 8680
8590  IF LEFT$(REPLY$,1) = "S" THEN 8680
8600  LOCATE 22,1 : PRINT "Error in Reply";
8610  GOTO 8540  'for better reply
8620  '
8630  REM User wants all Records.
8640  LOCATE 5,42 : PRINT SPACE$(36);
8650  LOCATE 5,42 : PRINT "Choose all notes.";
8660  GOTO 8740  'rejoin
8670  '
8680  REM user wants only Some records.
8690  LOCATE 5,42 : PRINT SPACE$(36);
8700  LOCATE 5,42 : PRINT "Choose all notes,";
8710  LOCATE 6,44 : PRINT SPACE$(34);
8720  LOCATE 6,44 : PRINT "Where:";
8730  SHOW0 = 0
8740  GOSUB 12830
8750  GOSUB 12840 : GOSUB 12850 : GOSUB 12860
8760  '
8770  REM Now find out just which selection is wanted.
8780  COLOR O,K
8790  LOCATE 8,42 : PRINT MSG$(7);
8800  COLOR G,K
8810  IF SHOW0 = -1 THEN LOCATE 8,55 : PRINT "(all)"; : GOTO 9560
8820  '
8830  REM Select Person Record
8840  VT = 1 : ROW = 8 : VSCR = PSCR
8850  MESS$ = MSG$(1)
8860  GOSUB 9040
8870  IF REPLY$ = "" THEN 9030
8880  SHOW1 = SHOWS
8890  COLOR G,K
8900  GOSUB 1960 'Open
8910  GET #2, SHOW1
8920  Q1  = CVS(P1$)
8930  Q2$ = P2$
8940  RTRM$ = Q2$ : GOSUB 12950 : Q2$ = RTRM$
8950  Q3$ = P3$
8960  RTRM$ = Q3$ : GOSUB 12950 : Q3$ = RTRM$
8970  Q8$ = P8$  'Birthdate
8980  CLOSE #2
8990  LOCATE ROW+0,55 : PRINT Q1;
9000  LOCATE ROW+1,46 : PRINT Q3$;
9010  LOCATE ROW+2,46 : PRINT Q2$;
9020  LOCATE ROW+3,46 : PRINT Q8$;
9030  GOTO 9560
9040  REM Show the Choices of Persons
9050  LOCATE 4,3 : PRINT SPACE$(37);
9060  COLOR K,W : LOCATE 4,8 : PRINT MESS$;" Descriptions"; : COLOR W,K
9070  ADJUST = -UDIM : GOSUB 6100 : GOTO 9340
9080  '
9090  REM Now list the current descriptions
9100  GOSUB 1960 'Open
9110  FOR R = LDIM + 1 TO UDIM
9120   IF R+ADJUST > MAX.PER THEN R = UDIM : GOTO 9310
9130   LOCATE 4+R,3 : PRINT SPACE$(37);
9140   NMBR$ = SPACE$(4)
9150   COLOR K,W
9160   RSET NMBR$ = RIGHT$(STR$(R+ADJUST),4)
9170   LOCATE 4+R,3 : PRINT NMBR$;
9180   COLOR G,K
9190   PRINT " ";
9200   IF VT = 1 THEN 9210 ELSE 9290
9210   REM Get a Record from the Persons File
9220   GET #2, R+ADJUST
9230   Q1  = CVS(P1$)
9240   Q2$ = P2$
9250   RTRM$ = Q2$ : GOSUB 12950 : Q2$ = RTRM$
9260   Q3$ = P3$
9270   RTRM$ = Q3$ : GOSUB 12950 : Q3$ = RTRM$
9280   PRINT LEFT$(Q3$+" "+Q2$,32);
9290   IF VT = 2 THEN PRINT VECT2$(R+ADJUST);
9300   IF VT = 3 THEN PRINT VECT3$(R+ADJUST);
9310  NEXT R
9320  CLOSE #2
9330  COLOR W,K
9340  GOSUB 12830
9350  GOSUB 12840 : GOSUB 12850
9360  GOSUB 12860
9370  REM Obtain User Selection of vector
9380  LOCATE 24,1 : PRINT "('enter' for (all),";
9390  IF ADJUST >= (VSCR-1)*UDIM THEN PRINT ")"; : GOTO 9410
9400  PRINT " '\ enter' for partial list,)";
9410  LOCATE 25,1 : PRINT "(or reply as shown.)";
9420  LOCATE 23,1 : PRINT "Enter the ";MESS$;" Number: ";
9430  LINE INPUT "", REPLY$
9440  IF REPLY$ = "" THEN COLOR G,K : LOCATE ROW,55 : PRINT "(all)" : COLOR W,K : GOTO 9540
9450  IF REPLY$ <> "\" THEN 9490
9460  ADJUST = ADJUST + UDIM
9470  IF ADJUST >= VSCR*UDIM THEN 9490
9480  GOTO 9090  'For more choices
9490  SHOWS = VAL(REPLY$)
9500  IF VT = 1 AND SHOWS > MAX.PER THEN 9520
9510  IF SHOWS < LDIM +1 OR SHOWS > VSCR*UDIM THEN 9520 ELSE 9540
9520  LOCATE 22,1 : PRINT "Number";SHOWS;"is out of range";
9530  GOTO 9070  'for better reply
9540  RETURN
9550  '
9560  REM continue after transfer
9570  '
9580  REM Obtain Source Selection
9590  GOSUB 12830
9600  GOSUB 12840
9610  GOSUB 12860
9620  REM Now find out just which selection is wanted.
9630  COLOR O,K
9640  LOCATE 13,42 : PRINT SPACE$(36);
9650  LOCATE 13,42 : PRINT MSG$(10);
9660  COLOR G,K
9670  IF SHOW0 = -1 THEN LOCATE 13,55 : PRINT "(all)"; : GOTO 9870
9680  REM Show the Choices
9690  LOCATE 4,3 : PRINT SPACE$(37);
9700  COLOR K,W : LOCATE 4, 8 : PRINT MSG$(5);" Descriptions"; : COLOR W,K
9710  ADJUST = -UDIM : GOSUB 6100
9720  '
9730  REM Now list the current descriptions
9740  REM Select Sources
9750  VT = 2 : ROW = 13 : VSCR = 21
9760  MESS$ = MSG$(20)
9770  GOSUB 9340
9780  IF REPLY$ = "" THEN 9850
9790  SHOW4 = SHOWS
9800  COLOR G,K
9810  LOCATE ROW,55 : PRINT SPACE$(6);
9820  LOCATE ROW,55 : PRINT SHOW4;
9830  LOCATE ROW+1,46 : PRINT SPACE$(32);
9840  LOCATE ROW+1,46 : PRINT VECT2$(SHOW4);
9850  GOTO 9870
9860  '
9870  REM Obtain Type Selection
9880  GOSUB 12830
9890  GOSUB 12840
9900  GOSUB 12860
9910  REM Now find out just which selection is wanted.
9920  COLOR O,K
9930  LOCATE 15,42 : PRINT SPACE$(36);
9940  LOCATE 15,42 : PRINT MSG$(12);
9950  COLOR G,K
9960  IF SHOW0 = -1 THEN LOCATE 15,55 : PRINT "(all)"; : GOTO 10150
9970  REM Show the Choices
9980  LOCATE 4,3 : PRINT SPACE$(37);
9990  COLOR K,W : LOCATE 4, 8 : PRINT MSG$(2);" Descriptions"; : COLOR W,K
10000  ADJUST = -UDIM : GOSUB 6100
10010  REM Now list the current Types
10020  REM Select Vector 3
10030  VT = 3 : ROW = 15 : VSCR = 21
10040  MESS$ = MSG$(22)
10050  GOSUB 9340
10060  IF REPLY$ = "" THEN 10130
10070  SHOW5 = SHOWS
10080  COLOR G,K
10090  LOCATE ROW,55 : PRINT SPACE$(6);
10100  LOCATE ROW,55 : PRINT SHOW5;
10110  LOCATE ROW+1,46 : PRINT SPACE$(32);
10120  LOCATE ROW+1,46 : PRINT VECT3$(SHOW5);
10130  GOTO 10150
10140  '
10150  REM Blank the left side of the screen
10160  COLOR W,K
10170  FOR R = LDIM TO UDIM
10180   LOCATE 4+R,3 : PRINT SPACE$(37);
10190  NEXT R
10200  '
10210  REM Now determine location of output
10220  GOSUB 12830
10230  GOSUB 12840
10240  GOSUB 12850
10250  GOSUB 12860
10260  LOCATE 24,1 : PRINT "and press the 'enter' key"; : LOCATE 23,1
10270  LINE INPUT "Type d (display), p (print), m (more), f (forget): ", REPLY$
10280  IF LEFT$(REPLY$,1) = "f" THEN 2230  'Return to main menu
10290  IF LEFT$(REPLY$,1) = "F" THEN 2230  'Return to main menu
10300  IF LEFT$(REPLY$,1) = "m" THEN 8400  'Reform the entire inquiry
10310  IF LEFT$(REPLY$,1) = "M" THEN 8400  'Reform the entire inquiry
10320  IF LEFT$(REPLY$,1) = "p" THEN OPEN "lpt1:" FOR OUTPUT AS #3 : WHERE.SHOW = 2 : GOTO 10390
10330  IF LEFT$(REPLY$,1) = "P" THEN OPEN "lpt1:" FOR OUTPUT AS #3 : WHERE.SHOW = 2 : GOTO 10390
10340  IF LEFT$(REPLY$,1) = "d" THEN OPEN "scrn:" FOR OUTPUT AS #3 : WHERE.SHOW = 1 : GOTO 10390
10350  IF LEFT$(REPLY$,1) = "D" THEN OPEN "scrn:" FOR OUTPUT AS #3 : WHERE.SHOW = 1 : GOTO 10390
10360  LOCATE 22,1 : PRINT "Error in Reply";
10370  GOTO 10230
10380  '
10390  REM Routine to read the records and select those whose criteria match
10400  GOSUB 1850  'To Open the File and Set the Field
10410  IF WHERE.SHOW = 1 THEN KEY ON : CLS : KEY OFF
10420  '
10430  REM Constants
10440  SHOWN = 0 : PRINTED = 0
10450  PAGE.NO = 1 : SCREEN.NO = 1
10460  '
10470  REM Begin Output
10480  GOSUB 10790  'to Print the Titles
10490  FOR RR = 1 TO HIGH.REC
10500   GET #1, RR
10510   T1 = CVD(F1$)
10520   IF WHERE.SHOW = 2 THEN 10530 ELSE 10550
10530   GOSUB 12840 : GOSUB 12850
10540   LOCATE 23,1 : PRINT "Searching Record: "; RR;
10550   IF T1 < 0 THEN 11690
10560   '
10570   REM Now do the selection
10580   IF SHOW0 = -1 THEN 10750  'bypass testing.  Want everything.
10590   '
10600   REM Test Persons
10610   IF SHOW1 = -1 THEN 10650  'any
10620   T2 = CVI(F2$)
10630   IF SHOW1 = T2 THEN 10650 ELSE 11690
10640   '
10650   REM Test Sources
10660   IF SHOW4 = -1 THEN 10700
10670   T5 = CVI(F5$)
10680   IF SHOW4 = T5 THEN 10700 ELSE 11690
10690   '
10700   REM Test Types
10710   IF SHOW5 = -1 THEN 10750
10720   T7 = CVI(F7$)
10730   IF SHOW5 = T7 THEN 10750 ELSE 11690
10740   '
10750   REM Have Satisfied the Test Requirements, so Print
10760   GOSUB 6980
10770   GOTO 11070  'to continue
10780   '
10790   REM Routine to print the Sreeen titles
10800   PRINT #3, TITLE$ + "      ";DATE$;"     ";TIME$;
10810   IF WHERE.SHOW = 1 THEN PRINT #3, "     Screen ";SCREEN.NO
10820   IF WHERE.SHOW = 2 THEN PRINT #3, "     Page ";PAGE.NO
10830   IF WHERE.SHOW = 1 THEN PRINT #3, "Display all notes";
10840   IF WHERE.SHOW = 2 THEN PRINT #3, "Print all notes";
10850   IF WHERE.SHOW = 2 THEN LOCATE 25,1 : PRINT "Press 'Esc' to quit at end of record.";
10860   PRINT #3, " containing items whose:"
10870   COLOR O,K : PRINT #3, MSG$(31); : COLOR G,K
10880   IF SHOW1 <> -1 THEN 10890 ELSE PRINT #3, "(all)" : GOTO 11000
10890  GOSUB 1960 'Open
10900  GET #2, SHOW1
10910  Q1  = CVS(P1$)
10920  Q2$ = P2$
10930   RTRM$ = Q2$ : GOSUB 12950 : Q2$ = RTRM$
10940  Q3$ = P3$
10950   RTRM$ = Q3$ : GOSUB 12950 : Q3$ = RTRM$
10960  Q8$ = P8$
10970  CLOSE #2 : COLOR G,K : PRINT #3, LEFT$(Q3$+" "+Q2$,48);
10980  COLOR O,K : PRINT #3, TAB(60); "Birth: ";
10990  COLOR G,K : PRINT #3, Q8$
11000   COLOR O,K: PRINT #3, MSG$(30);: COLOR G,K
11010   IF SHOW4 <> -1 THEN PRINT #3, VECT2$(SHOW4) ELSE PRINT #3,"(all)"
11020   COLOR O,K : PRINT #3, MSG$(33);: COLOR G,K
11030   IF SHOW5 <> -1 THEN PRINT #3, VECT3$(SHOW5) ELSE PRINT #3,"(all)"
11040   COLOR P,K : PRINT #3, STRING$(79,"=") : COLOR W,K
11050   RETURN
11060   '
11070   REM Display or Print the Selected Records
11080   REM Print the First Line of the Selected Record
11090   COLOR O,K : PRINT #3, "Note Number: ";
11100   COLOR K,W : PRINT #3, T1;
11110   COLOR O,K : PRINT #3, TAB(23); MSG$(25);" Date: ";
11120   COLOR G,K : PRINT #3, T8$;
11130   COLOR O,K : PRINT #3, TAB(52); MSG$(18);" Date: ";
11140   COLOR G,K : PRINT #3, T10$
11150   '
11160   REM Print the Second Line
11170   COLOR O,K : PRINT #3, MSG$(34);
11180  GOSUB 1960 'Open
11190  IF T2 >= 1 THEN 11220
11200  Q1 = 0 : Q2$ = "" : Q3$ = "" : Q8$ = ""
11210  GOTO 11290
11220  GET #2, T2
11230  Q1  = CVS(P1$)
11240  Q2$ = P2$
11250  RTRM$ = Q2$ : GOSUB 12950 : Q2$ = RTRM$
11260  Q3$ = P3$
11270  RTRM$ = Q3$ : GOSUB 12950 : Q3$ = RTRM$
11280  Q8$ = P8$
11290  CLOSE #2
11300   COLOR G,K : PRINT #3, LEFT$(Q3$+" "+Q2$,50);
11310   COLOR O,K : PRINT #3, TAB(60);"Birth: ";
11320   COLOR G,K : PRINT #3, Q8$
11330   '
11340   REM Print the Third Line
11350   COLOR O,K : PRINT #3, MSG$(35);
11360   COLOR G,K : PRINT #3, VECT2$(T5)
11370   '
11380   REM Print the Fourth Line
11390   COLOR O,K : PRINT #3, MSG$(37);
11400   COLOR G,K : PRINT #3, VECT3$(T7)
11410   '
11420   REM Print the Fifth Line
11430   COLOR O,K : PRINT #3, MSG$(38);
11440   COLOR G,K : PRINT #3, T11$
11450   '
11460   REM print a separator
11470   COLOR P,K : PRINT #3, STRING$(79,"=");
11480   COLOR W,K
11490  '
11500   REM reset the parameters
11510   Q1 = 0 : Q2$ = ""
11520   Q3$ = "" : Q8$ = ""
11530   '
11540   REM Update the Number or records displayed or printed
11550   SHOWN = SHOWN + 1
11560   PRINTED = PRINTED + 1
11570   IF SHOWN MOD 3 = 0 AND WHERE.SHOW = 1 THEN 11600
11580   IF PRINTED MOD 8 = 0 AND WHERE.SHOW = 2 THEN 11660 ELSE 11680
11590   '
11600   REM Bottom of Page Routine
11610   LOCATE 25,1 : PRINT "Press 'Esc' to quit, or press any other key to continue";
11620   A$ = INKEY$ : IF A$ = CHR$(27)  THEN RR = HIGH.REC : GOTO 11690
11630   IF A$ = "" THEN 11620
11640   IF WHERE.SHOW = 1 THEN SCREEN.NO = SCREEN.NO + 1 : PRINT #3,
11650   KEY ON : CLS : KEY OFF
11660   IF WHERE.SHOW = 2 THEN PAGE.NO = PAGE.NO + 1 : PRINT #3, PAGE.EJECT$;
11670   GOSUB 10790  'for Screen Titles
11680   A$ = INKEY$ : IF A$ = CHR$(27) THEN RR = HIGH.REC
11690  NEXT RR
11700  IF WHERE.SHOW = 1 THEN PRINT : PRINT "Search Completed."
11710  '
11720  REM Display or Print the Summarization
11730  IF WHERE.SHOW = 1 THEN 11860  ' for Display
11740  REM Print the Summarization
11750  PAGE.NO = PAGE.NO + 1 : LPRINT CHR$(12);
11760  FOR WAIT4 = 1 TO 2000 : NEXT WAIT4
11770  GOSUB 10790  ' To Print the Page Titles
11780   COLOR W,K : PRINT #3, "Summary of the Results of the Inquiry"
11790   COLOR O,K : PRINT #3, "Number of Notes Meeting the Criteria = ";
11800   COLOR G,K : PRINT #3, PRINTED
11810   COLOR W,K
11820  '
11830  REM Printing, so do a page-eject
11840  PRINT #3, PAGE.EJECT$; : GOTO 11990 'to close the files
11850  '
11860  REM Displaying, so pause at end of the search.
11870  GOSUB 12860
11880  LOCATE 25,1 : PRINT "Press any key to continue";
11890  A$ = INKEY$ : IF A$ = "" THEN 11890
11900  '
11910  REM Display the Totals
11920   SCREEN.NO = SCREEN.NO + 1 : CLS : GOSUB 10790  'For Titles
11930   COLOR W,K : PRINT #3, "Summary of the Results of the Inquiry"
11940   COLOR O,K : PRINT #3, "Number of Notes Meeting the Criteria = ";
11950   COLOR G,K : PRINT #3, SHOWN
11960   COLOR W,K
11970  LOCATE 25,1 : PRINT "Press any key to continue";
11980  A$ = INKEY$ : IF A$ = "" THEN 11980
11990  CLOSE #3
12000  CLOSE #1
12010  GOTO 2230  'Return to Main Menu
12020  '
12030  REM Routine to draw a double box
12040  COLOR P,K
12050  FOR I = R1 + 1 TO R2 - 1
12060   LOCATE I, C1 : PRINT CHR$(186);
12070   LOCATE I, C2 : PRINT CHR$(186);
12080  NEXT I
12090  FOR J = C1 + 1 TO C2 - 1
12100   LOCATE R1, J : PRINT CHR$(205);
12110   LOCATE R2, J : PRINT CHR$(205);
12120  NEXT J
12130   LOCATE R1, C1 : PRINT CHR$(201);
12140   LOCATE R1, C2 : PRINT CHR$(187);
12150   LOCATE R2, C1 : PRINT CHR$(200);
12160   LOCATE R2, C2 : PRINT CHR$(188);
12170  COLOR W,K
12180  RETURN
12190  '
12200  REM Routine to draw a single box
12210  COLOR P,K
12220  FOR I = R1 + 1 TO R2 - 1
12230   LOCATE I, C1 : PRINT CHR$(179);
12240   LOCATE I, C2 : PRINT CHR$(179);
12250  NEXT I
12260  FOR J = C1 + 1 TO C2 - 1
12270   LOCATE R1, J : PRINT CHR$(196);
12280   LOCATE R2, J : PRINT CHR$(196);
12290  NEXT J
12300   LOCATE R1, C1 : PRINT CHR$(218);
12310   LOCATE R1, C2 : PRINT CHR$(191);
12320   LOCATE R2, C1 : PRINT CHR$(192);
12330   LOCATE R2, C2 : PRINT CHR$(217);
12340  COLOR W,K
12350  RETURN
12360  '
12370  REM Routine to draw a double horizontal line.  Attach to double.
12380  COLOR P,K
12390  FOR J = C1 + 1 TO C2 - 1
12400   LOCATE R1,J : PRINT CHR$(205);
12410  NEXT J
12420  LOCATE R1,C1 : PRINT CHR$(204);
12430  LOCATE R1,C2 : PRINT CHR$(185);
12440  COLOR W,K
12450  RETURN
12460  '
12470  REM Routine to draw a single horizontal line.  Attach to double.
12480  COLOR P,K
12490  FOR J = C1 + 1 TO C2 - 1
12500   LOCATE R1,J : PRINT CHR$(196);
12510  NEXT J
12520  LOCATE R1,C1 : PRINT CHR$(199);
12530  LOCATE R1,C2 : PRINT CHR$(182);
12540  COLOR W,K
12550  RETURN
12560  '
12570  REM Routine to draw a double vertical line.  Attach to double.
12580  COLOR P,K
12590  FOR I = R1 + 1 TO R2 - 1
12600   LOCATE I,C1 : PRINT CHR$(186);
12610  NEXT I
12620  LOCATE R1,C1 : PRINT CHR$(203);
12630  LOCATE R2,C1 : PRINT CHR$(202);
12640  COLOR W,K
12650  RETURN
12660  '
12670  REM Routine to draw a single vertical line.  Attach to double.
12680  COLOR P,K
12690  FOR I = R1 + 1 TO R2 - 1
12700   LOCATE I,C1 : PRINT CHR$(179);
12710  NEXT I
12720  LOCATE R1,C1 : PRINT CHR$(209);
12730  LOCATE R2,C1 : PRINT CHR$(207);
12740  COLOR W,K
12750  RETURN
12760  '
12770  REM Program Wrapup
12780  KEY ON : CLS : KEY OFF : LOCATE 21,1
12790  PRINT "End of Program"
12800  GOTO 13040
12810  '
12820  REM Cleaning of Bottom Lines
12830  LOCATE 22,1 : PRINT SPACE$(79); : RETURN
12840  LOCATE 23,1 : PRINT SPACE$(79); : RETURN
12850  LOCATE 24,1 : PRINT SPACE$(79); : RETURN
12860  LOCATE 25,1 : PRINT SPACE$(79); : RETURN
12870  '
12880  REM Routine to File the new Maximums
12890  OPEN DD.HIGH$+"high" FOR OUTPUT AS #3
12900   PRINT #3, MAX.REC
12910   PRINT #3, HIGH.REC
12920  CLOSE #3
12930  RETURN
12940  '
12950  REM Generalized Right-trim routine
12960  ANY = 0  'Test value if empty
12970  FOR TRIM = LEN(RTRM$) TO 1 STEP -1
12980   IF MID$(RTRM$,TRIM,1) = " " THEN 13010
12990   RTRM$ = LEFT$(RTRM$,TRIM)
13000   ANY = 1 : TRIM = 1
13010  NEXT TRIM
13020  IF ANY = 0 THEN RTRM$ = ""
13030  RETURN
13040  END
