100  REM Documentation for the Genealogy ON DISPLAY Programs
110  REM All data is in the form of DATA statements.
120  REM By:  Melvin O. Duke.  Updated June 1986.
130  DATA Notes and Sources
140  DATA User's Manual
150  DATA -5
160  DATA 1
170  INDENT = 0
180  REM Printer Definitions
190  FORM.FEED$  = CHR$(12)
200  COMPR.OFF$  = CHR$(18)     : COMPR.ON$ = CHR$(15)
210  BOLD.OFF$   = CHR$(27)+"F" : BOLD.ON$ = CHR$(27)+"E"
220  EXPAND.OFF$ = CHR$(18)     : EXPAND.ON$ = CHR$(14)
230  DASHES$ = "+"+STRING$(54,45)+"+"
240  TRIM.LINE$ = "(Trim-line)"
250  REM Program begins here
260  READ TITLE$, DOC.NAME$, PAGE.NO, LINE.NO
270  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
280  GOSUB 920  'For trim line and heading space
290  FOR I = 1 TO 6 : LPRINT : NEXT I
300  LPRINT BOLD.ON$;     'Set Emphasized mode
310  LPRINT EXPAND.ON$;   'Set Expanded Print
320  LPRINT TAB(TAB.POS-5);TITLE$
330  LPRINT EXPAND.OFF$;  'Return to normal
340  LPRINT BOLD.OFF$;    'Return to normal
350  FOR I = 1 TO 3 : LPRINT : NEXT I
360  LPRINT BOLD.ON$;     'Set Emphasized mode
370  LPRINT TAB(TAB.POS+12);"ON DISPLAY"
380  LPRINT BOLD.OFF$;    'Return to normal
390  LPRINT : LPRINT : LPRINT
400  LPRINT TAB(TAB.POS+11);"Version 1.1"
410  FOR I = 1 TO 11 : LPRINT : NEXT I
420  LPRINT TAB(TAB.POS+10); DOC.NAME$
430  LINE.NO = LINE.NO + 27
440  '
450  READ REPLY$
460  REM First, change tildes to quotes
470  FOR Q = 1 TO LEN(REPLY$)
480   IF MID$(REPLY$,Q,1)="~"THEN MID$(REPLY$,Q,1)=CHR$(34)
490  NEXT Q
500  IF LEFT$(REPLY$,1) = "." THEN GOSUB 1270: GOTO 450
510  IF LINE.NO > 44 THEN GOSUB 1030
520  REM Print the line if not a command
530  LPRINT TAB(TAB.POS);REPLY$
540  LINE.NO = LINE.NO + 1
550  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
560  GOTO 450
570  DATA ".pa"
580  REM   Data for the Copyright Page
590  DATA "Anyone may request a copy of Notes and"
600  DATA "Sources ON DISPLAY, for trial, by sending"
610  DATA "an unformatted, double-sided, double-"
620  DATA "density, 5-1/4 inch diskette to the"
630  DATA "author of the programs."
640  DATA ".sp"
650  DATA "An addressed, postage-paid return"
660  DATA "mailer must accompany the diskette (no"
670  DATA "exceptions, please).
680  DATA ".sp"
690  DATA "A copy of the programs with documenta-"
700  DATA "tion will be sent by return mail."
710  DATA ".vt 2"
720  DATA "Users are encouraged to copy and share"
730  DATA "the programs with others."
740  DATA ".vt 2"
750  DATA "If you are using this program, you are"
760  DATA "expected to become a Registered User,"
770  DATA "by making a contribution to the author"
780  DATA "of the program ($30.00 suggested for"
790  DATA "Registered Users of Genealogy ON DIS-"
800  DATA "PLAY, otherwise, $45.00 suggested)."
810  DATA ".sp"
820  DATA "Melvin O. Duke"
830  DATA "P. O. Box 20836"
840  DATA "San Jose, CA  95160"
850  DATA "(408) 268-6637"
860  DATA ".vt 3"
870  DATA "Copyright (c) 1986, by:"
880  DATA "Melvin O. Duke."
890  DATA ".sp"
900  DATA "All rights reserved."
910  '
920  REM Top of each page routine
930  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
940  LPRINT
950  LPRINT TAB(30); TRIM.LINE$
960  LPRINT DASHES$ 'Dashes
970  FOR I = 1 TO 6
980   LPRINT
990  NEXT I
1000  LINE.NO = LINE.NO + 6
1010  RETURN
1020  '
1030  REM Bottom of each page Routine
1040  IF PAGE.NO < 1 THEN LPRINT : LPRINT : LPRINT : GOTO 1160
1050  LPRINT TAB(TAB.POS); STRING$(40,45)  'on line 46
1060  LPRINT TAB(TAB.POS+0); TITLE$+" ON DISPLAY.  Vers. 1.1" 'on line 47
1070  IF PAGE.NO MOD 2 = 1 THEN 1110
1080  LPRINT TAB(TAB.POS);"Page";PAGE.NO;
1090  LPRINT TAB(TAB.POS+27);"User's Manual"
1100  GOTO 1160
1110  LPRINT TAB(TAB.POS); "User's Manual";
1120  IF PAGE.NO < 10 THEN DELTA = 34
1130  IF PAGE.NO >  9 THEN DELTA = 33
1140  IF PAGE.NO > 99 THEN DELTA = 32
1150  LPRINT TAB(TAB.POS+DELTA); "Page"; PAGE.NO  'on line 48
1160  LPRINT : LPRINT : LPRINT
1170  LPRINT DASHES$ 'dashes after 51
1180  LPRINT TAB(30); TRIM.LINE$
1190  LPRINT FORM.FEED$;
1200  PAGE.NO = PAGE.NO + 1
1210  LINE.NO = 1
1220  IF REPLY$ = ".eof" THEN 1240  'Bypass after last page
1230  GOSUB 920  'For top of next page
1240  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1250  RETURN
1260  '
1270  REM Command Processor
1280  IF LEFT$(REPLY$,3) = ".h1" THEN 1390
1290  IF LEFT$(REPLY$,3) = ".h2" THEN 1550
1300  IF LEFT$(REPLY$,3) = ".h3" THEN 1660
1310  IF LEFT$(REPLY$,3) = ".sp" THEN 1770
1320  IF LEFT$(REPLY$,4) = ".eof" THEN 1820
1330  IF LEFT$(REPLY$,3) = ".pa" THEN 1850
1340  IF LEFT$(REPLY$,3) = ".pn" THEN PAGE.NO = VAL(RIGHT$(REPLY$,LEN(REPLY$)-3)) : RETURN
1350  IF LEFT$(REPLY$,3) = ".vt" THEN 1920
1360  IF LEFT$(REPLY$,3) = ".pk" THEN 2030
1370  IF LEFT$(REPLY$,3) = ".in" THEN 2160
1380  STOP
1390  REM Head 1 Processor
1400  FOR I = LINE.NO TO 44
1410   LPRINT
1420  NEXT I
1430  GOSUB 1030  'Bottom of page Routine
1440  IF PAGE.NO MOD 2 = 0 THEN GOSUB 1850  'For h1 on Odd pages
1450  LPRINT BOLD.ON$;     'Set emphasized print
1460  LPRINT EXPAND.ON$;   'Set expanded print
1470  IF PAGE.NO MOD 2 = 0 THEN ADJUST = -2 ELSE ADJUST = -5
1480  LPRINT TAB(TAB.POS+ADJUST); RIGHT$(REPLY$,LEN(REPLY$)-4)
1490  LPRINT EXPAND.OFF$;  'Return to normal
1500  LPRINT BOLD.OFF$;    'Return to non-bold
1510  LINE.NO = LINE.NO+1
1520  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1530  RETURN
1540  '
1550  REM Head 2 Processor
1560  IF LINE.NO = 7 THEN 1580 'skip spacing if at top of page
1570  IF LINE.NO > 43 THEN GOSUB 1850 ELSE LPRINT:LPRINT:LINE.NO = LINE.NO+2
1580  LPRINT BOLD.ON$;  'Set emphasized print
1590  LPRINT TAB(TAB.POS+1); RIGHT$(REPLY$,LEN(REPLY$)-4)
1600  LPRINT BOLD.OFF$; 'Return to normal
1610  LPRINT
1620  LINE.NO = LINE.NO + 2
1630  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1640  RETURN
1650  '
1660  REM Head 3 Processor
1670  IF LINE.NO = 7 THEN 1690 'skip spacing if at top of page
1680  IF LINE.NO > 43 THEN GOSUB 1850 ELSE LPRINT:LPRINT:LINE.NO = LINE.NO+2
1690  LPRINT BOLD.ON$;  'Set emphasized print
1700  LPRINT TAB(TAB.POS+1); RIGHT$(REPLY$,LEN(REPLY$)-4)
1710  LPRINT BOLD.OFF$; 'Return to normal
1720  LPRINT
1730  LINE.NO = LINE.NO + 2
1740  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1750  RETURN
1760  '
1770  REM Single Space Processor
1780  IF LINE.NO = 7 THEN 1800
1790  IF LINE.NO > 44 THEN GOSUB 1850 ELSE LPRINT : LINE.NO = LINE.NO + 1
1800  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1810  RETURN
1820  REM End of File Processor
1830  GOSUB 1850 'Bottom of Page
1840  GOTO 7160
1850  REM Page Eject Processor
1860  FOR I = LINE.NO TO 44
1870   LPRINT
1880   LINE.NO = LINE.NO + 1
1890  NEXT I
1900  GOSUB 1030  'Bottom of Page Processing
1910  RETURN
1920  REM Vertical Tab Processor
1930  IF LINE.NO = 7 THEN 2020
1940  IF LINE.NO > 44 THEN GOSUB 1030  'End of page
1950  QTY = VAL(RIGHT$(REPLY$,LEN(REPLY$)-3))
1960  FOR I = 1 TO QTY
1970   LPRINT
1980   LINE.NO = LINE.NO + 1
1990   IF LINE.NO > 44 THEN I = QTY
2000  NEXT I
2010  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
2020  RETURN
2030  REM Pack Processor
2040  IF LINE.NO > 44 THEN GOSUB 1030
2050  IF TAB.POS = 8 THEN ADJUST = 4
2060  IF TAB.POS = 13 THEN ADJUST = 7
2070  TAB.POS = TAB.POS + ADJUST + INDENT
2080  WIDTH "lpt1:", 132 'set condensed width
2090  LPRINT COMPR.ON$;  'Packed printing
2100  LPRINT TAB(TAB.POS); RIGHT$(REPLY$,LEN(REPLY$)-3)
2110  LPRINT COMPR.OFF$; 'Return to normal
2120  WIDTH "lpt1:", 80  'return to normal
2130  LINE.NO = LINE.NO + 1
2140  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
2150  RETURN
2160  REM Indent Processor
2170  INDENT = VAL(RIGHT$(REPLY$,LEN(REPLY$)-3))
2180  RETURN
3000  DATA ".h1 REFERENCE MATERIAL"
3010  DATA ".pn 51"
3020  DATA ".h2 SAMPLE SCREENS AND PROMPTING MESSAGES"
3030  DATA "The following is a sample session, where"
3040  DATA "the user is just beginning, and wants to"
3050  DATA "Create a Note File, and to Personalize"
3060  DATA "his Sources and Types, then he wants to"
3070  DATA "enter Notes, and finally, to Inquire into"
3080  DATA "those notes."
3090  DATA ".vt 2"
3100  DATA "He begins in the normal manner.  He"
3110  DATA "has the DOS Diskette in place, and has"
3120  DATA "Cartridge BASIC in place if he is using"
3130  DATA "a PCjr."
3140  DATA ".sp"
3150  DATA "He turns the system on, and responds to"
3160  DATA "any messages which ask for date and time."
3170  DATA ".sp"
3180  DATA "He then requests BASIC by typing:"
3190  DATA ".sp"
3200  DATA "   basic/s:256"
3210  DATA "       and presses the 'enter' key."
3220  DATA ".sp"
3230  DATA "He replaces the DOS Diskette with the"
3240  DATA "Notes and Sources ON DISPLAY Program"
3250  DATA "Diskette."
3260  DATA ".sp"
3270  DATA "He then starts Notes and Sources ON"
3280  DATA "DISPLAY by typing:"
3290  DATA ".sp"
3300  DATA "   run ~notesand~"
3310  DATA "       and presses the 'enter' key."
3320  DATA ".pa"
3330  DATA "The display screen then appears as:"
3340  DATA ".vt 2"
3350  DATA ".pk                   Notes and Sources ON DISPLAY"
3360  DATA ".pk                           Version 1.1"
3370  DATA ".vt 3"
3380  DATA ".pk    If you are using this program, you are expected to become a"
3390  DATA ".pk   Registered User, by making a contribution to the author of the"
3400  DATA ".pk   program ($30.00 suggested for Registered Users of Genealogy ON"
3410  DATA ".pk              DISPLAY, otherwise, $45.00 suggested)."
3420  DATA ".sp"
3430  DATA ".pk                          Melvin O. Duke"
3440  DATA ".pk                          P. O. Box 20836"
3450  DATA ".pk                        San Jose, CA  95160"
3460  DATA ".pk                          (408) 268-6637"
3470  DATA ".vt 3"
3480  DATA ".pk                        Copyright (c) 1986,"
3490  DATA ".pk                        by: Melvin O. Duke."
3500  DATA ".pk                       All Rights Reserved."
3510  DATA ".vt 2"
3520  DATA ".pk Press any key to continue."
3530  DATA ".vt 2"
3540  DATA "After any key is pressed, the screen is"
3550  DATA "cleared, and four brief messages appear."
3560  DATA "They indicate that four files are being"
3570  DATA "prepared for use."
3580  DATA ".pa"
3590  DATA "The Menu screen now appears, which shows"
3600  DATA "the available functions.  It appears as:"
3610  DATA ".vt 3"
3620  DATA ".in -3"
3630  DATA ".pk No   Available Functions in Notes and Sources ON DISPLAY"
3640  DATA ".vt 2"
3650  DATA ".pk  1   Create a New Note File."
3660  DATA ".sp"
3670  DATA ".pk  2   Extend the Note File by 100 records."
3680  DATA ".sp"
3690  DATA ".pk  3   Personalize or Redefine the Sources"
3700  DATA ".sp"
3710  DATA ".pk  4   Personalize or Redefine the Types"
3720  DATA ".sp"
3730  DATA ".pk  5   Enter or Update Note Information."
3740  DATA ".sp"
3750  DATA ".pk  6   Inquiry for Display or Printing."
3760  DATA ".sp"
3770  DATA ".pk  7   Menu of Functions in: Notes and Sources ON DISPLAY (This screen)."
3780  DATA ".vt 4"
3790  DATA ".pk Type a Function Number (0 to quit), and press the 'enter' key:"
3800  DATA ".in 0"
3810  DATA ".vt 2"
3820  DATA "The user chooses function 1, by typing:"
3830  DATA ".sp"
3840  DATA "   1"
3850  DATA "     and pressing the 'enter' key."
3860  DATA ".pa"
3870  DATA "The user then sees a warning message,"
3880  DATA "letting him know that if he types a y,"
3890  DATA "any existing Note File will no longer"
3900  DATA "exist, as:"
3910  DATA ".vt 3"
3920  DATA ".pk                 ***  WARNING  ***"
3930  DATA ".sp"
3940  DATA ".pk This function creates a new Note File by completely"
3950  DATA ".pk removing the old file (if one exists), and by writing 100 new,"
3960  DATA ".pk empty records.  Only the new file will then exist."
3970  DATA ".sp"
3980  DATA ".pk If this is REALLY what you want to do,"
3990  DATA ".pk type y (yes), and press the 'enter' key."
4000  DATA ".sp"
4010  DATA ".pk Otherwise, type n (no), and press the 'enter' key."
4020  DATA ".vt 4"
4030  DATA ".pk Enter your desired action:"
4040  DATA ".vt 2"
4050  DATA "Since the user is just starting out, and"
4060  DATA "wants a new file created, he types"
4070  DATA ".sp"
4080  DATA "  y"
4090  DATA "    and presses the 'enter' key."
4100  DATA ".sp"
4110  DATA "He then watches, as the program writes"
4120  DATA "a new file of 100 records, and the Menu"
4130  DATA "is re-displayed."
4140  DATA ".pa"
4150  DATA "The user then wants to personalize the"
4160  DATA "Sources, so he types:"
4170  DATA ".sp"
4180  DATA "  3"
4190  DATA "    and presses the 'enter' key."
4200  DATA ".sp"
4210  DATA "He sees:"
4220  DATA ".vt 2"
4230  DATA ".pk Update the Source Descriptions"
4240  DATA ".sp"
4250  DATA ".pk      Source Descriptions"
4260  DATA ".pk    1 Church"
4270  DATA ".pk    2 State of California"
4280  DATA ".pk    3 State of New York"
4290  DATA ".pk    4 State of Ohio"
4300  DATA ".pk    5 State of Utah"
4310  DATA ".pk    6 State of Virginia"
4320  DATA ".pk    7 Albany County, New York"
4330  DATA ".pk    8 Salt Lake County, Utah"
4340  DATA ".pk    9 Wasatch County, Utah"
4350  DATA ".pk   10 United States"
4360  DATA ".pk   11 England"
4370  DATA ".pk   12 Germany"
4380  DATA ".vt 4"
4390  DATA ".pk Enter the Source 1 Description.?"
4400  DATA ".pk ('enter' to leave alone, '/ enter' to end descriptions,)"
4410  DATA ".pk ('\ enter' for partial list, or reply as shown.)"
4420  DATA ".vt 2"
4430  DATA "He then enters his own descriptions of"
4440  DATA "the Sources, and when finished, asks"
4450  DATA "that they be saved."
4460  DATA ".pa"
4470  DATA "The user then wants to personalize the"
4480  DATA "Types, so he types:"
4490  DATA ".sp"
4500  DATA "  4"
4510  DATA "    and presses the 'enter' key."
4520  DATA ".sp"
4530  DATA "He sees:"
4540  DATA ".vt 2"
4550  DATA ".pk Update the Type Descriptions"
4560  DATA ".sp"
4570  DATA ".pk      Type Descriptions"
4580  DATA ".sp"
4590  DATA ".pk    1 Birth Records"
4600  DATA ".pk    2 Marriage Records"
4610  DATA ".pk    3 Census Records"
4620  DATA ".pk    4 Deeds"
4630  DATA ".pk    5 Land Records"
4640  DATA ".pk    6 Wills"
4650  DATA ".pk    7 Probates"
4660  DATA ".pk    8 Death Records"
4670  DATA ".pk    9 Obituaries"
4680  DATA ".pk   10 Funeral Records"
4690  DATA ".pk   11 Burial Records"
4700  DATA ".pk   12 Cemeteries"
4710  DATA ".vt 4"
4720  DATA ".pk Enter the Type 1 Description.?"
4730  DATA ".pk ('enter' to leave alone, '/ enter' to end descriptions,)"
4740  DATA ".pk ('\ enter' for partial list, or reply as shown.)"
4750  DATA ".vt 2"
4760  DATA "He then enters his own descriptions of"
4770  DATA "the Types, and when finished, asks"
4780  DATA "that they be saved."
4790  DATA ".pa"
4800  DATA "Now that a Note File has been created,"
4810  DATA "and Personalization is complete, the"
4820  DATA "user can begin to enter his notes.  He"
4830  DATA "types:"
4840  DATA ".sp"
4850  DATA "  5"
4860  DATA "    and presses the 'enter' key."
4870  DATA ".sp"
4880  DATA "He sees:"
4890  DATA ".vt 2"
4900  DATA ".pk   Note Entry or Update"
4910  DATA ".vt 15"
4920  DATA ".pk Enter Note Number to Update (0 to quit, ? next available):"
4930  DATA ".pa"
4940  DATA "He knows that he is beginning, so he"
4950  DATA "chooses Note number 1, and presses"
4960  DATA "the 'enter' key.  Otherwise, he would"
4970  DATA "probably have typed a question-mark,"
4980  DATA "and pressed the 'enter' key, to let"
4990  DATA "the program search for an unused"
5000  DATA "Note-record."
5010  DATA ".sp"
5020  DATA "He sees:"
5030  DATA ".vt 2"
5040  DATA ".pk Note Entry or Update                                    Note:    -1"
5050  DATA ".sp"
5060  DATA ".pk      Choices                                        Descriptions"
5070  DATA ".pk                                        Researched :"
5080  DATA ".sp"
5090  DATA ".pk                                        Person     :  0"
5100  DATA ".vt 4"
5110  DATA ".pk                                        Source     :  0"
5120  DATA ".sp"
5130  DATA ".pk                                        Type       :  0"
5140  DATA ".sp"
5150  DATA ".pk                                        Event Date :"
5160  DATA ".sp"
5170  DATA ".pk Note:"
5180  DATA ".vt 3"
5190  DATA ".pk Enter the Note Number:"
5200  DATA ".pk ('enter' to leave alone, '/ enter' to end descriptions,)"
5210  DATA ".pk ('\ enter' for partial list, or reply as shown.)"
5220  DATA ".pa"
5230  DATA "After entering the Note Number and the"
5240  DATA "Researched Date, through the use of the"
5250  DATA "`\ enter', he is then presented with"
5260  DATA "a list of the first 12 names from his"
5270  DATA "Genealogy ON DISPLAY Persons File."
5280  DATA ".sp"
5290  DATA "He sees:"
5300  DATA ".vt 2"
5310  DATA ".pk Note Entry or Update                                    Note:     1"
5320  DATA ".sp"
5330  DATA ".pk      Choices                                        Descriptions"
5340  DATA ".pk    1 Melvin Otto ABLE                  Researched : 22 Mar 1986"
5350  DATA ".pk    2 Helen Lillian LOVELY
5360  DATA ".pk    3 Melvin Kent ABLE                  Person     :  0"
5370  DATA ".pk    4 Ronald Robert ABLE"
5380  DATA ".pk    5 Carolyn Elizabeth ABLE"
5390  DATA ".pk    6 LINDA Ann ABLE"
5400  DATA ".pk    7 Otto ABLE"
5410  DATA ".pk    8 Beatrice BAKER                    Source     :  0"
5420  DATA ".pk    9 Keith ABLE"
5430  DATA ".pk   10 Barbara ABLE                      Type       :  0"
5440  DATA ".pk   11 Beatrice ABLE"
5450  DATA ".pk   12 James ABLE                        Event Date :"
5460  DATA ".sp"
5470  DATA ".pk Note:"
5480  DATA ".vt 3"
5490  DATA ".pk Enter the Persons Number:"
5500  DATA ".pk ('enter' to leave alone, '/ enter' to end descriptions,)"
5510  DATA ".pk ('\ enter' for partial list, or reply as shown.)"
5520  DATA ".vt 2"
5530  DATA "He chooses Person 1, by typing:"
5540  DATA ".sp"
5550  DATA "  1"
5560  DATA "    and pressing the 'enter' key."
5570  DATA ".pa"
5580  DATA "He then chooses a Source and a Type"
5590  DATA "from the same kind of lists.  He enters"
5600  DATA "an Event Date, and he enters his Note."
5610  DATA ".sp"
5620  DATA "He then sees:"
5630  DATA ".vt 3"
5640  DATA ".pk Note Entry or Update                                    Note:     1"
5650  DATA ".sp"
5660  DATA ".pk                                                     Descriptions"
5670  DATA ".pk                                        Researched : 22 Mar 1986"
5680  DATA ".pk
5690  DATA ".pk                                        Person     :  1"
5700  DATA ".pk                                            Melvin Otto"
5710  DATA ".pk                                            ABLE"
5720  DATA ".pk                                             5 Oct 1925"
5730  DATA ".sp"
5740  DATA ".pk                                        Source     :  5"
5750  DATA ".pk                                            State of Utah"
5760  DATA ".pk                                        Type       :  1"
5770  DATA ".pk                                            Birth Record"
5780  DATA ".pk                                        Event Date :  5 Oct 1925"
5790  DATA ".pk Note:"
5800  DATA ".sp"
5810  DATA ".pk Birth Certificate 12345, Book 55, Page 27, Line 4."
5820  DATA ".vt 2"
5830  DATA ".pk Type s (save), m (more), or f (forget), and press the 'enter' key:"
5840  DATA ".vt 2"
5850  DATA "The user saves the Note record."
5860  DATA ".sp"
5870  DATA "After entering as many more notes as he"
5880  DATA "desires, he chooses Note 0, to finish"
5890  DATA "his entries."
5900  DATA ".pa"
5910  DATA "The user now wants to inquire into his"
5920  DATA "data.  He types:"
5930  DATA ".sp"
5940  DATA "  6"
5950  DATA "    and presses the 'enter' key."
5960  DATA ".sp"
5970  DATA "He sees:"
5980  DATA ".vt 3"
5990  DATA ".pk Request for Notes to be Displayed or Printed"
6000  DATA ".sp"
6010  DATA ".pk                                        Choices"
6020  DATA ".vt 15"
6030  DATA ".pk Type a (all) or s (some) notes, and press the 'enter' key:"
6040  DATA ".pa"
6050  DATA "The user wants to see some of his notes,"
6060  DATA "so he types:"
6070  DATA ".sp"
6080  DATA "  s"
6090  DATA "    and presses the 'enter' key."
6100  DATA ".vt 3"
6110  DATA "He can be presented with a list of"
6120  DATA "persons from his Persons File, and he"
6130  DATA "chooses either one person, or all"
6140  DATA "persons."
6150  DATA ".vt 3"
6160  DATA "Next, he can be presented with a list"
6170  DATA "of Sources, and he chooses either one"
6180  DATA "source, or all sources."
6190  DATA ".vt 3"
6200  DATA "Finally, he can be presented with a"
6210  DATA "list of Types, and he chooses either"
6220  DATA "one type, or all types."
6230  DATA ".pa"
6240  DATA "After making his choices, he sees:"
6250  DATA ".vt 3"
6260  DATA ".pk Request for Notes to be Displayed or Printed"
6270  DATA ".sp"
6280  DATA ".pk                                        Choices"
6290  DATA ".pk                                        Choose all notes,"
6300  DATA ".pk                                          Where:"
6310  DATA ".sp"
6320  DATA ".pk                                        Person     :  1"
6330  DATA ".pk                                            Melvin Otto"
6340  DATA ".pk                                            ABLE"
6350  DATA ".pk                                             5 Oct 1925"
6360  DATA ".sp"
6370  DATA ".pk                                        Source     :  5"
6380  DATA ".pk                                            State of Utah"
6390  DATA ".pk                                        Type       :  1"
6400  DATA ".pk                                            Birth Record"
6410  DATA ".vt 4"
6420  DATA ".pk Type d (display), p (print), m (more), f (forget):"
6430  DATA ".pk and press the 'enter' key."
6440  DATA ".pa"
6450  DATA "The user decides to display the results"
6460  DATA "of his inquiry, so types:"
6470  DATA ".sp"
6480  DATA "  d"
6490  DATA "    and presses the 'enter' key."
6500  DATA ".sp"
6510  DATA "He sees:"
6520  DATA ".in -3"
6530  DATA ".vt 3"
6540  DATA ".pk Notes and Sources ON DISPLAY      03-20-1987    10:09:57     Screen 1 "
6550  DATA ".pk Display all notes containing items whose:"
6560  DATA ".pk Person is Melvin Otto ABLE                                Birth:  5 Oct 1925"
6570  DATA ".pk Source is State of Utah"
6580  DATA ".pk Type is Birth Record"
6590  DATA ".pk ============================================================================"
6600  DATA ".pk Note Number:  1       Event Date:  5 Oct 1925     Research Date: 22 Mar 1986"
6610  DATA ".pk Person: Melvin Otto ABLE                                  Birth:  5 Oct 1925"
6620  DATA ".pk Source: State of Utah"
6630  DATA ".pk Type  : Birth Record"
6640  DATA ".pk Note : Birth Certificate 12345.  Book 55, Page 27, Line 4."
6650  DATA ".pk ============================================================================"
6660  DATA ".pk Search Completed"
6670  DATA ".vt 4"
6680  DATA ".pk Press any key to continue"
6690  DATA ".in 0"
6700  DATA ".pa"
6710  DATA "The user presses any key, and sees"
6720  DATA "summary information, as:"
6730  DATA ".in -3"
6740  DATA ".vt 3"
6750  DATA ".pk Notes and Sources ON DISPLAY      03-20-1987    10:09:57     Screen 2 "
6760  DATA ".pk Display all notes containing items whose:"
6770  DATA ".pk Person is Melvin Otto ABLE                                Birth:  5 Oct 1925"
6780  DATA ".pk Source is State of Utah"
6790  DATA ".pk Type is Birth Record"
6800  DATA ".pk ============================================================================"
6810  DATA ".pk Summary of the Results of the Inquiry"
6820  DATA ".pk Number of Notes Meeting the Criteria =  1"
6830  DATA ".vt 10"
6840  DATA ".pk Press any key to continue"
6850  DATA ".in 0"
6860  DATA ".vt 2"
6870  DATA "The user presses any key, and once"
6880  DATA "again sees the Menu.  He chooses 0,"
6890  DATA "presses the 'enter' key, and ends"
6900  DATA "his session."
6910  DATA ".pa"
6920  DATA ".h2 COMMANDS USED."
6930  DATA ".h3 basic/s:256"
6940  DATA ".sp"
6950  DATA "The basic command is used in order to"
6960  DATA "load the BASIC processor from either"
6970  DATA "the PCjr's BASIC Cartridge, from the"
6980  DATA "DOS diskette, into storage, and to"
6990  DATA "establish a buffer size for the data"
7000  DATA "files."
7010  DATA ".h3 load (or the F3 function-key)"
7020  DATA ".sp"
7030  DATA "The load command is used in order to"
7040  DATA "load the ~notesand.bas~ program from"
7050  DATA "the Program Diskette into storage."
7060  DATA ".h3 run"
7070  DATA ".sp"
7080  DATA "The run command is used to cause any"
7090  DATA "of the Notes and Sources ON DISPLAY"
7100  DATA "documentation programs to begin."
7110  DATA ".sp"
7120  DATA "It is also used to cause the ~notesand~"
7130  DATA "program to be run, and to cause the"
7140  DATA "menu itself to appear on the screen."
7150  DATA ".eof"
7160  END
