10  'PROGRAM NAME = BCFFORM (FEDERAL BUILDINGS VERSION)
20  'THIS PROGRAM PRINTS OUT A GENERALIZED FORMAT FOR THE BUILDING CHARACTERISTICS FILE
30  ' THAT CAN BE USED TO PREPARE FOR A FILE CREATION SESSION WITH THE LCCDATA SUBPROGRAM
40  DIM A$(20),B$(20)
50  INPUT "WIDE CARRIAGE (W) OR NARROW CARRIAGE (N)";CL$
55  IF CL$="W" THEN WIDTH "LPT1:",130
60  INPUT "PRESS <ENTER> WHEN PAPER IS READY IN PRINTER",X$
80  A$="\                      \..............."
90  A$(1)="STUDY PERIOD (YRS)"
100  A$(2)="OCCUPANCY YEAR"
140  A$(3)="LCC ANALYSIS TYPE"
150  A$(4)="DOE REGION"
160  A$(5)="BUILDING TYPE CODE"
230  LPRINT "               GENERALIZED FORMAT FOR BUILDING CHARACTERISTICS FILE"
240  LPRINT "               ----------------------------------------------------"
245  LPRINT "               (NOTE: ALL RATES OF PRICE INCREASE (PRICE ESCALATION RATES)"
246  LPRINT "                          SHOULD BE NET OF GENERAL INFLATION)"
250  LPRINT
260  LPRINT "SECTION 1. PROJECT TITLE: ........................."
270  LPRINT "------------------------"
280  LPRINT 
290  LPRINT "SECTION 2. BASIC LCC ANALYSIS ASSUMPTIONS:
300  LPRINT "-----------------------------------------"
310  LPRINT
330  FOR I=1 TO 5:LPRINT USING A$;A$(I):NEXT I:LPRINT
360  BW$="\                            \..........  ..........  ..........  ..........  ..........  .........."
370  BN$="\                            \..........   ..........   .........."
380  EW$="              COMPONENT NO.       1           2           3           4           5           6"
390  EN$="              COMPONENT NO.       1           2           3"
400  EM$="              COMPONENT NO.       4           5           6"
410  B$(1)=" COMPONENT NAME
420  B$(2)=" INITIAL COST
425  B$(3)="*INITIAL CONSER.-RELATED COST"
440  B$(4)=" EXPECTED COMP. LIFE (YRS)"
500  B$(5)="+AVG. PRICE ESC. DURING P/C"
510  B$(6)="+AVG. PRICE ESC. DURING OCC."
540  B$(7)=" RESALE VALUE FACTOR (%)"
550  B$(8)=" NUMBER OF REPLACEMENTS"
560  LPRINT "SECTION 3. CAPITAL COMPONENT AND REPLACEMENT COST DATA:"
570  LPRINT "-------------------------------------------------------"
580  LPRINT
590  LPRINT "NO. OF CAPITAL COMPONENTS: ..........
600  LPRINT
610  IF CL$="W" THEN LPRINT EW$:LPRINT
620  IF CL$="N" THEN LPRINT EN$:LPRINT
630  FOR I=1 TO 8
640  IF CL$="W" THEN LPRINT USING BW$;B$(I)
650  IF CL$="N" THEN LPRINT USING BN$;B$(I)
660  NEXT I
670  LPRINT
680  S$= "+COST-PHASING SCHEDULE BY YEAR OF PLANNING/CONSTRUCTION PERIOD AND AT OCCUPANCY"
690  CW$="PLANNING/CONSTRUCTION YEAR #  .........%  .........%  .........%  .........%  .........%  .........%"
700  CN$="PLANNING/CONSTRUCTION YEAR #  .........%   .........%   .........%"
710  DW$="                AT OCCUPANCY  .........%  .........%  .........%  .........%  .........%  .........%"
715  DN$="                AT OCCUPANCY  .........%   .........%   .........%"
720  LPRINT S$
730  FOR I=1 TO 5
740  IF CL$="W" THEN LPRINT USING CW$;I
750  IF CL$="N" THEN LPRINT USING CN$;I
760  NEXT I
770  IF CL$="W" THEN LPRINT DW$
780  IF CL$="N" THEN LPRINT DN$
790  IF CL$="W" THEN 825
800  LPRINT:LPRINT EM$:LPRINT
810  FOR I=1 TO 8:LPRINT USING BN$;B$(I):NEXT I:LPRINT
820  LPRINT S$:FOR I=1 TO 5:LPRINT USING CN$;I:NEXT I:LPRINT DN$
825  LPRINT:LPRINT "-----------------------------------------------------------------"
826  LPRINT "* USED ONLY FOR ENERGY RELATED PROJECTS (LCC ANALYSIS TYPE 1)"
827  LPRINT "+ USED ONLY FOR NON-ENERGY RELATED PROJECTS (LCC ANALYSIS TYPE 2)"
830  PRINT:INPUT "ROLL PAPER TO NEW PAGE & PRESS <ENTER> TO CONTINUE",QQ$
840  LPRINT "REPLACEMENTS TO CAPITAL COMPONENTS:
850  F$="\                               \..........  ..........  ..........  .........."
860  G1$="                                            COMPONENT NO. #"
870  G2$="                                 ----------------------------------------------"
880  G3$="                                 ----------  ----------  ----------  ----------"
890  G$="                                      1           2           3           4"
900  C$(1)="YEAR OF REPLACEMENT"
910  C$(2)="INIT. COST OF REPLACEMENT (UNADJ)"
950  C$(3)="EXPECTED REPLACEMENT LIFE (YRS)"
960  C$(4)="RESALE VALUE (% OF INT COST)"
980  FOR I=1 TO 6
990  LPRINT
1000  LPRINT USING G1$;I:LPRINT G2$:LPRINT G$:LPRINT G3$
1010  FOR J=1 TO 4
1020  LPRINT USING F$;C$(J)
1030  NEXT J
1040  LPRINT
1050  NEXT I
1060  PRINT:INPUT "ROLL PAPER TO NEW PAGE & PRESS <ENTER> TO CONTINUE",QQ$
1400  LPRINT "SECTION 4. OPERATING AND MAINTENANCE COST DATA:"
1410  LPRINT "----------------------------------------------"
1420  LPRINT
1430  E$(1)=" ANNUAL RECURRING COST (BASE-YEAR $'S)"
1440  E$(2)="+AVG. AN. RATE OF INCREASE, ARC"
1450  E$(3)=" NO. OF NON-AN RECURRING COSTS (NARC'S)"
1460  E$(4)="+AVG. AN. RATE OF INCREASE, NARC'S"
1470  J$="\                                       \ .........."
1480  FOR I=1 TO 4
1490  LPRINT USING J$;E$(I)
1500  NEXT I
1510  LPRINT
1520  LPRINT "               NON-ANNUALLY RECURRING COSTS (BASE-YEAR DOLLARS)"
1530  LPRINT "              (NOTE: YEARS BEGIN WITH OCCUPANCY; E.G.,1,2,...,50)"
1540  LPRINT "--------------------------------------------------------------------------------"
1550  M$="NO. YEAR   AMOUNT    NO. YEAR   AMOUNT    NO. YEAR   AMOUNT   NO. YEAR   AMOUNT"
1560  K$="## ......  ......    ## ......  ......    ## ......  ......   ## ......  ......"
1570  LPRINT M$
1580  FOR I=1 TO 11
1590  LPRINT USING K$;I,I+13,I+26,I+39
1600  NEXT I
1610  FOR I=12 TO 13:LPRINT USING K$;I,I+13,I+26:NEXT I
1620  LPRINT
1630  LPRINT "SECTION 5. ENERGY COST DATA:
1640  LPRINT "---------------------------"
1650  LPRINT " NUMBER OF ENERGY TYPES ........"
1655  LPRINT "*CUMULATIVE GENERAL INFLATION FROM MID-YEAR 1985 TO DATE ........%"
1658  LPRINT
1659  LPRINT "                                               ENERGY TYPE"
1660  LPRINT "                               ---------------------------------------------"
1670  LPRINT "                                    1                2                 3"
1680  LPRINT "                               ----------        ---------         ---------
1690  LPRINT "  ENERGY TYPE CODE             ..........        .........         ........."
1700  LPRINT "  ANNUAL CONSUMP. (MIL. BTU)   ..........        ..........        .........."
1705  LPRINT "**PRICE PER MILLION BTU        $.........        $.........        $........"
1707  LPRINT "  DEMAND (OR OTHER) CHARGE     $.........        $.........        $........."
1710  LPRINT "**AVG. AN. RATE OF INCREASE"
1720  LPRINT "      DURING PLAN/CONSTRUCTION .........%        .........%        .........%"
1725  LPRINT " +PRICE ESCALATION METHOD      ..........        ..........        .........."
1730  LPRINT
1740  LPRINT "+**PRICE INCREASES DURING OCCUPANCY (NET OF GENERAL INFLATION):"
1750  LPRINT "NO. OF DISCRETE TIME INTERVALS ..........        ..........        .........."
1760  Q$="                            ---------------   ---------------   ---------------"
1770  P$="                            NO.  DUR.   AN.   NO.  DUR.   AN.   NO.  DUR.   AN."
1780  R$="                                (YRS)  RATE       (YRS)  RATE       (YRS)  RATE"
1790  O$="                           ##  .....  ....%  ##  .....  ....%  ##  .....  ....%"
1800  LPRINT Q$:LPRINT P$:LPRINT R$:LPRINT Q$
1810  FOR I=1 TO 10
1820  LPRINT USING O$;I,I,I
1830  NEXT I
1840  LPRINT "-------------------------------------------------"
1842  LPRINT "+ USED ONLY FOR NON-ENERGY RELATED PROJECTS (LCC ANALYSIS TYPE 2)"
1845  LPRINT "*NEEDED ONLY WHEN DEFAULTING TO DOE ENERGY PRICE PROJECTIONS ON DISK"
1850  LPRINT "**NOT NEEDED WHEN DEFAULTING TO DOE ENERGY PRICE PROJECTIONS"
1860  END
