10  'PROGRAM NAME = LCCMAIN (FEDERAL BLDGS VERSION)
20  'THIS IS SUBPROGRAM #3 IN THE FBLCC SERIES
110  DIM C(6,17),DA(6),DB(6)
130  DIM T1(6,6),T2(6,6)
140  DIM R1(6,5),R2(6,5),R6(6,5),R7(6,5),R9(6,5),RA(6,5),RB(6,5),E2(3,50),E3(3,50)
155  DIM M(2,50)
160  DIM T(5,27),Q(6,6),C$(6)
168  CLS
172  PRINT:PRINT:PRINT"THIS IS THE 'LCCMAIN' SUBPROGRAM.":PRINT
174  PRINT "TO COMPUTE THE LCC OF A BUILDING OR BUILDING SUBSYSTEM ENTER"
175  INPUT "ITS BUILDING CHARACTERISTICS FILE NAME: ",I$
180  IF I$=""THEN 185
181  PRINT "WHICH DRIVE TO FIND "I$" (A, B, C)";:INPUT D1$
182  IF D1$="A" OR D1$="B" OR D1$="C" THEN 184 ELSE 181
184  F8=1:GOTO 11000
185  F9=1:CLS:PRINT "CHOOSE NEXT JOB":GOTO 10000
190  PRINT:PRINT "READING DATA FROM BLDG CHAR. FILE"
200  OPEN "I",1,D1$+":"+I$+".BCF"
210  INPUT #1,F3$,TM$,TN$,A$,P3,P1,Y1,RG,I1,T7,C1,TYPE
290  FOR I=1 TO C1
300  INPUT #1,C$(I),C(I,1),C(I,2)
320  FOR J=1 TO P1+1:INPUT #1,Q(I,J):NEXT J
420  INPUT #1,C(I,15),C(I,7)
430  FOR J=10 TO 12:INPUT #1,C(I,J):NEXT J
460  IF C(I,12)=0 THEN 500
470  FOR K=1 TO C(I,12):INPUT #1,R1(I,K),R2(I,K),R6(I,K),R7(I,K):NEXT K
500  NEXT I
640  INPUT #1, M1,M2,M4,M5
650  IF M4=0 THEN 690
660  FOR J=1 TO M4:INPUT #1,M(1,J),M(2,J):NEXT J
690  INPUT #1, E1
700  IF E1=0 THEN 830
710  FOR I=1 TO E1:INPUT #1,E(I),E4(I),E1(1,I),E5(I),EM(I),E1(2,I)
720  IF EM(I)=4 THEN INPUT #1,E6(1,I),E6(2,I):GOTO 790
740  IF P1=0 THEN 760
750  INPUT #1,E1(5,I)
760  FOR J=1 TO E1(2,I):INPUT #1,E2(I,J),E3(I,J):NEXT J
790  NEXT I
830  CLOSE 1
840  RETURN
1120  REM BASIC LCC ANALYSIS SUBROUTINE
1130  P2=P3-P1:Y2=Y1+P1
1150  FOR I=1 TO 27:FOR K=1 TO 3:T(K,I)=0:NEXT K:NEXT I
1500  CLS
1510  PRINT "COMPUTING CAPITAL COMPONENT COSTS":GOSUB 2000
1520  PRINT "COMPUTING REPLACEMENT COSTS":GOSUB 2300
1610  PRINT "COMPUTING RESALE VALUE":GOSUB 6000
1630  PRINT "COMPUTING RECURRING AND NON-RECURRING O&M COSTS":GOSUB 7000
1670  PRINT "COMPUTING ENERGY COSTS":GOSUB 8000
1690  PRINT "SUMMING ALL COSTS":GOSUB 8500
1790  RETURN
1990  'COMPUTE CAPITAL COMPONENT COSTS
2000  IF P1>0 THEN 2060
2010  T(1,1)=0:T(1,2)=0:T(1,3)=0:T(2,2)=0
2020  FOR I=1 TO C1:C(I,14)=C(I,1):T(1,1)=T(1,1)+C(I,14)
2030  IF TYPE=1 AND AF>0 THEN T(1,3)=T(1,3)+C(I,2)*AF
2040  NEXT I
2050  T(1,6)=T(1,1):T(2,6)=T(1,6)-T(1,3):RETURN
2060  FOR I=1 TO C1:C(I,14)=0
2070  FOR J=1 TO P1+1:T1(I,J)=C(I,1)*Q(I,J)*(1+C(I,15))^(J-1)
2080  C(I,14)=C(I,14)+T1(I,J)
2090  NEXT J:NEXT I
2100  T(1,1)=0:T(1,2)=0:T(2,2)=0
2110  FOR I=1 TO C1:T(1,1)=T(1,1)+C(I,14)
2120  FOR J=1 TO P1:T(1,2)=T(1,2)+T1(I,J):T(2,2)=T(2,2)+T1(I,J)/I2^(J-1):NEXT J
2130  NEXT I
2140  T(1,6)=T(1,1)-T(1,2):T(2,6)=T(1,6)/I2^P1
2150  RETURN
2300  'SUBROUTINE TO CALCULATE REPLACEMENT COSTS
2305  FOR I=1 TO C1
2310  IF C(I,12)=0 THEN 2400
2320  FOR K=1 TO C(I,12)
2330  R9(I,K)=R2(I,K)*(1+C(I,15))^P1*(1+C(I,7))^R1(I,K)
2350  T(2,27)=T(2,27)+R9(I,K)/I2^R1(I,K)
2390  NEXT K
2400  NEXT I
2410  RETURN
6000  REM SUBROUTINE TO CALCULATE RESALE VALUE OF COMPONENTS AND REPLACEMENTS
6015  REM COMPUTE T(2,17) AND T(2,18)
6020  FOR I=1 TO C1
6030  IF C(I,10)<P2 THEN 6070
6040  DA(I)=C(I,14)*C(I,11)*(1+C(I,7))^P2
6050  T(2,17)=T(2,17)+DA(I)/I2^P2
6060  GOTO 6090
6070  DB(I)=C(I,14)*C(I,11)*(1+C(I,7))^C(I,10)
6080  T(2,18)=T(2,18)+DB(I)/I2^C(I,10)
6090  IF C(I,12)=0 THEN 6180
6100  FOR K=1 TO C(I,12)
6110  IF R1(I,K)+R6(I,K)-1<P2 THEN 6150
6115  IF R1(I,K)-1>=P2 THEN 6170
6120  RA(I,K)=R9(I,K)*R7(I,K)*(1+C(I,7))^(P2-R1(I,K)+1)
6130  T(2,17)=T(2,17)+RA(I,K)/I2^P2
6140  GOTO 6170
6150  RB(I,K)=R9(I,K)*R7(I,K)*(1+C(I,7))^R6(I,K)
6160  T(2,18)=T(2,18)+RB(I,K)/(1+C(I,7))^(R1(I,K)+R6(I,K)-1)
6170  NEXT K
6180  NEXT I
6630  RETURN
7000  REM COMPUTE P.V. OF RECURRING O&M
7010  IF M2=I1 THEN 7050 
7020  M3=((1+M2)/(I1-M2))*(1-((1+M2)/I2)^P2)*(1+M2)^P1
7030  GOTO 7060 
7040  REM
7050  M3=P2*(1+M2)^P1
7060  T(2,21)=M1*M3
7070  REM COMPUTE P.V. OF NON-RECURRING O&M
7080  IF M4=0 THEN 7120
7090  FOR J=1 TO M4
7095  IF M(1,J)>P2 THEN 7110
7100  T(2,22)=T(2,22)+M(2,J)*((1+M5)^P1)*((1+M5)/I2)^M(1,J)
7110  NEXT J
7120  RETURN
8000  REM E1(3,I)=UPW* FOR ITH ENERGY TYPE
8010  IF E1=0 THEN RETURN
8020  FOR I=1 TO E1
8030  ON EM(I) GOSUB 8070,8175
8040  NEXT I:RETURN
8060  'USER-DESIGNATED ESCALATION RATES
8070  SS=0:FOR K=1 TO E1(2,I):IF SS+E2(I,K)<P2 THEN 8090
8080  E2(I,K)=P2-SS:E1(2,I)=K:GOTO 8100
8090  SS=SS+E2(I,K):NEXT K
8100  E1(3,I)=0 'E1(3,I) WILL BE UPW* FACTOR
8110  FOR K=1 TO E1(2,I):D9=1:IF K=1 THEN 8130
8120  FOR J=1 TO K-1:D9=(((1+E3(I,J))/I2)^E2(I,J))*D9:NEXT J
8130  IF I1=E3(I,K) THEN D8=E2(I,K):GOTO 8150
8140  D8=(1+E3(I,K))/(I1-E3(I,K))*(1-((1+E3(I,K))/I2)^E2(I,K))
8150  E1(3,I)=D9*D8+E1(3,I)
8160  NEXT K:GOTO 8300
8170  'DOE ESCALATION RATES (ALL 1-YEAR INTERVALS)
8175  IF P1=0 THEN E1(5,I)=0:GOTO 8190
8180  D1=1:FOR K=1 TO P1:D1=D1*(1+E3(1,K)):NEXT K
8185  E1(5,I)=D1^(1/P1)-1
8190  E1(3,I)=0 'E1(3,I) WILL BE UPW* FACTOR
8195  FOR K=P1+1 TO P3:D9=1:IF K=P1+1 THEN 8210
8200  FOR J=P1+1 TO K-1:D9=D9*(1+E3(I,J))/I2:NEXT J
8210  IF I1=E3(I,K) THEN D8=1:GOTO 8230
8220  D8=(1+E3(I,K))/(I1-E3(I,K))*(1-(1+E3(I,K))/I2)
8230  E1(3,I)=D9*D8+E1(3,I):NEXT K
8300  E1(4,I)=(E1(1,I)*E4(I)+E5(I))*E1(3,I)
8310  IF P1>0 THEN E1(4,I)=E1(4,I)*(1+E1(5,I))^P1
8330  T(2,25)=T(2,25)+E1(4,I):E1(4,I)=E1(4,I)/I2^P1
8340  RETURN
8500  REM
8595  REM DISCOUNT ALL T(2,I) FROM I=17 TO 27 FROM OCCUPANCY TO BEGINNING OF STUDY PERIOD.
8600  FOR I=17 TO 27
8610  T(2,I)=T(2,I)/I2^P1
8615  NEXT I
8625  T(3,1)=T(2,17)+T(2,18)
8649  T(3,5)=T(2,21)+T(2,22)
8655  T(3,7)=T(2,2)+T(2,6)
8660  T(3,18)=T(2,27)
8670  T(3,19)=T(2,25)
8690  T(3,12)=T(3,5)+T(3,7)+T(3,18)+T(3,19)-T(3,1)
8740  REM COMPUTE CAPITAL RECOVERY FACTOR TO FIND ANNUALIZED VALUES
8742  IF I1<> 0 THEN 8750
8745  D9=1/P3:GOTO 8760
8750  D9=(I1*I2^P3)/(I2^P3-1)
8760  FOR I=1 TO 27:T(4,I)=T(2,I)*D9:T(5,I)=T(3,I)*D9:NEXT I
8900  RETURN
9000  PRINT "WRITING LCC ANALYSIS RESULTS TO LCC OUTPUT FILE "O$
9010  OPEN "O",1,D2$+":"+O$+".LCC"
9015  PRINT #1,"OUTPT"
9017  PRINT #1,I$
9019  PRINT #1,A$
9020  DT$=DATE$+" "+TIME$
9025  PRINT #1,DT$
9027  PRINT #1,TN$
9030  PRINT #1,P1,P3,Y1,Y2,RG,I1,T7,AF,TYPE,C1
9040  IF C1=0 THEN 9210
9050  FOR I=1 TO C1
9060  IF P1=0 THEN 9090
9070  FOR J=1 TO P1+1:PRINT #1,Q(I,J),T1(I,J),T2(I,J):NEXT J
9090  PRINT #1,C$(I)
9100  PRINT #1,C(I,14)
9110  NEXT I
9210  FOR I=1 TO 5:FOR J=1 TO 27:PRINT #1,T(I,J):NEXT J:NEXT I
9220  PRINT #1,E1:IF E1=0 THEN 9260
9230  FOR I=1 TO E1:PRINT #1,E(I),E1(1,I),E1(3,I),E1(4,I),E4(I),E5(I):NEXT I
9260  CLOSE 1
9270  PRINT:PRINT:PRINT "OUTPUT DATA SAVED IN FILE "O$
9275  PRINT:PRINT:INPUT "DO YOU WANT SUMMARY OUTPUT ON SCREEN (Y/N)";QQ$
9277  IF QQ$="Y" OR QQ$="y" THEN GOSUB 9500
9280  RETURN
9500  CLS:PRINT "LCC SUMMARY FOR "A$
9510  PRINT "                                   PRESENT VALUE      ANNUAL VALUE"
9520  FF$=  "\                                  \ $$########,       $$########,
9530  PRINT USING FF$;"INITIAL INVESTMENT", T(3,7),T(5,7)
9550  PRINT USING FF$;"ANNUALLY RECURRING O&M COSTS",T(2,21),T(4,21)
9560  PRINT USING FF$;"NON-AN. RECURRING O&M COSTS",T(2,22),T(4,22)
9570  PRINT USING FF$;"ENERGY COSTS",T(2,25),T(4,25)
9590  IF T(2,27)>0 THEN PRINT USING FF$;"REPLACEMENT COSTS",T(2,27),T(4,27)
9610  PRINT USING FF$;"LESS: REMAINING VALUE",T(3,1)*(-1),T(5,1)*(-1)
9620  PRINT "--------------------------------------------------------------------
9630  PRINT USING FF$;"TOTAL LCC ",T(3,12),T(5,12)
9650  PRINT:INPUT "PRESS <ENTER> TO CONTINUE",QQ
9660  RETURN
10000  REM PRINT MENU
10020  PRINT "  (1) COMPUTE LCC FOR ANOTHER PROJECT."
10035  F9=0
10040  PRINT "  (2) PRINT OUT LCC ANALYSES (GO TO PRINTLCC PROGRAM)"
10050  PRINT "  (3) CREATE/MODIFY BUILDING CHARACTERISTICS FILE (GO TO LCCDATA PROGRAM)"
10060  PRINT "  (4) PRINT OUT BUILDING CHARACTERISTICS FILE (GO TO PRINTBCF PROGRAM)"
10070  PRINT "  (5) COMPARE LCC OF TWO PROJECTS (GO TO COMPARE PROGRAM)"
10080  PRINT "  (6) STOP"
10090  INPUT "ENTER JOB CODE: ",A1
10100  ON A1 GOTO 11000,11175,11175,11175,11175,10200
10110  GOTO 10090
10120  GOSUB 11370:GOTO 11042
10200  INPUT "EXIT TO SYSTEM (S) OR BASIC (B)";QQ$
10210  IF QQ$="S" OR QQ$="s" THEN SYSTEM ELSE END
11000  REM READ DATA FROM BLDG CHAR FILE, PERFORM LCC ANALYSIS, WRITE OUTPUT FILE
11030  GOSUB 11200
11040  GOSUB 190
11047  I2=1+I1
11050  IF TYPE=1 THEN AF=0.1 ELSE AF=0 '10% FIRST COST ADJUSTMENT FACTOR
11055  GOSUB 1120
11060  GOSUB 9000
11070  CLS:PRINT "CHOOSE NEXT JOB:":GOTO 10000
11175  REM LEAVE LCCMAIN
11180  Q$(2)="PRINTLCC":Q$(3)="LCCDATA":Q$(4)="PRINTBCF": Q$(5)="COMPARE"
11190  PRINT:PRINT:PRINT "LOADING ";Q$(A1)
11195  RUN Q$(A1)+".BAS"
11200  REM VERIFY INPUT DATA FILE
11205  ON ERROR GOTO 11260
11207  IF F8=1 THEN 11225
11210  I$="":INPUT "ENTER BLDG CHARACTERISTICS FILE NAME: ",I$
11220  IF I$="" THEN 185
11222  PRINT "WHICH DRIVE TO FIND "I$" (A, B, C)";:INPUT D1$
11223  IF D1$="A" OR D1$="B" OR D1$="C" THEN 11225 ELSE 11222
11225  F8=0
11230  OPEN "I",1,D1$+":"+I$+".BCF"
11250  GOTO 11280
11260  PRINT "FILE "I$" IS NOT ON DISK. DO AGAIN..."
11270  RESUME 11210
11280  ON ERROR GOTO 0
11290  INPUT #1,F3$:CLOSE 1
11300  IF F3$=I$ OR F3$="BCFFILE" THEN 11360
11310  PRINT "FORMAT IS INCORRECT IN FILE "I$". DO YOU WANT TO TRY "
11320  INPUT "ANOTHER BLDG. CHARACTERISTICS FILE (Y/N)";Q1$
11330  IF LEFT$(Q1$,1)="N" THEN 10000
11340  IF LEFT$(Q1$,1)="Y" THEN 11200
11350  GOTO 11310
11360  REM
11370  ON ERROR GOTO 11450
11380  PRINT:INPUT "ENTER LCC OUTPUT FILE NAME TO STORE RESULTS OF THIS LCC ANALYSIS: ",O$
11392  IF O$="" THEN 11380
11395  PRINT "DISK TO STORE "O$" (A, B, C)";:INPUT D2$
11396  IF D2$="A" OR D2$="B" OR D2$="C" THEN 11400 ELSE 11395
11400  OPEN "I",1,D2$+":"+O$+".LCC"
11402  ON ERROR GOTO 11503
11403  INPUT #1,F$:CLOSE 1
11410  PRINT "FILE "O$" ALREADY HAS DATA. DO YOU WANT TO WRITE OVER THIS (Y/N)";:INPUT Q2$
11420  IF LEFT$(Q2$,1)="N" THEN 11370
11430  IF LEFT$(Q2$,1)="Y" THEN 11508
11440  GOTO 11410
11450  RESUME 11460
11460  ON ERROR GOTO 11490
11470  OPEN "O",1,D2$+":"+O$+".LCC":CLOSE 1
11480  GOTO 11510
11490  PRINT O$" IS NOT A GOOD FILE NAME. FILE NAMES MUST BEGIN WITH A LETTER"
11491  PRINT " AND HAVE NO MORE THAN 8 CHARACTERS."
11500  RESUME 11370
11503  CLOSE 1
11505  RESUME 11510
11508  ERASE D2$+":"+O$+".LCC"
11510  ON ERROR GOTO 0
11520  RETURN
