500   ' COPYRIGHT 1986 TRONOLONE & FOSTER, PC
1000  REM GENLGR.BAS
1010  CLEAR: ON ERROR GOTO 3070
1080  CLS: LOCATE 1,1
1090  PRINT"THIS PROGRAM IS TO BE USED FOR ESTABLISHING A NEW GENERAL LEDGER.  IT SHOULD BE"
1100  PRINT"USED AT THE BEGINNING OF EACH YEAR.  BEFORE YOU USE THIS PROGRAM, MAKE SURE"
1110  PRINT"THAT LAST YEAR'S DATA FILES HAVE BEEN COPIED TO DISKETTE.  CPA-LEDGER WILL"
1120  PRINT"COMPLETELY ERASE ANY DATA FILES THAT ARE NOW ON HARD DISK.": PRINT
1140  PRINT"AFTER THIS PROGRAM HAS COMPLETED ITS PROCESSING, A LISTING OF ALL AVAILABLE"
1150  PRINT"ACCOUNTS (ACTIVE AND INACTIVE) WILL BE PRINTED ON THE PRINTER.  REVIEW THE"
1160  PRINT"PRINTOUT VERY CAREFULLY AND NOTE ANY ERRORS, SUCH AS MISSPELLED ACCOUNT TITLES"
1170  PRINT"OR INCORRECT DESIGNATIONS AS TO WHETHER AN ACCOUNT HAS A NORMAL DEBIT OR"
1180  PRINT"NORMAL CREDIT BALANCE.  IF YOU NOTE ANY ERRORS, RERUN THIS COMPUTER PROGRAM BY"
1190  PRINT"SELECTING OPTION 1 AGAIN FROM THE SETUP MENU.  IT IS VERY IMPORTANT THAT YOUR"
1200  PRINT"PRINTOUT BE ERROR FREE BECAUSE THERE IS NO OTHER PROVISION FOR CORRECTING YOUR"
1210  PRINT"MISTAKES.": PRINT
1220  PRINT"THIS VERSION OF CPA-LEDGER IS FOR CORPORATIONS.  ALSO, THIS SHOULD BE THE FIRST"
1230  PRINT"CPA-LEDGER COMPUTER PROGRAM THAT YOU USE EACH ACCOUNTING YEAR.  ONCE YOUR"
1240  PRINT"GENERAL LEDGER IS ESTABLISHED AND YOU AGREE WITH THE PRINTED OUTPUT, THIS"
1250  PRINT"PROGRAM SHOULD NOT BE USED AGAIN UNTIL THE BEGINNING OF THE NEXT ACCOUNTING"
1260  PRINT"YEAR.  DO YOU WISH TO ESTABLISH A NEW GENERAL LEDGER?": C5=22: GOSUB 2520
1270  IF I8$="N" OR I8$="n" THEN GOTO 3130 ELSE CLS: LOCATE 10,36: PRINT "STAND BY.": OPEN "PASACT.FIL" FOR OUTPUT AS  #1: CLOSE: KILL "*.FIL"
1280  CLS: LOCATE 10,1: PRINT"ENTER YOUR BUSINESS NAME. ";: ROW=10: COLUMN=44: LENGTH=30: GOSUB 2860
1290  IF LEFT$(I8$,1) < "A" OR LEFT$(I8$,1) > "Z" THEN GOTO 1280
1300  T1$=I8$
1310  DATA BALANCE SHEET,INCOME STATEMENT
1320  DATA CURRENT ASSETS,1,1
1330  DATA INVESTMENTS AND FUNDS,1,2
1340  DATA OPERATIONAL ASSETS,1,3
1350  DATA INTANGIBLE ASSETS,1,4
1360  DATA OTHER ASSETS,1,5
1370  DATA DEFERRED CHARGES,1,6
1380  DATA CURRENT LIABILITIES,2,7
1390  DATA LONG-TERM LIABILITIES,2,8
1400  DATA CONTRIBUTED CAPITAL,3,9
1410  DATA OTHER CONTRIBUTED CAPITAL,4,10
1420  DATA RETAINED EARNINGS,5,11
1430  DATA ALL OTHER EQUITY,6,12
1440  DATA SALES,7,1
1450  DATA PURCHASES,8,2
1460  DATA OPERATING EXPENSES,9,3
1470  DATA OTHER REVENUES AND GAINS,10,4
1480  DATA OTHER EXPENSES AND LOSSES,11,5
1490  DATA EXTRAORDINARY GAINS,12,6
1500  DATA EXTRAORDINARY LOSSES,13,7
1510  DATA INCOME TAX EXPENSE,14,8
1520  B2=36: B3=24: B4=36: E1=2:
1530  DIM B(20) 'QTY OF ACCT CLASSI - CHG AS REQUIRED
1540  DIM A1$(2): DIM A2$(B2): DIM A3$(B3)
1550  CLS: LOCATE 10,16
1560  PRINT"STAND BY.  YOUR DATA FILES ARE BEING INITIALIZED."
1570   GOSUB 2150: CLS
1580  GOSUB 2850: LOCATE 10,1: PRINT"ENTER TODAY'S DATE (USE FORMAT MMDDYY. I.E., JUNE 8, 1984 = 060884).";: ROW=10: COLUMN=72: LENGTH=6: GOSUB 2860
1590  GOSUB 2640
1600  IF F1=1 OR I8$ < "0" OR I8$="" OR LEN(I8$) < 6 THEN CLS: GOTO 1580
1610  CLS: I1$=I8$
1620  FOR I=1 TO 2
1630  LOCATE 8,1
1640  PRINT"THE FOLLOWING QUESTIONS PERTAIN TO THE ";A1$(I);"."
1650  IF I=2 THEN B2=B3
1660  FOR J=1 TO B2
1670  GOSUB 2230
1671  IF PF=1 THEN PF=0: LOCATE 15,1: PRINT SPACE$(80): LOCATE 16,1: PRINT SPACE$(80)
1672  IF I2$="PURCHASES" THEN PF=1: LOCATE 15,1: PRINT"IF YOU DO NOT WISH TO HAVE A COST OF GOODS SOLD SECTION ON YOUR INCOME STATE-"
1674  IF I2$="PURCHASES" THEN LOCATE 16,1: PRINT"MENT, ENTER 0 (ZERO).  SEE THE USER'S MANUAL FOR DETAILS."
1680  LOCATE 10,1: PRINT SPACE$(80): LOCATE 10,1: PRINT"HOW MANY `";I2$;"' ACCOUNTS DO YOU WISH TO CREATE? ";
1690  GOSUB 2850: ROW=10: COLUMN=70: LENGTH=2: GOSUB 2860
1700  GOSUB 2470  'CHK NUM
1710  IF F1=1 OR I8$ < "0" THEN GOTO 1690
1720  I1=VAL(I8$): C1=I1
1722  IF I2$="RETAINED EARNINGS" AND I1 < 1 THEN LOCATE 15,1: PRINT"AT LEAST ONE RETAINED EARNINGS ACCOUNT IS REQUIRED.": GOTO 1690
1730  IF I1 > 0 THEN CLS: GOTO 1770
1740  ' WRITE EXTRA ACCTS FOR CLASSI WITH NO ACTIVE ACCTS
1750  FOR K = 1 TO 6: I3$="INACTIVE ACCOUNT": I4$=" ": I5$="0": GOSUB 2270: NEXT K: F20=F20+1: B(F20)=6: GOTO 1940
1760  ' B( = NBR ACCTS WRITTEN FOR CLASSI WITH ACTIVE ACCTS.
1770  F20=F20+1: B(F20)=((C1*4)+2)  ' C1=ACTIVE ACCTS,C1*X=ACTIVE ACCTS + INACTIVE ACCTS FOR EACH ACTIVE ACCT, +Y=QTY INACTIVE ACCTS ADDED AT BEGINNING OF EACH CLASSIFICATION. C1*X+Y=TOT ACCTS IN A CLASSIFICATION
1780  FOR K = 1 TO C1  'C1=QTY ACTIVE ACCTS REQUESTED
1790  IF K  > 1 THEN GOTO 1820
1800  ' ADD INACTIVE ACCTS AT START OF CLASSIFICATION
1810  FOR W = 1 TO 2: I3$="INACTIVE ACCOUNT": I4$=" ": I5$="0": GOSUB 2270: NEXT W
1820  CLS: LOCATE 10,1: PRINT"ENTER THE TITLE OF `";I2$;"' ACCOUNT NUMBER ";K;" OF ";I1; " BELOW."
1830  GOSUB 2850: ROW=12: COLUMN=25: LENGTH=30: GOSUB 2860: I3$=I8$
1840  IF LEFT$(I3$,1) < "A" OR LEFT$(I3$,1) > "Z" THEN GOTO 1830
1850  LOCATE 15,1: PRINT"ENTER  `D'  FOR  `DEBIT' BALANCE OR A  `C'  FOR  `CREDIT' BALANCE.";
1860  GOSUB 2850: ROW=15: COLUMN=75: LENGTH=1: GOSUB 2860: I4$=I8$
1870  IF I4$="D" OR I4$="C" THEN GOTO 1890
1880  GOTO 1860
1890  CLS: GOSUB 2390
1900  IF F1=1 THEN F1=0: GOTO 1820
1910  I5$="1": GOSUB 2270
1920  FOR W = 1 TO 3: I3$="INACTIVE ACCOUNT": I4$=" ": I5$="0": GOSUB 2270: NEXT W
1930  NEXT K
1940  NEXT J
1950  NEXT I
1960  'PRINT GENERAL LEDGER CHART OF ACCOUNTS ON THE PRINTER.
1970  B2=B4: C2=0: F20=0: CLS: LOCATE 10,36: PRINT"STAND BY.": LOCATE 12,36: PRINT "PRINTING."
1980  GOSUB 2700  'PRINT PAGE HEADINGS
1990  FOR I = 1 TO 2  'PRINT IDENTITY OF FINANCIAL STATEMENT
2000  IF C3 > 57 THEN B5=66-C3: GOSUB 2820: GOSUB 2700
2010  IF I=2 THEN LPRINT: C3=C3+1
2020  C3=C3+1
2030  LPRINT STRING$(27,"*");A1$(I);" ACCOUNTS";STRING$(27,"*"): IF I=2 THEN B2=B3
2040  FOR J=1 TO B2  'PRINT ACCT CLASSI (I.E., CURRENT ASSETS)
2050  C3=C3+2
2060  IF C3 > 57 THEN B5=66-C3: GOSUB 2820: GOSUB 2700
2070  GOSUB 2230: LPRINT: LPRINT I2$
2080  F20=F20+1: C1=B(F20)
2090  FOR K=1 TO C1  'PRINT THE ACCOUNT
2100  C2=C2+1: GET #1,C2: GOSUB 2330: LASTACTNO=C2
2110  C3=C3+1: IF C3 < 60 THEN GOTO 2130
2120  B5=66-C3: GOSUB 2820: GOSUB 2700
2130  NEXT K: NEXT J: NEXT I
2132  CLOSE
2134  OPEN "PASACT.FIL" FOR OUTPUT AS #2
2136  FRMCHK=30000: WRITE #2,LASTACTNO,FRMCHK
2140  FOR I=1 TO 10: LPRINT: NEXT I: GOTO 3130   'EOF
2150  OPEN "TEST1.FIL" FOR OUTPUT AS #3: CLOSE #3
2160  OPEN "R",1,"GENLEG.FIL",111
2170  FIELD #1,25 AS X1$,30 AS X2$,6 AS X3$,1 AS X4$,4 AS X5$,2 AS X7$,1 AS X8$,10 AS X9$,8 AS Y1$,8 AS Y2$,8 AS Y3$,8 AS Y4$
2180  OPEN "GENJNL.FIL" FOR OUTPUT AS #2
2190  FOR I = 1 TO 2: READ I9$: A1$(I)=I9$: NEXT I
2200  FOR I = 1 TO B2: READ I9$: A2$(I)=I9$: NEXT I
2210  FOR I = 1 TO B3: READ I9$: A3$(I)=I9$: NEXT I
2220  RETURN
2230  IF I=2 THEN GOTO 2250
2240  I2$=A2$(J): J=J+1: I8$=A2$(J): J=J+1: I9$=A2$(J): GOTO 2260
2250  I2$=A3$(J): J=J+1: I8$=A3$(J): J=J+1: I9$=A3$(J)
2260  I6$=I8$: I7$=I9$: RETURN
2270  LSET X1$=I2$: LSET X2$=I3$: LSET X3$=I1$: LSET X4$=I5$
2280  C2=C2+1
2290  LSET X5$=MKS$(C2): LSET X6$=I6$: LSET X7$=I7$: LSET X8$=I4$
2300  T2$="               ": LSET X9$=T2$
2310  LSET Y1$=MKD$(0
