100 'Loan Qualification ("LOANQUAL")
110 CLS
120 COLOR 0,15 : PRINT "Loan Qualification" : COLOR 15,0
130 DEFDBL A-Z
140 DEFINT M-N
150 MONEYFMT$ = "$$##,###,###.##"
160 '     Let user enter data
170 PRINT : PRINT
180 PRINT "Do not enter dollar signs or commas"
190 PRINT
200 INPUT "Monthly payment: ", PMT
210 INPUT "Term (in months): ", NMONTHS
220 INPUT "Annual interest rate (in percent): ", AR
230 PR = AR / 1200    'Convert to monthly interest rate
240 '     Find present value of payments
250 IF PR <> 0  THEN PNCPL = (PMT / PR) * (1 - (1 + PR) ^ -NMONTHS)                             ELSE PNCPL = PMT * NMONTHS
260 '     Print results
270 PRINT
280 PRINT "Borrower can qualify for loan of ";
290 PRINT USING MONEYFMT$ ; PNCPL
300 END
