10  REM ***********************************************************
20  REM ** A DECISION MAKER
30  REM ** WRITTEN BY PHIL FELDMAN AND TOM RUGG - APRIL 1977
40  REM ** KILOBAUD MAGAZINE - JULY 1977 - PAGE 90
50  REM ** CONVERTED TO IBM PC WITH SOME SLIGHT CHANGES
60  REM ** BY ROBERT N. ANDERSON - K4OSW - 3/29/82
70  REM ***********************************************************
80  CLS : KEY OFF
90  LOCATE 13,32
100  PRINT "A DECISION MAKER"
110  FOR X=1 TO 5000 : NEXT
120  CLS
130  DIM F$(10),L$(10),F(10),M(10,10),V(10),Z(10)
140  Y$="Y"
150  Y1$="y"
160  PRINT "     I CAN HELP YOU MAKE DECISIONS BY CHOOSING THE"
170  PRINT "BEST POSSIBILITY FOR YOU OUT OF SEVERAL ALTERNATIVES."
180  PRINT "ALL I NEED TO DO IS ORGANIZE INFORMATION YOU ALREADY HAVE."
190  PRINT " " : PRINT "     WHICH OF THESE BEST DESCRIBES THE TYPE OF"
200  PRINT "DECISION YOU HAVE TO MAKE ?" : PRINT " "
210  PRINT "  1 - CHOOSE AN ITEM FROM SEVERAL ALTERNATIVES"
220  PRINT "  2 - CHOOSE A COURSE OF ACTION FROM SEVERAL ALTERNATIVES"
230  PRINT " " : INPUT"WHICH TYPE ( 1 OR 2 ) DO YOU HAVE TO MAKE ";C
240  IF C<1 THEN 230
250  IF C>2 THEN 230
260  PRINT " " : IF C=1 THEN PRINT "     WHAT TYPE OF ITEM IS IT THAT YOU"
270  IF C=1 THEN PRINT "NEED TO DECIDE UPON ":INPUT S$
280  IF C=2 THEN S$="COURSE OF ACTION"
290  CLS : PRINT "     I WILL NOW NEED A LIST OF EACH ";S$
300  PRINT "THAT YOU ARE CONSIDERING. PLEASE INPUT THEM ONE AT A"
310  PRINT "TIME. THE ORDER IS OF NO IMPORTANCE."
320  PRINT " " : INPUT"     FIRST, HOW MANY ARE THERE ALTOGETHER ";L0
330  IF (L0>=2) AND (L0<=10) THEN 350
340  GOSUB 950 : GOTO 320
350  PRINT " " : FOR I = 1 TO L0 :PRINT " " : PRINT "NUMBER ";I;" PLEASE"
360  INPUT L$(I) : NEXT I : CLS
370  PRINT "O.K. THIS IS THE LIST UNDER CONSIDERATION" : PRINT " "
380  FOR I= 1 TO L0 : PRINT I ; TAB(5);L$(I) : NEXT I : PRINT " " : GOSUB 960
390  IF B$=Y1$ THEN 410 ELSE 400
400  IF B$<>Y$ THEN 290
410  CLS : PRINT "     NOW, HOW MANY DIFFERENT FACTORS ARE IMPORTANT"
420  PRINT "TO YOU IN CHOOSING A ";S$ :INPUT F0
430  IF (F0>=1) AND (F0<=10) THEN 450
440  GOSUB 950 :GOTO 410
450  PRINT " " : PRINT  "     I NEED A LIST OF EACH OF THESE FACTORS"
460  FOR I = 1 TO F0 : PRINT " " : PRINT "FACTOR NUMBER ";I :INPUT F$(I) : NEXT
470  CLS : PRINT "     NOW LOOK AT THE FOLLOWING LIST OF FACTORS YOU"
480  PRINT "HAVE PROVIDED AND DECIDE WHICH IS THE MOST IMPORTANT"
490  PRINT " " : FOR I=1 TO F0 : PRINT I;TAB(5);F$(I) : NEXT
500  PRINT " " : PRINT "     WHICH FACTOR ( BY NUMBER ) IS MOST IMPORTANT ?"
510  PRINT "( INPUT 0 IF YOU WISH TO CHANGE THE LIST )" :INPUT F2
520  IF F2=0 THEN 410
530  IF F2<1 THEN 500
540  IF F2>F0 THEN 500
550  CLS : PRINT "     O.K. SUPPOSE WE HAVE A SCALE OF IMPORTANCE THAT"
560  PRINT "RANGES FROM 0 TO 10. LET'S SAY ";F$(F2)
570  PRINT "HAS A VALUE OF 10 SINCE IT IS AT THE TOP OF THE SCALE. ON"
580  PRINT "THIS SCALE, WHAT VALUE WOULD EACH OF THE OTHER FACTORS"
590  PRINT "HAVE ( DECIMAL NUMBERS ARE O.K. ) ?" : PRINT " " : FOR I=1 TO F0
600  IF I=F2 THEN 630
610  PRINT F$(I) : INPUT F(I) : IF (F(I)>=0) AND (F(I)<=10) THEN 630
620  PRINT "     YOUR INPUT IS NO GOOD, TRY AGAIN..." :GOTO 610
630  NEXT : F(F2)=10 : C=0 : FOR I=1 TO F0 : C=C + F(I) : NEXT : FOR I=1 TO F0
640  F(I)=F(I) / C : NEXT : CLS : PRINT "     NOW CONSIDER HOW EACH ";S$
650  PRINT "RATES WITH RESPECT TO EACH OF THE FACTORS. WE WILL"
660  PRINT "CONSIDER EACH FACTOR SEPARATELY AND THEN RATE EACH"
670  PRINT S$;" IN TERMS OF THAT FACTOR ONLY." : PRINT " "
680  PRINT "LET'S CONSIDER ";L$(1);" TO HAVE A"
690  PRINT "VALUE OF 10 ON EACH SCALE. THEN EVERY OTHER ";S$
700  PRINT "WILL BE GIVEN A NUMBER HIGHER OR LOWER THAN 10"
710  PRINT "ACCORDING TO HOW MUCH BETTER OR WORSE THAN"
720  PRINT L$(1);" YOU THINK IT IS." : FOR I=1 TO F0 : PRINT " "
730  PRINT "CONSIDERING ";F$(I);" ONLY, AND"
740  PRINT "ASSUMING ";L$(1);" HAS A VALUE OF 10,"
750  PRINT "WHAT VALUE WOULD YOU GIVE TO EACH OF THE FOLLOWING :"
760  PRINT " " : FOR J=2 TO L0
770  PRINT L$(J) : INPUT M(J,I) : IF M(J,I)>=0 THEN 790
780  PRINT "     C'MON.  NO NEGATIVE NUMBERS.  TRY AGAIN." : GOTO 770
790  NEXT J : PRINT " " : M(1,I)=10 :NEXT I : FOR I=1 TO F0 : C=0 :FOR J=1 TO L0
800  C=C + M(J,I) : NEXT J : FOR J=1 TO L0 : M(J,I)=M(J,I) / C : NEXT J : NEXT I
810  FOR J=1 TO L0 : V(J)=0 : FOR I=1 TO F0 : V(J)=V(J) + M(J,I) * F(I)
820  NEXT I : NEXT J : FOR I=1 TO 10 : Z(I)=I :NEXT : C=L0 - 1 : FOR J=1 TO L0
830  FOR I=1 TO C : N1=Z(I) : N2=Z(I + 1) : IF V(N1)>V(N2) THEN 850
840  Z(I + 1)=N1 : Z(I)=N2
850  NEXT I : NEXT J : C1=Z(1) : C2=Z(2) : C=100 / V(C1) : FOR J=1 TO L0
860  V(J)=C * V(J) : NEXT : CLS : D=V(C1) - V(C2)
870  PRINT "     WELL, YOUR BEST CHOICE SEEMS TO BE ";L$(C1)
880  IF D<10 THEN PRINT "BUT ITS PRETTY CLOSE."
890  IF (D<20) AND (D>10) THEN PRINT "BY A FAIR MARGIN."
900  IF D>=20 THEN PRINT "BY A GOOD-SIZED MARGIN."
910  PRINT " " : PRINT "     HERE'S THE FINAL LIST WITH ";L$(C1)
920  PRINT "GIVEN A VALUE OF 100 AND THE OTHERS SET ACCORDINGLY"
930  PRINT " " : PRINT  " " : PRINT "RATING";TAB(17);S$ : FOR J=1 TO L0 : C=Z(J)
940  PRINT V(C),L$(C) : NEXT : GOTO 980
950  PRINT " " : PRINT "     THE NUMBER MUST BE BETWEEN 2 AND 10 !" : RETURN
960  INPUT"     IS THIS CORRECT (YES OR NO) ";A$
970  B$=LEFT$(A$,1) : RETURN
980  LOCATE 23,1
990  PRINT "Press any key to terminate program....."
1000  A$=INKEY$ : IF A$="" THEN 1000
1010  CLS : KEY ON : END
