2  'ORIGINAL PROGRAM APPEARED IN MATRIX #2
3  '   Program has been augmented in several areas           and any errors introduced are not the
4  '        responsibility of M. Erlewine
15  GOSUB 4000
20  CLS
30  CLEAR 5000
40  DIM X(12),Y(12),C$(12), ZD$(12)
50  GOSUB 2410
60  WW$="\ \ ###.## ##.# "
70  DATA ARI,TAU,GEM,CAN,LEO,VIR,LIB,SCR,SAG,CAP,AQU,PIS
80  DATA EAR,MER,VEN,MAR,JUP,SAT,URA,NEP,PLU,MON,NOD
90  REM CONVERTS SECONDS TO DEGREES WITHIN 360 CIRCLE
100  DEF FNP(X)=SGN(X)*((ABS(X)/M)/360-INT((ABS(X)/M)/360))*360
110  PI=3.14159
120  REM CONVERTS DEGREES TO RADIANS
130  DEF FNR(X)=X*PI/180
140  REM CONVERTS RADIANS TO DEGREES
150  DEF FND(X)=X*180/PI
160  REM CASTS OUT CIRCLES WITHIN 360
170  DEF FNU(X)=X-(INT(X/360)*360)
180  REM    CONVERTS DD.MM FORMAT TO DD.DECIMAL FORMAT
190  DEF FNQ(X)=SGN(X)*(INT(ABS(X))+(ABS(X)  -INT(ABS(X)))*100/60)
200  REM SINE FUNCTION WHEN WORKING IN DEGREES
210  DEF FNS(X)=SIN(X*PI/180)
220  REM ARCSINE FUNCTION WHEN WORKING IN DEGREES
230  DEF FNX(X)=ATN(X/(1-X*X)^0.5)
240  REM ROUND TO TWO PLACES
250  DEF FNW(X)=INT(X*100+0.5)/100
260  DEF FNZ$(X)= ZD$(INT(X/30)+1):DEF FNY(X)=(FNW(X-(INT(X/30)*30)))
270  FOR I = 1 TO 12: READ ZD$(I): NEXT I
280  FOR I = 1 TO 11: READ C$(I): NEXT I
290  REM INPUT EVENT INFO FROM KEYPAD
300  INPUT "DATE:MM.DDYYYY=";A$: M = VAL ( MID$ ( A$, 1,2 ))
310  Y = VAL ( MID$(A$, 6, 4)): D= VAL ( MID$ (A$, 4, 2))
320  INPUT " AM OR PM"; F$: INPUT " TIME: HH.MM"; F1
330  INPUT " TIME ZONE: H" ; XQ
340  F= FNQ(F1) + XQ: IF F$= "PM"  THEN F= F+12
350  INPUT "LONGITUDE:  DD.MM";LQ: LO=FNQ(LQ)
360  INPUT "LATITUDE: DD.MM"; LW: LA = FNR(FNQ(LW))
370  REM JULIAN DAY NUMBER ROUTINE   ( USE FOR 1900-2000 ONLY)
380  JD=367*Y-INT(7*(Y+INT((M+9)/12))/4)+INT (275*M/9)+D+1.72101E+06
390  JD=JD-0.5*SGN(100*Y+M-190002)+0.5
400  REM T=TIME INTERVAL FROM EPOCH 1900.0
410  T=((JD-2.41502E+06) + F/24) /36525
420  REM RAMC (LOCAL SIDEREAL TIME
430  RA= FNR(FNU((6.64607+2400.05*T+2.5803E-05*T*T+F) *15 - LO))
440  REM OBLIQUITY OF THE ECLIPTIC FOR EPOCH
450  OE = FNR ( 23.4523-0.0130125 * T)
460  REM ANGLES SUBROUTINE ( SET-UP )
470  R2 = RA: OB  = - OE: B = LA: GOSUB 1110
480  REM  BEGIN PLANETS ROUTINE
490   PRINT"   HELIO"; TAB(23); "GEOCENTRIC"
500  FOR I = 1 TO 11
510  IF I = 10 GOTO 1530 :   REM  MOON ROUTINE
520  IF I =11 THEN G =TN: A = 0: GOTO 820  : REM  TRUE LUNAR NODE
530  REM CALCULATE MEAN ANOMALY & ECCENTRICITY ( IN RADIANS)
540  GOSUB 1380 : M=FNR(FNU(S)): GOSUB 1380 : E = S
550  REM SOLVE KEPLER'S EQUATION FOR ECCENTRIC ANOMALY
560  EA = M: FOR A% = 1 TO 5: EA = M + E * SIN (EA): NEXT A%
570  REM COMPUTE PERIFOCAL COORDINATES
580  READ AU:X= AU*(COS(EA)-E):Y=AU * SIN(EA)* (1-E*E)^0.5
590  REM ROTATE THROUGH CLASSICAL ORIENTATION ANGLE
600  GOSUB 1430 : GOSUB 1380 : A = A +FNR(S): GOSUB 1400
610  D=X:X=Y:Y=0:GOSUB 1430 : GOSUB 1380 : AN=  FNR(S): GOSUB 1380
620  A=A+FNR(S)
630  GOSUB 1400 : G=Y: Y=X:X=D: GOSUB 1430
640  A = A + AN: IF A < 0 THEN A = A + 2 * PI
650  REM CONVERT HELIO RECTANGULAR TO HELIO SPHERICAL COORDINATE
660  GOSUB 1400 : XX = X: YY = Y: ZZ = G: GOSUB 1430
670  C = FNU(FND(A)): X = R: Y = G: GOSUB 1430
680  D = FND(A): IF D > 20 THEN D = D - 360
690  REM  DIRECT OR RETROGRADE MOTION? (USING CIRCULAR ORBITS)
700  IF I = 1 THEN X1=XX: Y1=YY: Z1=ZZ: M1 =R:C1=C: GOTO 730
710  R =((R^0.5+M1^0.5)*(M1^0.5*R^0.5))/(R^1.5+M1^1.5)
720  RX=R-COS (FNR(C1)-FNR(C))
730  IF I = 1 THEN X1 =XX: Y1=YY: Z1=ZZ: G= FNR(FNU(C+180)): GOTO 810
740  REM TRANSFORM HELIO RECTANGULAR TO GEO RECTANGULAR COORDS
750  X = XX- X1: Y = YY - Y1: Z = ZZ - Z1
760  REM CONVERT GEO RECTANGULAR TO GEO SPHERICAL COORDINATES
770  GOSUB 1430 : G = A: Y = Z: X = R: GOSUB 1430
780  IF A > 0.35 THEN A = A -2 * PI
790  IF I = 10 OR I = 11 THEN GOTO 830
800  REM   PRINT HELIO TO GEO COORDINATES
810  PRINT USING WW$;C$(I); FNW(C); FNW(D);
820  R$="": IF RX < 0 THEN R$ = "R"
830  C$(1)="SUN": PRINT TAB(21);USING WW$; C$(I); FNW(FND(G));FNW(FND(A));:PRINT R$;TAB(44);:PRINT USING "\ \ ##.##";FNZ$(FNW(FND(G)));FNY(FNW(FND(G)))
840   REM STORE GEO COORDINATE ( IN RADIANS )
850   X(I)=G: Y(I)=A:NEXT I
860  REM  CONVERT GEO PLANETS FROM ECLIPTIC TO R.A. & DECLI.
870  FOR I = 1 TO 11:  L= X(I):B=Y(I):OB=OE:GOSUB 1050
880  X(I)=G:Y(I)=Q
890  NEXT I: GOTO 1170
900  REM <UNK! {0009}>END MAIN PROGRAM, BEGIN SUBSECTIONS
910  REM     LOCAL SPACE:HORIZON SYSTEM
920  CLS:PRINT TAB(27);"LOCAL SPACE": PRINT
930  OB=-(PI/2-LA): R2=RA+PI/2:L3=LO: R3=RA
940  FOR I = 1 TO 11: L=X (I) -R2: B=Y(I): GOSUB 1050
950  PRINT TAB(23);USING "\  \  ###.##  ###.#";C$(I); FNW(FND(G)); FNW(FND(Q)): NEXT I
960  IF S =1 THEN  OB =S7: S = O
970  PRINT
980  GOTO 1170
990  REM  LOCAL SPACE:<UNK! {0009}>RELOCATION CHART
1000   PRINT "LOCALITY SHIFT   "
1010  GOSUB 1320 : R2 = FNR(FNU((LO-L2)+FND(RA))):B2=FNR(B2)
1020  R3=R2:L3=L2:B=B2:OB=-OE:GOSUB 1110
1030  OB=-(PI/2-B2): R2=R2+PI/2:S=1:GOTO 940
1040  REM  COORDINATE TRANSFORM ROUTINE
1050  A = B:R = 1: GOSUB 1400 : Q =Y: R=X: A=L:GOSUB 1400 :
1060  G = X: X = Y: Y = Q: GOSUB 1430
1070  A = A + OB: GOSUB 1400 : Q = FNX(Y):Y=X:X=G:GOSUB 1430
1080  IF A < 0 THEN A = A + 2 *<UNK! {0009}>PI
1090  G = A : RETURN
1100  REM  CHART ANGLES ROUTINE
1110  CLS:A = R2:R=1: GOSUB 1400 : X=X*COS(OB): GOSUB 1430 :MC=FND(A)
1120  L=R2: GOSUB 1050 : IF B < 0 THEN R2= R2 + PI
1130  AS = FNU(FND(G + PI/2)):L=R2+PI: B=PI/2-B:GOSUB 1050
1140  VT=FNU(FND(G+PI/2))
1150  PRINT "RA=";FND(R2);TAB(23);"ASC=";FNW(AS);"    ";: PRINT TAB(44);USING "\ \ ##.##";FNZ$(AS);FNY(AS)
1160  PRINT "MC=";FNW(MC); TAB(23); "VTX="; FNW(VT): RETURN
1170  PRINT "1=LS  2=SFT  3=^  4=EQ  5=RUN  6=VER  7=A*D  8=CHG  9=DATA"
1180   G$=INKEY$: IF G$="" THEN 1180
1190   G= VAL (G$)
1200  ON G GOTO 920  ,  1000 ,  1280 ,  1350 ,  1240 ,  1230 ,  1260 , 2270 ,2330
1210   GOTO 1180
1220  REM  LOCAL SPACE:<UNK! {0009}>PRIME VERTICAL CHART (MUNDOSCOPE)
1230  PRINT "PRIME VERTICAL": PRINT: S7=OB:S=1:OB=-((PI/2+OB)*-1):GOTO 940
1240  RUN 40
1250  REM POSITION OF CELESTIAL OBJECT ( RA & DECL) ON HORIZON
1260  GOSUB 1320 : L=FNR(L2)-R2:B=FNR(B2):GOSUB 1050 : GOTO 1290
1270  REM LOCAL SPACE:  DIRECTION OF A CITY ON THE HORIZON
1280  GOSUB 1320 :B= FNR(B2): L=( FNR(L3-L2) + R3)-(R3+PI/2):GOSUB 1050
1290  PRINT "AZI=";FNW(FND(G));:PRINT TAB(19);"ALT=";FNW(FND(Q))
1300  GOTO 1180
1310  REM       LOCAL SPACE:  INPUT
1320  INPUT "LONG="; L2: L2=FNQ(L2)
1330  INPUT "LAT="; B2: B2 = FNQ(B2): RETURN
1340  REM MUNDANE SPACE:  EQUATORIAL COORDINATES
1350   PRINT "EQUATORIAL SPACE": PRINT: FOR I = 1 TO 11
1360  PRINT USING "####.##   ###.##";FNW(FND(X(I)));FNW(FND(Y(I))): NEXT I:PRINT: GOTO 1170
1370  REM ASSEMBLES ORBITAL ELEMENTS
1380  READ S, S1,S2: S=S+S1*T+S2*T*T:RETURN
1390  REM POLAR TO RECTANGULAR COORDINATES
1400  IF A = 0 THEN A = 0
1410  X=R*COS(A):Y=R*SIN(A): RETURN
1420   REM RECTANGULAR TO POLAR COORDINATES
1430  IF Y=0 THEN Y = 0
1440   IF X = 0 THEN X= 9.99E-07
1450   R=(X*X+Y*Y)^0.5
1460  A= ATN(Y/X)
1470  IF A < 0 THEN A = A + PI
1480  IF Y < 0 THEN A = A + PI
1490  RETURN
1500  REM MOON AND MOON'S NODES
1510  REM
1520  REM COMPUTE MEAN LUNAR LONGITUDE
1530  LL=973563 +1.73256E+09*T-4*T*T
1540  REM COMPUT SUN'S MEAN LONGITUDE OF PREIGEE
1550  G= 1.0124E+06+6189*T
1560  REM COMPUTE MEAN LUNAR NODE
1570  N=933060-6.96291E+06*T+7.5*T*T
1580  REM COMPUTE MEAN LONGITUDE OF LUNAR PERIGEE
1590  G1 = 1.20359E+06+1.46485E+07*T-37*T*T
1600  REM COMPUTE MEAN ELONGATION OF MOON FROM SUN
1610  D= 1.26266E+06+1.60296E+09*T-5*T*T: M=3600
1620  REM  COMPUTE AUXILIARY ANGLES
1630  L=(LL-G1)/M:L1=((LL-D) -G)/M:F=(LL-N)/M: D=D/M:Y=2*D
1640  REM    COMPUTE MOON'S LONGITUDE
1650  ML=22639.6 * FNS(L) - 4586.4 * FNS( L - Y)
1660  ML=ML +2369.9 * FNS(Y) + 769 *FNS(2*L)- 669*FNS(L1)
1670  ML = ML- 411.6 * FNS(2*F)-212*FNS(2*L-Y)
1680  ML = ML - 206 * FNS (L + L1-Y)+192*FNS(L+Y)
1690  ML = ML -165*FNS(L1-Y) +148 * FNS (L-L1) - 125 * FNS(D)
1700  ML=ML - 110 * FNS(L+L1)-55*FNS(2*F-Y)
1710  REM COMPUTE THE LUNAR LATITUDE
1720  MB=18461.5 * FNS(F)+ 1010 * FNS(L+F)-999*FNS(F-L)
1730  MB = MB - 624 * FNS(F-Y) + 199* FNS (F + Y - L)
1740  MB = MB - 167* FNS(L + F-Y) +117 *FNS (F+Y)
1750  MB = MB + 62* FNS(2 * L +F) -33 * FNS (F-Y-L)
1760  MB=MB -32* FNS(F-2*L)-30*FNS(L1+F-Y)
1770  ML = ML -45*FNS(L+2*F) +40*FNS(L-2*F)
1780  REM COMPUTE TRUE LUNAR NODE
1790  TN=N+5392*FNS(2*F-Y)-541*FNS(L1)-442*FNS(Y)
1800  TN = TN+423*FNS(2*S)-291*FNS(2*L-2*F)
1810  G=FNR(FNP(LL+ML)): TN=FNR(FNU(FNP(TN)))
1820  A = FNR (FNP(MB)): RX=0:GOTO 820
1830  DATA 358.4758445, 35999.04975, -.150278E-3, .01675104
1840  DATA -.418E-4, -.126E-6
1850   DATA 1.00000023,<UNK! {0009}>101.2208333,  1.719175,  .000452778
1860  DATA 0, 0, 0, 0, 0, 0, 102.2793806
1870   DATA 149472.5152, .6389E-5,  .20561421,  .2046E-4
1880   DATA     -3E-7,  .3870984,  28.75375278
1890  DATA .370280556,  .000120833, 47.14594444,  1.185208333
1900  DATA<UNK! {0009}>.000173889,  7.002880556
1910  DATA  .001860833,<UNK! {0009}>-.18333E-4,  212.6032194,  58517.80386
1920  DATA<UNK! {0009}>.001286056,  .00682069
1930  DATA  -.4774E-4,  .91E-7,<UNK! {0009}>.7233316,  54.384186111
1940  DATA  .508186111,<UNK! {0009}>     -.1386389E-2
1950  DATA  75.77964722,  .89985,  .41E-3,  3.393630556
1960  DATA<UNK! {0009}>.10058333E-2,  -.972E-6,  319.529425
1970  DATA  19139.8585,<UNK! {0009}>.180806E-3,  .0933129,<UNK! {0009}>.92064E-4
1980  DATA<UNK! {0009}>-.77E-7,  1.5236915
1990  DATA  285.4317611,  1.069766667,  .13125E-3,  48.78644167
2000  DATA<UNK! {0009}>.770991667,  -1.389E-5
2010  DATA 1.850333333,<UNK! {0009}>-.675E-3,  .12611E-4,  225.4928125
2020  DATA<UNK! {0009}>3033.687936,  0
2030  DATA  .04838144,  -.155E-4,  0
2040  DATA  5.20290493,<UNK! {0009}>273.3930152,  1.33834464,  0
2050  DATA<UNK! {0009}>99.41984827,  1.05829152
2060   DATA  0,<UNK! {0009}>1.3096585, -.515613E-2,  0,  174.2152960
2070  DATA      1223.507963
2080  DATA  0,  .05422831,  -.20495E-3,<UNK! {0009}>0,  9.55251745
2090  DATA<UNK! {0009}>338.911673
2100  DATA  -.31667941,<UNK! {0009}>0, 112.8261394,  .82587569,  0
2110  DATA<UNK! {0009}>2.49080547
2120  DATA  -.00466035,<UNK! {0009}> 0,  74.17574887,  427.2742717
2130  DATA<UNK! {0009}>0,  .04681664
2140  DATA  .00041875,  0,  19.22150505,  95.68630387
2150  DATA<UNK! {0009}>2.05082548,  0
2160  DATA  73.52220082,  .52415598,  0,  .77256652
2170  DATA<UNK! {0009}>.12824E-3,  0
2180  DATA  30.1329437,<UNK! {0009}>240.4551595,  0,  .00912805
2190  DATA<UNK! {0009}>-.00127185,  0
2200  DATA  30.1137593,<UNK! {0009}>284.168255,  -21.6328615,  0
2210  DATA<UNK! {0009}>130.6841531,  1.10046492
2220  DATA  0,  1.77939281,  -.00975088,  0,  229.7810007
2230  DATA<UNK! {0009}>145.1781092,  0,  .24797376
2240  DATA  .00289875,  0, 39.53903455, 113.5365761
2250  DATA<UNK! {0009}>.20863761,  0, 108.94405
2260  DATA  1.37395444,<UNK! {0009}>0,  17.15140319,  -.01611824, 0
2270  RESTORE:GOTO 270
2280  RESTORE
2290  FOR I = 1 TO 23
2300  READ DM$
2310  NEXT
2320  RETURN
2330  CLS
2340  PRINT TAB(20); "CURRENT DATA ARE:  "
2350  PRINT "DATE:  ";A$
2360  PRINT "TIME: ";F1; F$
2370  PRINT LQ
2380  PRINT LW
2390  PRINT "TIME ZONE: ";XQ
2400  GOTO 1170
2410  A$="12.251982": ' default date
2420  F1=6: '  default time
2430  XQ=6: ' default  time zone (cst)
2440  LQ=90.04: '   default  longitude
2450  F$="AM"
2460  LW=29.56: ' default latitude
2470  RETURN
4000  CLS:PRINT:PRINT TAB(12); "ASTROLOGIC AND ASTRONOMIC CALCULATOR "
4010  PRINT:PRINT
4020  PRINT "When the program asks for data, follow the format
4030  PRINT"requested, otherwise strange errors will result.
4040  PRINT"    For example, 'HH.MM' requires that hours and minutes
4050  PRINT"be entered 04.59 for a time of one minute before five.
4060  PRINT"Midnight is 00.00  - - - Noon is 00.00
4070  PRINT"The distinction is made in the AM or PM question.
4071  PRINT"The Time Zone question is answered with a 6 for CSTa 5 for EST/CDT  etc
4080  PRINT"             ************************
4090  PRINT"     The default values for the Data Input question are
4100  PRINT"are found in lines 2410-2470.
4102   :PRINT "               ANY KEY TO CONTINUE "
4105  M$=INKEY$:IF M$="" THEN 4105
4110  RETURN
