100  REM Program to show how to change the Printer Characteristics
110  REM By:  Melvin O. Duke
120  FOR I = 1 TO 5 : LPRINT : NEXT I
130  LPRINT TAB(10);"Modifications to use Other Printers"
140  LPRINT TAB(10);"-----------------------------------"
150  FOR I = 1 TO 2 : LPRINT : NEXT I
160  LPRINT TAB(10);"The 'default' printer for these programs is an IBM Matrix"
170  LPRINT TAB(10);"Printer.  If you have some other printer, you may have to"
180  LPRINT TAB(10);"make some changes to the two programs: TEXTPROC and"
190  LPRINT TAB(10);"YOURVOWN."
200  FOR I = 1 TO 4 : LPRINT : NEXT I
210  LPRINT TAB(10);"The changes to the TEXTPROC program consist of changing"
220  LPRINT TAB(10);"the following lines within that program.  Each of these"
230  LPRINT TAB(10);"lines contain one or more characters which control the"
240  LPRINT TAB(10);"printer."
250  LPRINT
260  LPRINT TAB(10);"It will be necessary for you to look in the Technical"
270  LPRINT TAB(10);"Manual for your printer to find out just what characters"
280  LPRINT TAB(10);"are used to perform the same functions.  Then you must"
290  LPRINT TAB(10);"replace the 'default' settings with those of your printer."
300  FOR I = 1 TO 2 : LPRINT : NEXT I
310  REM Set Printer Characteristics
320  LPRINT TAB(10);
330  LPRINT "220 WIDE.ON$     = CHR$(14)       'Set Expanded Print ON"
340  LPRINT TAB(10);
350  LPRINT "230 WIDE.OFF$    = CHR$(18)       'Set Expanded Print OFF"
360  LPRINT TAB(10);
370  LPRINT "240 BOLD.ON$     = CHR$(27)+";CHR$(34);"E";CHR$(34);
380  LPRINT "   'Set Emphasized Print ON"
390  LPRINT TAB(10);
400  LPRINT "240 BOLD.ON$     = CHR$(27)+";CHR$(34);"F";CHR$(34);
410  LPRINT "   'Set Emphasized Print OFF"
420  LPRINT TAB(10);
430  LPRINT "260 SQUEEZE.ON$  = CHR$(15)       'Set Compressed Print ON"
440  LPRINT TAB(10);
450  LPRINT "270 SQUEEZE.OFF$ = CHR$(18)       'Set Compressed Print OFF"
460  LPRINT TAB(10);
470  LPRINT "280 PAGE.EJECT$  = CHR$(12)       'Skip to Top of Next Page"
480  FOR I = 1 TO 5 : LPRINT : NEXT I
490  LPRINT TAB(10);"A similar change must be made in the YOURVOWN Program."
500  LPRINT
510  LPRINT TAB(10);"The line:"
520  LPRINT
530  LPRINT TAB(10);
540  LPRINT "170 PAGE.EJECT$ = CHR$(12)        'Skip to Top of Next Page"
550  LPRINT
560  LPRINT TAB(10);"must be changed to correspond to the character used by"
570  LPRINT TAB(10);"your printer to move your paper to the top of the next"
580  LPRINT TAB(10);"sheet (page-eject)."
590  FOR I = 1 TO 17 : LPRINT : NEXT I
600  END
