100  REM DESCEND Program.
110  REM Prints (and Displays) Descendents Charts
120  REM Copyright (c) 1983 - 1987 by: Melvin O. Duke.
130  DEFINT A-Z
600  REM Titles
610  TITLE$ = "Descendents Chart"
620  TITLE$ = TITLE$ + " ON DISPLAY"
700  REM Terminate if not called from the Menu
710  IF DD.MENU$ <> "" THEN 770
720  COLOR 7,0 : KEY ON : CLS : LOCATE 15,1
730  PRINT "Cannot run the"
740  PRINT TITLE$
750  PRINT "Program, unless selected from the MENU"
760  END
770  REM OK
900  REM Dimension Statements
940  DIM PERSATLVL(MAX.GEN+1), SEXATLVL$(MAX.GEN+1)
950  DIM MARRATLVL(MAX.GEN+1), SPOUSATLVL(MAX.GEN+1)
960  DIM TEMPMAR(MAX.GEN+1), TEMPCHILD(MAX.GEN+1)
1000  REM Produce the first screen
1010  KEY ON : CLS : KEY OFF
1020  REM Draw the outer double box
1030  R1 = 1 : C1 = 1 : R2 = 24 : C2 = 79 : GOSUB 1300
1040  REM Find the title location
1050  TITLE.POS = 40 - INT(LEN(TITLE$)/2)
1060  REM Draw the title box
1070  R1=3:C1=TITLE.POS-2:R2=6:C2=TITLE.POS+LEN(TITLE$)+1:GOSUB 1500
1080  REM Print the title
1090  LOCATE 4,TITLE.POS : PRINT TITLE$
1100  LOCATE 5,40-INT(LEN(VERSION$)/2) :  PRINT VERSION$;
1230  REM Draw the Copyright box
1240  R1 = 19 : C1 = 21 : R2 = 22 : C2 = 59 : GOSUB 1300
1250  REM Print the Copyright
1260  LOCATE 20,40-INT(LEN(COPY1$)/2) :  PRINT COPY1$;
1270  LOCATE 21,40-INT(LEN(COPY2$)/2) :  PRINT COPY2$;
1280  GOTO 1660
1300  REM subroutine to print a double box
1310  COLOR P
1320  FOR I = R1 + 1 TO R2 - 1
1330   LOCATE I, C1 : PRINT CHR$(186);
1340   LOCATE I, C2 : PRINT CHR$(186);
1350  NEXT I
1360   LOCATE R1, C1+1 : PRINT STRING$(C2-C1-1,205);
1390   LOCATE R2, C1+1 : PRINT STRING$(C2-C1-1,205);
1400   LOCATE R1, C1 : PRINT CHR$(201);
1410   LOCATE R1, C2 : PRINT CHR$(187);
1420   LOCATE R2, C1 : PRINT CHR$(200);
1430   LOCATE R2, C2 : PRINT CHR$(188);
1440  COLOR W
1450  RETURN
1500  REM subroutine to print a single box
1510  COLOR B
1520  FOR I = R1 + 1 TO R2 - 1
1530   LOCATE I, C1 : PRINT CHR$(179);
1540   LOCATE I, C2 : PRINT CHR$(179);
1550  NEXT I
1560   LOCATE R1, C1+1 : PRINT STRING$(C2-C1-1,196);
1590   LOCATE R2, C1+1 : PRINT STRING$(C2-C1-1,196);
1600   LOCATE R1, C1 : PRINT CHR$(218);
1610   LOCATE R1, C2 : PRINT CHR$(191);
1620   LOCATE R2, C1 : PRINT CHR$(192);
1630   LOCATE R2, C2 : PRINT CHR$(217);
1640  COLOR W
1650  RETURN
1660  REM ask user to press a key to continue
1670  LOCATE 25,1
1680  PRINT "Have Data Diskette(s) in Place, then Press any key to continue.";
1690  K$ = INKEY$ : IF K$ = "" THEN 1690
1700  KEY ON : CLS : KEY OFF
2000  REM DESCEND Program Starts Here.
2010  REM set initial color
2020  COLOR W,K
2030  REM Ask about whether to print
2040  PRT.SW = 0
2050  LOCATE 19,1
2060  PRINT "Descendents Charts will be Displayed."
2070  INPUT "Do you want to Print as well as to Display";REPLY$
2080  IF LEFT$(REPLY$,1)="y" OR LEFT$(REPLY$,1) ="Y"THEN PRT.SW = 1
2090  ON PRT.SW+1 GOTO 2230, 2110
2100  STOP
2110  LOCATE 1,1 : PRINT "Charts will be Printed"
2120  GOSUB 5750 'Clean
2130  REM Routine to obtain Printer Information
2140  LOCATE 21,1 : PRINT "Make sure that the Printer is on and Ready"
2150  LOCATE 22,1 : PRINT "Make sure that the correct Diskette(s) are in place."
2160  LOCATE 23,1 : PRINT "Then press any key"
2170  A$ = INKEY$ : IF A$ = "" THEN 2170
2180  REM reset all Printer Defaults
2190  WIDTH "lpt1:", 132  'For printing Genealogy Forms
2200  IF WIDE   = 0 THEN WIDE   = 1
2210  IF LENGTH = 0 THEN LENGTH = 2
2220  IF FORMS  = 0 THEN FORMS  = 1
2230  KEY ON : CLS : KEY OFF
2240  REM Read the Parent/Child Index
2250  OPEN DD.PCIDX$+"pcindex" FOR INPUT AS #1
2260  LOCATE 4,1 : PRINT "Open the Parent/Child Index";
2270  INPUT #1, PC.COUNT
2280  DIM PA.ID(PC.COUNT), CH.ID(PC.COUNT)
2290  FOR I = 1 TO PC.COUNT
2300  LOCATE 5,1 : PRINT "Reading Index Record #:";I;
2310   INPUT #1, PA.ID(I), CH.ID(I)
2320  NEXT I
2330  CLOSE #1
2340  REM Read the Marriage Index
2350  LOCATE 7,1 : PRINT "Open the Marriage Index";
2360  OPEN DD.MARIDX$+"mindex" FOR INPUT AS #2
2370  INPUT #2, M.COUNT
2380  DIM PERS.NO(M.COUNT), M.NO(M.COUNT)
2390  FOR I = 1 TO M.COUNT
2400  LOCATE 8,1 : PRINT "Reading Marriage Index Record #:";I;
2410   INPUT #2,PERS.NO(I), M.NO(I)
2420  NEXT I
2430  CLOSE #2
2440  REM Open the Persons File
2450  LOCATE 10,1 : PRINT "Open the Persons File"
2460  OPEN DD.PERS$+"persfile" AS #1 LEN = 256
2470  FIELD 1, 5 AS F1$, 20 AS F2$, 30 AS F3$, 2 AS F4$, 5 AS F5$, 5 AS F6$, 5 AS F7$, 11 AS F8$, 18 AS F9$, 16 AS F10$, 16 AS F11$, 11 AS F12$, 18 AS F13$, 16 AS F14$, 16 AS F15$, 11 AS F16$, 18 AS F17$, 16 AS F18$, 16 AS F19$
2480  REM open the Marriages File
2490  LOCATE 12,1 : PRINT "Open the Marriage File"
2500  OPEN DD.MARR$+"marrfile" AS #2 LEN = 128
2510  FIELD 2, 5 AS M1$, 5 AS M2$, 5 AS M3$, 5 AS M4$, 11 AS M5$, 18 AS M6$, 16 AS M7$, 16 AS M8$, 45 AS M9$
2520  REM Obtain a Person Record from the User
2530  LOCATE 20,1
2540  INPUT "Enter the Record-number of a Person (0 to quit)"; REPLY$
2550  IF REPLY$ = "0" THEN 5310
2560  PERSON = VAL(REPLY$)
2570  IF PERSON < 1 OR PERSON > MAX.PER THEN KEY ON : CLS : LOCATE 19,1 : PRINT "Number is out of range"; : KEY OFF : GOTO 2520
2580  ON PRT.SW + 1 GOTO 3020, 2590
2590  GOSUB 2600 : GOTO 3020
2600  REM Reset the Printer Characteristics for next page if required.
2610  IF FORMS = 1 THEN 2650  'Don't stop if forms are continuous
2620  REM Process Single Sheets
2630  PRINT "Press any key when next form is ready"
2640  A$ = INKEY$ : IF A$ = "" THEN 2640
2650  REM Reset paper sensing if required
2660  IF FORMS = 2 THEN LPRINT PAP.SEN.OFF$;
2670  REM Reset paper length if required
2680  IF LENGTH = 1 THEN LPRINT PAP.SHORT$;
2690  IF LENGTH = 1 AND MAX.LINES = 58 THEN MAX.LINES = 43
2700  REM Reset Condensed Printing if required
2710  IF WIDE = 1 THEN LPRINT COMPR.ON$;
2720  RETURN
2730  REM Routine to do a Right-trim
2740  TEMP2$ = ""
2750  FOR J = LEN(TEMP1$) TO 1 STEP -1
2760   IF MID$(TEMP1$,J,1) = " " THEN 2780
2770   TEMP2$ = LEFT$(TEMP1$,J) : J = 1
2780  NEXT J
2790  RETURN
2800  REM Routine to Extract Personal Information
2810  T1! = CVS(F1$) : T1 = T1!
2820  TEMP1$ = F2$ : TEMP2$ = F2$ : GOSUB 2730
2830  T2$ = TEMP2$
2840  IF CHART.NOS$ = "n" THEN GOSUB 5510
2850  TEMP1$ = F3$ : TEMP2$ = F3$ : GOSUB 2730
2860  T3$ = TEMP2$
2870  T4$ = " "
2880  IF LEFT$(F4$,1) = MALE.LTR$   THEN T4$ = MALE.LTR$
2890  IF LEFT$(F4$,1) = FEMALE.LTR$ THEN T4$ = FEMALE.LTR$
2900  T6! = CVS(F6$) : T6 = T6! 'Father
2910  T7! = CVS(F7$) : T7 = T7! 'Mother
2920  T8$ = F8$
2930  T12$ = F12$
2940  RETURN
2950  RETURN
2960  REM Extraction of Marriage Information
2970  TT1! = CVS(M1$) : TT1 = TT1! 'Rec.no
2980  TT2! = CVS(M2$) : TT2 = TT2! 'Husband
2990  TT3! = CVS(M3$) : TT3 = TT3! 'Wife
3000  TT5$ = M5$  'Marriage Date
3010  RETURN
3020  REM Routine to Produce a Descendents Chart
3030  REM First of all, set all numbers to 0 and letters to -
3040  FOR ATLVL = 1 TO MAX.GEN
3050   PERSATLVL(ATLVL) = 0
3060   SEXATLVL$(ATLVL) = "-"
3070   MARRATLVL(ATLVL) = 0
3080   SPOUSATLVL(ATLVL) = 0
3090  NEXT ATLVL
3100  REM Establish a starting-point for level 1
3110  LEVEL = 1
3120  PERSATLVL(LEVEL) = PERSON
3130  GET #1, PERSATLVL(LEVEL)
3140  GOSUB 2800  'for Person's Information
3150  REM Test if Empty
3160  IF T1 > 0 THEN 3190
3170  KEY ON : CLS : KEY OFF : LOCATE 20,1 : PRINT "Record";PERSON;"is Empty"
3180  GOTO 3640
3190  SEXATLVL$(LEVEL) = T4$
3200  PERSON$ = T3$+" "+T2$
3210  PAGE.NO = 1 : PAGE.LEN = 0
3220  ON PRT.SW+1 GOTO 3490, 3230
3230  REM Print the Title on the First Page, Date, Time, and Person Indicated
3240  GOSUB 3250 : GOSUB 3300 : GOTO 3440
3250  LPRINT
3260  LPRINT TAB(11);"Descendents Chart for ";PERSON$;
3270  LPRINT TAB(112); "Page"; PAGE.NO
3280  LPRINT
3290  RETURN
3300  LPRINT TAB(11);"From the Genealogy ON DISPLAY Computerized Data Base"
3310  LPRINT TAB(11);"Prepared on ";DATE$;" at ";TIME$
3320  LPRINT
3330  LPRINT TAB(11);"  d-Descendant Generation Name";
3340  LPRINT TAB( 83);"Date of";
3350  LPRINT TAB( 96);"Date of";
3360  LPRINT TAB(109);"Date of"
3370  LPRINT TAB(11);"   s-Spouse     Generation Name";
3380  LPRINT TAB( 83);"Birth";
3390  LPRINT TAB( 96);"Marriage";
3400  LPRINT TAB(109);"Death"
3410  LPRINT TAB(11);
3420  FOR VERT = 1 TO 109 : LPRINT "-";: NEXT VERT : LPRINT
3430  RETURN
3440  LPRINT TAB(11);
3450  LPRINT " -1 "+LEFT$(T3$+" "+T2$,69);
3460  LPRINT TAB( 83);T8$;
3470  LPRINT TAB(109);T12$
3480  PAGE.LEN = PAGE.LEN + 10
3490   KEY ON : CLS : KEY OFF : PRINT "Descendents Chart for ";
3500   PRINT T3$;" ";T2$ : COLOR O,K
3510   PRINT
3520   PRINT "From the Genealogy ON DISPLAY Computerized Data Base"
3530   PRINT "Prepared on ";DATE$;" at ";TIME$
3540   PRINT :  PRINT : COLOR O,K
3550   PRINT "  d-Descendant Generation Name"
3560   PRINT "   s-Spouse     Generation Name"
3570  COLOR P,K : FOR VERT = 1 TO 79 :  PRINT "-";: NEXT VERT :  PRINT
3580  COLOR G,K : PRINT " -1 "+LEFT$(T3$+" "+T2$,76)
3590  COLOR W,K
3600  MLEVEL=0
3610  GOTO 3690  'look for marriage
3620  ON PRT.SW+1 GOTO 3640,3630
3630  LPRINT FORM.FEED$;
3640  PRINT
3650  PRINT "Press any key to continue"
3660  A$ = INKEY$ : IF A$ = "" THEN 3660
3670  KEY ON : CLS : KEY OFF
3680  GOTO 2520
3690  REM Locate an unreported marriage, if present
3700  MLEVEL = MLEVEL + 1
3710  REM Establish Skip-ahead Start-value and Delta
3720  MRECATLVL = 1 : DELTA = INT(M.COUNT/10) : IF DELTA = 0 THEN 3770
3730  REM Add delta and test if too far
3740  MRECATLVL = MRECATLVL + DELTA
3750  IF MRECATLVL > 9 * DELTA THEN 3770
3760  IF PERS.NO(MRECATLVL) < PERSATLVL(LEVEL) THEN 3740 'Not there yet
3770  MRECATLVL = MRECATLVL - DELTA -1
3780  REM Search Routine
3790  MRECATLVL = MRECATLVL + 1
3800   IF PERS.NO(MRECATLVL) < PERSATLVL(LEVEL) THEN 4510 'Not there yet
3810   IF PERS.NO(MRECATLVL) > PERSATLVL(LEVEL) THEN MRECATLVL = M.COUNT : GOTO 4510
3820   REM found a marriage.  Try to accept it.
3830   IF MARRATLVL(LEVEL) <> 0 AND MARRATLVL(LEVEL) = M.NO(MRECATLVL) THEN 4510
3840   IF MARRATLVL(LEVEL) = 0 THEN MARRATLVL(LEVEL) = M.NO(MRECATLVL)
3850   REM get the marriage record, and the spouse
3860   GET #2, M.NO(MRECATLVL)
3870   GOSUB 2960  'to Extract Marriage Information
3880   IF SEXATLVL$(LEVEL) = MALE.LTR$   THEN SELF = TT2 : SPOUSE = TT3
3890   IF SEXATLVL$(LEVEL) = FEMALE.LTR$ THEN SELF = TT3 : SPOUSE = TT2
3900   SPOUSATLVL(LEVEL) = SPOUSE
3910   PERSATLVL(LEVEL) = SELF
3920   GET #1, SPOUSE
3930   GOSUB 2800  'to Extract Personal Information
3940  IF CHART.NOS$ = "n" THEN GOSUB 5630
3950  ON PRT.SW+1 GOTO 4120, 3960
3960   REM Now print the Spouse
3970   LPRINT TAB(11);
3980   FOR VERT = 2 TO LEVEL
3990    LPRINT "| ";
4000   NEXT VERT
4010   LPRINT " ";
4020   LPRINT "s"+LEFT$(STR$(-VERT+1)+" "+T3$+" "+T2$,119-(2*VERT));
4030   IF T8$ = SPACE$(11) THEN 4050
4040   LPRINT TAB( 83);T8$;
4050   IF TT5$ = SPACE$(11) THEN 4070
4060   LPRINT TAB( 96);TT5$;
4070   IF T12$ = SPACE$(11) THEN 4090
4080   LPRINT TAB(109);T12$;
4090   LPRINT
4100   PAGE.LEN = PAGE.LEN + 1
4110   GOSUB 5420  'test page-break
4120   COLOR P,K
4130   FOR VERT = 2 TO LEVEL
4140     PRINT "| ";
4150   NEXT VERT
4160    PRINT " ";
4170    COLOR G,K : PRINT "s"+STR$(-VERT+1)+" "+T3$+" "+T2$
4180    COLOR W,K
4190   REM Line After the Spouse
4200  ON PRT.SW+1 GOTO 4320, 4210
4210   LPRINT TAB(11);
4220   FOR VERT = 2 TO LEVEL
4230    LPRINT "| ";
4240   NEXT VERT
4250   LPRINT "+";
4260   FOR VERT = LEVEL*2 TO 109
4270    LPRINT "-";
4280   NEXT VERT
4290   LPRINT
4300   PAGE.LEN = PAGE.LEN + 1
4310   GOSUB 5420  'test page-break
4320   COLOR P,K : FOR VERT = 2 TO LEVEL
4330     PRINT "| ";
4340   NEXT VERT
4350    PRINT "+";
4360   FOR VERT = LEVEL*2 TO 79
4370     PRINT "-";
4380   NEXT VERT
4390    PRINT : COLOR W,K
4400   TEMPMAR(LEVEL) = MRECATLVL        'Save the Index
4410   REM now look for children
4420   LEVEL = LEVEL + 1
4430   GOTO 4540                         'Look for Children of this Marriage
4440   REM blank prior level
4450   PERSATLVL(LEVEL) = 0
4460   SEXATLVL$(LEVEL) = "-"
4470   MARRATLVL(LEVEL) = 0
4480   SPOUSATLVL(LEVEL) = 0
4490   LEVEL = LEVEL -1
4500   MRECATLVL = TEMPMAR(LEVEL)        'Restore the Index
4510  IF MRECATLVL < M.COUNT THEN 3790
4520  MLEVEL = MLEVEL - 1
4530  IF MLEVEL = 0 THEN 3620 ELSE 5060
4540  REM Search for Children of the Marriage
4550  IF LEVEL > MAX.GEN THEN 5300  'return
4560  REM Establish Skip-ahead Start-value and Delta
4570  LL = 1 : DELTA = INT(PC.COUNT/10) : IF DELTA = 0 THEN 4620
4580  REM Add delta and test if too far
4590  LL = LL + DELTA
4600  IF LL > 9 * DELTA THEN 4620
4610  IF PERSATLVL(LEVEL-1) > PA.ID(LL) THEN 4590
4620  LL = LL -DELTA -1
4630  REM Search Routine
4640  LL = LL + 1
4650   IF PERSATLVL(LEVEL-1) > PA.ID(LL) THEN 5070
4660   IF PERSATLVL(LEVEL-1) < PA.ID(LL) THEN LL = PC.COUNT : GOTO 5070
4670   REM found a child.  Try to accept.
4680   PERSATLVL(LEVEL) = CH.ID(LL)
4690   GET #1, CH.ID(LL)
4700   GOSUB 2800  'To extract personal information
4710   REM identify that both parents match
4720   IF SEXATLVL$(LEVEL-1) = MALE.LTR$ THEN 4750
4730   IF SEXATLVL$(LEVEL-1) = FEMALE.LTR$ THEN 4790
4740   STOP
4750   REM Male Parent in Direct Line
4760   IF PERSATLVL(LEVEL-1) <> T6 THEN 5070
4770   IF SPOUSATLVL(LEVEL-1) <> T7 THEN 5070
4780   GOTO 4820
4790   REM Female Parent in Direct Line
4800   IF PERSATLVL(LEVEL-1) <> T7 THEN 5070
4810   IF SPOUSATLVL(LEVEL-1) <> T6 THEN 5070
4820   REM Passed All Tests, so print this child
4830  ON PRT.SW+1 GOTO 4960, 4840
4840   LPRINT TAB(11);
4850   FOR VERT = 2 TO LEVEL
4860    LPRINT "| ";
4870   NEXT VERT
4880   LPRINT "d"+LEFT$(STR$(-VERT+1)+" "+T3$+" "+T2$,120-(2*VERT));
4890   IF T8$ = SPACE$(11) THEN 4910
4900   LPRINT TAB( 83);T8$;
4910   IF T12$ = SPACE$(11) THEN 4930
4920   LPRINT TAB(109);T12$;
4930   LPRINT
4940   PAGE.LEN = PAGE.LEN + 1
4950   GOSUB 5420  'test page-break
4960   COLOR P,K : FOR VERT = 2 TO LEVEL
4970     PRINT "| ";
4980   NEXT VERT
4990    COLOR G,K : PRINT "d"+STR$(-VERT+1)+" "+T3$+" "+T2$
5000    COLOR W,K
5010   REM save information at this level
5020   SEXATLVL$(LEVEL) = T4$
5030   REM Search for Spouse
5040   TEMPCHILD(LEVEL) = LL             'Save the Index
5050   GOTO 3690  'for Marriage Search
5060   LL = TEMPCHILD(LEVEL)             'Restore the Index
5070  IF LL < PC.COUNT THEN 4640
5080  REM Print a line after last child
5090  ON PRT.SW+1 GOTO 5210, 5100
5100   LPRINT TAB(11);
5110   FOR VERT = 1 TO 2*LEVEL-4 STEP 2
5120    LPRINT "| ";
5130   NEXT VERT
5140   LPRINT "+";
5150   FOR VERT = 2*LEVEL-2 TO 109
5160    LPRINT "-";
5170   NEXT VERT
5180   LPRINT
5190   PAGE.LEN = PAGE.LEN + 1
5200   GOSUB 5420  'test page-break
5210  COLOR P
5220   FOR VERT = 1 TO 2*LEVEL-4 STEP 2
5230     PRINT "| ";
5240   NEXT VERT
5250    PRINT "+";
5260   FOR VERT = 2*LEVEL-2 TO 79
5270     PRINT "-";
5280   NEXT VERT
5290    PRINT : COLOR W,K
5300  GOTO 4440  'return
5310  REM Wrapup
5320  ON PRT.SW+1 GOTO 5370, 5330
5330  LPRINT PAP.SENS.OFF$;
5340  LPRINT PAP.LONG$;
5350  LPRINT COMPR.OFF$;
5360  WIDTH "lpt1:",80
5370  CLOSE #1
5380  CLOSE #2
5390  KEY ON : CLS : KEY OFF : LOCATE 21,1
5400  PRINT "End of Program"
5410  RUN DD.MENU$+"menu"
5420  REM Page-break Test
5430  IF PAGE.LEN < MAX.LINES THEN 5490
5440  REM Page eject,and reset parms
5450  LPRINT FORM.FEED$;
5460  GOSUB 2600  'Reset Printer
5470  PAGE.NO = PAGE.NO + 1 : PAGE.LEN = 6
5480  GOSUB 3250 : GOSUB 3330 'top of next page
5490  RETURN
5500  END
5510  REM Routine to Obtain a Usable Person Number for the Chart
5520  REM Convert the Person Number to a String
5530  PNUM$ = STR$(T1)
5540  REM Find the Length of the String
5550  PLEN = LEN(PNUM$)
5560  REM Get rid of the leading space for algebraic sign
5570  PNUM$ = RIGHT$(PNUM$,PLEN-1)
5580  REM Surround with Quotes and add a Leading Space
5590  PNUM$ = " (P-" + PNUM$ + ")"
5600  REM Suffix Person Number to Surname
5610  T2$ = T2$ + PNUM$
5620  RETURN
5630  REM Routine to Obtain a Usable Marriage Number for the Chart
5640  REM Convert the Marriage Number to a String
5650  PNUM$ = STR$(TT1)
5660  REM Find the Length of the String
5670  PLEN = LEN(PNUM$)
5680  REM Get rid of the leading space for algebraic sign
5690  PNUM$ = RIGHT$(PNUM$,PLEN-1)
5700  REM Surround with Quotes and add a Leading Space
5710  PNUM$ = " (M-" + PNUM$ + ")"
5720  REM Suffix Person Number to Surname
5730  T2$ = T2$ + PNUM$
5740  RETURN
5750  REM Clean User Input Area
5760  LOCATE 19,1 : PRINT SPACE$(79);
5770  LOCATE 20,1 : PRINT SPACE$(79);
5780  LOCATE 21,1 : PRINT SPACE$(79);
5790  LOCATE 22,1 : PRINT SPACE$(79);
5800  LOCATE 23,1 : PRINT SPACE$(79);
5810  RETURN
