100  REM INDEXPC Program
110  REM Forms the Parent/Child Index
120  REM Copyright (c) 1983 - 1987 by: Melvin O. Duke.
130  DEFINT A-Z
600  REM Titles
610  TITLE$ = "Prepare the Parent/Child Index"
620  TITLE$ = TITLE$ + " ON DISPLAY"
700  REM Terminate if not called from the Menu
710  IF DD.MENU$ <> "" THEN 770
720  COLOR 7,0 : KEY ON : CLS : LOCATE 15,1
730  PRINT "Cannot run the"
740  PRINT TITLE$
750  PRINT "Program, unless selected from the MENU"
760  END
770  REM OK
900  REM Dimension Statements
910  DIM PA.ID(2*MAX.PER), CH.ID(2*MAX.PER), B.DATE!(2*MAX.PER)
1000  REM Produce the first screen
1010  KEY ON : CLS : KEY OFF
1020  REM Draw the outer double box
1030  R1 = 1 : C1 = 1 : R2 = 24 : C2 = 79 : GOSUB 1300
1040  REM Find the title location
1050  TITLE.POS = 40 - INT(LEN(TITLE$)/2)
1060  REM Draw the title box
1070  R1=3:C1=TITLE.POS-2:R2=6:C2=TITLE.POS+LEN(TITLE$)+1:GOSUB 1500
1080  REM Print the title
1090  LOCATE 4,TITLE.POS : PRINT TITLE$
1100  LOCATE 5,40-INT(LEN(VERSION$)/2) :  PRINT VERSION$;
1230  REM Draw the Copyright box
1240  R1 = 19 : C1 = 21 : R2 = 22 : C2 = 59 : GOSUB 1300
1250  REM Print the Copyright
1260  LOCATE 20,40-INT(LEN(COPY1$)/2) :  PRINT COPY1$;
1270  LOCATE 21,40-INT(LEN(COPY2$)/2) :  PRINT COPY2$;
1280  GOTO 1700
1300  REM subroutine to print a double box
1310  COLOR P
1320  FOR I = R1 + 1 TO R2 - 1
1330   LOCATE I, C1 : PRINT CHR$(186);
1340   LOCATE I, C2 : PRINT CHR$(186);
1350  NEXT I
1360   LOCATE R1, C1+1 : PRINT STRING$(C2-C1-1,205);
1390   LOCATE R2, C1+1 : PRINT STRING$(C2-C1-1,205);
1400   LOCATE R1, C1 : PRINT CHR$(201);
1410   LOCATE R1, C2 : PRINT CHR$(187);
1420   LOCATE R2, C1 : PRINT CHR$(200);
1430   LOCATE R2, C2 : PRINT CHR$(188);
1440  COLOR W
1450  RETURN
1500  REM subroutine to print a single box
1510  COLOR B
1520  FOR I = R1 + 1 TO R2 - 1
1530   LOCATE I, C1 : PRINT CHR$(179);
1540   LOCATE I, C2 : PRINT CHR$(179);
1550  NEXT I
1560   LOCATE R1, C1+1 : PRINT STRING$(C2-C1-1,196);
1590   LOCATE R2, C1+1 : PRINT STRING$(C2-C1-1,196);
1600   LOCATE R1, C1 : PRINT CHR$(218);
1610   LOCATE R1, C2 : PRINT CHR$(191);
1620   LOCATE R2, C1 : PRINT CHR$(192);
1630   LOCATE R2, C2 : PRINT CHR$(217);
1640  COLOR W
1650  RETURN
1700  REM ask user to press a key to continue
1710  LOCATE 25,1
1720  PRINT "Have Data Diskette(s) in Place, then Press any key to continue.";
1730  K$ = INKEY$ : IF K$ = "" THEN 1730
1740  KEY ON : CLS : KEY OFF
2000  REM INDEXPC Program Starts Here
2010  OPEN DD.PERS$+"persfile" AS #1 LEN = 256
2020  FIELD 1, 5 AS F1$, 20 AS F2$, 30 AS F3$, 2 AS F4$, 5 AS F5$, 5 AS F6$, 5 AS F7$, 11 AS F8$, 18 AS F9$, 16 AS F10$, 16 AS F11$, 11 AS F12$, 18 AS F13$, 16 AS F14$, 16 AS F15$, 11 AS F16$, 18 AS F17$, 16 AS F18$, 16 AS F19$
2030  REM Read all records, and create the index.
2040  KEY ON : CLS : KEY OFF
2050  C = 0
2060  FOR I = 1 TO MAX.PER
2070   GET #1, I
2080   LOCATE 15,1 : PRINT "Processing Person Record:"; I;
2090   REM Extract information from the file
2100   T1! = CVS(F1$) : T1 = T1! 'Child-id
2110   IF T1 < 0 THEN 2440
2120   T6! = CVS(F6$) : T6 = T6! 'Father-id
2130   T7! = CVS(F7$) : T7 = T7! 'Mother-id
2140   T8$ = F8$  'Birthdate as dd mmm yyyy
2150   IF T8$ = "           " THEN BD! = 0 : GOTO 2320
2160   REM convert Birthdate
2170   BD! = VAL(RIGHT$(T8$,4))*10000
2180   MO$ = MID$(T8$,4,3)
2190   IF MO$ = "Jan" THEN BD! = BD! +  100 : GOTO 2310
2200   IF MO$ = "Feb" THEN BD! = BD! +  200 : GOTO 2310
2210   IF MO$ = "Mar" THEN BD! = BD! +  300 : GOTO 2310
2220   IF MO$ = "Apr" THEN BD! = BD! +  400 : GOTO 2310
2230   IF MO$ = "May" THEN BD! = BD! +  500 : GOTO 2310
2240   IF MO$ = "Jun" THEN BD! = BD! +  600 : GOTO 2310
2250   IF MO$ = "Jul" THEN BD! = BD! +  700 : GOTO 2310
2260   IF MO$ = "Aug" THEN BD! = BD! +  800 : GOTO 2310
2270   IF MO$ = "Sep" THEN BD! = BD! +  900 : GOTO 2310
2280   IF MO$ = "Oct" THEN BD! = BD! + 1000 : GOTO 2310
2290   IF MO$ = "Nov" THEN BD! = BD! + 1100 : GOTO 2310
2300   IF MO$ = "Dec" THEN BD! = BD! + 1200 : GOTO 2310
2310   BD! = BD! + VAL(LEFT$(T8$,2))
2320   REM create the father/child index record
2330   IF T6 = 0 THEN 2380  'skip if zero
2340   C = C + 1
2350   CH.ID(C) = T1
2360   PA.ID(C) = T6
2370   B.DATE!(C) = BD!
2380   REM create the mother/child index record
2390   IF T7 = 0 THEN 2440  'skip if zero
2400   C = C + 1
2410   CH.ID(C) = T1
2420   PA.ID(C) = T7
2430   B.DATE!(C) = BD!
2440  NEXT I
2450  CLOSE #1
2460  LOCATE 18,1 : PRINT "There are:"; C; "Index Records";
2470  REM Sort the index into ascending sequence
2480  REM
2490  REM Sort by Parent
2500  FOR I = 1 TO 6
2510   B(I) = B(I-1)*4+1
2520   IF B(I) <= C/2 THEN K1 = I
2530  NEXT I
2540  B(K1) = INT(C/5)+1
2550  B(1) = 1
2560  LOCATE 22,1 : PRINT "Processing Parents     ";
2570  FOR I = K1 TO 1 STEP -1
2580  LOCATE 23,1 : PRINT "For Group:";I;
2590   K1 = B(I)
2600   FOR J = K1 TO C
2610    LOCATE 23,20 : PRINT "J:";J;
2620    K2=PA.ID(J) : B.TEMP! = B.DATE!(J) : TEMP3 = CH.ID(J)
2630    FOR K = J-K1 TO 0 STEP -K1
2640    'LOCATE 23,30 : PRINT "K:";K, "Freespace:";FRE(0)
2650     IF K2 > PA.ID(K) THEN 2690
2660     IF K2 = PA.ID(K) AND B.TEMP! > B.DATE!(K) THEN 2690
2670     PA.ID(K+K1)=PA.ID(K) : CH.ID(K+K1)=CH.ID(K):B.DATE!(K+K1)=B.DATE!(K)
2680    NEXT K
2690    PA.ID(K+K1)=K2: CH.ID(K+K1)=TEMP3: B.DATE!(K+K1)=B.TEMP!
2700   NEXT J
2710  NEXT I
2720  REM Write the Parent/Child Index
2730  KEY ON : CLS : KEY OFF : LOCATE 21,1
2740  PRINT "Writing the Parent/Child Index"
2750  OPEN DD.PCIDX$+"pcindex" FOR OUTPUT AS #2
2760  WRITE #2,C
2770  FOR I = 1 TO C
2780   WRITE #2, PA.ID(I)
2790   WRITE #2, CH.ID(I)
2800  NEXT I
2810  CLOSE #2
2820  KEY ON : CLS : KEY OFF : LOCATE 21,1
2830  PRINT "End of Program"
2840  RUN DD.MENU$+"menu"
