100  REM LISTPCI Program.
110  REM Prints the Parent/Child Index
120  REM Copyright (c) 1983 - 1987 by: Melvin O. Duke.
130  DEFINT A-Z
600  REM Titles
610  TITLE$ = "List the Parent/Child Index"
620  TITLE$ = TITLE$ + " ON DISPLAY"
700  REM Terminate if not called from the Menu
710  IF DD.MENU$ <> "" THEN 770
720  COLOR 7,0 : KEY ON : CLS : LOCATE 15,1
730  PRINT "Cannot run the"
740  PRINT TITLE$
750  PRINT "Program, unless selected from the MENU"
760  END
770  REM OK
1000  REM Produce the first screen
1010  KEY ON : CLS : KEY OFF
1020  REM Draw the outer double box
1030  R1 = 1 : C1 = 1 : R2 = 24 : C2 = 79 : GOSUB 1300
1040  REM Find the title location
1050  TITLE.POS = 40 - INT(LEN(TITLE$)/2)
1060  REM Draw the title box
1070  R1=3:C1=TITLE.POS-2:R2=6:C2=TITLE.POS+LEN(TITLE$)+1:GOSUB 1500
1080  REM Print the title
1090  LOCATE 4,TITLE.POS : PRINT TITLE$
1100  LOCATE 5,40-INT(LEN(VERSION$)/2) :  PRINT VERSION$;
1230  REM Draw the Copyright box
1240  R1 = 19 : C1 = 21 : R2 = 22 : C2 = 59 : GOSUB 1300
1250  REM Print the Copyright
1260  LOCATE 20,40-INT(LEN(COPY1$)/2) :  PRINT COPY1$;
1270  LOCATE 21,40-INT(LEN(COPY2$)/2) :  PRINT COPY2$;
1280  GOTO 1700
1300  REM subroutine to print a double box
1310  COLOR P
1320  FOR I = R1 + 1 TO R2 - 1
1330   LOCATE I, C1 : PRINT CHR$(186);
1340   LOCATE I, C2 : PRINT CHR$(186);
1350  NEXT I
1360   LOCATE R1, C1+1 : PRINT STRING$(C2-C1-1,205);
1390   LOCATE R2, C1+1 : PRINT STRING$(C2-C1-1,205);
1400   LOCATE R1, C1 : PRINT CHR$(201);
1410   LOCATE R1, C2 : PRINT CHR$(187);
1420   LOCATE R2, C1 : PRINT CHR$(200);
1430   LOCATE R2, C2 : PRINT CHR$(188);
1440  COLOR W
1450  RETURN
1500  REM subroutine to print a single box
1510  COLOR B
1520  FOR I = R1 + 1 TO R2 - 1
1530   LOCATE I, C1 : PRINT CHR$(179);
1540   LOCATE I, C2 : PRINT CHR$(179);
1550  NEXT I
1560   LOCATE R1, C1+1 : PRINT STRING$(C2-C1-1,196);
1590   LOCATE R2, C1+1 : PRINT STRING$(C2-C1-1,196);
1600   LOCATE R1, C1 : PRINT CHR$(218);
1610   LOCATE R1, C2 : PRINT CHR$(191);
1620   LOCATE R2, C1 : PRINT CHR$(192);
1630   LOCATE R2, C2 : PRINT CHR$(217);
1640  COLOR W
1650  RETURN
1700  REM ask user to press a key to continue
1710  LOCATE 25,1
1720  PRINT "Have Data Diskette(s) in Place, then Press any key to continue.";
1730  K$ = INKEY$ : IF K$ = "" THEN 1730
1740  KEY ON : CLS : KEY OFF
2000  REM LISTPCI Program Starts Here.
2010  OPEN DD.PERS$+"persfile" AS #1 LEN = 256
2020  FIELD 1, 5 AS F1$, 20 AS F2$, 30 AS F3$, 2 AS F4$, 5 AS F5$, 5 AS F6$, 5 AS F7$, 11 AS F8$, 18 AS F9$, 16 AS F10$, 16 AS F11$, 11 AS F12$, 18 AS F13$, 16 AS F14$, 16 AS F15$, 11 AS F16$, 18 AS F17$, 16 AS F18$, 16 AS F19$
2030  REM Read all records, and print the actual ones
2040  OPEN DD.PCIDX$+"pcindex" FOR INPUT AS #2
2050  INPUT #2, C
2060  KEY ON : CLS : KEY OFF : LOCATE 19,1
2070  PRINT "There are";C;"Parent/Child Index Records in the File"
2080  GOSUB 2100
2090  GOTO 2170
2100  LPRINT "Listing of the Parent/Child Index Records ";DATE$;"  ";TIME$
2110  LPRINT
2120  LPRINT "PARENT PARENT-NAME";
2130  LPRINT TAB(40);"CHILD  CHILD-NAME"
2140  LPRINT "------ -----------";
2150  LPRINT TAB(40);"-----  ----------"
2160  RETURN
2170  FOR I = 1 TO C
2180   INPUT #2, PAR.ID
2190   LOCATE 23,1 : PRINT "Listing Parent/Child Index Record";I
2200   LPRINT USING "####"; PAR.ID;
2210   GET #1, PAR.ID
2220   REM Extract information from the file for use
2230   T2$ = F2$
2240   T3$ = F3$
2250   FOR J = 1 TO LEN(F2$)-1
2260    IF RIGHT$(T2$,1)=" "THEN T2$ = LEFT$(T2$,LEN(T2$)-1) ELSE J = LEN(F2$)-1
2270   NEXT J
2280   FOR J = 1 TO LEN(F3$)-1
2290    IF RIGHT$(T3$,1)=" "THEN T3$ = LEFT$(T3$,LEN(T3$)-1) ELSE J = LEN(F3$)-1
2300   NEXT J
2310   LPRINT TAB(7); LEFT$(T2$+", "+T3$,32);
2320   INPUT #2, CHI.ID
2330   LPRINT TAB(40);: LPRINT USING "####"; CHI.ID;
2340   GET #1, CHI.ID
2350   T2$ = F2$
2360   T3$ = F3$
2370   FOR J = 1 TO LEN(F2$)-1
2380    IF RIGHT$(T2$,1)=" "THEN T2$ = LEFT$(T2$,LEN(T2$)-1) ELSE J = LEN(F2$)-1
2390   NEXT J
2400   FOR J = 1 TO LEN(F3$)-1
2410    IF RIGHT$(T3$,1)=" "THEN T3$ = LEFT$(T3$,LEN(T3$)-1) ELSE J = LEN(F3$)-1
2420   NEXT J
2430   LPRINT TAB(47); LEFT$(T2$+", "+T3$,32)
2440   IF I MOD 55 = 0 THEN LPRINT FORM.FEED$;: GOSUB 2100
2450  NEXT I
2460  CLOSE #2
2470  CLOSE #1
2480  KEY ON : CLS : KEY OFF : LOCATE 21,1
2490  PRINT "End of Program"
2500  LPRINT FORM.FEED$;
2510  RUN DD.MENU$+"menu"
