100  REM PEDIGREE Program.
110  REM Prints Pedigree (Family Tree) Charts
120  REM Copyright (c) 1983 - 1987 by: Melvin O. Duke.
130  DEFINT A-Z
600  REM Titles
610  TITLE$ = "Pedigree Chart"
620  TITLE$ = TITLE$ + " ON DISPLAY"
700  REM Terminate if not called from the Menu
710  IF DD.MENU$ <> "" THEN 770
720  COLOR 7,0 : KEY ON : CLS : LOCATE 15,1
730  PRINT "Cannot run the"
740  PRINT TITLE$
750  PRINT "Program, unless selected from the MENU"
760  END
770  REM OK
900  REM Dimension Statements
940  DIM PERS(31), FORM$(49)
1000  REM Produce the first screen
1010  KEY ON : CLS : KEY OFF
1020  REM Draw the outer double box
1030  R1 = 1 : C1 = 1 : R2 = 24 : C2 = 79 : GOSUB 1300
1040  REM Find the title location
1050  TITLE.POS = 40 - INT(LEN(TITLE$)/2)
1060  REM Draw the title box
1070  R1=3:C1=TITLE.POS-2:R2=6:C2=TITLE.POS+LEN(TITLE$)+1:GOSUB 1500
1080  REM Print the title
1090  LOCATE 4,TITLE.POS : PRINT TITLE$
1100  LOCATE 5,40-INT(LEN(VERSION$)/2) :  PRINT VERSION$;
1230  REM Draw the Copyright box
1240  R1 = 19 : C1 = 21 : R2 = 22 : C2 = 59 : GOSUB 1300
1250  REM Print the Copyright
1260  LOCATE 20,40-INT(LEN(COPY1$)/2) :  PRINT COPY1$;
1270  LOCATE 21,40-INT(LEN(COPY2$)/2) :  PRINT COPY2$;
1280  GOTO 1700
1300  REM subroutine to print a double box
1310  COLOR P
1320  FOR I = R1 + 1 TO R2 - 1
1330   LOCATE I, C1 : PRINT CHR$(186);
1340   LOCATE I, C2 : PRINT CHR$(186);
1350  NEXT I
1360   LOCATE R1, C1+1 : PRINT STRING$(C2-C1-1,205);
1390   LOCATE R2, C1+1 : PRINT STRING$(C2-C1-1,205);
1400   LOCATE R1, C1 : PRINT CHR$(201);
1410   LOCATE R1, C2 : PRINT CHR$(187);
1420   LOCATE R2, C1 : PRINT CHR$(200);
1430   LOCATE R2, C2 : PRINT CHR$(188);
1440  COLOR W
1450  RETURN
1500  REM subroutine to print a single box
1510  COLOR B
1520  FOR I = R1 + 1 TO R2 - 1
1530   LOCATE I, C1 : PRINT CHR$(179);
1540   LOCATE I, C2 : PRINT CHR$(179);
1550  NEXT I
1560   LOCATE R1, C1+1 : PRINT STRING$(C2-C1-1,196);
1590   LOCATE R2, C1+1 : PRINT STRING$(C2-C1-1,196);
1600   LOCATE R1, C1 : PRINT CHR$(218);
1610   LOCATE R1, C2 : PRINT CHR$(191);
1620   LOCATE R2, C1 : PRINT CHR$(192);
1630   LOCATE R2, C2 : PRINT CHR$(217);
1640  COLOR W
1650  RETURN
1700  REM ask user to press a key to continue
1710  LOCATE 25,1
1720  PRINT "Have Data Diskette(s) in Place, then Press any key to continue.";
1730  K$ = INKEY$ : IF K$ = "" THEN 1730
1740  KEY ON : CLS : KEY OFF
2000  REM PEDIGREE Program Starts Here.
2010  REM Routine to obtain Printer Information
2020  LOCATE 21,1 : PRINT "Make sure that the Printer is on and Ready"
2030  LOCATE 22,1 : PRINT "Make sure that the correct Diskette(s) are in place."
2040  LOCATE 23,1 : PRINT "Then press any key"
2050  A$ = INKEY$ : IF A$ = "" THEN 2050
2060  KEY ON : CLS : KEY OFF
2070  REM reset all Printer Defaults
2080  WIDTH "lpt1:", 132  'For printing Genealogy Forms
2090  IF WIDE   = 0 THEN WIDE   = 1
2100  IF LENGTH = 0 THEN LENGTH = 2
2110  IF FORMS  = 0 THEN FORMS  = 1
2120  REM Read the Marriage Index
2130  LOCATE 7,1 : PRINT "Open the Marriage Index";
2140  OPEN DD.MARIDX$+"mindex" FOR INPUT AS #2
2150  INPUT #2, M.COUNT
2160  DIM PERS.NO(M.COUNT), M.NO(M.COUNT)
2170  FOR I = 1 TO M.COUNT
2180  LOCATE 8,1 : PRINT "Reading Marriage Index Record #:";I:
2190   INPUT #2,PERS.NO(I), M.NO(I)
2200  NEXT I
2210  CLOSE #2
2220  REM Open the Persons File
2230  LOCATE 10,1 : PRINT "Open the Persons File"
2240  OPEN DD.PERS$+"persfile" AS #1 LEN = 256
2250  FIELD 1, 5 AS F1$, 20 AS F2$, 30 AS F3$, 2 AS F4$, 5 AS F5$, 5 AS F6$, 5 AS F7$, 11 AS F8$, 18 AS F9$, 16 AS F10$, 16 AS F11$, 11 AS F12$, 18 AS F13$, 16 AS F14$, 16 AS F15$, 11 AS F16$, 18 AS F17$, 16 AS F18$, 16 AS F19$
2260  REM open the Marriages File
2270  LOCATE 12,1 : PRINT "Open the Marriage File"
2280  OPEN DD.MARR$+"marrfile" AS #2 LEN = 128
2290  FIELD 2, 5 AS M1$, 5 AS M2$, 5 AS M3$, 5 AS M4$, 11 AS M5$, 18 AS M6$, 16 AS M7$, 16 AS M8$, 45 AS M9$
2300  REM Obtain a Person Record from the User
2310  LOCATE 20,1 : INPUT "Enter the Record-number of a Person (0 to quit)";REPLY$
2320  IF REPLY$ = "0" THEN 7490
2330  PERS(1) = VAL(REPLY$)
2340  IF PERS(1) < 1 OR PERS(1) > MAX.PER THEN KEY ON : CLS : LOCATE 19,1 : PRINT "Number is out of range"; : KEY OFF : GOTO 2300
2350  REM Reset the Printer characteristics for next page if required.
2360  IF FORMS = 1 THEN 2400  'Don't stop if forms are continuous
2370  REM process single sheets
2380  PRINT "Press any key when next form is ready"
2390  A$ = INKEY$ : IF A$ = "" THEN 2390
2400  REM Reset paper sensing if required
2410  IF FORMS = 2 THEN LPRINT PAP.SEN.OFF$;
2420  REM Reset paper length if required
2430  IF LENGTH = 1 THEN LPRINT PAP.SHORT$;
2440  REM Reset Condensed printing if required
2450  IF WIDE = 1 THEN LPRINT COMPR.ON$;
2460  KEY ON : CLS : KEY OFF
2470  GOTO 3110
2480  REM Routine to Extract Personal Information
2490  T1! = CVS(F1$) : T1 = T1!
2500  TEMP1$ = F2$ : TEMP2$ = F2$ : GOSUB 2670  'Rtrim
2510  T2$ = TEMP2$
2520  TEMP1$ = F3$ : TEMP2$ = F3$ : GOSUB 2670  'Rtrim
2530  T3$ = TEMP2$
2540  T6! = CVS(F6$) : T6 = T6!
2550  T7! = CVS(F7$) : T7 = T7!
2560  T8$ = F8$
2570  TEMP1$ = F9$ : TEMP2$ = F9$ : GOSUB 2670  'Rtrim
2580  T9$ = TEMP2$
2590  TEMP1$ = F11$ : TEMP2$ = F11$ : GOSUB 2670  'Rtrim
2600  T11$ = TEMP2$
2610  T12$ = F12$
2620  TEMP1$ = F13$ : TEMP2$ = F13$ : GOSUB 2670  'Rtrim
2630  T13$ = TEMP2$
2640  TEMP1$ = F15$ : TEMP2$ = F15$ : GOSUB 2670  'Rtrim
2650  T15$ = TEMP2$
2660  RETURN
2670  REM General RTRIM$ Routine
2680  FOR J = 1 TO LEN(TEMP1$)-1
2690   IF RIGHT$(TEMP2$,1) = " " THEN TEMP2$ = LEFT$(TEMP2$,LEN(TEMP2$)-1) ELSE J = LEN(TEMP1$)-1
2700  NEXT J
2710  RETURN
2720  REM Blank out a Person Record
2730  T1 = 0
2740  T2$ = ""
2750  T3$ = ""
2760  T4$ = ""
2770  T5 = 0
2780  T6 = 0
2790  T7 = 0
2800  T8$ = ""
2810  T9$ = ""
2820  T10$ = ""
2830  T11$ = ""
2840  T12$ = ""
2850  T13$ = ""
2860  T14$ = ""
2870  T15$ = ""
2880  T16$ = ""
2890  T17$ = ""
2900  T18$ = ""
2910  T19$ = ""
2920  RETURN
2930  REM Routine to extract a name
2940  NM$ = T2$+", "+T3$
2950  IF COL = 24 THEN NM$ = LEFT$(NM$,48)
2960  IF COL > 24 THEN NM$ = LEFT$(NM$,23)
2970  MID$(FORM$(ROW),COL,LEN(NM$))=NM$
2980  RETURN
2990  REM Routine to extract a birth-location
3000  BL$=T9$+", "+T11$
3010  IF COL = 27 THEN BL$ = LEFT$(BL$,46)
3020  IF COL > 27 THEN BL$ = LEFT$(BL$,20)
3030  MID$(FORM$(ROW),COL,LEN(BL$))=BL$
3040  RETURN
3050  REM Routine to extract a death-location
3060  DL$ = T13$+", "+T15$
3070  IF COL = 27 THEN DL$ = LEFT$(DL$,46)
3080  IF COL > 27 THEN DL$ = LEFT$(DL$,20)
3090  MID$(FORM$(ROW),COL,LEN(DL$))=DL$
3100  RETURN
3110  REM Routine to Produce a Pedigree Chart
3120  REM Test if already formed
3130  IF PERS(1) = LAST.PERS THEN 7380
3140  REM Start with all Spaces
3150  FOR I = 1 TO 49
3160   FORM$(I) = SPACE$(131)
3170  NEXT I
3180  IF WIDE = 2 AND FORMS = 2 AND DD.ORD$ <> "no" THEN 3190 ELSE GOSUB 7590
3190  REM get 1
3200  LOCATE 20,1 : PRINT "Processing Person # 1 on the Chart"
3210  IF PERS(1) = 0 THEN GOSUB 2720 : GOTO 3340
3220  GET #1, PERS(1) : GOSUB 2480  'Extract 1
3230  ROW = 22: COL = 1: GOSUB 9420  'for Person Number
3240  MID$(FORM$(22),1,PLEN) = PNUM$
3250  IF T2$ = " " AND T3$ = " " THEN 3280
3260  ROW=23: COL=1: GOSUB 2930
3270  MID$(FORM$(2),1,LEN(T2$+T3$)+1) = T3$+" "+T2$
3280  MID$(FORM$(24),3,11) = T8$
3290  IF T9$ = " " AND T11$ = " " THEN 3310
3300  ROW=25: COL=3: GOSUB 2990
3310  MID$(FORM$(27),3,11) = T12$
3320  IF T13$ = " " AND T15$ = " " THEN 3340
3330  ROW=28: COL=3: GOSUB 3050
3340  PERS(2) = T6
3350  PERS(3) = T7
3360  REM get 11
3370  LOCATE 20,20: PRINT " 2";
3380  IF PERS(2) = 0 THEN GOSUB 2720 : GOTO 3490
3390  GET #1, PERS(2) : GOSUB 2480  'Extract 11
3400  ROW=12: COL=24: GOSUB 9420  'for Person Number
3410  IF T2$ = " " AND T3$ = " " THEN 3430
3420  GOSUB 2930
3430  MID$(FORM$(13),27,11) = T8$
3440  IF T9$ = " " AND T11$ = " " THEN 3460
3450  ROW=14: COL=27: GOSUB 2990
3460  MID$(FORM$(16),27,11) = T12$
3470  IF T13$ = " " AND T15$ = " " THEN 3490
3480  ROW=17: COL=27: GOSUB 3050
3490  PERS(4) = T6
3500  PERS(5) = T7
3510  REM get 10
3520  LOCATE 20,20: PRINT " 3";
3530  IF PERS(3) = 0 THEN GOSUB 2720 : GOTO 3640
3540  GET #1, PERS(3) : GOSUB 2480  'Extract 10
3550  ROW=36: COL=24: GOSUB 9420  'for Person Number
3560  IF T2$ = " " AND T3$ = " " THEN 3580
3570  GOSUB 2930
3580  MID$(FORM$(37),27,11) = T8$
3590  IF T9$ = " " AND T11$ = " " THEN 3610
3600  ROW=38: COL=27: GOSUB 2990
3610  MID$(FORM$(39),27,11) = T12$
3620  IF T13$ = " " AND T15$ = " " THEN 3640
3630  ROW=40: COL=27: GOSUB 3050
3640  PERS(6) = T6
3650  PERS(7) = T7
3660  REM get 111
3670  LOCATE 20,20: PRINT " 4";
3680  IF PERS(4) = 0 THEN GOSUB 2720 : GOTO 3790
3690  GET #1, PERS(4) : GOSUB 2480  'Extract 111
3700  ROW=6: COL=49: GOSUB 9420  'for Person Number
3710  IF T2$ = " " AND T3$ = " " THEN 3730
3720  GOSUB 2930
3730  MID$(FORM$(7),52,11) = T8$
3740  IF T9$ = " " AND T11$ = " " THEN 3760
3750  ROW=8: COL=52: GOSUB 2990
3760  MID$(FORM$(10),52,11) = T12$
3770  IF T13$ = " " AND T15$ = " " THEN 3790
3780  ROW=11: COL=52: GOSUB 3050
3790  PERS(8) = T6
3800  PERS(9) = T7
3810  REM get 110
3820  LOCATE 20,20: PRINT " 5";
3830  IF PERS(5) = 0 THEN GOSUB 2720 : GOTO 3940
3840  GET #1, PERS(5) : GOSUB 2480  'Extract 110
3850  ROW=18: COL=49: GOSUB 9420  'for Person Number
3860  IF T2$ = " " AND T3$ = " " THEN 3880
3870  GOSUB 2930
3880  MID$(FORM$(19),52,11) = T8$
3890  IF T9$ = " " AND T11$ = " " THEN 3910
3900  ROW=20: COL=52: GOSUB 2990
3910  MID$(FORM$(21),52,11) = T12$
3920  IF T13$ = " " AND T15$ = " " THEN 3940
3930  ROW=22: COL=52: GOSUB 3050
3940  PERS(10) = T6
3950  PERS(11) = T7
3960  REM get 101
3970  LOCATE 20,20: PRINT " 6";
3980  IF PERS(6) = 0 THEN GOSUB 2720 : GOTO 4090
3990  GET #1, PERS(6) : GOSUB 2480  'Extract 101
4000  ROW=30: COL=49: GOSUB 9420  'for Person Number
4010  IF T2$ = " " AND T3$ = " " THEN 4030
4020  GOSUB 2930
4030  MID$(FORM$(31),52,11) = T8$
4040  IF T9$ = " " AND T11$ = " " THEN 4060
4050  ROW=32: COL=52: GOSUB 2990
4060  MID$(FORM$(34),52,11) = T12$
4070  IF T13$ = " " AND T15$ = " " THEN 4090
4080  ROW=35: COL=52: GOSUB 3050
4090  PERS(12) = T6
4100  PERS(13) = T7
4110  REM get 100
4120  LOCATE 20,20: PRINT " 7";
4130  IF PERS(7) = 0 THEN GOSUB 2720 : GOTO 4240
4140  GET #1, PERS(7) : GOSUB 2480  'Extract 100
4150  ROW=42: COL=49: GOSUB 9420  'for Person Number
4160  IF T2$ = " " AND T3$ = " " THEN 4180
4170  GOSUB 2930
4180  MID$(FORM$(43),52,11) = T8$
4190  IF T9$ = " " AND T11$ = " " THEN 4210
4200  ROW=44: COL=52: GOSUB 2990
4210  MID$(FORM$(45),52,11) = T12$
4220  IF T13$ = " " AND T15$ = " " THEN 4240
4230  ROW=46: COL=52: GOSUB 3050
4240  PERS(14) = T6
4250  PERS(15) = T7
4260  REM get 1111
4270  LOCATE 20,20: PRINT " 8";
4280  IF PERS(8) = 0 THEN GOSUB 2720 : GOTO 4390
4290  GET #1, PERS(8) : GOSUB 2480  'Extract 1111
4300  ROW=3: COL=74: GOSUB 9420  'for Person Number
4310  IF T2$ = " " AND T3$ = " " THEN 4330
4320  GOSUB 2930
4330  MID$(FORM$(4),77,11) = T8$
4340  IF T9$ = " " AND T11$ = " " THEN 4360
4350  ROW=5: COL=77: GOSUB 2990
4360  MID$(FORM$(7),77,11) = T12$
4370  IF T13$ = " " AND T15$ = " " THEN 4390
4380  ROW=8: COL=77: GOSUB 3050
4390  PERS(16) = T6
4400  PERS(17) = T7
4410  REM get 1110
4420  LOCATE 20,20: PRINT " 9";
4430  IF PERS(9) = 0 THEN GOSUB 2720 : GOTO 4540
4440  GET #1, PERS(9) : GOSUB 2480  'Extract 1110
4450  ROW=9: COL=74: GOSUB 9420  'for Person Number
4460  IF T2$ = " " AND T3$ = " " THEN 4480
4470  GOSUB 2930
4480  MID$(FORM$(10),77,11) = T8$
4490  IF T9$ = " " AND T11$ = " " THEN 4510
4500  ROW=11: COL=77: GOSUB 2990
4510  MID$(FORM$(12),77,11) = T12$
4520  IF T13$ = " " AND T15$ = " " THEN 4540
4530  ROW=13: COL=77: GOSUB 3050
4540  PERS(18) = T6
4550  PERS(19) = T7
4560  REM get 1101
4570  LOCATE 20,20: PRINT "10";
4580  IF PERS(10) = 0 THEN GOSUB 2720 : GOTO 4690
4590  GET #1, PERS(10) : GOSUB 2480  'Extract 1101
4600  ROW=15: COL=74: GOSUB 9420  'for Person Number
4610  IF T2$ = " " AND T3$ = " " THEN 4630
4620  GOSUB 2930
4630  MID$(FORM$(16),77,11) = T8$
4640  IF T9$ = " " AND T11$ = " " THEN 4660
4650  ROW=17: COL=77: GOSUB 2990
4660  MID$(FORM$(19),77,11) = T12$
4670  IF T13$ = " " AND T15$ = " " THEN 4690
4680  ROW=20: COL=77: GOSUB 3050
4690  PERS(20) = T6
4700  PERS(21) = T7
4710  REM get 1100
4720  LOCATE 20,20: PRINT "11";
4730  IF PERS(11) = 0 THEN GOSUB 2720 : GOTO 4840
4740  GET #1, PERS(11) : GOSUB 2480  'Extract 1100
4750  ROW=21: COL=74: GOSUB 9420  'for Person Number
4760  IF T2$ = " " AND T3$ = " " THEN 4780
4770  GOSUB 2930
4780  MID$(FORM$(22),77,11) = T8$
4790  IF T9$ = " " AND T11$ = " " THEN 4810
4800  ROW=23: COL=77: GOSUB 2990
4810  MID$(FORM$(24),77,11) = T12$
4820  IF T13$ = " " AND T15$ = " " THEN 4840
4830  ROW=25: COL=77: GOSUB 3050
4840  PERS(22) = T6
4850  PERS(23) = T7
4860  REM get 1011
4870  LOCATE 20,20: PRINT "12";
4880  IF PERS(12) = 0 THEN GOSUB 2720 : GOTO 4990
4890  GET #1, PERS(12) : GOSUB 2480  'Extract 1010
4900  ROW=27: COL=74: GOSUB 9420  'for Person Number
4910  IF T2$ = " " AND T3$ = " " THEN 4930
4920  GOSUB 2930
4930  MID$(FORM$(28),77,11) = T8$
4940  IF T9$ = " " AND T11$ = " " THEN 4960
4950  ROW=29: COL=77: GOSUB 2990
4960  MID$(FORM$(31),77,11) = T12$
4970  IF T13$ = " " AND T15$ = " " THEN 4990
4980  ROW=32: COL=77: GOSUB 3050
4990  PERS(24) = T6
5000  PERS(25) = T7
5010  REM get 1010
5020  LOCATE 20,20: PRINT "13";
5030  IF PERS(13) = 0 THEN GOSUB 2720 : GOTO 5140
5040  GET #1, PERS(13) : GOSUB 2480  'Extract 1010
5050  ROW=33: COL=74: GOSUB 9420  'for Person Number
5060  IF T2$ = " " AND T3$ = " " THEN 5080
5070  GOSUB 2930
5080  MID$(FORM$(34),77,11) = T8$
5090  IF T9$ = " " AND T11$ = " " THEN 5110
5100  ROW=35: COL=77: GOSUB 2990
5110  MID$(FORM$(36),77,11) = T12$
5120  IF T13$ = " " AND T15$ = " " THEN 5140
5130  ROW=37: COL=77: GOSUB 3050
5140  PERS(26) = T6
5150  PERS(27) = T7
5160  REM get 1001
5170  LOCATE 20,20: PRINT "14";
5180  IF PERS(14) = 0 THEN GOSUB 2720 : GOTO 5290
5190  GET #1, PERS(14) : GOSUB 2480  'Extract 1001
5200  ROW=39: COL=74: GOSUB 9420  'for Person Number
5210  IF T2$ = " " AND T3$ = " " THEN 5230
5220  GOSUB 2930
5230  MID$(FORM$(40),77,11) = T8$
5240  IF T9$ = " " AND T11$ = " " THEN 5260
5250  ROW=41: COL=77: GOSUB 2990
5260  MID$(FORM$(43),77,11) = T12$
5270  IF T13$ = " " AND T15$ = " " THEN 5290
5280  ROW=44: COL=77: GOSUB 3050
5290  PERS(28) = T6
5300  PERS(29) = T7
5310  REM get 1001
5320  LOCATE 20,20: PRINT "15";
5330  IF PERS(15) = 0 THEN GOSUB 2720 : GOTO 5440
5340  GET #1, PERS(15) : GOSUB 2480  'Extract 1000
5350  ROW=45: COL=74: GOSUB 9420  'for Person Number
5360  IF T2$ = " " AND T3$ = " " THEN 5380
5370  GOSUB 2930
5380  MID$(FORM$(46),77,11) = T8$
5390  IF T9$ = " " AND T11$ = " " THEN 5410
5400  ROW=47: COL=77: GOSUB 2990
5410  MID$(FORM$(48),77,11) = T12$
5420  IF T13$ = " " AND T15$ = " " THEN 5440
5430  ROW=49: COL=77: GOSUB 3050
5440  PERS(30) = T6
5450  PERS(31) = T7
5460  IF DD.ORD$ = "no" THEN 6540
5470  REM get 11111
5480  LOCATE 20,20: PRINT "16";
5490  IF PERS(16) = 0 THEN GOSUB 2720 : GOTO 5530
5500  GET #1, PERS(16) : GOSUB 2480  'Extract 11111
5510  ROW=1: COL=98: GOSUB 9420  'for Person Number
5520  GOSUB 2930
5530  REM get 11110
5540  LOCATE 20,20: PRINT "17";
5550  IF PERS(17) = 0 THEN GOSUB 2720 : GOTO 5590
5560  GET #1, PERS(17) : GOSUB 2480  'Extract 11110
5570  ROW=4: COL=98: GOSUB 9420  'for Person Number
5580  GOSUB 2930
5590  REM get 11101
5600  LOCATE 20,20: PRINT "18";
5610  IF PERS(18) = 0 THEN GOSUB 2720 : GOTO 5650
5620  GET #1, PERS(18) : GOSUB 2480  'Extract 11101
5630  ROW=7: COL=98: GOSUB 9420  'for Person Number
5640  GOSUB 2930
5650  REM get 11100
5660  LOCATE 20,20: PRINT "19";
5670  IF PERS(19) = 0 THEN GOSUB 2720 : GOTO 5710
5680  GET #1, PERS(19) : GOSUB 2480  'Extract 11100
5690  ROW=10: COL=98: GOSUB 9420  'for Person Number
5700  GOSUB 2930
5710  REM get 11011
5720  LOCATE 20,20: PRINT "20";
5730  IF PERS(20) = 0 THEN GOSUB 2720 : GOTO 5780
5740  GET #1, PERS(20) : GOSUB 2480  'Extract 11011
5750  IF WIDE=2 AND FORMS=2 AND DD.ORD$ <> "no" THEN ROW=13 ELSE ROW=14
5760  COL=98: GOSUB 9420  'for Person Number
5770  GOSUB 2930
5780  REM get 11010
5790  LOCATE 20,20: PRINT "21";
5800  IF PERS(21) = 0 THEN GOSUB 2720 : GOTO 5840
5810  GET #1, PERS(21) : GOSUB 2480  'Extract 11010
5820  ROW=16: COL=98: GOSUB 9420  'for Person Number
5830  GOSUB 2930
5840  REM get 11001
5850  LOCATE 20,20: PRINT "22";
5860  IF PERS(22) = 0 THEN GOSUB 2720 : GOTO 5900
5870  GET #1, PERS(22) : GOSUB 2480  'Extract 11001
5880  ROW=19: COL=98: GOSUB 9420  'for Person Number
5890  GOSUB 2930
5900  REM get 11000
5910  LOCATE 20,20: PRINT "23";
5920  IF PERS(23) = 0 THEN GOSUB 2720 : GOTO 5960
5930  GET #1, PERS(23) : GOSUB 2480  'Extract 11000
5940  ROW=22: COL=98: GOSUB 9420  'for Person Number
5950  GOSUB 2930
5960  REM get 10111
5970  LOCATE 20,20: PRINT "24";
5980  IF PERS(24) = 0 THEN GOSUB 2720 : GOTO 6030
5990  GET #1, PERS(24) : GOSUB 2480  'Extract 10111
6000  IF WIDE=2 AND FORMS=2 AND DD.ORD$ <> "no" THEN ROW=25 ELSE ROW=26
6010  COL=98: GOSUB 9420  'for Person Number
6020  GOSUB 2930
6030  REM get 10110
6040  LOCATE 20,20: PRINT "25";
6050  IF PERS(25) = 0 THEN GOSUB 2720 : GOTO 6090
6060  GET #1, PERS(25) : GOSUB 2480  'Extract 10110
6070  ROW=28: COL=98: GOSUB 9420  'for Person Number
6080  GOSUB 2930
6090  REM get 10101
6100  LOCATE 20,20: PRINT "26";
6110  IF PERS(26) = 0 THEN GOSUB 2720 : GOTO 6150
6120  GET #1, PERS(26) : GOSUB 2480  'Extract 10101
6130  ROW=31: COL=98: GOSUB 9420  'for Person Number
6140  GOSUB 2930
6150  REM get 10100
6160  LOCATE 20,20: PRINT "27";
6170  IF PERS(27) = 0 THEN GOSUB 2720 : GOTO 6210
6180  GET #1, PERS(27) : GOSUB 2480  'Extract 10100
6190  ROW=34: COL=98: GOSUB 9420  'for Person Number
6200  GOSUB 2930
6210  REM get 10011
6220  LOCATE 20,20: PRINT "28";
6230  IF PERS(28) = 0 THEN GOSUB 2720 : GOTO 6280
6240  GET #1, PERS(28) : GOSUB 2480  'Extract 10011
6250  IF WIDE=2 AND FORMS=2 AND DD.ORD$ <> "no" THEN ROW=37 ELSE ROW=38
6260  COL=98: GOSUB 9420  'for Person Number
6270  GOSUB 2930
6280  REM get 10010
6290  LOCATE 20,20: PRINT "29";
6300  IF PERS(29) = 0 THEN GOSUB 2720 : GOTO 6340
6310  GET #1, PERS(29) : GOSUB 2480  'Extract 10010
6320  ROW=40: COL=98: GOSUB 9420  'for Person Number
6330  GOSUB 2930
6340  REM get 10001
6350  LOCATE 20,20: PRINT "30";
6360  IF PERS(30) = 0 THEN GOSUB 2720 : GOTO 6400
6370  GET #1, PERS(30) : GOSUB 2480  'Extract 10001
6380  ROW=43: COL=98: GOSUB 9420  'for Person Number
6390  GOSUB 2930
6400  REM get 10000
6410  LOCATE 20,20: PRINT "31";
6420  IF PERS(31) = 0 THEN GOSUB 2720 : GOTO 6460
6430  GET #1, PERS(31) : GOSUB 2480  'Extract 10000
6440  ROW=46: COL=98: GOSUB 9420  'for Person Number
6450  GOSUB 2930
6460  GOTO 6540
6470  REM Extract Marriage Information
6480  TT2! = CVS(M2$) : TT2 = TT2! 'Husband
6490  TT3! = CVS(M3$) : TT3 = TT3! 'Wife
6500  REM Position based upon forms
6510  TT5$ = SPACE$(13)
6520  IF WIDE = 2 AND FORMS = 2 AND DD.ORD$ <> "no" THEN RSET TT5$ = M5$ ELSE LSET TT5$ = M5$
6530  RETURN
6540  REM Find Marriage of Person (1)
6550  KEY ON : CLS : KEY OFF
6560  LOCATE 20,1 : PRINT "Processing Marriage of # 1 on Chart"
6570  FOUND = 0
6580  FOR L = 1 TO M.COUNT
6590   IF PERS(1) > PERS.NO(L) THEN 6650
6600   IF PERS(1) < PERS.NO(L) THEN L = M.COUNT : GOTO 6650
6610   REM found the marriage
6620   FOUND = 1
6630   GET #2, M.NO(L)
6640   L = M.COUNT
6650  NEXT L
6660  IF FOUND = 0 THEN 6790
6670  REM extract marriage information
6680  GOSUB 6470  'extract
6690  MID$(FORM$(26),10,13) = TT5$
6700  REM identify the spouse
6710  IF TT2 = PERS(1) THEN SPOUSE = TT3
6720  IF TT3 = PERS(1) THEN SPOUSE = TT2
6730  GET #1, SPOUSE
6740  GOSUB 2480  'Extract Person Info
6750  MID$(FORM$(29),1,LEN(T2$+T3$)+2) = T2$ + ", " + T3$
6760  COL = 1
6770  GOSUB 9420  'Obtain Spouse's Record No.
6780  MID$(FORM$(30),1,PLEN) = PNUM$
6790  GOTO 7020
6800  REM find a marriage
6810  FOUND = 0
6820  IF HUSB = 0 THEN 7010  'return
6830  REM Establish Skip-ahead Start-value and Delta
6840  START.AT = 1 : DELTA = INT(M.COUNT/10) : IF DELTA = 0 THEN 6890
6850  REM Add delta and test if too far
6860  START.AT = START.AT + DELTA
6870  IF START.AT > 9 * DELTA THEN 6890
6880  IF HUSB > PERS.NO(START.AT) THEN 6860
6890  START.AT = START.AT - DELTA
6900  REM Search Routine
6910  FOR L = START.AT TO M.COUNT
6920   IF HUSB > PERS.NO(L) THEN  7000  'next l
6930   IF HUSB < PERS.NO(L) THEN L = M.COUNT : GOTO 7000  'next l
6940   REM found one marriage
6950   GET #2, M.NO(L)
6960   GOSUB 6470  'Extract marriage info
6970   IF TT3 <> WIFE THEN 7000 'next l
6980   FOUND = 1
6990   L = M.COUNT
7000  NEXT L
7010  RETURN
7020  LOCATE 20,25: PRINT " 2";
7030  HUSB = PERS(2) : WIFE = PERS(3)
7040  GOSUB 6800  'Look for marriage
7050  IF FOUND = 0 THEN 7070
7060  MID$(FORM$(15),30,13) = TT5$
7070  LOCATE 20,25: PRINT " 4";
7080  HUSB = PERS(4) : WIFE = PERS(5)
7090  GOSUB 6800  'Look for marriage
7100  IF FOUND = 0 THEN 7120
7110  MID$(FORM$(9),55,13) = TT5$
7120  LOCATE 20,25: PRINT " 6";
7130  HUSB = PERS(6) : WIFE = PERS(7)
7140  GOSUB 6800  'Look for marriage
7150  IF FOUND = 0 THEN 7170
7160  MID$(FORM$(33),55,13) = TT5$
7170  LOCATE 20,25: PRINT " 8";
7180  HUSB = PERS(8) : WIFE = PERS(9)
7190  GOSUB 6800  'Look for marriage
7200  IF FOUND = 0 THEN 7220
7210  MID$(FORM$(6),80,13) = TT5$
7220  LOCATE 20,25: PRINT "10";
7230  HUSB = PERS(10) : WIFE = PERS(11)
7240  GOSUB 6800  'Look for marriage
7250  IF FOUND = 0 THEN 7270
7260  MID$(FORM$(18),80,13) = TT5$
7270  LOCATE 20,25: PRINT "12";
7280  HUSB = PERS(12) : WIFE = PERS(13)
7290  GOSUB 6800  'Look for marriage
7300  IF FOUND = 0 THEN 7320
7310  MID$(FORM$(30),80,13) = TT5$
7320  LOCATE 20,25: PRINT "14";
7330  HUSB = PERS(14) : WIFE = PERS(15)
7340  GOSUB 6800  'Look for marriage
7350  IF FOUND = 0 THEN 7370
7360  MID$(FORM$(42),80,13) = TT5$
7370  REM All Marriages found
7380  PRINT : PRINT "Ready to Print"
7390  LPRINT
7400  REM Print the Pedigree Chart
7410  FOR I = 1 TO 49
7420   PRINT "Printing Line: ";I
7430   IF DD.ORD$ = "no" THEN LPRINT TAB(18); LEFT$(FORM$(I),97) ELSE LPRINT FORM$(I)
7440  NEXT I
7450  LAST.PERS = PERS(1)
7460  KEY ON : CLS : KEY OFF
7470  LPRINT FORM.FEED$;
7480  GOTO 2300  'for next chart
7490  REM Wrapup
7500  LPRINT COMPR.OFF$;      'Normal Printing
7510  LPRINT PAP.SEN.ON$;     'Paper Sensing ON
7520  LPRINT PAP.LONG$;       'Normal Page of 66 Lines
7530  CLOSE #1
7540  CLOSE #2
7550  WIDTH "lpt1:",80        'Reset for narrow paper
7560  KEY ON : CLS : KEY OFF : LOCATE 21,1
7570  PRINT "End of Program"
7580  RUN DD.MENU$+"menu"
7590  REM Create the Form
7600  REM Draw the Vertical Lines
7610  LOCATE 15,1 : PRINT "Drawing the Vertical Lines"
7620  FOR II = 13 TO 36
7630   MID$(FORM$(II),23,1) = CHR$(124)
7640  NEXT II
7650  FOR II = 7 TO 18
7660   MID$(FORM$(II),48,1) = CHR$(124)
7670   MID$(FORM$(II+24),48,1) = CHR$(124)
7680  NEXT II
7690  FOR II = 4 TO 9
7700   MID$(FORM$(II),73,1) = CHR$(124)
7710   MID$(FORM$(II+12),73,1) = CHR$(124)
7720   MID$(FORM$(II+24),73,1) = CHR$(124)
7730   MID$(FORM$(II+36),73,1) = CHR$(124)
7740  NEXT II
7750  IF DD.ORD$ = "no" THEN 7890
7760  FOR II = 2 TO 4
7770   MID$(FORM$(II),97,1) = CHR$(124)
7780   MID$(FORM$(II+6),97,1) = CHR$(124)
7790   IF II = 2 THEN 7810
7800   MID$(FORM$(II+12),97,1) = CHR$(124)
7810   MID$(FORM$(II+18),97,1) = CHR$(124)
7820   IF II = 2 THEN 7840
7830   MID$(FORM$(II+24),97,1) = CHR$(124)
7840   MID$(FORM$(II+30),97,1) = CHR$(124)
7850   IF II = 2 THEN 7870
7860   MID$(FORM$(II+36),97,1) = CHR$(124)
7870   MID$(FORM$(II+42),97,1) = CHR$(124)
7880  NEXT II
7890  REM Draw the Horizontal Lines
7900  PRINT "Drawing the Horizontal Lines"
7910  FOR JJ = 1 TO 22
7920   MID$(FORM$(23),JJ,1) = CHR$(95)
7930   MID$(FORM$(29),JJ,1) = CHR$(95)
7940  NEXT JJ
7950  PRINT "Drawing Lines for Parents"
7960  FOR II = 12 TO 36 STEP 24
7970   MID$(FORM$(II),24) = STRING$(24,95)
7980  NEXT II
7990  PRINT "Drawing Lines for Grandparents"
8000  FOR II = 6 TO 42 STEP 12
8010   MID$(FORM$(II),49) = STRING$(24,95)
8020  NEXT II
8030  PRINT "Drawing Lines for Great-grandparents"
8040  FOR II = 3 TO 45 STEP 6
8050   MID$(FORM$(II),74) = STRING$(23,95)
8060  NEXT II
8070  IF DD.ORD$ = "no" THEN 8150
8080  PRINT "Drawing Lines for Great-great-grandparents"
8090  FOR II = 1 TO 46 STEP 3
8100    IF II = 13 OR II = 25 OR II = 37 THEN 8130
8110    MID$(FORM$(II),98,23) = STRING$(23,95)
8120    GOTO 8140
8130    MID$(FORM$(II+1),98,23) = STRING$(23,95)
8140  NEXT II
8150  REM Prepare the Title Information
8160  PRINT "Preparing Titles and Numbers"
8170  PRINT : PRINT : PRINT : PRINT : PRINT
8180  MID$(FORM$( 1),1,18) = "PEDIGREE CHART of:"
8190  MID$(FORM$(49),1,43) = "Genealogy ON DISPLAY Computerized Data Base"
8200  MID$(FORM$( 3),1,15) = "Person Record: "
8210  P.NO$ = STR$(PERS(1))
8220  P.NO$ = RIGHT$(P.NO$,LEN(P.NO$)-1)
8230  MID$(FORM$( 3),16,LEN(P.NO$)) = P.NO$
8240  MID$(FORM$( 4),1,22) = "Prepared:  "+DATE$
8250  MID$(FORM$( 5),1,19) = "At (time): "+TIME$
8260  IF CHART.NOS$ = "n" THEN 8280
8270  MID$(FORM$(22),1,1) = "1"
8280  MID$(FORM$(24),1,1) = "B"
8290  MID$(FORM$(25),1,1) = "W"
8300  MID$(FORM$(26),1,8) = "Married:"
8310  MID$(FORM$(27),1,1) = "D"
8320  MID$(FORM$(28),1,1) = "W"
8330  IF CHART.NOS$ = "n" THEN 8350
8340  MID$(FORM$(12),21,2) = " 2"
8350  MID$(FORM$(13),24,2) = "B:"
8360  MID$(FORM$(14),24,2) = "W:"
8370  MID$(FORM$(15),24,5) = "Marr:"
8380  MID$(FORM$(16),24,2) = "D:"
8390  MID$(FORM$(17),24,2) = "W:"
8400  IF CHART.NOS$ = "n" THEN 8420
8410  MID$(FORM$(36),21,2) = " 3"
8420  MID$(FORM$(37),24,2) = "B:"
8430  MID$(FORM$(38),24,2) = "W:"
8440  MID$(FORM$(39),24,2) = "D:"
8450  MID$(FORM$(40),24,2) = "W:"
8460  IF CHART.NOS$ = "n" THEN 8480
8470  MID$(FORM$( 6),46,2) = " 4"
8480  MID$(FORM$( 7),49,2) = "B:"
8490  MID$(FORM$( 8),49,2) = "W:"
8500  MID$(FORM$( 9),49,5) = "Marr:"
8510  MID$(FORM$(10),49,2) = "D:"
8520  MID$(FORM$(11),49,2) = "W:"
8530  IF CHART.NOS$ = "n" THEN 8550
8540  MID$(FORM$(18),46,2) = " 5"
8550  MID$(FORM$(19),49,2) = "B:"
8560  MID$(FORM$(20),49,2) = "W:"
8570  MID$(FORM$(21),49,2) = "D:"
8580  MID$(FORM$(22),49,2) = "W:"
8590  IF CHART.NOS$ = "n" THEN 8610
8600  MID$(FORM$(30),46,2) = " 6"
8610  MID$(FORM$(31),49,2) = "B:"
8620  MID$(FORM$(32),49,2) = "W:"
8630  MID$(FORM$(33),49,5) = "Marr:"
8640  MID$(FORM$(34),49,2) = "D:"
8650  MID$(FORM$(35),49,2) = "W:"
8660  IF CHART.NOS$ = "n" THEN 8680
8670  MID$(FORM$(42),46,2) = " 7"
8680  MID$(FORM$(43),49,2) = "B:"
8690  MID$(FORM$(44),49,2) = "W:"
8700  MID$(FORM$(45),49,2) = "D:"
8710  MID$(FORM$(46),49,2) = "W:"
8720  IF CHART.NOS$ = "n" THEN 8740
8730  MID$(FORM$( 3),71,2) = " 8"
8740  MID$(FORM$( 4),74,2) = "B:"
8750  MID$(FORM$( 5),74,2) = "W:"
8760  MID$(FORM$( 6),74,5) = "Marr:"
8770  MID$(FORM$( 7),74,2) = "D:"
8780  MID$(FORM$( 8),74,2) = "W:"
8790  IF CHART.NOS$ = "n" THEN 8810
8800  MID$(FORM$( 9),71,2) = " 9"
8810  MID$(FORM$(10),74,2) = "B:"
8820  MID$(FORM$(11),74,2) = "W:"
8830  MID$(FORM$(12),74,2) = "D:"
8840  MID$(FORM$(13),74,2) = "W:"
8850  IF CHART.NOS$ = "n" THEN 8870
8860  MID$(FORM$(15),71,2) = "10"
8870  MID$(FORM$(16),74,2) = "B:"
8880  MID$(FORM$(17),74,2) = "W:"
8890  MID$(FORM$(18),74,5) = "Marr:"
8900  MID$(FORM$(19),74,2) = "D:"
8910  MID$(FORM$(20),74,2) = "W:"
8920  IF CHART.NOS$ = "n" THEN 8940
8930  MID$(FORM$(21),71,2) = "11"
8940  MID$(FORM$(22),74,2) = "B:"
8950  MID$(FORM$(23),74,2) = "W:"
8960  MID$(FORM$(24),74,2) = "D:"
8970  MID$(FORM$(25),74,2) = "W:"
8980  IF CHART.NOS$ = "n" THEN 9000
8990  MID$(FORM$(27),71,2) = "12"
9000  MID$(FORM$(28),74,2) = "B:"
9010  MID$(FORM$(29),74,2) = "W:"
9020  MID$(FORM$(30),74,5) = "Marr:"
9030  MID$(FORM$(31),74,2) = "D:"
9040  MID$(FORM$(32),74,2) = "W:"
9050  IF CHART.NOS$ = "n" THEN 9070
9060  MID$(FORM$(33),71,2) = "13"
9070  MID$(FORM$(34),74,2) = "B:"
9080  MID$(FORM$(35),74,2) = "W:"
9090  MID$(FORM$(36),74,2) = "D:"
9100  MID$(FORM$(37),74,2) = "W:"
9110  IF CHART.NOS$ = "n" THEN 9130
9120  MID$(FORM$(39),71,2) = "14"
9130  MID$(FORM$(40),74,2) = "B:"
9140  MID$(FORM$(41),74,2) = "W:"
9150  MID$(FORM$(42),74,5) = "Marr:"
9160  MID$(FORM$(43),74,2) = "D:"
9170  MID$(FORM$(44),74,2) = "W:"
9180  IF CHART.NOS$ = "n" THEN 9200
9190  MID$(FORM$(45),71,2) = "15"
9200  MID$(FORM$(46),74,2) = "B:"
9210  MID$(FORM$(47),74,2) = "W:"
9220  MID$(FORM$(48),74,2) = "D:"
9230  MID$(FORM$(49),74,2) = "W:"
9240  IF CHART.NOS$ = "n" OR DD.ORD$ = "no" THEN 9410
9250  MID$(FORM$( 1),95,2) = "16"
9260  MID$(FORM$( 4),95,2) = "17"
9270  MID$(FORM$( 7),95,2) = "18"
9280  MID$(FORM$(10),95,2) = "19"
9290  MID$(FORM$(14),95,2) = "20"
9300  MID$(FORM$(16),95,2) = "21"
9310  MID$(FORM$(19),95,2) = "22"
9320  MID$(FORM$(22),95,2) = "23"
9330  MID$(FORM$(26),95,2) = "24"
9340  MID$(FORM$(28),95,2) = "25"
9350  MID$(FORM$(31),95,2) = "26"
9360  MID$(FORM$(34),95,2) = "27"
9370  MID$(FORM$(38),95,2) = "28"
9380  MID$(FORM$(40),95,2) = "29"
9390  MID$(FORM$(43),95,2) = "30"
9400  MID$(FORM$(46),95,2) = "31"
9410  RETURN
9420  REM Routine to Obtain a Usable Person Number for the Chart
9430  REM Skip if Forms Wide and Single Sheets
9440  IF WIDE = 2 AND FORMS = 2 THEN 9570  'return
9450  IF CHART.NOS$ <> "n" THEN 9570
9460  REM Convert the Person Number to a String
9470  PNUM$ = STR$(T1)
9480  REM Find its Length
9490  PLEN = LEN(PNUM$)
9500  REM Get rid of the leading space for algebraic sign
9510  PNUM$ = RIGHT$(PNUM$,PLEN-1)
9520  REM Append a Trailing Space
9530  PNUM$ = PNUM$ + " "
9540  REM bypass if column is 1 (person or spouse)
9550  IF COL = 1 THEN 9570
9560  MID$(FORM$(ROW),COL-PLEN,PLEN) = PNUM$
9570  RETURN
9580  REM Clean User Input Area
9590  LOCATE 19,1 : PRINT SPACE$(79);
9600  LOCATE 20,1 : PRINT SPACE$(79);
9610  LOCATE 21,1 : PRINT SPACE$(79);
9620  LOCATE 22,1 : PRINT SPACE$(79);
9630  LOCATE 23,1 : PRINT SPACE$(79);
9640  RETURN
