100  REM PRINTMAR Program.
110  REM Prints Detailed Marriage Information
120  REM Copyright (c) 1983 - 1987 by: Melvin O. Duke.
130  DEFINT A-Z
600  REM Titles
610  TITLE$ = "Print the Marriages File"
620  TITLE$ = TITLE$ + " ON DISPLAY"
700  REM Terminate if not called from the Menu
710  IF DD.MENU$ <> "" THEN 770
720  COLOR 7,0 : KEY ON : CLS : LOCATE 15,1
730  PRINT "Cannot run the"
740  PRINT TITLE$
750  PRINT "Program, unless selected from the MENU"
760  END
770  REM OK
1000  REM Produce the first screen
1010  KEY ON : CLS : KEY OFF
1020  REM Draw the outer double box
1030  R1 = 1 : C1 = 1 : R2 = 24 : C2 = 79 : GOSUB 1300
1040  REM Find the title location
1050  TITLE.POS = 40 - INT(LEN(TITLE$)/2)
1060  REM Draw the title box
1070  R1=3:C1=TITLE.POS-2:R2=6:C2=TITLE.POS+LEN(TITLE$)+1:GOSUB 1500
1080  REM Print the title
1090  LOCATE 4,TITLE.POS : PRINT TITLE$
1100  LOCATE 5,40-INT(LEN(VERSION$)/2) :  PRINT VERSION$;
1230  REM Draw the Copyright box
1240  R1 = 19 : C1 = 21 : R2 = 22 : C2 = 59 : GOSUB 1300
1250  REM Print the Copyright
1260  LOCATE 20,40-INT(LEN(COPY1$)/2) :  PRINT COPY1$;
1270  LOCATE 21,40-INT(LEN(COPY2$)/2) :  PRINT COPY2$;
1280  GOTO 1700
1300  REM subroutine to print a double box
1310  COLOR P
1320  FOR I = R1 + 1 TO R2 - 1
1330   LOCATE I, C1 : PRINT CHR$(186);
1340   LOCATE I, C2 : PRINT CHR$(186);
1350  NEXT I
1360   LOCATE R1, C1+1 : PRINT STRING$(C2-C1-1,205);
1390   LOCATE R2, C1+1 : PRINT STRING$(C2-C1-1,205);
1400   LOCATE R1, C1 : PRINT CHR$(201);
1410   LOCATE R1, C2 : PRINT CHR$(187);
1420   LOCATE R2, C1 : PRINT CHR$(200);
1430   LOCATE R2, C2 : PRINT CHR$(188);
1440  COLOR W
1450  RETURN
1500  REM subroutine to print a single box
1510  COLOR B
1520  FOR I = R1 + 1 TO R2 - 1
1530   LOCATE I, C1 : PRINT CHR$(179);
1540   LOCATE I, C2 : PRINT CHR$(179);
1550  NEXT I
1560   LOCATE R1, C1+1 : PRINT STRING$(C2-C1-1,196);
1590   LOCATE R2, C1+1 : PRINT STRING$(C2-C1-1,196);
1600   LOCATE R1, C1 : PRINT CHR$(218);
1610   LOCATE R1, C2 : PRINT CHR$(191);
1620   LOCATE R2, C1 : PRINT CHR$(192);
1630   LOCATE R2, C2 : PRINT CHR$(217);
1640  COLOR W
1650  RETURN
1700  REM ask user to press a key to continue
1710  LOCATE 25,1
1720  PRINT "Have Data Diskette(s) in Place, then Press any key to continue.";
1730  K$ = INKEY$ : IF K$ = "" THEN 1730
1740  KEY ON : CLS : KEY OFF
2000  REM PRINTMAR Program Starts Here
2010  OPEN DD.PERS$+"persfile" AS #1 LEN = 256
2020  FIELD 1, 5 AS F1$, 20 AS F2$, 30 AS F3$, 2 AS F4$, 5 AS F5$, 5 AS F6$, 5 AS F7$, 11 AS F8$, 18 AS F9$, 16 AS F10$, 16 AS F11$, 11 AS F12$, 18 AS F13$, 16 AS F14$, 16 AS F15$, 11 AS F16$, 18 AS F17$, 16 AS F18$, 16 AS F19$
2030  OPEN DD.MARR$+"marrfile" AS #2 LEN = 128
2040  FIELD 2, 5 AS M1$, 5 AS M2$, 5 AS M3$, 5 AS M4$, 11 AS M5$, 18 AS M6$, 16 AS M7$, 16 AS M8$, 45 AS M9$
2050  REM Determine User Wants
2060  KEY ON : CLS : KEY OFF : LOCATE 21,1
2070  PRINT "Enter the Marriage Number to be Printed (0 to quit), or 'all': ";
2080  LINE INPUT REPLY$
2090  IF REPLY$ = "0" THEN 2890
2100  K = 0
2110  GOTO 2160
2120  LPRINT TAB(10);"Print-out of Contents of the Marriages File"
2130  LPRINT TAB(10);DATE$,TIME$
2140  LPRINT
2150  RETURN
2160  IF LEFT$(REPLY$,1) = "a" OR LEFT$(REPLY$,1) = "A" THEN 2220
2170  K = 4
2180  I = VAL(REPLY$)
2190  IF I < 1 OR I > MAX.MAR THEN KEY ON : CLS : KEY OFF : LOCATE 20,1 : PRINT "Number is out of range"; : GOTO 2070
2200  GOSUB 2120
2210  GOSUB 2280 : GOTO 2060
2220  REM Read all records, and print the actual ones
2230  IF START.MAR < 1 THEN START.MAR = 1
2240  FOR I = START.MAR TO MAX.MAR
2250  LOCATE 22,1 : PRINT "Processing Record";I;
2260  GOSUB 2280
2270  GOTO 2820
2280  GET #2, I
2290  REM Extract information from the file for use
2300  T1! = CVS(M1$) : T1 = T1!
2310  IF T1 < 1 THEN 2810
2320  K = K + 1
2330  IF K MOD 5 = 1 THEN GOSUB 2120
2340  T2! = CVS(M2$) : T2 = T2!
2350  T3! = CVS(M3$) : T3 = T3!
2360  T4! = CVS(M4$)
2370  T5$ = M5$
2380  T6$ = M6$
2390  T7$ = M7$
2400  T8$ = M8$
2410  T9$ = M9$
2420  REM Obtain the name of the Male Spouse
2430  GET #1, T2
2440  REM Obtain the last and given names
2450  TEMP$ = F2$   'Male Spouse`s last name
2460  TMP$ = F2$
2470  GOSUB 2840
2480  TT2$ = TMP$
2490  TEMP$ = F3$   'Male Spouse's given names
2500  TMP$ = F3$
2510  GOSUB 2840
2520  TT3$ = TMP$
2530  REM Obtain the name of the Female Spouse
2540  GET #1, T3
2550  REM Obtain the last and given names
2560  TEMP$ = F2$   'Female Spouse`s last name
2570  TMP$ = F2$
2580  GOSUB 2840
2590  TT4$ = TMP$
2600  TEMP$ = F3$   'Female Spouse's given names
2610  TMP$ = F3$
2620  GOSUB 2840
2630  TT5$ = TMP$
2640  REM Now Print the Information
2650  LPRINT TAB(10);"Marriage Record-number : ";
2660  LPRINT USING "####"; T1
2670  LPRINT TAB(10);"Male Spouse            : ";
2680  LPRINT USING "####"; T2;
2690  LPRINT TAB(42); LEFT$(TT2$+", "+TT3$,37)
2700  LPRINT TAB(10);"Female Spouse          : ";
2710  LPRINT USING "####"; T3;
2720  LPRINT TAB(42); LEFT$(TT4$+", "+TT5$,37)
2730  LPRINT TAB(10);"Marriage-code          : ";T4!
2740  LPRINT TAB(10);"Marriage-date          : ";T5$
2750  LPRINT TAB(10);"Marriage-city          : ";T6$
2760  LPRINT TAB(10);"Marriage-county        : ";T7$
2770  LPRINT TAB(10);"Marriage-state         : ";T8$
2780  LPRINT TAB(10);"Comments: ";T9$
2790  LPRINT : LPRINT
2800  IF K MOD 5 = 0 THEN LPRINT FORM.FEED$;
2810  RETURN
2820  NEXT I
2830  GOTO 2890
2840  REM rtrim$ subroutine
2850  FOR J = 1 TO LEN(TEMP$)-1
2860   IF RIGHT$(TMP$,1)=" " THEN TMP$ = LEFT$(TMP$,LEN(TMP$)-1) ELSE J = LEN(TEMP$)-1
2870  NEXT J
2880  RETURN
2890  CLOSE #1
2900  KEY ON : CLS : KEY OFF : LOCATE 21,1
2910  PRINT "End of Program"
2920  IF (LEFT$(REPLY$,1) = "a" OR LEFT$(REPLY$,1) = "A") AND K MOD 5 <> 0 THEN 2930 ELSE 2940
2930  LPRINT FORM.FEED$;
2940  RUN DD.MENU$+"menu"
