100  REM Documentation for the Genealogy ON DISPLAY Programs
110  REM All data is in the form of DATA statements.
120  REM By:  Melvin O. Duke.  Updated June 1986.
130  DATA Notes and Sources
140  DATA User's Manual
150  DATA -5
160  DATA 1
170  INDENT = 0
180  REM Printer Definitions
190  FORM.FEED$  = CHR$(12)
200  COMPR.OFF$  = CHR$(18)     : COMPR.ON$ = CHR$(15)
210  BOLD.OFF$   = CHR$(27)+"F" : BOLD.ON$ = CHR$(27)+"E"
220  EXPAND.OFF$ = CHR$(18)     : EXPAND.ON$ = CHR$(14)
230  DASHES$ = "+"+STRING$(54,45)+"+"
240  TRIM.LINE$ = "(Trim-line)"
250  REM Program begins here
260  READ TITLE$, DOC.NAME$, PAGE.NO, LINE.NO
270  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
280  GOSUB 920  'For trim line and heading space
290  FOR I = 1 TO 6 : LPRINT : NEXT I
300  LPRINT BOLD.ON$;     'Set Emphasized mode
310  LPRINT EXPAND.ON$;   'Set Expanded Print
320  LPRINT TAB(TAB.POS-5);TITLE$
330  LPRINT EXPAND.OFF$;  'Return to normal
340  LPRINT BOLD.OFF$;    'Return to normal
350  FOR I = 1 TO 3 : LPRINT : NEXT I
360  LPRINT BOLD.ON$;     'Set Emphasized mode
370  LPRINT TAB(TAB.POS+12);"ON DISPLAY"
380  LPRINT BOLD.OFF$;    'Return to normal
390  LPRINT : LPRINT : LPRINT
400  LPRINT TAB(TAB.POS+11);"Version 1.1"
410  FOR I = 1 TO 11 : LPRINT : NEXT I
420  LPRINT TAB(TAB.POS+10); DOC.NAME$
430  LINE.NO = LINE.NO + 27
440  '
450  READ REPLY$
460  REM First, change tildes to quotes
470  FOR Q = 1 TO LEN(REPLY$)
480   IF MID$(REPLY$,Q,1)="~"THEN MID$(REPLY$,Q,1)=CHR$(34)
490  NEXT Q
500  IF LEFT$(REPLY$,1) = "." THEN GOSUB 1270: GOTO 450
510  IF LINE.NO > 44 THEN GOSUB 1030
520  REM Print the line if not a command
530  LPRINT TAB(TAB.POS);REPLY$
540  LINE.NO = LINE.NO + 1
550  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
560  GOTO 450
570  DATA ".pa"
580  REM   Data for the Copyright Page
590  DATA "Anyone may request a copy of Notes and"
600  DATA "Sources ON DISPLAY, for trial, by sending"
610  DATA "an unformatted, double-sided, double-"
620  DATA "density, 5-1/4 inch diskette to the"
630  DATA "author of the programs."
640  DATA ".sp"
650  DATA "An addressed, postage-paid return"
660  DATA "mailer must accompany the diskette (no"
670  DATA "exceptions, please).
680  DATA ".sp"
690  DATA "A copy of the programs with documenta-"
700  DATA "tion will be sent by return mail."
710  DATA ".vt 2"
720  DATA "Users are encouraged to copy and share"
730  DATA "the programs with others."
740  DATA ".vt 2"
750  DATA "If you are using this program, you are"
760  DATA "expected to become a Registered User,"
770  DATA "by making a contribution to the author"
780  DATA "of the program ($30.00 suggested for"
790  DATA "Registered Users of Genealogy ON DIS-"
800  DATA "PLAY, otherwise, $45.00 suggested)."
810  DATA ".sp"
820  DATA "Melvin O. Duke"
830  DATA "P. O. Box 20836"
840  DATA "San Jose, CA  95160"
850  DATA "(408) 268-6637"
860  DATA ".vt 3"
870  DATA "Copyright (c) 1986, by:"
880  DATA "Melvin O. Duke."
890  DATA ".sp"
900  DATA "All rights reserved."
910  '
920  REM Top of each page routine
930  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
940  LPRINT
950  LPRINT TAB(30); TRIM.LINE$
960  LPRINT DASHES$ 'Dashes
970  FOR I = 1 TO 6
980   LPRINT
990  NEXT I
1000  LINE.NO = LINE.NO + 6
1010  RETURN
1020  '
1030  REM Bottom of each page Routine
1040  IF PAGE.NO < 1 THEN LPRINT : LPRINT : LPRINT : GOTO 1160
1050  LPRINT TAB(TAB.POS); STRING$(40,45)  'on line 46
1060  LPRINT TAB(TAB.POS+0); TITLE$+" ON DISPLAY.  Vers. 1.1" 'on line 47
1070  IF PAGE.NO MOD 2 = 1 THEN 1110
1080  LPRINT TAB(TAB.POS);"Page";PAGE.NO;
1090  LPRINT TAB(TAB.POS+27);"User's Manual"
1100  GOTO 1160
1110  LPRINT TAB(TAB.POS); "User's Manual";
1120  IF PAGE.NO < 10 THEN DELTA = 34
1130  IF PAGE.NO >  9 THEN DELTA = 33
1140  IF PAGE.NO > 99 THEN DELTA = 32
1150  LPRINT TAB(TAB.POS+DELTA); "Page"; PAGE.NO  'on line 48
1160  LPRINT : LPRINT : LPRINT
1170  LPRINT DASHES$ 'dashes after 51
1180  LPRINT TAB(30); TRIM.LINE$
1190  LPRINT FORM.FEED$;
1200  PAGE.NO = PAGE.NO + 1
1210  LINE.NO = 1
1220  IF REPLY$ = ".eof" THEN 1240  'Bypass after last page
1230  GOSUB 920  'For top of next page
1240  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1250  RETURN
1260  '
1270  REM Command Processor
1280  IF LEFT$(REPLY$,3) = ".h1" THEN 1390
1290  IF LEFT$(REPLY$,3) = ".h2" THEN 1550
1300  IF LEFT$(REPLY$,3) = ".h3" THEN 1660
1310  IF LEFT$(REPLY$,3) = ".sp" THEN 1770
1320  IF LEFT$(REPLY$,4) = ".eof" THEN 1820
1330  IF LEFT$(REPLY$,3) = ".pa" THEN 1850
1340  IF LEFT$(REPLY$,3) = ".pn" THEN PAGE.NO = VAL(RIGHT$(REPLY$,LEN(REPLY$)-3)) : RETURN
1350  IF LEFT$(REPLY$,3) = ".vt" THEN 1920
1360  IF LEFT$(REPLY$,3) = ".pk" THEN 2030
1370  IF LEFT$(REPLY$,3) = ".in" THEN 2160
1380  STOP
1390  REM Head 1 Processor
1400  FOR I = LINE.NO TO 44
1410   LPRINT
1420  NEXT I
1430  GOSUB 1030  'Bottom of page Routine
1440  'IF PAGE.NO MOD 2 = 0 THEN GOSUB 1860  'For h1 on Odd pages
1450  LPRINT BOLD.ON$;     'Set emphasized print
1460  LPRINT EXPAND.ON$;   'Set expanded print
1470  IF PAGE.NO MOD 2 = 0 THEN ADJUST = -2 ELSE ADJUST = -5
1480  LPRINT TAB(TAB.POS+ADJUST); RIGHT$(REPLY$,LEN(REPLY$)-4)
1490  LPRINT EXPAND.OFF$;  'Return to normal
1500  LPRINT BOLD.OFF$;    'Return to non-bold
1510  LINE.NO = LINE.NO+1
1520  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1530  RETURN
1540  '
1550  REM Head 2 Processor
1560  IF LINE.NO = 7 THEN 1580 'skip spacing if at top of page
1570  IF LINE.NO > 43 THEN GOSUB 1850 ELSE LPRINT:LPRINT:LINE.NO = LINE.NO+2
1580  LPRINT BOLD.ON$;  'Set emphasized print
1590  LPRINT TAB(TAB.POS+1); RIGHT$(REPLY$,LEN(REPLY$)-4)
1600  LPRINT BOLD.OFF$; 'Return to normal
1610  LPRINT
1620  LINE.NO = LINE.NO + 2
1630  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1640  RETURN
1650  '
1660  REM Head 3 Processor
1670  IF LINE.NO = 7 THEN 1690 'skip spacing if at top of page
1680  IF LINE.NO > 43 THEN GOSUB 1850 ELSE LPRINT:LPRINT:LINE.NO = LINE.NO+2
1690  LPRINT BOLD.ON$;  'Set emphasized print
1700  LPRINT TAB(TAB.POS+1); RIGHT$(REPLY$,LEN(REPLY$)-4)
1710  LPRINT BOLD.OFF$; 'Return to normal
1720  LPRINT
1730  LINE.NO = LINE.NO + 2
1740  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1750  RETURN
1760  '
1770  REM Single Space Processor
1780  IF LINE.NO = 7 THEN 1800
1790  IF LINE.NO > 44 THEN GOSUB 1850 ELSE LPRINT : LINE.NO = LINE.NO + 1
1800  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1810  RETURN
1820  REM End of File Processor
1830  GOSUB 1850 'Bottom of Page
1840  GOTO 5190
1850  REM Page Eject Processor
1860  FOR I = LINE.NO TO 44
1870   LPRINT
1880   LINE.NO = LINE.NO + 1
1890  NEXT I
1900  GOSUB 1030  'Bottom of Page Processing
1910  RETURN
1920  REM Vertical Tab Processor
1930  IF LINE.NO = 7 THEN 2020
1940  IF LINE.NO > 44 THEN GOSUB 1030  'End of page
1950  QTY = VAL(RIGHT$(REPLY$,LEN(REPLY$)-3))
1960  FOR I = 1 TO QTY
1970   LPRINT
1980   LINE.NO = LINE.NO + 1
1990   IF LINE.NO > 44 THEN I = QTY
2000  NEXT I
2010  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
2020  RETURN
2030  REM Pack Processor
2040  IF LINE.NO > 44 THEN GOSUB 1030
2050  IF TAB.POS = 8 THEN ADJUST = 4
2060  IF TAB.POS = 13 THEN ADJUST = 7
2070  TAB.POS = TAB.POS + ADJUST + INDENT
2080  WIDTH "lpt1:", 132 'set condensed width
2090  LPRINT COMPR.ON$;  'Packed printing
2100  LPRINT TAB(TAB.POS); RIGHT$(REPLY$,LEN(REPLY$)-3)
2110  LPRINT COMPR.OFF$; 'Return to normal
2120  WIDTH "lpt1:", 80  'return to normal
2130  LINE.NO = LINE.NO + 1
2140  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
2150  RETURN
2160  REM Indent Processor
2170  INDENT = VAL(RIGHT$(REPLY$,LEN(REPLY$)-3))
2180  RETURN
3000  REM APPENDIX
3010  DATA ".h1 A.  MESSAGES"
3020  DATA ".pn 67"
3030  DATA ".h2 START-UP MESSAGES"
3040  DATA "The initial System Message, when the"
3050  DATA "system is turned on, is:"
3060  DATA ".sp"
3070  DATA ".pk Current date is Tue 1-01-1980"
3080  DATA ".pk Enter new date:"
3090  DATA ".sp"
3100  DATA "The user is expected to respond with an"
3110  DATA "appropriate date."
3120  DATA ".sp"
3130  DATA "The next system message is:"
3140  DATA ".sp"
3150  DATA ".pk Current time is 0:00:52.17"
3160  DATA ".pk Enter new time:"
3170  DATA ".sp"
3180  DATA "The user is expected to respond with"
3190  DATA "the correct time."
3200  DATA ".sp"
3210  DATA "The System then responds:"
3220  DATA ".sp"
3230  DATA ".pk The IBM Personal Computer DOS"
3240  DATA ".pk Version 2.10 (C) Copyright IBM Corp 1981, 1982, 1983"
3250  DATA ".sp"
3260  DATA "When starting BASIC, the message"
3270  DATA "in response to:"
3280  DATA ".sp"
3290  DATA ".pk basic/s:256"
3300  DATA ".sp"
3310  DATA "is similar to:"
3320  DATA ".sp"
3330  DATA ".pk IBM Personal Computer Basic"
3340  DATA ".pk Version D2.00 Copyright IBM Corp. 1981, 1982, 1983"
3350  DATA ".pk 61118 Bytes Free"
3360  DATA ".h1 B.  HINTS
3370  DATA ".h2 DATES"
3380  DATA "The program expects dates in the form"
3390  DATA "dd Mmm yyyy, such as: 19 Jun 1928."
3400  DATA "Partial dates, or approximate dates,"
3410  DATA "may be entered.  They will be moved as"
3420  DATA "far to the right as possible.  How-"
3430  DATA "ever, there is only space for 11 char-"
3440  DATA "acters in any date."
3450  DATA ".h2 Replacing Information"
3460  DATA "When personalizing, or when using the"
3470  DATA "entry/update function, information"
3480  DATA "(with the exception of the note-"
3490  DATA "number) can be replaced by entering"
3500  DATA "the new information.  The new infor-"
3510  DATA "mation simply replaces the old."
3520  DATA ".h2 Removing a Note."
3530  DATA "In the event that a user wishes to re-"
3540  DATA "move a Note, he may do so by changing"
3550  DATA "the note-number to the same number"
3560  DATA "preceded by a minus-sign.  This will"
3570  DATA "cause the note to be cleared, and it"
3580  DATA "may then be 'saved'."
3590  DATA ".h1 C.  MODIFICATIONS"
3600  DATA ".h2 Making Changes"
3610  DATA "In all of the following examples, the"
3620  DATA "~notesand.bas~ program has to be load-"
3630  DATA "ed, edited, and then saved."
3640  DATA ".sp"
3650  DATA "Since ~notesand.bas~ is a BASIC"
3660  DATA "program, you will need to use the"
3670  DATA "BASIC Editor (see the BASIC Manual"
3680  DATA "for details) to make the changes."
3690  DATA ".h2 Color Considerations"
3700  DATA "Line 260 in the ~notesand.bas~ program"
3710  DATA "establishes color, through the use of"
3720  DATA "a SCREEN Statement, which is:"
3730  DATA ".sp"
3740  DATA "  SCREEN S1,S2,S3,S4
3750  DATA ".sp"
3760  DATA "For many display screens, color can be"
3770  DATA "disabled by editing the definition of"
3780  DATA "S2 in Line 220 of the ~notesand.bas~"
3790  DATA "program.  It can be changed from"
3800  DATA "S2 = 1, to S2 = 0."
3810  DATA ".pa"
3820  DATA ".h2 Color Definitions"
3830  DATA "Lines 310 through 380 of the program"
3840  DATA "establish color for a number of"
3850  DATA "variables, which are then used by"
3860  DATA "the ~notesand.bas~ program."
3870  DATA ".sp"
3880  DATA "Color can be disabled, or it can be"
3890  DATA "changed, by changing the numbers for"
3900  DATA "the variables.  For example, color"
3910  DATA "can be disabled by changing each of"
3920  DATA "the numbers which is not a zero (0)"
3930  DATA "to a seven (7)."
3940  DATA ".h2 Changing the Number of Persons"
3950  DATA "The program, as distributed, provides"
3960  DATA "for 500 persons in the Genealogy ON"
3970  DATA "DISPLAY Persons File."
3980  DATA ".sp"
3990  DATA "If your Persons File has some other"
4000  DATA "number, it will be necessary to change"
4010  DATA "the 500 in the ~notesand.bas~ program"
4020  DATA "to the same number that is in your"
4030  DATA "Genealogy ON DISPLAY ~menu~ program."
4040  DATA ".sp"
4050  DATA "This can be done in the following way:"
4060  DATA ".sp"
4070  DATA "In the ~notesand.bas~ program:"
4080  DATA ".sp"
4090  DATA "Line-number:   610"
4100  DATA "Old-value:     MAX.PER = 500"
4110  DATA "New-value:     Same as Genealogy ON"
4120  DATA "               DISPLAY"
4130  DATA ".pa"
4140  DATA ".h2 Repositioning the Files"
4150  DATA "As released, all files are located on"
4160  DATA "drive a:.  In order to change this to"
4170  DATA "another drive, the letter which iden-"
4180  DATA "tifies the drive must be changed."
4190  DATA ".sp"
4200  DATA "In the ~notesand.bas~ program, these"
4210  DATA "drive-letters are located in line"
4220  DATA "numbers 410-460.  They are:"
4230  DATA ".sp"
4240  DATA "Name       Ltr.    Reference"
4250  DATA "---------------    ------------------"
4260  DATA "DD.VERI$ = ~a:~    'Verify /s:256 File"
4270  DATA "DD.NOTE$ = ~a:~    'The Note File"
4280  DATA "DD.PERS$ = ~a:~    'The Persons File"
4290  DATA "DD.SOUR$ = ~a:~    'The Sources File"
4300  DATA "DD.TYPE$ = ~a:~    'The Types File"
4310  DATA "DD.HIGH$ = ~a:~    'Highest Notes"
4320  DATA ".sp"
4330  DATA "The disk drive-letter for any of the"
4340  DATA "above files may be changed by chang-"
4350  DATA "ing each a: to the desired drive-"
4360  DATA "letter, such as b:"
4370  DATA ".sp"
4380  DATA "In the event you are using a hard-disk"
4390  DATA "with sub-directories, you will need to"
4400  DATA "to change each a: to its path, such as:"
4410  DATA ".sp"
4420  DATA "DD.NOTE$ = ~c:\notesand\~"
4430  DATA ".pa"
4440  DATA ".h2 Utilizing other Printers"
4450  DATA "As designed, an IBM Matrix Printer,"
4460  DATA "an IBM Proprinter, or some equivalent"
4470  DATA "printer is assumed."
4480  DATA ".sp"
4490  DATA "Control for Form-feeding (move the"
4500  DATA "paper to the top of the next page) is"
4510  DATA "provided in the ~notesand.bas~ program,"
4520  DATA "in line 510."
4530  DATA ".sp"
4540  DATA "The variable name, and its purpose,"
4550  DATA "is as follows:"
4560  DATA ".sp"
4570  DATA "Name:           Purpose"
4580  DATA "-------------   -----------------------"
4590  DATA "FORM.FEED$      To Top of the Next Page"
4600  DATA ".sp"
4610  DATA "For the above, change the definition to"
4620  DATA "that of your printer."
4630  DATA ".h1 D. TERMS & CONDITIONS"
4640  DATA ".h2 Terms"
4650  DATA "If you are using this program, you are"
4660  DATA "expected to become a Registered User,"
4670  DATA "by making a contribution to the author"
4680  DATA "of the program ($30.00 suggested for"
4690  DATA "Registered Users of Genealogy ON DIS-"
4700  DATA "PLAY, otherwise, $45.00 suggested)."
4710  DATA ".sp"
4720  DATA "     Melvin O. Duke"
4730  DATA "     P. O. Box 20836"
4740  DATA "     San Jose, CA  95160"
4750  DATA "     (408) 268-6637"
4760  DATA ".vt 3"
4770  DATA "Anyone may request a copy of Notes and"
4780  DATA "Sources ON DISPLAY, for trial, by send-"
4790  DATA "ing an unformatted, double-sided,"
4800  DATA "double-density, 5-1/4 inch diskette to"
4810  DATA "the author of the programs."
4820  DATA ".sp"
4830  DATA "A self-addressed, postage-paid return"
4840  DATA "diskette-mailer must accompany the"
4850  DATA "diskette (no exceptions, please)."
4860  DATA ".sp"
4870  DATA "A copy of the programs with documenta-"
4880  DATA "tion will be sent by return mail."
4890  DATA ".pa"
4900  DATA ".h2 Conditions"
4910  DATA "A limited license is granted to all users"
4920  DATA "of these programs, to make copies of"
4930  DATA "them, and distribute them to other users,"
4940  DATA "on the following conditions:"
4950  DATA ".sp"
4960  DATA "1.  The Notes and Sources ON DISPLAY pro-"
4970  DATA "    grams are not to be distributed to"
4980  DATA "    others in a modified form."
4990  DATA ".sp"
5000  DATA "2.  No fee (or other consideration) is"
5010  DATA "    is to be charged for copying or dis-"
5020  DATA "    tributing the Notes and Sources ON"
5030  DATA "    DISPLAY programs."
5040  DATA ".sp"
5050  DATA "3.  The notices displayed at program"
5060  DATA "    start-up are not to be bypassed,"
5070  DATA "    altered, or removed."
5080  DATA ".h2 Disclaimer"
5090  DATA "In no event will the Author be liable to"
5100  DATA "you for any damages, including any lost"
5110  DATA "profits, lost savings or other inciden-"
5120  DATA "tal or consequential damages arising out"
5130  DATA "of the use of or inability to use these"
5140  DATA "programs, even if the Author has been"
5150  DATA "advised of the possibility of such"
5160  DATA "damages, or for any claim by any other"
5170  DATA "party."
5180  DATA ".eof"
5190  END
