100  REM Program Directory for the Notes and Sources ON DISPLAY Program
110  REM All data is in the form of DATA statements.
120  REM By:  Melvin O. Duke.  Updated June 1986.
130  DATA Notes and Sources
140  DATA Program Directory
150  DATA -1
160  DATA 1
170  INDENT = 0
180  REM Printer Definitions
190  FORM.FEED$  = CHR$(12)
200  COMPR.OFF$  = CHR$(18)     : COMPR.ON$ = CHR$(15)
210  BOLD.OFF$   = CHR$(27)+"F" : BOLD.ON$ = CHR$(27)+"E"
220  EXPAND.OFF$ = CHR$(18)     : EXPAND.ON$ = CHR$(14)
230  REM Program begins here
240  READ TITLE$, DOC.NAME$, PAGE.NO, LINE.NO
250  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
260  GOSUB 900  'For trim line and heading space
270  FOR I = 1 TO 6 : LPRINT : NEXT I
280  LPRINT BOLD.ON$;    'Set Emphasized Print
290  LPRINT EXPAND.ON$;  'Set Expanded Print
300  LPRINT TAB(TAB.POS-5);TITLE$
310  LPRINT EXPAND.OFF$;  'Return to normal
320  LPRINT BOLD.OFF$;    'Return to normal
330  FOR I = 1 TO 3 : LPRINT : NEXT I
340  LPRINT BOLD.ON$; 'Set Emphasized mode
350  LPRINT TAB(TAB.POS+12);"ON DISPLAY"
360  LPRINT BOLD.OFF$; 'Return to normal
370  LPRINT : LPRINT : LPRINT
380  LPRINT TAB(TAB.POS+11);"Version 1.1"
390  FOR I = 1 TO 11 : LPRINT : NEXT I
400  LPRINT TAB(TAB.POS+8); DOC.NAME$
410  LINE.NO = LINE.NO + 27
420  '
430  READ REPLY$
440  REM First, change tildes to quotes
450  FOR Q = 1 TO LEN(REPLY$)
460   IF MID$(REPLY$,Q,1)="~"THEN MID$(REPLY$,Q,1)=CHR$(34)
470  NEXT Q
480  IF LEFT$(REPLY$,1) = "." THEN GOSUB 1250: GOTO 430
490  IF LINE.NO > 44 THEN GOSUB 1010
500  REM Print the line if not a command
510  LPRINT TAB(TAB.POS);REPLY$
520  LINE.NO = LINE.NO + 1
530  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
540  GOTO 430
550  DATA ".pa"
560  REM   Data for the Copyright Page
570  DATA "Anyone may request a copy of Notes and"
580  DATA "Sources ON DISPLAY, for trial, by sending"
590  DATA "an unformatted, double-sided, double-"
600  DATA "density, 5-1/4 inch diskette to the"
610  DATA "author of the programs."
620  DATA ".sp"
630  DATA "An addressed, postage-paid return"
640  DATA "mailer must accompany the diskette (no"
650  DATA "exceptions, please).
660  DATA ".sp"
670  DATA "A copy of the programs with documenta-"
680  DATA "tion will be sent by return mail."
690  DATA ".vt 2"
700  DATA "Users are encouraged to copy and share"
710  DATA "the programs with others."
720  DATA ".vt 2"
730  DATA "If you are using this program, you are"
740  DATA "expected to become a Registered User,"
750  DATA "by making a contribution to the author"
760  DATA "of the program ($30.00 suggested for"
770  DATA "Registered Users of Genealogy ON DIS-"
780  DATA "PLAY, otherwise, $45.00 suggested)."
790  DATA ".sp"
800  DATA "Melvin O. Duke"
810  DATA "P. O. Box 20836"
820  DATA "San Jose, CA  95160"
830  DATA "(408) 268-6637"
840  DATA ".vt 3"
850  DATA "Copyright (c) 1986, by:"
860  DATA "Melvin O. Duke."
870  DATA ".sp"
880  DATA "All rights reserved."
890  '
900  REM Top of each page routine
910  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
920  LPRINT
930  LPRINT TAB(30); "(Trim-line)"
940  LPRINT "+"+STRING$(54,45)+"+" 'Dashes
950  FOR I = 1 TO 6
960   LPRINT
970  NEXT I
980  LINE.NO = LINE.NO + 6
990  RETURN
1000  '
1010  REM Bottom of each page Routine
1020  IF PAGE.NO < 1 THEN LPRINT : LPRINT : LPRINT : GOTO 1140
1030  LPRINT TAB(TAB.POS); STRING$(40,45)  'on line 46
1040  LPRINT TAB(TAB.POS+0); TITLE$+" ON DISPLAY.  Vers. 1.1" 'on line 47
1050  IF PAGE.NO MOD 2 = 1 THEN 1090
1060  LPRINT TAB(TAB.POS);"Page";PAGE.NO;
1070  LPRINT TAB(TAB.POS+23);"Program Directory"
1080  GOTO 1140
1090  LPRINT TAB(TAB.POS); "Program Directory";
1100  IF PAGE.NO < 10 THEN DELTA = 34
1110  IF PAGE.NO >  9 THEN DELTA = 33
1120  IF PAGE.NO > 99 THEN DELTA = 32
1130  LPRINT TAB(TAB.POS+DELTA); "Page"; PAGE.NO  'on line 48
1140  LPRINT : LPRINT : LPRINT
1150  LPRINT "+"+STRING$(54,45)+"+" 'dashes after 51
1160  LPRINT TAB(30); "(Trim-line)"
1170  LPRINT FORM.FEED$;
1180  PAGE.NO = PAGE.NO + 1
1190  LINE.NO = 1
1200  IF REPLY$ = ".eof" THEN 1220  'Bypass after last page
1210  GOSUB 900  'For top of next page
1220  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1230  RETURN
1240  '
1250  REM Command Processor
1260  IF LEFT$(REPLY$,3) = ".h1" THEN 1360
1270  IF LEFT$(REPLY$,3) = ".h2" THEN 1520
1280  IF LEFT$(REPLY$,3) = ".h3" THEN 1630
1290  IF LEFT$(REPLY$,3) = ".sp" THEN 1740
1300  IF LEFT$(REPLY$,4) = ".eof" THEN 1790
1310  IF LEFT$(REPLY$,3) = ".pa" THEN 1820
1320  IF LEFT$(REPLY$,3) = ".vt" THEN 1890
1330  IF LEFT$(REPLY$,3) = ".pk" THEN 1990
1340  IF LEFT$(REPLY$,3) = ".in" THEN 2120
1350  STOP
1360  REM Head 1 Processor
1370  FOR I = LINE.NO TO 44
1380   LPRINT
1390  NEXT I
1400  GOSUB 1010  'Bottom of page Routine
1410  IF PAGE.NO MOD 2 = 0 THEN GOSUB 1820  'For h1 on Odd pages
1420  LPRINT BOLD.ON$;     'Set Emphasized Printing
1430  LPRINT EXPAND.ON$;   'Set expanded print
1440  IF PAGE.NO MOD 2 = 0 THEN ADJUST = -2 ELSE ADJUST = -5
1450  LPRINT TAB(TAB.POS+ADJUST); RIGHT$(REPLY$,LEN(REPLY$)-4)
1460  LPRINT EXPAND.OFF$;  'Return to normal
1470  LPRINT BOLD.OFF$;    'Return to non-bold
1480  LINE.NO = LINE.NO+1
1490  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1500  RETURN
1510  '
1520  REM Head 2 Processor
1530  IF LINE.NO = 7 THEN 1550 'skip spacing if at top of page
1540  IF LINE.NO > 43 THEN GOSUB 1820 ELSE LPRINT:LPRINT:LINE.NO = LINE.NO+2
1550  LPRINT BOLD.ON$;    'Set emphasized print
1560  LPRINT TAB(TAB.POS+1); RIGHT$(REPLY$,LEN(REPLY$)-4)
1570  LPRINT BOLD.OFF$;   'Return to normal
1580  LPRINT
1590  LINE.NO = LINE.NO + 2
1600  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1610  RETURN
1620  '
1630  REM Head 3 Processor
1640  IF LINE.NO = 7 THEN 1660 'skip spacing if at top of page
1650  IF LINE.NO > 43 THEN GOSUB 1820 ELSE LPRINT:LPRINT:LINE.NO = LINE.NO+2
1660  LPRINT BOLD.ON$;    'Set emphasized print
1670  LPRINT TAB(TAB.POS+1); RIGHT$(REPLY$,LEN(REPLY$)-4)
1680  LPRINT BOLD.OFF$;   'Return to normal
1690  LPRINT
1700  LINE.NO = LINE.NO + 2
1710  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1720  RETURN
1730  '
1740  REM Single Space Processor
1750  IF LINE.NO = 7 THEN 1770
1760  IF LINE.NO > 44 THEN GOSUB 1820 ELSE LPRINT : LINE.NO = LINE.NO + 1
1770  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1780  RETURN
1790  REM End of File Processor
1800  GOSUB 1820 'Bottom of Page
1810  GOTO 5860 'end
1820  REM Page Eject Processor
1830  FOR I = LINE.NO TO 44
1840   LPRINT
1850   LINE.NO = LINE.NO + 1
1860  NEXT I
1870  GOSUB 1010  'Bottom of Page Processing
1880  RETURN
1890  REM Vertical Tab Processor
1900  IF LINE.NO = 7 THEN 1980
1910  QTY = VAL(RIGHT$(REPLY$,LEN(REPLY$)-3))
1920  FOR I = 1 TO QTY
1930   LPRINT
1940   LINE.NO = LINE.NO + 1
1950   IF LINE.NO > 44 THEN I = QTY
1960  NEXT I
1970  IF LINE.NO > 44 THEN GOSUB 1010  'End of page
1980  RETURN
1990  REM Pack Processor
2000  IF LINE.NO > 44 THEN GOSUB 1010
2010  IF TAB.POS = 8 THEN ADJUST = 4
2020  IF TAB.POS = 13 THEN ADJUST = 7
2030  TAB.POS = TAB.POS + ADJUST + INDENT
2040  WIDTH "lpt1:", 132  'set condensed width
2050  LPRINT COMPR.ON$;   'Packed printing
2060  LPRINT TAB(TAB.POS); RIGHT$(REPLY$,LEN(REPLY$)-3)
2070  LPRINT COMPR.OFF$;  'Return to normal
2080  WIDTH "lpt1:", 80   'return to normal
2090  LINE.NO = LINE.NO + 1
2100  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
2110  RETURN
2120  REM Indent Processor
2130  INDENT = VAL(RIGHT$(REPLY$,LEN(REPLY$)-3))
2140  RETURN
3000  REM DIRECTOR
3010  DATA ".h1 INTRODUCTION"
3020  DATA ".h2 OVERVIEW"
3030  DATA "This Program Directory contains the"
3040  DATA "information about the contents of the"
3050  DATA "Distribution Diskette for the Notes and"
3060  DATA "Sources ON DISPLAY programs and docu-"
3070  DATA "tation."
3080  DATA ".h2 CONTENT"
3090  DATA "The Distribution Diskette contains the"
3100  DATA "following Documentation Programs:"
3110  DATA ".sp"
3120  DATA "  Program    Program      Program"
3130  DATA "  Name       Language        Size"
3140  DATA "  --------   --------   ---------"
3150  DATA "  runfirst   basic          1,328"
3160  DATA "  printers   basic          1,352"
3170  DATA "  director   basic         15,719"
3180  DATA "  tableofc   basic         11,607"
3190  DATA "  introduc   basic         13,749"
3200  DATA "  general    basic         20,767"
3210  DATA "  usingthe   basic         31,800"
3220  DATA "  referenc   basic         21,450"
3230  DATA "  appendix   basic         13,982"
3240  DATA ".pa"
3250  DATA "The Distribution Diskette contains the"
3260  DATA "following Notes and Sources Program:"
3270  DATA ".sp"
3280  DATA "  Program    Program      Program"
3290  DATA "  Name       Language        Size"
3300  DATA "  --------   --------   ---------"
3310  DATA "  notesand   basic         35,979"
3320  DATA ".vt 2"
3330  DATA "The Distribution Diskette contains the"
3340  DATA "following Data Files:"
3350  DATA ".sp"
3360  DATA "  Data File             Data File"
3370  DATA "  Name                       Size"
3380  DATA "  --------              ---------"
3390  DATA "  verifile                    256"
3400  DATA "  sourfile                    795"
3410  DATA "  typefile                    891"
3420  DATA "  high                         11"
3430  DATA ".vt 2"
3440  DATA "The Distribution Diskette contains the"
3450  DATA "following Batch File:"
3460  DATA ".sp"
3470  DATA "  Batch File           Batch File"
3480  DATA "  Name                       Size"
3490  DATA "  --------              ---------"
3500  DATA "  cleandoc                    199"
3510  DATA ".pa"
3520  DATA "The Distribution Diskette contains the"
3530  DATA "following Overview File:"
3540  DATA ".sp"
3550  DATA "  File                       File"
3560  DATA "  Name                       Size"
3570  DATA "  ------------              -----"
3580  DATA "  overview.bas              8,388"
3590  DATA ".vt 2"
3600  DATA ".h2 REQUIREMENTS"
3610  DATA ".h3 Hardware Requirements"
3620  DATA "IBM PCjr, PC, PC/XT or PC/AT with:"
3630  DATA ".sp"
3640  DATA "   One double-sided Diskette Drive."
3650  DATA ".sp"
3660  DATA "   Either the IBM Matrix Printer, the"
3670  DATA "   IBM Proprinter (or equivalents)."
3680  DATA ".sp"
3690  DATA "   At least 96 K of Memory (128 K is"
3700  DATA "   recommended)."
3710  DATA ".sp"
3720  DATA "   Either the IBM Color Display,"
3730  DATA "   the IBM Monochrome Display (or"
3740  DATA "   equivalents)."
3750  DATA ".pa"
3760  DATA ".h2 Software Requirements."
3770  DATA "IBM PC-DOS.
3780  DATA "  Version 2.1 or later (or Version"
3790  DATA "    2.0 on the other members of the"
3800  DATA "    IBM PC Family of Computers)."
3810  DATA ".sp"
3820  DATA "BASIC"
3830  DATA "  (on Cartridge or Diskette)."
3840  DATA ".h1 GENERAL INFORMATION"
3850  DATA ".h2 DOCUMENTATION PROGRAMS"
3860  DATA "Nine documentation programs are included"
3870  DATA "on the Distribution Diskette.  These are"
3880  DATA "BASIC programs, which can be 'run'."
3890  DATA ".sp"
3900  DATA "The documentation programs contain their"
3910  DATA "own formatting capability, as well as"
3920  DATA "the content of the documents which they"
3930  DATA "will produce."
3940  DATA ".sp"
3950  DATA "By 'running' each of the documentation"
3960  DATA "programs, the user is able to obtain one"
3970  DATA "or more copies of each chapter of the"
3980  DATA "documentation as he desires."
3990  DATA ".vt 2"
4000  DATA "These documentation programs are:"
4010  DATA ".sp
4020  DATA "  1.  runfirst  (causes a display of the"
4030  DATA "      cover letter, showing how to get"
4040  DATA "      started.)"
4050  DATA ".sp"
4060  DATA "  2.  printers  (shows the changes to"
4070  DATA "      the documentation programs for"
4080  DATA "      printing on other printers.)"
4090  DATA ".pa"
4100  DATA "  3.  director  (documentation of the"
4110  DATA "      content of the Distribution"
4120  DATA "      Diskette)."
4130  DATA ".sp"
4140  DATA "      Produces this document."
4150  DATA ".vt 2"
4160  DATA "  4 through 9.  Documentation for the"
4170  DATA "      Notes and Sources ON DISPLAY Program."
4180  DATA ".sp"
4190  DATA "      Produces a 74 Page User's Manual"
4200  DATA "      for use with the Notes and Sources"
4210  DATA "      ON DISPLAY Program."
4220  DATA ".sp"
4230  DATA "  4.  tableofc  (table of contents for"
4240  DATA "      the User's Manual)."
4250  DATA ".sp"
4260  DATA "  5.  introduc  (introduction for the"
4270  DATA "      User's Manual)."
4280  DATA ".sp"
4290  DATA "  6.  general  (general information for"
4300  DATA "      the User's Manual)."
4310  DATA ".sp"
4320  DATA "  7.  usingthe  (using the programs, for"
4330  DATA "      the User's Manual)."
4340  DATA ".sp"
4350  DATA "  8.  referenc  (reference material for"
4360  DATA "      the User's Manual)."
4370  DATA ".sp"
4380  DATA "  9.  appendix  (appendixes for the"
4390  DATA "      User's Manual)."
4400  DATA ".pa"
4410  DATA ".h2 NOTES AND SOURCES PROGRAM"
4420  DATA "One Notes and Sources program is"
4430  DATA "included on the Distribution"
4440  DATA "Diskette.  It is:"
4450  DATA ".sp"
4460  DATA "  1.  notesand"
4470  DATA ".sp"
4480  DATA "      Program for Making Entries of"
4490  DATA "      Notes; for Personalizing both the"
4500  DATA "      Sources used and the document"
4510  DATA "      Types; and for Inquiring into"
4520  DATA "      those Notes, for either Display-"
4530  DATA "      ing on the Screen, or Printing"
4540  DATA "      on the Printer."
4550  DATA ".h2 DATA FILES"
4560  DATA "Four data files are included on the"
4570  DATA "Distribution Diskette.  They are:"
4580  DATA ".sp"
4590  DATA "  1.  verifile"
4600  DATA ".sp"
4610  DATA "Its purpose is to verify that BASIC was"
4620  DATA "brought up with the /s:256 parameter."
4630  DATA ".vt 2"
4640  DATA "  2.  sourfile"
4650  DATA ".sp"
4660  DATA "This file contains the current des-"
4670  DATA "cription of the Sources involved"
4680  DATA "in the issuance of documents, etc."
4690  DATA "The content of this file may be"
4700  DATA "personalized by a user."
4710  DATA ".pa"
4720  DATA "  3.  typefile"
4730  DATA ".sp"
4740  DATA "This file contains the current des-"
4750  DATA "cription of the types of documents,"
4760  DATA "which contain information about the"
4770  DATA "selected persons.  This file may be"
4780  DATA "personalized by a user."
4790  DATA ".vt 2"
4800  DATA "  4.  high"
4810  DATA ".sp"
4820  DATA "This file contains definitions of the"
4830  DATA "highest note-number formatted, and the"
4840  DATA "highest note-number used."
4850  DATA ".sp"
4860  DATA "It is changed whenever additional"
4870  DATA "note-records are formatted, and when"
4880  DATA "a new note-record is saved which has"
4890  DATA "a note-number higher than one pre-"
4900  DATA "viously saved."
4910  DATA ".h2 BATCH FILE"
4920  DATA "One batch file is included on the"
4930  DATA "Distribution Diskette.  It is:"
4940  DATA ".sp"
4950  DATA "  1.  cleandoc.bat"
4960  DATA ".sp"
4970  DATA "Its purpose is to erase the documenta-"
4980  DATA "tion from a new Notes Diskette, after"
4990  DATA "that diskette has been copied from the"
5000  DATA "Distribution Diskette."
5010  DATA ".pa"
5020  DATA ".h2 OVERVIEW PROGRAM"
5030  DATA "One overview program is included on"
5040  DATA "the Distribution Diskette.  It is:"
5050  DATA ".sp"
5060  DATA "  1.  overview.bas"
5070  DATA ".sp"
5080  DATA "This program is provided, so that you"
5090  DATA "may show your friends just what Notes"
5100  DATA "and Sources ON DISPLAY is all about."
5110  DATA "The overview program may also be used"
5120  DATA "for presentations, such as Association"
5130  DATA "or Club Meetings."
5140  DATA ".sp"
5150  DATA "It is suitable for use on either a"
5160  DATA "color or monochrome monitor."
5170  DATA ".sp"
5180  DATA "In order to use this program, type:"
5190  DATA ".sp"
5200  DATA "  run ~overview~"
5210  DATA ".sp"
5220  DATA "and press the 'enter' key."
5230  DATA ".pa"
5240  DATA "(This page is intentionally blank)"
5250  DATA ".h1 USING THE PROGRAMS"
5260  DATA ".h2 FIRST TIME USAGE"
5270  DATA "The following steps are necessary when"
5280  DATA "a new user receives the Distribution"
5290  DATA "Diskette.  (Details of the steps are"
5300  DATA "shown in the User's Manual.)"
5310  DATA ".sp"
5320  DATA "1.  Copy the Distribution Diskette,"
5330  DATA "to a new diskette, for your Notes."
5340  DATA ".sp"
5350  DATA "2.  Erase the Documentation, through"
5360  DATA "the use of ~cleandoc.bat~."
5370  DATA ".sp"
5380  DATA "3.  Erase ~cleandoc.bat~, through the"
5390  DATA "use of the DOS ~erase~ command."
5400  DATA ".sp"
5410  DATA "4.  Obtain access to the Genealogy ON"
5420  DATA "DISPLAY Persons File.  If you have a"
5430  DATA "one-drive system, you will have to copy"
5440  DATA "the Persons File to your new diskette."
5450  DATA "Otherwise, you will have to identify"
5460  DATA "the location of the Persons File in"
5470  DATA "~notesand.bas~, through the use of the"
5480  DATA "BASIC Editor."
5490  DATA ".pa"
5500  DATA ".h2 GETTING STARTED"
5510  DATA "The user should perform the following"
5520  DATA "steps in starting the Notes and Sources"
5530  DATA "ON DISPLAY program.  (Note:  The steps"
5540  DATA "essentially provide for making BASIC"
5550  DATA "available, and starting the Program.)"
5560  DATA ".sp"
5570  DATA "1.  Insert the PC DOS diskette into"
5580  DATA "    Drive 'a:'."
5590  DATA ".sp"
5600  DATA "2.  If using the PCjr, insert the"
5610  DATA "    BASIC Cartridge into either slot."
5620  DATA ".sp"
5630  DATA "3.  Turn the Printer On."
5640  DATA ".sp"
5650  DATA "4.  Turn the System On."
5660  DATA ".sp"
5670  DATA "5.  Type today's date if the system"
5680  DATA "    asks the user to Enter today's date."
5690  DATA ".sp"
5700  DATA "6.  Type the correct time if the system"
5710  DATA "    asks the user to Enter the time."
5720  DATA ".sp"
5730  DATA "7.  Type: basic/s:256"
5740  DATA "          and press the 'enter' key."
5750  DATA ".pa"
5760  DATA "8.  Replace the DOS Diskette with the"
5770  DATA "    Notes and Sources ON DISPLAY disk-"
5780  DATA "    ette in Drive 'a:'."
5790  DATA ".sp"
5800  DATA "9.  Type:  run ~notesand~"
5810  DATA "            and press the 'enter' key."
5820  DATA ".sp"
5830  DATA "10.  Follow any instructions which appear"
5840  DATA "     at the bottom of each screen."
5850  DATA ".eof"
5860  END
