100  REM Documentation for the Genealogy ON DISPLAY Programs
110  REM All data is in the form of DATA statements.
120  REM By:  Melvin O. Duke.  Updated June 1986.
130  DATA Notes and Sources
140  DATA User's Manual
150  DATA -5
160  DATA 1
170  INDENT = 0
180  REM Printer Definitions
190  FORM.FEED$  = CHR$(12)
200  COMPR.OFF$  = CHR$(18)     : COMPR.ON$ = CHR$(15)
210  BOLD.OFF$   = CHR$(27)+"F" : BOLD.ON$ = CHR$(27)+"E"
220  EXPAND.OFF$ = CHR$(18)     : EXPAND.ON$ = CHR$(14)
230  REM Program begins here
240  READ TITLE$, DOC.NAME$, PAGE.NO, LINE.NO
250  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
260  GOSUB 900  'For trim line and heading space
270  FOR I = 1 TO 6 : LPRINT : NEXT I
280  LPRINT BOLD.ON$;    'Set Emphasized Print
290  LPRINT EXPAND.ON$;  'Set Expanded Print
300  LPRINT TAB(TAB.POS-5);TITLE$
310  LPRINT EXPAND.OFF$;  'Return to normal
320  LPRINT BOLD.OFF$;    'Return to normal
330  FOR I = 1 TO 3 : LPRINT : NEXT I
340  LPRINT BOLD.ON$; 'Set Emphasized mode
350  LPRINT TAB(TAB.POS+12);"ON DISPLAY"
360  LPRINT BOLD.OFF$; 'Return to normal
370  LPRINT : LPRINT : LPRINT
380  LPRINT TAB(TAB.POS+11);"Version 1.1"
390  FOR I = 1 TO 11 : LPRINT : NEXT I
400  LPRINT TAB(TAB.POS+8); DOC.NAME$
410  LINE.NO = LINE.NO + 27
420  '
430  READ REPLY$
440  REM First, change tildes to quotes
450  FOR Q = 1 TO LEN(REPLY$)
460   IF MID$(REPLY$,Q,1)="~"THEN MID$(REPLY$,Q,1)=CHR$(34)
470  NEXT Q
480  IF LEFT$(REPLY$,1) = "." THEN GOSUB 1250: GOTO 430
490  IF LINE.NO > 44 THEN GOSUB 1010
500  REM Print the line if not a command
510  LPRINT TAB(TAB.POS);REPLY$
520  LINE.NO = LINE.NO + 1
530  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
540  GOTO 430
550  DATA ".pa"
560  REM   Data for the Copyright Page
570  DATA "Anyone may request a copy of Notes and"
580  DATA "Sources ON DISPLAY, for trial, by sending"
590  DATA "an unformatted, double-sided, double-"
600  DATA "density, 5-1/4 inch diskette to the"
610  DATA "author of the programs."
620  DATA ".sp"
630  DATA "An addressed, postage-paid return"
640  DATA "mailer must accompany the diskette (no"
650  DATA "exceptions, please).
660  DATA ".sp"
670  DATA "A copy of the programs with documenta-"
680  DATA "tion will be sent by return mail."
690  DATA ".vt 2"
700  DATA "Users are encouraged to copy and share"
710  DATA "the programs with others."
720  DATA ".vt 2"
730  DATA "If you are using this program, you are"
740  DATA "expected to become a Registered User,"
750  DATA "by making a contribution to the author"
760  DATA "of the program ($30.00 suggested for"
770  DATA "Registered Users of Genealogy ON DIS-"
780  DATA "PLAY, otherwise, $45.00 suggested)."
790  DATA ".sp"
800  DATA "Melvin O. Duke"
810  DATA "P. O. Box 20836"
820  DATA "San Jose, CA  95160"
830  DATA "(408) 268-6637"
840  DATA ".vt 3"
850  DATA "Copyright (c) 1986, by:"
860  DATA "Melvin O. Duke."
870  DATA ".sp"
880  DATA "All rights reserved."
890  '
900  REM Top of each page routine
910  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
920  LPRINT
930  LPRINT TAB(30); "(Trim-line)"
940  LPRINT "+"+STRING$(54,45)+"+" 'Dashes
950  FOR I = 1 TO 6
960   LPRINT
970  NEXT I
980  LINE.NO = LINE.NO + 6
990  RETURN
1000  '
1010  REM Bottom of each page Routine
1020  IF PAGE.NO < 1 THEN LPRINT : LPRINT : LPRINT : GOTO 1140
1030  LPRINT TAB(TAB.POS); STRING$(40,45)  'on line 46
1040  LPRINT TAB(TAB.POS+0); TITLE$+" ON DISPLAY.  Vers. 1.1" 'on line 47
1050  IF PAGE.NO MOD 2 = 1 THEN 1090
1060  LPRINT TAB(TAB.POS);"Page";PAGE.NO;
1070  LPRINT TAB(TAB.POS+27);"User's Manual"
1080  GOTO 1140
1090  LPRINT TAB(TAB.POS); "User's Manual";
1100  IF PAGE.NO < 10 THEN DELTA = 34
1110  IF PAGE.NO >  9 THEN DELTA = 33
1120  IF PAGE.NO > 99 THEN DELTA = 32
1130  LPRINT TAB(TAB.POS+DELTA); "Page"; PAGE.NO  'on line 48
1140  LPRINT : LPRINT : LPRINT
1150  LPRINT "+"+STRING$(54,45)+"+" 'dashes after 51
1160  LPRINT TAB(30); "(Trim-line)"
1170  LPRINT FORM.FEED$;
1180  PAGE.NO = PAGE.NO + 1
1190  LINE.NO = 1
1200  IF REPLY$ = ".eof" THEN 1220  'Bypass after last page
1210  GOSUB 900  'For top of next page
1220  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1230  RETURN
1240  '
1250  REM Command Processor
1260  IF LEFT$(REPLY$,3) = ".h1" THEN 1360
1270  IF LEFT$(REPLY$,3) = ".h2" THEN 1520
1280  IF LEFT$(REPLY$,3) = ".h3" THEN 1630
1290  IF LEFT$(REPLY$,3) = ".sp" THEN 1740
1300  IF LEFT$(REPLY$,4) = ".eof" THEN 1790
1310  IF LEFT$(REPLY$,3) = ".pa" THEN 1820
1320  IF LEFT$(REPLY$,3) = ".vt" THEN 1890
1330  IF LEFT$(REPLY$,3) = ".pk" THEN 1990
1340  IF LEFT$(REPLY$,3) = ".in" THEN 2120
1350  STOP
1360  REM Head 1 Processor
1370  FOR I = LINE.NO TO 44
1380   LPRINT
1390  NEXT I
1400  GOSUB 1010  'Bottom of page Routine
1410  IF PAGE.NO MOD 2 = 0 THEN GOSUB 1820  'For h1 on Odd pages
1420  LPRINT BOLD.ON$;     'Set Emphasized Printing
1430  LPRINT EXPAND.ON$;   'Set expanded print
1440  IF PAGE.NO MOD 2 = 0 THEN ADJUST = -2 ELSE ADJUST = -5
1450  LPRINT TAB(TAB.POS+ADJUST); RIGHT$(REPLY$,LEN(REPLY$)-4)
1460  LPRINT EXPAND.OFF$;  'Return to normal
1470  LPRINT BOLD.OFF$;    'Return to non-bold
1480  LINE.NO = LINE.NO+1
1490  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1500  RETURN
1510  '
1520  REM Head 2 Processor
1530  IF LINE.NO = 7 THEN 1550 'skip spacing if at top of page
1540  IF LINE.NO > 43 THEN GOSUB 1820 ELSE LPRINT:LPRINT:LINE.NO = LINE.NO+2
1550  LPRINT BOLD.ON$;    'Set emphasized print
1560  LPRINT TAB(TAB.POS+1); RIGHT$(REPLY$,LEN(REPLY$)-4)
1570  LPRINT BOLD.OFF$;   'Return to normal
1580  LPRINT
1590  LINE.NO = LINE.NO + 2
1600  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1610  RETURN
1620  '
1630  REM Head 3 Processor
1640  IF LINE.NO = 7 THEN 1660 'skip spacing if at top of page
1650  IF LINE.NO > 43 THEN GOSUB 1820 ELSE LPRINT:LPRINT:LINE.NO = LINE.NO+2
1660  LPRINT BOLD.ON$;    'Set emphasized print
1670  LPRINT TAB(TAB.POS+1); RIGHT$(REPLY$,LEN(REPLY$)-4)
1680  LPRINT BOLD.OFF$;   'Return to normal
1690  LPRINT
1700  LINE.NO = LINE.NO + 2
1710  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1720  RETURN
1730  '
1740  REM Single Space Processor
1750  IF LINE.NO = 7 THEN 1770
1760  IF LINE.NO > 44 THEN GOSUB 1820 ELSE LPRINT : LINE.NO = LINE.NO + 1
1770  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1780  RETURN
1790  REM End of File Processor
1800  GOSUB 1820 'Bottom of Page
1810  GOTO 4190 'end
1820  REM Page Eject Processor
1830  FOR I = LINE.NO TO 44
1840   LPRINT
1850   LINE.NO = LINE.NO + 1
1860  NEXT I
1870  GOSUB 1010  'Bottom of Page Processing
1880  RETURN
1890  REM Vertical Tab Processor
1900  IF LINE.NO = 7 THEN 1980
1910  QTY = VAL(RIGHT$(REPLY$,LEN(REPLY$)-3))
1920  FOR I = 1 TO QTY
1930   LPRINT
1940   LINE.NO = LINE.NO + 1
1950   IF LINE.NO > 44 THEN I = QTY
1960  NEXT I
1970  IF LINE.NO > 44 THEN GOSUB 1010  'End of page
1980  RETURN
1990  REM Pack Processor
2000  IF LINE.NO > 44 THEN GOSUB 1010
2010  IF TAB.POS = 8 THEN ADJUST = 4
2020  IF TAB.POS = 13 THEN ADJUST = 7
2030  TAB.POS = TAB.POS + ADJUST + INDENT
2040  WIDTH "lpt1:", 132  'set condensed width
2050  LPRINT COMPR.ON$;   'Packed printing
2060  LPRINT TAB(TAB.POS); RIGHT$(REPLY$,LEN(REPLY$)-3)
2070  LPRINT COMPR.OFF$;  'Return to normal
2080  WIDTH "lpt1:", 80   'return to normal
2090  LINE.NO = LINE.NO + 1
2100  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
2110  RETURN
2120  REM Indent Processor
2130  INDENT = VAL(RIGHT$(REPLY$,LEN(REPLY$)-3))
2140  RETURN
3000  DATA ".h1 TABLE OF CONTENTS"
3010  DATA ".sp"
3020  DATA "INTRODUCTION - - - - - - - - - - - -   1"
3030  DATA "  OVERVIEW - - - - - - - - - - - - -   1"
3040  DATA "    Personalized Information - - - -   1"
3050  DATA "    Integrated Approach  - - - - - -   1"
3060  DATA "    Multiple Choices - - - - - - - -   2"
3070  DATA "  CAPABILITIES - - - - - - - - - - -   3"
3080  DATA "    Format a Note File - - - - - - -   3"
3090  DATA "    Extend the Note File - - - - - -   3"
3100  DATA "    Personalize the Sources  - - - -   4"
3110  DATA "    Personalize the Types of Data  -   4"
3120  DATA "    Enter or Update Notes  - - - - -   4"
3130  DATA "    Inquiry for Display or Printing    5"
3140  DATA "  BENEFITS/ADVANTAGES  - - - - - - -   6"
3150  DATA "  RESULTS  - - - - - - - - - - - - -   6"
3160  DATA "  REQUIREMENTS - - - - - - - - - - -   7"
3170  DATA "    Hardware Requirements  - - - - -   7"
3180  DATA "    Software Requirements  - - - - -   8"
3190  DATA ".sp"
3200  DATA "GENERAL INFORMATION  - - - - - - - -   9"
3210  DATA "  DATA ACCESS REQUIREMENTS - - - - -   9"
3220  DATA "  DESCRIPTION OF FUNCTIONS - - - - -   9"
3230  DATA "    Formatting the Note File - - - -   9"
3240  DATA "    Personalization of Files - - - -  10"
3250  DATA "    Data Entry and Update  - - - - -  10"
3260  DATA "    Inquiry for Display or Printing   11"
3270  DATA "  DEFINITION OF TERMS  - - - - - - -  12"
3280  DATA "    Sources  - - - - - - - - - - - -  12"
3290  DATA "    Types  - - - - - - - - - - - - -  12"
3300  DATA "    Notes  - - - - - - - - - - - - -  13"
3310  DATA "    Lists  - - - - - - - - - - - - -  13"
3320  DATA "    Data Entry or Update - - - - - -  14"
3330  DATA "    Inquiry for Display or Printing   14"
3340  DATA ".pa"
3350  DATA "  EXPLANATION OF GENERAL CONCEPTS  -  15"
3360  DATA "    Notes and Sources ON DISPLAY - -  15"
3370  DATA "    The Notefile - - - - - - - - - -  18"
3380  DATA "    The Sources File - - - - - - - -  19"
3390  DATA "    The Types File - - - - - - - - -  19"
3400  DATA "  BEFORE YOU START - - - - - - - - -  20"
3410  DATA "    Introduction to Personalization   20"
3420  DATA "    List of Note Types - - - - - - -  20"
3430  DATA "    List of Sources  - - - - - - - -  23"
3440  DATA ".sp"
3450  DATA "USING THE PROGRAMS - - - - - - - - -  25"
3460  DATA "  FIRST TIME USAGE - - - - - - - - -  25"
3470  DATA "    Backing up the Diskettes - - - -  25"
3480  DATA "    Preparing a New Notes Diskette -  25"
3490  DATA "      Copy the Distribution Diskette  26"
3500  DATA "      Delete the Documentation - - -  27"
3510  DATA "  CONVENTIONS  - - - - - - - - - - -  29"
3520  DATA "    Standard Screen Information  - -  29"
3530  DATA "    Screen Appearance  - - - - - - -  30"
3540  DATA "    Use of the Enter Key - - - - - -  31"
3550  DATA "    Use of / Enter - - - - - - - - -  31"
3560  DATA "    Use of \ Enter - - - - - - - - -  32"
3570  DATA "    Abbreviated Responses  - - - - -  32"
3580  DATA "    Correcting Typing Mistakes - - -  33"
3590  DATA "    Replacing with Blanks  - - - - -  33"
3600  DATA "    Use of the Question Mark - - - -  33"
3610  DATA "  GETTING STARTED  - - - - - - - - -  34"
3620  DATA "  HOW TO OPERATE - - - - - - - - - -  36"
3630  DATA "    Selecting a Function - - - - - -  36"
3640  DATA "      Create (Format) a Notes File -  37"
3650  DATA "      Extend the Notes file  - - - -  38"
3660  DATA "      Personalize the Sources  - - -  39"
3670  DATA "      Personalize the Types  - - - -  39"
3680  DATA "      Data Entry of Notes  - - - - -  40"
3690  DATA "      Inquiry into Notes - - - - - -  42"
3700  DATA ".pa"
3710  DATA "  HOW TO STOP  - - - - - - - - - - -  45"
3720  DATA "    Stopping From the Menu - - - - -  45"
3730  DATA "    Stopping Personalization - - - -  46"
3740  DATA "    Stopping Data Entry  - - - - - -  47"
3750  DATA "    Stopping Inquiry - - - - - - - -  48"
3760  DATA ".sp"
3770  DATA "REFERENCE MATERIAL - - - - - - - - -  51"
3780  DATA "  SAMPLE SCREENS AND PROMPTING"
3790  DATA "      MESSAGES - - - - - - - - - - -  51"
3800  DATA "    Program Logo - - - - - - - - - -  52"
3810  DATA "    Menu of Functions  - - - - - - -  53"
3820  DATA "    Warning Screen - - - - - - - - -  54"
3830  DATA "    Update the Sources - - - - - - -  55"
3840  DATA "    Update the Types - - - - - - - -  56"
3850  DATA "    Data Entry (request for number)   57"
3860  DATA "    Data Entry (empty note)  - - - -  58"
3870  DATA "    Data Entry (persons shown) - - -  59"
3880  DATA "    Data Entry (completed) - - - - -  60"
3890  DATA "    Inquiry (empty)  - - - - - - - -  61"
3900  DATA "    Inquiry (completed)  - - - - - -  63"
3910  DATA "    Inquiry output (detailed)  - - -  64"
3920  DATA "    Inquiry output (summary) - - - -  65"
3930  DATA "  COMMANDS USED  - - - - - - - - - -  66"
3940  DATA "    Basic Command  - - - - - - - - -  66"
3950  DATA "    Load Command - - - - - - - - - -  66"
3960  DATA "    Run Command  - - - - - - - - - -  66"
3970  DATA ".sp"
3980  DATA "APPENDIX A.  MESSAGES  - - - - - - -  67"
3990  DATA "  Start-up Messages  - - - - - - - -  67"
4000  DATA ".sp"
4010  DATA "APPENDIX B. HINTS  - - - - - - - - -  68"
4020  DATA "  Dates  - - - - - - - - - - - - - -  68"
4030  DATA "  Replacing Information  - - - - - -  68"
4040  DATA "  Removing a Record  - - - - - - - -  68"
4050  DATA ".pa"
4060  DATA "APPENDIX C.  MODIFICATIONS - - - - -  69"
4070  DATA "  Making Changes - - - - - - - - - -  69"
4080  DATA "  Color Considerations - - - - - - -  69"
4090  DATA "  Color Definitions  - - - - - - - -  70"
4100  DATA "  Changing the Number of Persons - -  70"
4110  DATA "  Repositioning the Files  - - - - -  71"
4120  DATA "  Utilizing Other Printers - - - - -  72"
4130  DATA ".sp"
4140  DATA "APPENDIX D.  TERMS & CONDITIONS  - -  73"
4150  DATA "  Terms  - - - - - - - - - - - - - -  73"
4160  DATA "  Conditions - - - - - - - - - - - -  74"
4170  DATA "  Disclaimer - - - - - - - - - - - -  74"
4180  DATA ".eof"
4190  END
