100  REM Documentation for the Genealogy ON DISPLAY Programs
110  REM All data is in the form of DATA statements.
120  REM By:  Melvin O. Duke.  Updated June 1986.
130  DATA Notes and Sources
140  DATA User's Manual
150  DATA -5
160  DATA 1
170  INDENT = 0
180  REM Printer Definitions
190  FORM.FEED$  = CHR$(12)
200  COMPR.OFF$  = CHR$(18)     : COMPR.ON$ = CHR$(15)
210  BOLD.OFF$   = CHR$(27)+"F" : BOLD.ON$ = CHR$(27)+"E"
220  EXPAND.OFF$ = CHR$(18)     : EXPAND.ON$ = CHR$(14)
230  DASHES$ = "+"+STRING$(54,45)+"+"
240  TRIM.LINE$ = "(Trim-line)"
250  REM Program begins here
260  READ TITLE$, DOC.NAME$, PAGE.NO, LINE.NO
270  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
280  GOSUB 920  'For trim line and heading space
290  FOR I = 1 TO 6 : LPRINT : NEXT I
300  LPRINT BOLD.ON$;     'Set Emphasized mode
310  LPRINT EXPAND.ON$;   'Set Expanded Print
320  LPRINT TAB(TAB.POS-5);TITLE$
330  LPRINT EXPAND.OFF$;  'Return to normal
340  LPRINT BOLD.OFF$;    'Return to normal
350  FOR I = 1 TO 3 : LPRINT : NEXT I
360  LPRINT BOLD.ON$;     'Set Emphasized mode
370  LPRINT TAB(TAB.POS+12);"ON DISPLAY"
380  LPRINT BOLD.OFF$;    'Return to normal
390  LPRINT : LPRINT : LPRINT
400  LPRINT TAB(TAB.POS+11);"Version 1.1"
410  FOR I = 1 TO 11 : LPRINT : NEXT I
420  LPRINT TAB(TAB.POS+10); DOC.NAME$
430  LINE.NO = LINE.NO + 27
440  '
450  READ REPLY$
460  REM First, change tildes to quotes
470  FOR Q = 1 TO LEN(REPLY$)
480   IF MID$(REPLY$,Q,1)="~"THEN MID$(REPLY$,Q,1)=CHR$(34)
490  NEXT Q
500  IF LEFT$(REPLY$,1) = "." THEN GOSUB 1270: GOTO 450
510  IF LINE.NO > 44 THEN GOSUB 1030
520  REM Print the line if not a command
530  LPRINT TAB(TAB.POS);REPLY$
540  LINE.NO = LINE.NO + 1
550  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
560  GOTO 450
570  DATA ".pa"
580  REM   Data for the Copyright Page
590  DATA "Anyone may request a copy of Notes and"
600  DATA "Sources ON DISPLAY, for trial, by sending"
610  DATA "an unformatted, double-sided, double-"
620  DATA "density, 5-1/4 inch diskette to the"
630  DATA "author of the programs."
640  DATA ".sp"
650  DATA "An addressed, postage-paid return"
660  DATA "mailer must accompany the diskette (no"
670  DATA "exceptions, please).
680  DATA ".sp"
690  DATA "A copy of the programs with documenta-"
700  DATA "tion will be sent by return mail."
710  DATA ".vt 2"
720  DATA "Users are encouraged to copy and share"
730  DATA "the programs with others."
740  DATA ".vt 2"
750  DATA "If you are using this program, you are"
760  DATA "expected to become a Registered User,"
770  DATA "by making a contribution to the author"
780  DATA "of the program ($30.00 suggested for"
790  DATA "Registered Users of Genealogy ON DIS-"
800  DATA "PLAY, otherwise, $45.00 suggested)."
810  DATA ".sp"
820  DATA "Melvin O. Duke"
830  DATA "P. O. Box 20836"
840  DATA "San Jose, CA  95160"
850  DATA "(408) 268-6637"
860  DATA ".vt 3"
870  DATA "Copyright (c) 1986, by:"
880  DATA "Melvin O. Duke."
890  DATA ".sp"
900  DATA "All rights reserved."
910  '
920  REM Top of each page routine
930  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
940  LPRINT
950  LPRINT TAB(30); TRIM.LINE$
960  LPRINT DASHES$ 'Dashes
970  FOR I = 1 TO 6
980   LPRINT
990  NEXT I
1000  LINE.NO = LINE.NO + 6
1010  RETURN
1020  '
1030  REM Bottom of each page Routine
1040  IF PAGE.NO < 1 THEN LPRINT : LPRINT : LPRINT : GOTO 1160
1050  LPRINT TAB(TAB.POS); STRING$(40,45)  'on line 46
1060  LPRINT TAB(TAB.POS+0); TITLE$+" ON DISPLAY.  Vers. 1.1" 'on line 47
1070  IF PAGE.NO MOD 2 = 1 THEN 1110
1080  LPRINT TAB(TAB.POS);"Page";PAGE.NO;
1090  LPRINT TAB(TAB.POS+27);"User's Manual"
1100  GOTO 1160
1110  LPRINT TAB(TAB.POS); "User's Manual";
1120  IF PAGE.NO < 10 THEN DELTA = 34
1130  IF PAGE.NO >  9 THEN DELTA = 33
1140  IF PAGE.NO > 99 THEN DELTA = 32
1150  LPRINT TAB(TAB.POS+DELTA); "Page"; PAGE.NO  'on line 48
1160  LPRINT : LPRINT : LPRINT
1170  LPRINT DASHES$ 'dashes after 51
1180  LPRINT TAB(30); TRIM.LINE$
1190  LPRINT FORM.FEED$;
1200  PAGE.NO = PAGE.NO + 1
1210  LINE.NO = 1
1220  IF REPLY$ = ".eof" THEN 1240  'Bypass after last page
1230  GOSUB 920  'For top of next page
1240  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1250  RETURN
1260  '
1270  REM Command Processor
1280  IF LEFT$(REPLY$,3) = ".h1" THEN 1390
1290  IF LEFT$(REPLY$,3) = ".h2" THEN 1550
1300  IF LEFT$(REPLY$,3) = ".h3" THEN 1660
1310  IF LEFT$(REPLY$,3) = ".sp" THEN 1770
1320  IF LEFT$(REPLY$,4) = ".eof" THEN 1820
1330  IF LEFT$(REPLY$,3) = ".pa" THEN 1850
1340  IF LEFT$(REPLY$,3) = ".pn" THEN PAGE.NO = VAL(RIGHT$(REPLY$,LEN(REPLY$)-3)) : RETURN
1350  IF LEFT$(REPLY$,3) = ".vt" THEN 1920
1360  IF LEFT$(REPLY$,3) = ".pk" THEN 2030
1370  IF LEFT$(REPLY$,3) = ".in" THEN 2160
1380  STOP
1390  REM Head 1 Processor
1400  FOR I = LINE.NO TO 44
1410   LPRINT
1420  NEXT I
1430  GOSUB 1030  'Bottom of page Routine
1440  IF PAGE.NO MOD 2 = 0 THEN GOSUB 1850  'For h1 on Odd pages
1450  LPRINT BOLD.ON$;     'Set emphasized print
1460  LPRINT EXPAND.ON$;   'Set expanded print
1470  IF PAGE.NO MOD 2 = 0 THEN ADJUST = -2 ELSE ADJUST = -5
1480  LPRINT TAB(TAB.POS+ADJUST); RIGHT$(REPLY$,LEN(REPLY$)-4)
1490  LPRINT EXPAND.OFF$;  'Return to normal
1500  LPRINT BOLD.OFF$;    'Return to non-bold
1510  LINE.NO = LINE.NO+1
1520  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1530  RETURN
1540  '
1550  REM Head 2 Processor
1560  IF LINE.NO = 7 THEN 1580 'skip spacing if at top of page
1570  IF LINE.NO > 43 THEN GOSUB 1850 ELSE LPRINT:LPRINT:LINE.NO = LINE.NO+2
1580  LPRINT BOLD.ON$;  'Set emphasized print
1590  LPRINT TAB(TAB.POS+1); RIGHT$(REPLY$,LEN(REPLY$)-4)
1600  LPRINT BOLD.OFF$; 'Return to normal
1610  LPRINT
1620  LINE.NO = LINE.NO + 2
1630  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1640  RETURN
1650  '
1660  REM Head 3 Processor
1670  IF LINE.NO = 7 THEN 1690 'skip spacing if at top of page
1680  IF LINE.NO > 43 THEN GOSUB 1850 ELSE LPRINT:LPRINT:LINE.NO = LINE.NO+2
1690  LPRINT BOLD.ON$;  'Set emphasized print
1700  LPRINT TAB(TAB.POS+1); RIGHT$(REPLY$,LEN(REPLY$)-4)
1710  LPRINT BOLD.OFF$; 'Return to normal
1720  LPRINT
1730  LINE.NO = LINE.NO + 2
1740  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1750  RETURN
1760  '
1770  REM Single Space Processor
1780  IF LINE.NO = 7 THEN 1800
1790  IF LINE.NO > 44 THEN GOSUB 1850 ELSE LPRINT : LINE.NO = LINE.NO + 1
1800  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
1810  RETURN
1820  REM End of File Processor
1830  GOSUB 1850 'Bottom of Page
1840  GOTO 9850
1850  REM Page Eject Processor
1860  FOR I = LINE.NO TO 44
1870   LPRINT
1880   LINE.NO = LINE.NO + 1
1890  NEXT I
1900  GOSUB 1030  'Bottom of Page Processing
1910  RETURN
1920  REM Vertical Tab Processor
1930  IF LINE.NO = 7 THEN 2020
1940  IF LINE.NO > 44 THEN GOSUB 1030  'End of page
1950  QTY = VAL(RIGHT$(REPLY$,LEN(REPLY$)-3))
1960  FOR I = 1 TO QTY
1970   LPRINT
1980   LINE.NO = LINE.NO + 1
1990   IF LINE.NO > 44 THEN I = QTY
2000  NEXT I
2010  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
2020  RETURN
2030  REM Pack Processor
2040  IF LINE.NO > 44 THEN GOSUB 1030
2050  IF TAB.POS = 8 THEN ADJUST = 4
2060  IF TAB.POS = 13 THEN ADJUST = 7
2070  TAB.POS = TAB.POS + ADJUST + INDENT
2080  WIDTH "lpt1:", 132 'set condensed width
2090  LPRINT COMPR.ON$;  'Packed printing
2100  LPRINT TAB(TAB.POS); RIGHT$(REPLY$,LEN(REPLY$)-3)
2110  LPRINT COMPR.OFF$; 'Return to normal
2120  WIDTH "lpt1:", 80  'return to normal
2130  LINE.NO = LINE.NO + 1
2140  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
2150  RETURN
2160  REM Indent Processor
2170  INDENT = VAL(RIGHT$(REPLY$,LEN(REPLY$)-3))
2180  RETURN
3000  DATA ".h1 USING THE PROGRAMS"
3010  DATA ".pn 25"
3020  DATA ".h2 FIRST TIME USAGE"
3030  DATA ".h3 Backing up the Diskettes"
3040  DATA "Good procedures indicate that upon"
3050  DATA "receipt of any program or programs, it"
3060  DATA "is highly desirable for you to make"
3070  DATA "back-up copies for your own protection."
3080  DATA "Such is surely the case with the Notes"
3090  DATA "and Sources ON DISPLAY diskette."
3100  DATA ".sp"
3110  DATA "Once you have entered your notes into"
3120  DATA "your Notes diskette (see below), you"
3130  DATA "will also want to back up that diskette"
3140  DATA "from time to time."
3150  DATA ".h3 Preparing a New Notes Diskette"
3160  DATA "Begin with a formatted diskette, which"
3170  DATA "was formatted without including DOS"
3180  DATA "(no /s).
3190  DATA ".sp"
3200  DATA "If you do not have one available, it"
3210  DATA "will be necessary to format one."
3220  DATA "Refer to FORMAT Command in the DOS"
3230  DATA "Manual."
3240  DATA ".pa"
3250  DATA ".h3 Copy the Distribution Diskette"
3260  DATA "The entire contents of the Distribution"
3270  DATA "diskette should be copied to your new"
3280  DATA "Notes diskette."
3290  DATA ".sp"
3300  DATA "1.  Bring up DOS (but not BASIC)."
3310  DATA ".sp"
3320  DATA "2.  Insert the Distribution Diskette in"
3330  DATA "      drive 'a:' (and the Notes Diskette"
3340  DATA "      in drive 'b:' if you have one)."
3350  DATA ".sp"
3360  DATA "3.  Type:  copy a:*.* b:"
3370  DATA "      and press the 'enter' key."
3380  DATA ".sp"
3390  DATA "4.  On a one-drive system, replace the"
3400  DATA "      Distribution Diskette with the"
3410  DATA "      Notes Diskette when asked to do"
3420  DATA "      so, and press the 'enter' key."
3430  DATA ".pa"
3440  DATA ".h3 Delete the Documentation"
3450  DATA "The documentation should be removed from"
3460  DATA "your Notes diskette, to provide more"
3470  DATA "space for your notes themselves."
3480  DATA ".sp"
3490  DATA "With your Notes diskette in Drive a:,"
3500  DATA "(while you are still in DOS), do the"
3510  DATA "following:"
3520  DATA ".sp"
3530  DATA "1.  Type:  cleandoc"
3540  DATA "           and press the `enter' key."
3550  DATA ".sp"
3560  DATA "This batch file will cause all of the"
3570  DATA "documentation programs to be erased."
3580  DATA ".sp"
3590  DATA "2.  Type:  erase cleandoc.bat"
3600  DATA "           and press the 'enter' key."
3610  DATA ".sp"
3620  DATA "This erases the batch file which you"
3630  DATA "just used to remove the documentation."
3640  DATA ".sp"
3650  DATA "3.  If you are using a single-drive"
3660  DATA "    system, your Genealogy ON DISPLAY"
3670  DATA "    Persons File must be copied to"
3680  DATA "    your Notes diskette.  To do this,"
3690  DATA "    have the Data Diskette (with the"
3700  DATA "    the Persons File in drive b:."
3710  DATA ".sp"
3720  DATA "    Type:  copy b:persfile a:"
3730  DATA "           and press the 'enter' key."
3740  DATA ".sp"
3750  DATA "This will copy the Persons File from"
3760  DATA "Genealogy ON DISPLAY to the diskette"
3770  DATA "which will contain your notes."
3780  DATA ".sp"
3790  DATA "If you are using a System where you can"
3800  DATA "access your Persons File from Genealogy"
3810  DATA "ON DISPLAY, such as a two-drive system,"
3820  DATA "or a hard-disk system, you need to make"
3830  DATA "a change in the ~notesand.bas~ program,"
3840  DATA "to indicate where your Persons File is"
3850  DATA "located."
3860  DATA ".sp"
3870  DATA "To do this, bring up DOS and BASIC, and"
3880  DATA "do the following:"
3890  DATA ".sp"
3900  DATA "1.  load ~notesand.bas~"
3910  DATA ".sp"
3920  DATA "2.  type: edit 430"
3930  DATA "          and press the 'enter' key."
3940  DATA ".sp"
3950  DATA "You will see a line which reads:"
3960  DATA ".sp"
3970  DATA "  430 DD.PERS$ = ~a:~    'Persons File"
3980  DATA ".sp"
3990  DATA "Using the cursor keys, move the cursor"
4000  DATA "to the a, and change it to the drive-"
4010  DATA "location where you Persons File will"
4020  DATA "actually be located when you run the"
4030  DATA "program.  For example, if you expect"
4040  DATA "the Persons File to be on the b:-drive,"
4050  DATA "change the line to read:"
4060  DATA ".sp"
4070  DATA "  430 DD.PERS$ = ~b:~    'Persons File"
4080  DATA ".sp"
4090  DATA "    and press the 'enter' key."
4100  DATA ".sp"
4110  DATA "3.  Save the changed program."
4120  DATA ".sp"
4130  DATA "    Type: save ~notesand.bas~"
4140  DATA "          and press the 'enter' key."
4150  DATA ".sp"
4160  DATA "Your Notes Diskette is now ready for"
4170  DATA "you to use."
4180  DATA ".pa"
4190  DATA ".h2 CONVENTIONS"
4200  DATA ".h3 Standard Screen Information"
4210  DATA "Once you begin to use Notes and Sources"
4220  DATA "ON DISPLAY, you will quickly learn that"
4230  DATA "certain information always appears in"
4240  DATA "the same place on each screen.  For ex-"
4250  DATA "ample, line 23 is always the line where"
4260  DATA "your input is entered.  Line 2 is the"
4270  DATA "Title Line.  Line 22 is where any errors"
4280  DATA "will be shown, etc."
4290  DATA ".sp"
4300  DATA "In addition, the left side of the screen"
4310  DATA "shows what choices you have available,"
4320  DATA "while the right side of the screen shows"
4330  DATA "the choices which you have already made."
4340  DATA ".sp"
4350  DATA "Following is a diagram which more clear-"
4360  DATA "ly shows you where to look for things on"
4370  DATA "the screen."
4380  DATA ".sp"
4390  DATA "Not all information will appear on all"
4400  DATA "screens, but when you see something,"
4410  DATA "it will always be in the same place."
4420  DATA ".pa"
4430  DATA ".h3 Screen Appearance"
4440  DATA ".pk Line   Line"
4450  DATA ".pk No.    Usage"
4460  DATA ".pk  1  +- Top Border -------------------------------------------+"
4470  DATA ".pk  2  |  Title Line                               Note No.     |"
4480  DATA ".pk  3  +- Separator ---------------+----------------------------+"
4490  DATA ".pk  4  |  No.  Description         |   Choices Made             |"
4500  DATA ".pk  5  |   1   1st Description     |                            |"
4510  DATA ".pk  6  |   2   2nd Description     |   Researched: Date         |"
4520  DATA ".pk  7  |   3   3rd Description     |                            |"
4530  DATA ".pk  8  |   4   4th Description     |   Person    : No.          |"
4540  DATA ".pk  9  |   5   5th Description     |     Given Names            |"
4550  DATA ".pk 10  |   6   6th Description     |     Surname                |"
4560  DATA ".pk 11  |   7   7th Description     |     Birthdate              |"
4570  DATA ".pk 12  |   8   8th Description     |                            |"
4580  DATA ".pk 13  |   9   5th Description     |   Source    : No.          |"
4590  DATA ".pk 14  |  10  10th Description     |     Selected Source        |"
4600  DATA ".pk 15  |  11  11th Description     |   Type      : No.          |"
4610  DATA ".pk 16  |  12  12th Description     |     Selected Type          |"
4620  DATA ".pk 17  +- Separator ---------------+   Event Date: Date         |"
4630  DATA ".pk 18  | Note:                                                  |"
4640  DATA ".pk 19  |                                                        |"
4650  DATA ".pk 20  | Content of an individual note.                         |"
4660  DATA ".pk 21  +- Bottom Border ----------------------------------------+"
4670  DATA ".pk 22   Error Message Line"
4680  DATA ".pk 23   Your Input Line"
4690  DATA ".pk 24   First Informational Message Line"
4700  DATA ".pk 25   Second Informational Message Line"
4710  DATA ".pa"
4720  DATA ".h3 Use of the Enter Key"
4730  DATA "Pressing the 'enter' key (by itself)"
4740  DATA "indicates that you do not want to change"
4750  DATA "the item requested.  It is bypassed, and"
4760  DATA "the next item is requested from you."
4770  DATA ".sp"
4780  DATA "When making an inquiry, it is assumed"
4790  DATA "that you want (all).  If you press the"
4800  DATA "'enter' key, without choosing any item,"
4810  DATA "you choice is assumed to be (all)."
4820  DATA ".h3 Use of / Enter (Slash Enter)"
4830  DATA "Typing a / (slash), followed by pressing"
4840  DATA "the 'enter' key, indicates that you are"
4850  DATA "finished with whatever it was that you"
4860  DATA "were doing at the time."
4870  DATA ".sp"
4880  DATA "If you were personalizing a list, it"
4890  DATA "means that you have finished your per-"
4900  DATA "sonalization, and are now ready to save"
4910  DATA "your new personalized list (or forget"
4920  DATA "it, etc.)."
4930  DATA ".sp"
4940  DATA "If you were entering or updating a Note"
4950  DATA "record, it means that you have finished"
4960  DATA "with your entry or update, and that you"
4970  DATA "are now ready to save the Note record"
4980  DATA "(or forget it, etc.)"
4990  DATA ".pa"
5000  DATA ".h3 Use of \ Enter (Backslash Enter)"
5010  DATA "Typing a \ (backslash), followed by"
5020  DATA "pressing the 'enter' key, indicates that"
5030  DATA "you want to see a portion of the list"
5040  DATA "that can be shown on the left side of"
5050  DATA "the display screen.  This facility"
5060  DATA "allows you to go through an entire list,"
5070  DATA "one section at a time, if you want to."
5080  DATA ".h3 Abbreviated Responses"
5090  DATA "Many of your responses may be abbrevia-"
5100  DATA "ted.  This means that you do not have"
5110  DATA "to type out the entire word, but just"
5120  DATA "the first letter of the word."
5130  DATA ".sp"
5140  DATA "In addition, if you want to enter"
5150  DATA "today's date, simply type a t, and"
5160  DATA "then press the 'enter' key."
5170  DATA ".sp"
5180  DATA "Words which may be abbreviated are:"
5190  DATA ".sp"
5200  DATA "  a  -  All"
5210  DATA "  d  -  Display"
5220  DATA "  f  -  Forget"
5230  DATA "  m  -  More"
5240  DATA "  p  -  Print"
5250  DATA "  s  -  Save"
5260  DATA "  s  -  Some"
5270  DATA "  t  -  Today's Date"
5280  DATA "  y  -  Yes"
5290  DATA ".sp"
5300  DATA "You may respond with either lower-case"
5310  DATA "or upper-case letters."
5320  DATA ".pa"
5330  DATA ".h3 Correcting Typing Mistakes"
5340  DATA "Sometimes you will make a mistake while"
5350  DATA "you are typing.  You may use the 'back-"
5360  DATA "space' key to back up, erasing the"
5370  DATA "errors, and then you can type the cor-"
5380  DATA "rect information."
5390  DATA ".h3 Replacing with Blanks"
5400  DATA "Occasionally, you might want to change"
5410  DATA "something from its present value to"
5420  DATA "blanks.  Since the 'enter' key has other"
5430  DATA "meanings, it will be necessary for you"
5440  DATA "to type a blank which has quotes around"
5450  DATA "it.  This is done by typing a quote,"
5460  DATA "then a space, then another quote, and"
5470  DATA "finally by pressing the 'enter' key."
5480  DATA ".sp"
5490  DATA "Such as:      ~ ~      (Must be exact)"
5500  DATA ".h3 Use of the Question-Mark"
5510  DATA "The question-mark is used to let you"
5520  DATA "search for an unused Note record, when"
5530  DATA "you are entering or updating those"
5540  DATA "Note records."
5550  DATA ".sp"
5560  DATA "If you are just starting the program,"
5570  DATA "searching will start from Note record"
5580  DATA "1.  If you have updated any Note, and"
5590  DATA "then type a question-mark in place of"
5600  DATA "the number of a Note record, searching"
5610  DATA "will begin at the last number that you"
5620  DATA "have used."
5630  DATA ".pa"
5640  DATA ".h2 GETTING STARTED"
5650  DATA "The user should perform the following"
5660  DATA "steps in starting the Notes and Source"
5670  DATA "ON DISPLAY programs.  (Note: The steps"
5680  DATA "essentially provide for making BASIC"
5690  DATA "and the Persons File from Genealogy ON"
5700  DATA "DISPLAY available, and starting the"
5710  DATA "program.)"
5720  DATA ".sp
5730  DATA " 1. Insert the PC DOS diskette into"
5740  DATA "    Drive 'a:'."
5750  DATA ".sp
5760  DATA " 2. If using the PCjr, insert the"
5770  DATA "    BASIC Cartridge into either slot."
5780  DATA ".sp
5790  DATA " 3. Turn the Printer On."
5800  DATA ".sp"
5810  DATA " 4. Turn the System On."
5820  DATA ".sp"
5830  DATA " 5. Type today's date if the system"
5840  DATA "    asks the user to Enter today's date."
5850  DATA "    (This is important, since it may be"
5860  DATA "    used by the program.)"
5870  DATA ".sp"
5880  DATA " 6. Type the correct time if the system"
5890  DATA "    asks the user to Enter the time."
5900  DATA ".sp"
5910  DATA "Note:  Make sure that your latest copy"
5920  DATA "of the Persons File from Genealogy ON"
5930  DATA "DISPLAY is available.  If you are using"
5940  DATA "a single-drive system, you will need to"
5950  DATA "copy the latest version to your Notes"
5960  DATA "diskette at this time.  This is done"
5970  DATA "with the COPY Command of DOS, as:"
5980  DATA ".pa"
5990  DATA "With the Notes Diskette in drive a:,"
6000  DATA "and the diskette with the Genealogy ON"
6010  DATA "DISPLAY Persons File in drive b:,"
6020  DATA ".sp"
6030  DATA " 7. Type: copy b:persfile a:"
6040  DATA "          and press the 'enter' key."
6050  DATA ".sp"
6060  DATA "Next, with the DOS Diskette in drive a:,"
6070  DATA ".sp"
6080  DATA " 8. Type: basic/s:256"
6090  DATA "          and press the 'enter' key."
6100  DATA ".sp"
6110  DATA "Note:  The /s:256 is essential, in order"
6120  DATA "to use files whose records are as long"
6130  DATA "as those in the Persons File of Gene-"
6140  DATA "alogy ON DISPLAY."
6150  DATA ".sp"
6160  DATA "Without the /s:256 the ~notesand.bas~"
6170  DATA "program gives an error message when it"
6180  DATA "tries to use the verifile (which has"
6190  DATA "one record which is 256 characters long)."
6200  DATA "The program is terminated, and it is"
6210  DATA "necessary for you to go back to DOS, and"
6220  DATA "bring up BASIC again, but with /s:256."
6230  DATA ".sp"
6240  DATA " 9. Replace the DOS Diskette with your"
6250  DATA "    Notes diskette in drive a:."
6260  DATA ".sp"
6270  DATA "10. Type: run ~notesand.bas~"
6280  DATA "           and press the 'enter' key."
6290  DATA ".sp"
6300  DATA "11.  Follow any instructions which"
6310  DATA "     appear at the bottom of each"
6320  DATA "     screen."
6330  DATA ".pa"
6340  DATA ".h2 HOW TO OPERATE."
6350  DATA ".h3 Selecting a Function"
6360  DATA "After you have typed:"
6370  DATA ".sp"
6380  DATA "   run ~notesand.bas~"
6390  DATA "       and pressed the 'enter' key,"
6400  DATA ".sp"
6410  DATA "you will see a Title Screen, and a"
6420  DATA "message to:
6430  DATA ".sp"
6440  DATA "  ~Press any key to continue.~"
6450  DATA ".sp"
6460  DATA "After pressing any key, you will see"
6470  DATA "a screen showing how four data files"
6480  DATA "are being prepared for your use."
6490  DATA ".sp"
6500  DATA "Next, you will see a menu, listing the"
6510  DATA "functions of Notes and Sources ON"
6520  DATA "DISPLAY, and asking you to type the num-"
6530  DATA "ber of one of the functions, and then to"
6540  DATA "press the 'enter' key."
6550  DATA ".sp"
6560  DATA "You may then select the function that"
6570  DATA "you desire."
6580  DATA ".pa"
6590  DATA ".h3 Create (Format) a Notes File"
6600  DATA "Usually, you will only select Function 1"
6610  DATA "once (in your lifetime).  This function"
6620  DATA "completely erases any Note file that"
6630  DATA "currently exists.  Then it creates a"
6640  DATA "new Note file, by writing 100 new, empty"
6650  DATA "records, with numbers where numbers"
6660  DATA "should be, and letters where letters"
6670  DATA "should be."
6680  DATA ".sp"
6690  DATA "After selecting Function 1, you are"
6700  DATA "given a second chance.  If you really"
6710  DATA "want to destroy an old file, and start"
6720  DATA "a new one, you may do so."
6730  DATA ".sp"
6740  DATA "  Type: y"
6750  DATA "        and press the 'enter' key."
6760  DATA ".sp"
6770  DATA "If this is really what you want to do,"
6780  DATA "the program will then KILL the old file,"
6790  DATA "and write 100 new records."
6800  DATA ".pa"
6810  DATA ".h3 Extend the Notes File"
6820  DATA "You may extend your Notes file at any"
6830  DATA "time, by selecting Function 2 from the"
6840  DATA "Menu."
6850  DATA ".sp"
6860  DATA "  Type: 2"
6870  DATA "    and press the 'enter' key."
6880  DATA ".sp"
6890  DATA "It is usually good practice to have only"
6900  DATA "as many empty Note records available as"
6910  DATA "you need at the present time, but not a"
6920  DATA "lot of additional records.  The reason"
6930  DATA "for this is that the program will only"
6940  DATA "search for a record up to the one with"
6950  DATA "the highest record number that has been"
6960  DATA "used, and never for one which has never"
6970  DATA "been formatted."
6980  DATA ".sp"
6990  DATA "After selecting Function 2, the program"
7000  DATA "formats an additional 100 records, and"
7010  DATA "returns to the Menu."
7020  DATA ".pa"
7030  DATA ".h3 Personalize the Sources"
7040  DATA "By selecting Function 3 from the Menu,"
7050  DATA "the user is able to enter or to change"
7060  DATA "the definitions of the Sources.  He is"
7070  DATA "able to do this at any time that the"
7080  DATA "Menu is shown."
7090  DATA ".sp"
7100  DATA "You will probably do this once when you"
7110  DATA "first start to use Notes and Sources ON"
7120  DATA "DISPLAY.  You may also do this to extend"
7130  DATA "your definitions at some later time."
7140  DATA "However, you should not rearrange this"
7150  DATA "list once you have entered Note records,"
7160  DATA "since doing so changes the content of"
7170  DATA "those Note records, as well."
7180  DATA ".h3 Personalize the Types"
7190  DATA "By selecting Function 4 from the Menu,"
7200  DATA "the user is able to enter or to change"
7210  DATA "the definitions of the Types.  He is"
7220  DATA "able to do this at any time that the"
7230  DATA "Menu is shown."
7240  DATA ".sp"
7250  DATA "You will probably do this once when you"
7260  DATA "first start to use Notes and Sources ON"
7270  DATA "DISPLAY.  You may also do this to extend"
7280  DATA "your definitions at some later time."
7290  DATA "However, you should not rearrange this"
7300  DATA "list once you have entered Note records,"
7310  DATA "since doing so changes the content of"
7320  DATA "those Note records, as well."
7330  DATA ".pa"
7340  DATA ".h3 Data Entry of Notes"
7350  DATA "By selecting Function 5, the user is"
7360  DATA "able to enter his Genealogical Notes."
7370  DATA ".sp"
7380  DATA "If you know the number of the Note that"
7390  DATA "you want to enter or change, you may"
7400  DATA "choose that Note record by typing its"
7410  DATA "number, and pressing the 'enter' key."
7420  DATA ".sp"
7430  DATA "If it is a new note, and you want the"
7440  DATA "program to find an empty Note record to"
7450  DATA "use, you may type a Question-mark, and"
7460  DATA "press the 'enter' key.  The program will"
7470  DATA "then search until it finds an empty Note"
7480  DATA "Record (or until it reaches the top of"
7490  DATA "those formatted).  It will then display"
7500  DATA "the contents of the Note, and ask you"
7510  DATA "to enter its Note number."
7520  DATA ".sp"
7530  DATA "At this point you should enter the Note"
7540  DATA "number (which will presently be shown"
7550  DATA "at the top of the screen, on the right,"
7560  DATA "but will have a minus-sign in front of"
7570  DATA "it).  Entering this number without the"
7580  DATA "minus-sign, makes it a real Note, not"
7590  DATA "just one that is unused."
7600  DATA ".sp"
7610  DATA "You should then follow the instructions"
7620  DATA "at the bottom of the screen, which will"
7630  DATA "lead you through the process of enter-"
7640  DATA "ing all of the information in the Note."
7650  DATA ".pa"
7660  DATA "You may use (\ enter) to see the next"
7670  DATA "12 Descriptions in any list, and do"
7680  DATA "it over and over again, if necessary,"
7690  DATA "until you find the one that you want."
7700  DATA ".sp"
7710  DATA "When you are through with your entry,"
7720  DATA "you may then s (save) the Note, if you"
7730  DATA "want to, or you may f (forget) it.  You"
7740  DATA "may also re-do part of it, by request-"
7750  DATA "ing m (more), which will take you back"
7760  DATA "to the top of the screen, so that you"
7770  DATA "may change any information within the"
7780  DATA "Note."
7790  DATA ".pa"
7800  DATA ".h3 Inquiry into Notes"
7810  DATA "By selecting Function 6, you are able"
7820  DATA "to make inquiries into your Notes, and"
7830  DATA "have the results of those inquiries"
7840  DATA "either displayed on your display screen,"
7850  DATA "or printed on your printer."
7860  DATA ".sp"
7870  DATA "First of all, you will be requested to"
7880  DATA "choose between showing a (all) of your"
7890  DATA "notes, or just s (some) of them.  Most"
7900  DATA "of the time you will want to just look"
7910  DATA "at some of them."
7920  DATA ".sp"
7930  DATA "If you have selected s (some) records,"
7940  DATA "you can then be presented with a list"
7950  DATA "of the first 12 persons from your"
7960  DATA "Genealogy ON DISPLAY Persons File,"
7970  DATA "through the use of '\ enter', and be"
7980  DATA "asked to choose one of them.  If the"
7990  DATA "person is not shown, you may use the"
8000  DATA "'\ enter' to see the next 12 persons."
8010  DATA "You may continue to go through the"
8020  DATA "names in your Persons File, until you"
8030  DATA "find the person that you want.  (If"
8040  DATA "you already know the number assigned"
8050  DATA "to the Person, you may enter it, with-"
8060  DATA "out scrolling through your Persons"
8070  DATA "File.)"
8080  DATA ".sp"
8090  DATA "You may also choose (all) of the per-"
8100  DATA "sons from your Persons file, by just"
8110  DATA "pressing the 'enter' key."
8120  DATA ".pa"
8130  DATA "After choosing one Person, or all of the"
8140  DATA "persons from your Persons file, you will"
8150  DATA "then be asked to select from your per-"
8160  DATA "sonalized list of Sources.  If you al-"
8170  DATA "ready know the number of the Source, you"
8180  DATA "may enter it without looking for it in"
8190  DATA "the list."
8200  DATA ".sp"
8210  DATA "You may use (\ enter) to see the next 12"
8220  DATA "Descriptions in your list, and do it"
8230  DATA "over and over again, if necessary, until"
8240  DATA "you find the one that you want."
8250  DATA ".sp"
8260  DATA "You may choose to enter the number of"
8270  DATA "the Source.  You may also choose (all)"
8280  DATA "sources by just pressing the 'enter'"
8290  DATA "key."
8300  DATA ".sp"
8310  DATA "After choosing one Source, or all of the"
8320  DATA "sources from your list of Sources, you"
8330  DATA "will then be asked to select from your"
8340  DATA "personalized list of Types.  If you"
8350  DATA "already know the number of the Type, you"
8360  DATA "may enter it without looking for it in"
8370  DATA "the list."
8380  DATA ".sp"
8390  DATA "You may use (\ enter) to see the next 12"
8400  DATA "Descriptions in your list, and do it"
8410  DATA "over and over again, if necessary, until"
8420  DATA "you find the one that you want."
8430  DATA ".sp"
8440  DATA "You may choose to enter the number of"
8450  DATA "the Type.  You may also choose (all)"
8460  DATA "types by just pressing the 'enter'"
8470  DATA "key."
8480  DATA ".pa"
8490  DATA "After you have made all of the selec-"
8500  DATA "tions, you are presented with four"
8510  DATA "choices.  You may d (display) the"
8520  DATA "results of your inquiry.  You may"
8530  DATA "p (print) the results of your inquiry."
8540  DATA "You may do m (more), meaning that you"
8550  DATA "want to re-form your inquiry.  Or,"
8560  DATA "finally, you may f (forget) the in-"
8570  DATA "quiry altogether."
8580  DATA ".sp"
8590  DATA "If you request printing, the results of"
8600  DATA "the inquiry will be printed on your"
8610  DATA "printer, eight records to a page.  If"
8620  DATA "you request display, the results of"
8630  DATA "the inquiry will be displayed on your"
8640  DATA "screen, three records to a screen."
8650  DATA ".sp"
8660  DATA "Doing more takes you back to the start"
8670  DATA "of the inquiry.  Forgetting takes you"
8680  DATA "back to the menu."
8690  DATA ".pa"
8700  DATA ".h2 HOW TO STOP."
8710  DATA "The user may stop at any time, by"
8720  DATA "pressing (and holding down) the Function"
8730  DATA "(FN) key, and then pressing the Break"
8740  DATA "(B) key on the PCjr."
8750  DATA ".sp"
8760  DATA "The user may stop at any time, by"
8770  DATA "pressing (and holding down) the control"
8780  DATA "(Ctrl) key, and then pressing the Break"
8790  DATA "key on the PC, the PC/XT, or the PC/AT."
8800  DATA ".h3 Stopping From the Menu."
8810  DATA "Whenever the Menu is shown, the program"
8820  DATA "can be ended by selecting Function"
8830  DATA "Number 0."
8840  DATA ".sp"
8850  DATA "Type:  0"
8860  DATA "       and press the 'enter' key."
8870  DATA ".pa"
8880  DATA ".h3 Stopping Personalization."
8890  DATA "Whenever the user is requested to enter"
8900  DATA "a description, he is also given the"
8910  DATA "choice of typing a (/ enter), to end"
8920  DATA "his descriptions.  At this point,"
8930  DATA ".sp"
8940  DATA "Type:  /"
8950  DATA "       and press the 'enter key."
8960  DATA ".sp"
8970  DATA "This completes the definitions, and the"
8980  DATA "user is requested to indicate whether"
8990  DATA "he wants the new definitions saved, or"
9000  DATA "whether they should be forgotten.  At"
9010  DATA "this point, either:"
9020  DATA ".sp"
9030  DATA "Type:  s"
9040  DATA "       and press the 'enter' key, or"
9050  DATA ".sp"
9060  DATA "Type:  f"
9070  DATA "       and press the 'enter key."
9080  DATA ".pa"
9090  DATA ".h3 Stopping Data Entry."
9100  DATA "Whenever the user is requested to choose"
9110  DATA "from one of the lists, he is also given"
9120  DATA "the choice of typing '/ enter', to end"
9130  DATA "his data entry.  At this point,"
9140  DATA ".sp"
9150  DATA "Type:  /"
9160  DATA "and press the 'enter' key."
9170  DATA ".sp"
9180  DATA "This completes the data entry, and the"
9190  DATA "user is requested to indicate whether"
9200  DATA "he wants the new Note to be saved, or"
9210  DATA "whether it should be forgotten.  At this"
9220  DATA "point, either:"
9230  DATA ".sp"
9240  DATA "Type:  s"
9250  DATA "       and press the 'enter' key, or"
9260  DATA ".sp"
9270  DATA "Type:  f"
9280  DATA "       and press the 'enter' key."
9290  DATA ".sp"
9300  DATA "This returns the user to the screen"
9310  DATA "where he is requested to enter the"
9320  DATA "number of the Note to be used for data"
9330  DATA "entry or update.  At this point,"
9340  DATA ".sp"
9350  DATA "Type:  0"
9360  DATA "       and press the 'enter' key."
9370  DATA ".sp"
9380  DATA "This returns the user to the menu, where"
9390  DATA "he may select function 0, and press the"
9400  DATA "'enter' key, to end the program."
9410  DATA ".pa"
9420  DATA ".h3 Stopping Inquiry."
9430  DATA "The user may stop during an inqiry, by"
9440  DATA "first completing the selection of a"
9450  DATA "person, a source, and a type (or all,"
9460  DATA "for any of these).  Selecting (all), by"
9470  DATA "pressing the 'enter' key is probably"
9480  DATA "the simplest way."
9490  DATA ".sp"
9500  DATA "After each has been selected, the user"
9510  DATA "is presented with a choice of what he"
9520  DATA "wants to do next.  By selecting to"
9530  DATA "f (forget), the program returns to the"
9540  DATA "menu.  He can then select function 0,"
9550  DATA "and press the 'enter' key, to end the"
9560  DATA "program."
9570  DATA ".sp"
9580  DATA "If the inquiry has been completed, and"
9590  DATA "the results of the inquiry are being"
9600  DATA "displayed or printed, the user may"
9610  DATA "press the Esc (escape) key.  This will"
9620  DATA "cause the inquiry to stop after com-"
9630  DATA "pletion of the output of the next"
9640  DATA "record which meets the requirements"
9650  DATA "specified in the inquiry."
9660  DATA ".sp"
9670  DATA "The user will receive a message which"
9680  DATA "shows that the search is complete, and"
9690  DATA "be asked to press any key to continue."
9700  DATA "He should do so."
9710  DATA ".sp"
9720  DATA "The user will then see the summary of"
9730  DATA "the records which met the criteria of"
9740  DATA "the inquiry, and again, be asked to"
9750  DATA "press any key to continue.  He should"
9760  DATA "do so."
9770  DATA ".pa"
9780  DATA "The Menu is then displayed, and the"
9790  DATA "user may end the program by selecting"
9800  DATA "function 0, and pressing the 'enter"
9810  DATA "key."
9820  DATA ".pa"
9830  DATA "(This page is intentionally blank.)"
9840  DATA ".eof"
9850  END
