

       LIMITED WARRANTY

       These programs are provided "as is" without warranty
       of any kind, either expressed or implied, including,
       but not limited to the implied warranties of
       merchantability and fitness for a particular purpose.
       The entire risk as to the quality and performance of
       the program is with you.  Should the program prove
       defective, you (and not FAB Software or its dealers)
       assume the entire cost of all necessary servicing,
       repair or correction.

       In no event will the FAB Software be liable to you for
       any damages, including any lost profits, lost savings
       or other incidental or consequential damages arising
       out of the use of or inability to use these programs,
       even if the FAB Software has been advised of the
       possibility of such damages, or for any claim by any
       other party.

       COPYRIGHT

       Copyright (C) 1984, 1985, 1986, 1987 by Frank A. Bell.
       All rights reserved.

       This software is protected by both United States
       Copyright Law and international treaty provisions.
       Therefore you must treat this software just like a
       book with the following exception.  FAB Software
       authorizes you to make archival copies of the software
       for the sole purpose of backing-up your software and
       protecting your investment from loss.

       By saying, "just like a book", FAB Software means that
       this software may be used by any number of people and
       may be freely moved from one computer location to
       another, so long as there is No Possibility of it
       being used at one location while it's being used at
       another.  Just as a book which can't be read by two
       different people in two different places at the same
       time, neither can the software be used by two
       different people in two different places at the same
       time.

       There is a special full-power evaluation version of
       Newkey which may be copied subject to the restrictions
       listed in "Restricted Permission to Copy".










                              NEWKEY

                      A Keyboard Enhancer for
                     The IBM Personal Computer

                            Version 4.0
















                                          FAB Software
                                          P.O. Box 336
                                          Wayland, MA 01778


                                                             i

                         TABLE OF CONTENTS


       1 - NEWKEY INTRODUCTION                              1
          1.1 Purpose and Terminology                       1
          1.2 Installation Tips                             2
          1.3 Guided Tour                                   2

       2 - GETTING STARTED                                  3
          2.1  Loading Newkey                               3
            2.1.1  Buffer Size                              3
            2.1.2  Newkey Load Order                        4
          2.2  Defining a Macro                             4
          2.3  Macro Definition Status Line                 6
          2.4  Space Considerations                         6
          2.5  Error Correction                             7
          2.6  Pop-up Access to Newkey's Features           7
          2.7  Menu Access to Macro Definition Commands     7

       3 - MACRO FUNCTIONS                                  8
          3.1  Variable Length Fill-in-the-Blanks           8
            3.1.1  Ending a Variable Pause Without
               Actually Typing the Pause End key            9
          3.2  Fixed Length Fill-in-the-Blanks              9
          3.3  Playback Bypass                             10
          3.4  Time Delay (1/2 sec)                        11
          3.5  Date/Time Function                          12
          3.6  Clear Screen                                13
          3.7  Screen off/on                               13
          3.8  Beep                                        13

       4 - CONTROLLING MACRO EXECUTION                     14
          4.1  Switching Newkey Off/On                     14
          4.2  Playback Bypass                             14
          4.3  Inactivated Macros                          14
          4.4  Cancel Newkey Processing                    15
          4.5  Unload and Reclaim Memory                   15
          4.6  Slow Typing Mode                            15
            4.6.1  Setting Slow Typing Speed               16
            4.6.2  Slow Typing On/off During Playback      16
          4.7  Single Step Macro Playback                  16
          4.8  Disk Wait During Macro Playback             17



       ii

       5 - EDITING MACROS                                  18
          5.1  Display Directory and Descriptions          18
          5.2  Display Directory                           18
          5.3  Displaying a Macro                          18
          5.4  Editing a Macro                             19
            5.4.1  Inserting Macro Functions               19
            5.4.2  Escaping Editor Command Key Processing  20
            5.4.3  Copying/Moving a Macro                  20
            5.4.4  Copying the Keyboard Buffer             20
          5.5  Deleting a Macro                            20
          5.6  Editing Using a Text Editor                 21

       6 - ADVANCED MACRO FEATURES                         22
          6.1  Defining a Multi-Character Macro            22
          6.2  Playing back a Multi-Character Macro        22
          6.3  Shorthand Mode                              23
            6.3.1  Capitals in Shorthand Mode              24
            6.3.2  Controlling Shorthand Mode              24
            6.3.4  Shorthand Mode Restrictions             25
          6.4  Nested Macro playback                       26
            6.4.1  Recursion                               26
          6.5  Defining Macros From Within Macros          27
          6.6  Macro May Call Itself                       28
          6.7  Invoking Newkey From its Own Macros         29
            6.7.1  Turning Newkey Parameters On/off
               Through Macros                              29
            6.7.2  Scope of Macro Definition and Playback  30
          6.8  Cut and Paste                               31
            6.8.1  Cutting                                 31
            6.8.2  Pasting                                 31

       7 - KEYBOARD AND SCREEN CONTROL FEATURES            33
          7.1  Screen Saver Mode                           33
            7.1.1  Blank Delay Time                        33
            7.1.2  Blank By Saving Screen                  33
            7.1.3  Video I/O Restore Screen                34
          7.2  Extended Keyboard Buffer                    35
          7.3  Fast Key Parameters                         35
            7.3.1  Fast Key Delay                          35
            7.3.2  Fast Key Rate                           36
            7.3.3  AT Keyboard Parameters (IBM AT only)    36
          7.4  Keyboard Click                              36
          7.5  Cap/Num Lock Indicators                     36



                                                           iii

       8 - CUSTOMIZING NEWKEY                              37
          8.1  Display/Update Control Keys                 37
          8.2  Display/Update Newkey Parameters            38
            8.2.1 Making Absolute Parameter Changes On/Off 38
          8.3  Black and White Mode                        39
          8.4  Customizing Macro Definition Messages       39
            8.4.1  Macro Already Defined Warning Switch    39
            8.4.2  Defining Alpha Character Warning Switch 40
            8.4.3  Enter Description Request Switch        40
            8.4.4  Status Line Position                    40
          8.5  Preventing Key Creation                     41
          8.6  Customizing Newkey's Colors                 42

       9 - LOADING, SAVING & CLEARING MACROS               43
          9.1  Save File                                   43
          9.2  Load File                                   43
          9.3  Merge File                                  44
          9.4  Clear Current Macros                        44
          9.5  Guarded Macros                              45

       10 - NEWKEYSP OVERVIEW                              46
          10.1  Invoking Newkeysp                          46
          10.2  Execute Multiple Newkeysp Commands         46
          10.3  Newkeysp batch commands                    47
          10.4  Executing Macros From a Batch File         47

       11 - NOTES ON KEYS SUPPORTED                        48
          11.1  Enhanced Keyboard                          48
          11.2  Synonyms - Different Keys, Same Ascii
            Codes                                          48
          11.3  Generating Extended Ascii Codes            49

       12 - TIPS ON USING NEWKEY                           50
          12.1  Use Your Autoexec.bat File                 50
          12.2  Setting the Macro Buffer Size Parameter    50
          12.3  Do Not Forget to Save Your Macros          51
          12.4  Combining Macro Files                      51
          12.5  Multiple Macro Files                       51

       13 - COMMON PROBLEMS WITH NEWKEY                    52
          13.1  Keys That Used to Work No Longer Work      52
          13.2  Other Memory-resident programs hang        52
          13.3  Monitor Does Not Clearly Display Newkey
            Menus                                          52
          13.4  Screen Does Not Blank                      52

       iv

          13.5  Cannot Restore Blanked Screen              53
          13.6  Newkey Does Not Work Right With Certain
            Programs                                       53
          13.7  Cannot Access Extended Ascii (upper 128)
            codes                                          54
          13.8  Losing Part of Macro Definition            54
          13.9  Limited Memory Considerations              54
          13.10 Computer Hangs up and Must be Rebooted     54

       14 - FILES SUPPLIED WITH NEWKEY                     55
          14.1  Sample Macro Files                         55
          14.2  Files on the Newkey Disk                   56

       15 - TECHNICAL OVERVIEW                             58
          15.1  Newkey Requirements                        58
          15.2  How Does Newkey Work?                      58
          15.3  Newkey's Limitations                       58
          15.4  Hardware Compatibility                     59
          15.5  IBM's Enhanced Keyboard                    59
          15.6  Hercules Graphics boards                   59
          15.7  Graphics Modes                             60
          15.8  Software Compatibility                     60
          15.9  Shift Status Reset                         62

       16 - MISCELLANEOUS                                  63
          16.1 Support                                     63
          16.2 Reporting Newkey Bugs                       63
          16.3 FAB Software                                64
          16.4 Restricted Permission to Copy               65
            16.4.1 What May be Copied                      65
            16.4.2 Rules For Copying Evaluation Version    66
          16.5 Price List and Order Form                   67
          16.6 The User-Supported Concept                  67

       APPENDIX A - KEYS SUPPORTED                         68

       APPENDIX B - EXTENDED CODES, ADDITIONAL KEYS        72

       APPENDIX C - SYNONYMS                               75

       APPENDIX D - SUMMARY OF CHANGES                     76


                                                             1

                  CHAPTER 1 - NEWKEY INTRODUCTION


       1.1 Purpose and Terminology

       The Newkey keyboard enhancer simplifies the entry of
       common keystroke sequences by allowing these sequences
       to be assigned to any key desired.  Once assigned to a
       particular key, whenever that key is struck the
       predefined sequence of keystrokes will be substituted
       for the struck key.

       For example, the <altc> key might be defined as "copy"
       and whenever <altc> is struck the string "copy" will
       be substituted for it.  The process of assigning a
       sequence of keystrokes to another key is called "macro
       definition".  The process of substituting the
       Newkey-assigned sequence for a key that is actually
       struck is called "playback".

       When we refer to specific keystrokes, such as <altc>
       in the above example, the keystroke name will be
       enclosed in a "<" and a ">".  The keystroke name will
       be made up of an optional prefix (alt, caps, ctrl, or
       num) plus the a key's name.  To enter <altc> for
       example, press the "alt" key and then while continuing
       to hold the alt key down, press the "c" key.

       Newkey allows customization of software packages,
       ready creation of boiler plate passages, keyboard
       redefinition, and other useful purposes.  Several
       sample key files are included with Newkey and are
       described in section 14.1, "Sample Macro Files".

       Newkey provides many features including:

       -  Ability to define almost any key
       -  Shorthand mode
       -  Fixed and variable length pauses during playback
       -  Nested macro playback
       -  Multi-character macro names
       -  Macro descriptions/titles
       -  Cut & Paste
       -  Extended keyboard buffer
       -  Ability to custom tailor most Newkey features

       2

       -  Screen saver feature
       -  Slow typing mode and many more
       -  Saving macros on disk from memory
       -  Loading macros from disk to memory
       -  Merging macros from disk to memory
       -  Display and edit macros
       -  Easy modification of control keys
       -  Many more features too numerous to list

       Newkeysp, the Newkey Support Program, provides many
       functions to complement Newkey, including:

       -  Execute macros from batch files
       -  Execute Newkey functions from batch files
       -  Set Newkey menu colors


       1.2 Installation Tips

       - First make a copy of the Newkey disk and put away
       the supplied disk as a backup.

       - Next read the "readme" file.  This file will contain
       the latest Newkey information which has come up since
       this manual was printed.

       -  Users of earlier versions should consult the
       "Summary of Changes" in appendix D for important
       conversion information.

       - Hard disk users will want to put the "newkey.exe"
       and "newkeysp.exe" programs in a directory which is
       specified in their "path" command so that they are
       readily accessible from all of their sub-directories.
       Floppy disk users will want both of these programs on
       their application disks so that they will be readily
       accessible without switching disks.


       1.3 Guided Tour

       A guided tour comes with Newkey and may be invoked by
       issuing the command "demo" while the Newkey disk is in
       the default disk drive.  This tour illustrates many of
       Newkey's major features and requires 192k of memory.

                                                             3

                    CHAPTER 2 - GETTING STARTED


       2.1  Loading Newkey

       To load Newkey, type

               newkey [/buffer size]

       and press the <enter> key.  Within a second or two a
       short message will be displayed with the line

               Newkey loaded

       at the bottom.

       When you receive this message, Newkey is loaded and
       ready to use.  You may wish to load a predefined set
       of macros.  To do this, refer to section 9.2, "Load
       File", for more information.


       2.1.1  Buffer Size

       Newkey comes with a default macro buffer size which
       will accept up to 1000 characters of macro
       definitions.  This default may be changed at run time
       by specifying the parameter "/xxxxx" when first
       invoking Newkey where "xxxxx" is up to a 5 digit
       number specifying the number of characters which
       Newkey will reserve for the macro buffer.  Newkey will
       reserve twice this number of bytes in memory (each
       character requires two bytes).

       For example:

           newkey /1000

       will reserve enough space for 1000 characters of
       playback (2000 bytes of storage.)

       The legal range for this number is 5 - 32000.


       4

       2.1.2  Newkey Load Order

       The number of programs interacting with the operating
       system is growing every day.  Many of these programs
       make themselves resident and latch on to the same
       interrupts Newkey uses.  Version 4.0 has been written
       to provide the maximum possible compatibility with
       these programs.

       Generally speaking, it is impossible to make any hard
       and fast rules about the order in which your
       memory-resident programs should be loaded.  Some
       programs require Newkey to be loaded before they are
       loaded, some after.  For further information refer to
       section 15.8, "Software Compatibility".

       2.2  Defining a Macro

       To define a macro follow these steps:

       1.  Press the <alt=> key.

       A window will open up looking like this:

         Defining key =
         Press enter to define a multi-character macro
                Press ESC to exit


       2.  Press the key you wish to define.

       Let's assume that you are defining <altc> to be
       "copy".  Press <altc> and it will be displayed in the
       window.


         Defining key = <altc>
         Description  = Start copying
                 Press ESC to exit


       3.  Now you will be asked to enter a description.

       This field allows you to create a short description of
       what the macro does.  When you are finished entering

                                                             5

       the description press <enter>.  In the above example,
       "Start copying" is the description that has been
       entered.

       At this point the following 4 things will happen:

       - The window will close
       - A status line will be displayed at the top of your
           screen
       - The cursor will take on a block shape
       - A beep will sound each time you press a key

       As long as you are in macro definition mode, the
       status line will be displayed, the cursor will retain
       some sort of block shape, and each keystroke will
       cause a beep.

       4.  Now enter the keystrokes you want the macro to
       represent ("copy " in our example.)

       The system will continue to act on these keystrokes as
       if macro definition was not occurring.  This enables
       you to monitor the macro definition to ensure that you
       are actually creating a macro that will do what you
       wish.

       6.  When you have finished defining the macro press
       the <alt-> key.

       The status line will disappear, the cursor will take
       on its normal shape, and your macro definition is
       finished.

       Now press <altc> and watch "copy" be played back.
       Unless saved in a disk file, the new macro will be
       lost when the system is rebooted.  For more
       information on saving macros, refer to section 9.1,
       "Save file".

       Macros may also be created or modified by using
       Newkey's macro editor or with your word processor or
       text editor on a saved macro file.

       Most of the macro definition messages and other aids
       described this chapter as well as others can be

       6

       customized to suit your preferences.  If you do not
       need these aids or protections you can eliminate them
       and the additional keystrokes they require.  These
       options are described in section 8.4, "Customizing
       Macro Definition Messages".

       2.3  Macro Definition Status Line

       Newkey will display a status line during macro
       definition.  This status line will display in reverse
       video the key being defined, the current defining
       mode, and which keys to press to end or cancel macro
       definition.  Possible defining modes are:

          TEXT = text mode
          FIX  = fixed length pause
          VAR  = variable length pause

       2.4  Space Considerations

       Newkey comes with enough macro space for 1000
       characters.  If new macro definitions total more than
       1000 characters in a session, Newkey will display this
       message in reverse video

        *OUT OF MEMORY FOR DYNAMIC DEFINING - PRESS
                      ESC TO CONTINUE*

       If you receive this message, all further new macro
       definition will be halted, including the one you are
       currently creating.  At this point there are two ways
       to get more macro definition space:

       Method 1

       1. Save the current macros (section 9.1)
       2. Unload Newkey (section 4.5).
       3. Reload Newkey increasing the size of the macro
       buffer (section 2.1.1).
       4. Reload the saved macros (section 9.2).

       Method 2

       Delete some unused or unnecessary macros (section 5.5,
       "Deleting a Macro").

                                                             7

       2.5  Error Correction

       During macro definition, Newkey treats the <ctrlh> key
       as a back space and delete.  This allows you to
       correct a mistake during macro definition without the
       correction becoming part of the macro.

       2.6  Pop-up Access to Newkey's Features

       Most of Newkey's features may be invoked at any time
       without leaving your current program by pressing
       <ctrl/>.  Newkey will save your current screen,
       present you with a menu of options, and when you are
       done, restore your screen just where you left off.

       This feature is not available in the small version of
       Newkey, Newkeysm.exe, resulting in a savings of 26K in
       memory.

       2.7  Menu Access to Macro Definition Commands

       This option allows you another method of executing the
       macro commands described later besides pressing the
       appropriate control key.  If you don't remember what
       key does what, instead of looking it up just call up
       the pop-up menu and select the "Display/execute macro
       definition commands" option.

       A menu will be displayed listing all of your possible
       options.  Only those which are highlighted may be
       selected.  Those which are highlighted will depend on
       several factors, such as whether you are in macro
       definition mode or not.


       8

                    CHAPTER 3 - MACRO FUNCTIONS


       This chapter describes the special purpose functions
       which can be invoked by Newkey's macros.  These
       include the useful fill-in-the-blanks functions and
       powerful date/time functions.

       3.1  Variable Length Fill-in-the-Blanks

       Newkey provides you with the ability to define
       variable length fill-in-the-blanks fields within
       macros.  When one of these is encountered during
       playback, Newkey will stop playback and wait for the
       user to enter any keystrokes he wishes.  Newkey will
       continue to accept keystrokes until the <enter> key is
       pressed, when normal playback will continue.  To
       define a variable length fill-in-the-blanks field
       follow these steps:

          1.  Press <ctrl[>.  The cursor will change from a
          full block to half block with its bottom missing
          and the mode in the status line will change from
          "TEXT" to "VAR".

          2.  Enter whatever keystrokes you wish.

          3.  Press <ctrl[>.  The cursor will change back to
          a full block and the mode in the status line will
          change from "VAR" to "TEXT".

       For example, suppose you frequently started a letter
       with "My dear John (Frank, Susan, etc.) it is now
       time", you might wish to define one macro to mean "My
       dear xxxxxx it is now time".  To do this you would
       follow these steps:

          1.  Press <alt=> to start macro definition.
          2.  Press <altl>, the key you wish to define.
          3.  Press <enter> to bypass the description.
          4.  Type "My dear ".
          5.  Press <ctrl[> to start variable length field.
          6.  Type in any name, although it is not
          necessary to the definition.
          7.  Press <ctrl[> to end variable length field.

                                                             9

          8.  Type in " it is now time".
          9.  Press <alt-> to end macro definition.

       Now if you were to press <altl>, "My dear " would be
       displayed and the system would wait for you to enter a
       name.  Once you had entered a name and pressed the
       <enter> key, the system would continue with " now is
       the time".

       3.1.1  Ending a Variable Pause Without Actually Typing
       the Pause End key

       Variable length pauses will end automatically if the
       last key in a macro is the pause end key (<enter>) and
       that macro is invoked during the variable length
       pause.  For example:

         <altf> is defined as "xxx<vfld>end"

         <altg> is defined as "yyyy<enter>"

       if you were to press <altf>, "xxx" would be returned,
       Newkey would enter the variable pause and wait for you
       to enter text.  If you now pressed <altg>, "yyyy"
       would be returned and since <enter> is the last key in
       the macro, Newkey will end the variable length pause
       in <altf> and return "end".

       Try it out.  Define <alth> as "yyyy" and repeat using
       it instead of <altg>.  This option can save you many
       keystrokes in certain applications.

       3.2  Fixed Length Fill-in-the-Blanks

       Newkey provides you with the ability to define fixed
       length fill-in-the-blanks fields within macros.  When
       one of these is encountered in a macro, Newkey will
       stop playback and wait for the user to enter a
       predefined number of keystrokes.  Newkey will accept
       keystrokes until the predefined number is reached,
       when normal playback will continue.  To define a fixed
       length fill-in-the-blanks field follow these steps:

          1.  Press <ctrl]>.  The cursor will change from a
          full block to half block with its top missing and

       10

          the status line mode will change from "TEXT" to
          "FIX".

          2.  Enter whatever keystrokes you wish.

          3.  Press <ctrl]>.  The cursor will change back to
          a full block and the status line mode will change
          from "FIX" to "TEXT".

       For example, suppose you frequently started a letter
       with "Enclosed are the xx (some number) items per your
       request", you might wish to define one macro to mean
       "Enclosed are the xx items per your request".  To do
       this you would follow these steps:

          1.  Press <alt=> to start macro definition.
          2.  Press <altl>, the key you wish to define.
          3.  Press <enter> to skip the description.
          4.  Type "Enclosed are the ".
          5.  Press <ctrl]> to start fixed length field.
          6.  Type in any two characters.
          7.  Press <ctrl]> to end fixed length field.
          8.  Type in " items per your request".
          9.  Press <alt-> to end macro definition.

       Now if you were to press <altl>, "Enclosed are the "
       would be displayed and the system would wait for you
       to enter any two characters.  Once you had entered the
       second character, the system would continue with "
       items per your request".

       3.3  Playback Bypass

       Newkey provides the ability to prevent further
       playback within a macro.  This is similar to turning
       Newkey off for just one keystroke.  To invoke playback
       bypass follow these steps:

          1.  Before entering the key, press <ctrl2>.

          2.  Press the key you wish to always be returned.

       When Newkey encounters this key at this spot within
       the macro, it will return the key without further
       playback, even if the key is defined in the macro

                                                            11

       file.  For example, suppose you wish to define the key
       <altk> to be "<ctrlk><ctrld>", but <ctrlk> is already
       defined as "<ctrlj><ctrlq>".  Follow these steps:

          1.  Press <alt=> to start macro definition.
          2.  Press <altk>, the key you wish to define.
          3.  Press <enter> to skip the description.
          4.  Press <ctrl2> to signal that the next key is
          not to be translated.
          5.  Press <ctrlk>, the key you wish to be returned.
          6.  Press <ctrld>.
          7.  Press <alt-> to end macro definition.

       Now when you press <altk>, <ctrlk>, not "<ctrlj>
       <ctrlq>", plus <ctrld> will be returned.  The playback
       bypass key only affects the next key entered.  To
       prevent playback of more than one key, it is necessary
       to press the playback bypass key before entering each
       of them.

       3.4  Time Delay (1/2 sec)

       Macro playback may be delayed for 1/2 second by
       pressing <ctrl->.  This may be repeated as often as
       necessary in order to incorporate any elapsed time
       delay into your macro.  Newkey will beep each time the
       delay is entered during macro definition.  During
       playback the cursor will become a fat bar in the
       middle of the line.

       Time delays are used when your application program can
       not handle keys returned at Newkey's normal rate.  In
       these cases, it is necessary to give the program some
       breathing room, otherwise it will throw keys away.  It
       can also be used for those situations in which the
       delay was being used to wait for some external event
       to occur (a remote site to respond to your
       communications requests, for example).

       Try it out.  Define <altt> as "time delay starts",
       type a few <ctrl->s, "time delay ends".  Now press
       <altt>.


       12

       3.5  Date/Time Function

       Newkey now allows you to display the date and time
       during macro playback in an almost unlimited number of
       formats.  Using the basic building blocks of the date
       and time functions you can build your own date/time
       template.  These building blocks are:

       Time functions                  Date functions

       hh = hours, twelve hour clock   dd = day
       mm = minutes                    mm = month
       ss = seconds                    yy,yyy,yyyy = year
       tt = hours, 24 hour clock       ddd,mmm = abbrev.
       xx = am,pm                        day/month name
       XX = AM,PM                      dddd,mmmm = full
                                         day/month name

       To create a date or time function during macro
       definition select the "date" or "time" option on the
       "Display/execution macro definition commands" screen.
       You will then be prompted to define your date or time
       template.  Just enter the above building blocks as you
       would like to see them when they are played back.  You
       are not limited to just these building blocks.  Any
       characters found in the date/time function which can
       not be interpreted as one of the building blocks will
       be returned just as they are.  This means that you
       have complete flexibility in creating your own
       date/time function.

       The following examples illustrate some of the more
       popular date/time formats.  For example, assume that
       it is 1:13:03 pm on Sunday, September 11, 1986.

                 Sample Date Functions

       template                what Newkey returns

       mm/dd/yy                5/11/86
       yy/mm/dd                86/5/11
       mm-dd-yy                5-11-86
       mm/dd/yyyy              5/11/1986
       mmmm dd, yyyy           September 11, 1986


                                                            13

       mmm dd, yyyy            Sep 11, 1986
       mmm. dd, yyyy           Sep. 11, 1986
       dddd, mmm dd, yyyy      Sunday, Sep 11, 1986
       ddd, mmm dd, yyyy       Sun, Sep 11, 1986

                 Sample Time Functions

       template                what Newkey returns

       hh:mm:ss                1:13:03
       hh:mm xx                1:13 pm
       hh:mm XX                1:13 PM
       tt:mm:ss                13:13:03

       For further examples load the DATE.KEY macro file.

       3.6  Clear Screen

       Newkey allows you to clear your screen during macro
       playback.  To do this select the "Insert clear screen"
       option on the "Display/execute macro definition
       commands" menu.

       3.7  Screen off/on

       This function will cause your screen to be turned
       off/on in the same way as the screen blanker works.
       To do this select the "Screen off" or "Screen on"
       option on the "Display/execute macro definition
       commands" menu.  To turn the screen back on just press
       any key a couple of times.

       3.8  Beep

       Newkey allows you to beep during macro playback.  To
       do this select the "Insert beep" option on the
       "Display/execute macro definition commands" menu.



       14

              CHAPTER 4 - CONTROLLING MACRO EXECUTION

       Newkey offers many methods of controlling how and when
       macros will be executed.  You can permanently unload
       Newkey or just turn if off for the next keystroke.
       You can slow macro playback to a crawl or let it zip
       along.  These methods and more are discussed below.

       4.1  Switching Newkey Off/On

       Newkey may be deactivated/activated by pressing
       <ctrl6>.  This acts as a toggle switching Newkey from
       one status to another.  When deactivated, Newkey is
       still resident in memory, but will act as if the
       normal keyboard interrupt is in control.

       4.2  Playback Bypass

       Macro playback may be bypassed by pressing <ctrl2>
       followed by the key desired.  This is the same
       procedure used to enter a playback bypass key during
       macro definition described in section 4.2, "Playback
       Bypass".

       4.3  Inactivated Macros

       Sometimes you may wish to turn off a macro for an
       extended period of time.  Rather than continually
       pressing the playback bypass key described in the
       previous section it would be easier to temporarily
       inactivate the key.  Newkey now allows you to do this
       by displaying the key's macro and pressing 'I'.

       Inactivated macros will be marked by a 'I' in the
       status field when displaying the macro directory.  To
       reactivate the macro  follow the same steps, but press
       'A' instead of 'I' when displaying the macro.  Unlike
       guarded macros, inactivated macros will not be saved
       to macro files as inactivated macros.



                                                            15

       4.4  Cancel Newkey Processing

       Newkey processing may be canceled at anytime by
       pressing the cancel key, <ctrlesc>.  This feature will
       immediately cancel macro playback or definition and
       clear the keyboard buffer.  This is especially useful
       for ending macros which call themselves or long macros
       using the slow typing mode or time delays.

       4.5  Unload and Reclaim Memory

       Type in "Newkeysp /u" and press <enter>.  This
       function will unload Newkey completely from the system
       and free up its memory for reuse.  Caution must be
       exercised in using this feature.  If another program
       has been permanently loaded after Newkey, then its
       storage will also be freed.

       This function will not always free up Newkey's storage
       if it is executed from a batch file (unless it is the
       last command).  For some reason DOS will not always
       free the storage, even though it reports that it did.
       If this occurs, try loading and unloading Newkey
       again.  This will sometimes free the old storage as
       well as the new.

       4.6  Slow Typing Mode

       Newkey may be operated in a special slow typing mode.
       This mode is provided because some programs cannot
       handle the fast rate at which Newkey normally returns
       keys, with the result that the keys are discarded.  By
       operating in slow typing mode, you can give these
       programs enough time to complete their tasks before
       being fed the next key.  Macro execution may also be
       delayed by using the time delay function described in
       section 3.4, "Time Delay".

       Newkey comes with slow typing mode turned off, but
       this may be changed by using Newkeysp, through the
       pop-up menus, or from within a macro itself.


       16

       4.6.1  Setting Slow Typing Speed

       You may change the amount of time Newkey will wait
       between keystrokes.  This value divided by 18 gives
       you the number of seconds between each keystroke.
       Legal values are 1 (.05 second) to 255 (14 seconds).
       Newkey comes with this delay value set to 1.  To
       change select "Display/Update Newkey Parameters" on
       the Newkeysp menu or Newkey's pop-up menu.

       4.6.2  Slow Typing On/off During Playback

       Slow typing mode may be turned on/off during macro
       playback.  To do this you must enter the commands when
       you are defining the macro.  During macro definition:

         Press <ctrl3> to turn slow typing on

         Press <ctrl4> to turn slow typing off

       Newkey will beep to let you know that it has accepted
       them.

       Try it out.  Define <alta> as "slow is off", <ctrl3>,
       "slow is on", <ctrl4>, "slow is off again".  Press
       <alta>.  If you do not notice much difference, change
       the delay time to 10 (see section 4.6.1, "Setting Slow
       Typing Speed") and try again.

       4.7  Single Step Macro Playback

       Macro playback may be put in a special single step
       mode in which Newkey will wait for you to press any
       key before returning the next keystroke in your macro
       back to the calling program.  This feature can be very
       useful in debugging a complicated macro.

       Two caveats are in order: first, use of the single
       step features eliminates certain timing problems that
       might be experienced if playback were allowed to occur
       at its normal rate.  So if playback in single step
       mode works correctly, but it doesn't in normal mode
       you are probably encountering a timing problem which
       can be solved by inserting time delays or turning on
       slow typing mode at appropriate spots in your macro.

                                                            17

       For more information on these refer to section 4.6,
       "Slow Typing Mode", and section 3.4, "Time Delay".

       The second caveat is that you may notice that you must
       press a key more than once before your program appears
       to take any action on the first keystroke.  This is
       because some programs (DOS included) will issue a
       second keyboard read before acting on the first
       keystroke.  If this occurs, just keep pressing keys
       until you notice some action taking place.  Usually it
       will not take more than one or two more presses.

       4.8  Disk Wait During Macro Playback

       Newkey will now allow you to delay macro playback
       while a program is accessing your floppy disk drives.
       This is important because some programs will throw
       away keystrokes while your floppy disk drives are
       spinning.  To turn on the disk wait feature select the
       "disk wait" option on the "Display/update Newkey
       parameters"  screen.  You may also turn the disk wait
       option on/off during macro definition by selecting the
       "disk wait on" or "disk wait off" option on the
       "Display/execution macro definition commands".



       18

                    CHAPTER 5 - EDITING MACROS

       You may display and edit macros at any time.

       5.1  Display Directory and Descriptions

       Select the "Display directory and descriptions" option
       on the pop-up menu screen.  A directory of all macros
       that have been defined and one line's worth of their
       associated descriptions will be displayed.  If the
       macro has not been given a description Newkey will
       display part of the macro's translation.

       To see more of a particular macro, just press that
       macro's key to enter Newkey's display key mode.

       5.2  Display Directory

       Select the "Display directory"  option on the pop-up
       screen, or type in "Newkeysp /d" and press <enter>.  a
       directory of all macros that have been defined will be
       displayed.  From this directory you may now display
       the macro by pressing that key.

       5.3  Displaying a Macro

       Select the "Display macro" option on the pop-up
       screen, or type in "Newkeysp /k" and press <enter>.  A
       screen requesting you to enter the key you wish
       translated will be displayed.  If the key has been
       defined to Newkey, its translation will be displayed.
       Refer to appendix A for a description of the macro
       format.

       To see a multi-character macro follow these steps:

       1.  Press any key to enter display key mode.
       2.  Press <enter>.
       3.  Type in the multi-character macro name you wish to
       display and press <enter>.

       To exit use the <esc> key.




                                                            19

       5.4  Editing a Macro

       To edit a macro, display it using one of the methods
       described in the previous sections and then press 'e'
       to enter edit mode.  Editing is always done in insert
       mode.  With the following exceptions your keystrokes
       will be translated into their ascii equivalent:

         Altesc - stop editing.  You will be asked whether
       you want to save your changes.

         Back tab - move 5 keystrokes to the left

         Bksp - delete keystroke at left of cursor position

         Cursor keys - move cursor

         Del - delete keystroke at current cursor position

         F1 - escape editor's command key processing

         F2 - insert one of Newkey's special macro functions
       such as the date or time delay functions, or perform
       one of the following:

              - copy another macro in
              - move another macro in
              - capture the keyboard buffer

         Pgdn - scroll screen down

         Pgup - scroll screen up

         Tab - move 5 keystrokes to the right

       5.4.1  Inserting Macro Functions

       Many of Newkey's macro functions, such as variable
       length fill-in-the-blanks and time delays can be
       entered by pressing the same key as you would during
       macro definition.  For example, to enter a time delay
       during macro definition you would press the <ctrl->
       key.  To enter a time delay during editing just press
       <ctrl-> as well and a <wait> will be inserted.


       20

       For those functions which may only be entered through
       the "Display/execute macro definition commands" menu
       during macro definition press <F2> and select the
       desired function to insert.

       5.4.2  Escaping Editor Command Key Processing

       Sometimes you may want to insert a key that is
       normally treated as a command to the editor.  To do
       this press <F1> followed by the desired key to
       "escape" the editor's command key processing.  For
       example:

       Pressing     Action taken     Pressing  Action taken
       <F1><ctrl->  inserts <ctrl->  <ctrl->   inserts <wait>
       <F1><lft>    inserts <lft>    <lft>     moves cursor
       <F1><F2>     inserts <F2>     <F2>      displays menu
       <F1><F1>     inserts <F1>     <F1>      starts escape

       By pressing <F1> first you are telling the editor not
       to do anything special with the next key, just insert
       it into the macro being edited.

       5.4.3  Copying/Moving a Macro

       Starting editing the target macro and move the cursor
       to the point at which the selected macro is to be
       copied/moved in.  Press F2 to bring up the special
       functions screen.  Select the "copy outside macro" or
       "move outside macro" option.  You will be prompted for
       the macro to be copied/moved.

       5.4.4  Copying the Keyboard Buffer

       Follow the same steps as described in section 5.4.2
       but select the "copy keyboard buffer" option instead.

       5.5  Deleting a Macro

       Macros may be deleted in two ways:

       1. Undefine the macro.

          a. Start the normal macro definition process
          (<alt=>).

                                                            21

          b. Press the key you wish to undefine.
          c. Press <enter> to skip the description
          request.
          d. Press <alt-> to end macro definition.

       2.  Display the macro using the "Display Macro" option
       and press "d" to delete the macro.

       5.6  Editing Using a Text Editor

       You may also edit a saved macro file using a text
       editor or word-processor capable of editing ascii
       files.  This is a slightly more error prone process
       than using Newkey's built-in macro editor, but if you
       follow the following rules you should not have any
       problems.

       1.  All macro definitions must begin with "<begdef>"
       and end with "<enddef>".

       2.  The macro being defined should immediately follow
       the "<begdef>" and should be enclosed in carats ("<
       >").

       3.  All single characters may be placed in the macro
       without the surrounding carats.

       5.  To define a macro within a macro, enter a
       "<begdef>" followed by the key you wish to define.  Do
       not end it with an "<enddef>".

       6.  Descriptions must be in the lines preceding the
       macro's <begdef> and must begin with a "*".  There is
       no limit on a description's length.

       7.  Special Newkey control fields may be entered to
       invoke such functions as beep and clear screen.  See
       the "Special Newkey Control Fields" section in
       Appendix A.

       All non-single character keys may be in upper or lower
       case.  All characters in between macro definitions
       will be ignored.  This allows you to document the
       macro definitions if desired.

       22

                CHAPTER 6 - ADVANCED MACRO FEATURES


       Many of these features are illustrated in the sample
       macro file, TEST.KEY, and the guided tour (see section
       1.3, "Guided Tour").

       6.1  Defining a Multi-Character Macro

       Newkey allows you to define macros with names up to 8
       characters in length.  This allows you to assign
       meaningful names to your macros, names that you will
       remember.  For example, you might have a macro named
       "sales" that will generate your sales report or a
       macro called "address" that will take the address out
       of a letter in your word processor and print it on an
       envelope.

       To define a multi-character macro, follow the same
       steps as described in "Defining a Macro", except at
       the point where you would normally enter the key to be
       defined press <enter> instead.  Then type the name you
       have chosen and press <enter> when you are done.
       Macro definition will then continue as normal.

       Macro names must be between 2-8 characters in length
       and can be any combination of alphanumeric and most
       special characters.

       6.2  Playing back a Multi-Character Macro

       To playback a multi-character macro, press <alt,>.  A
       window will open up asking you to enter the name of
       the multi-character macro you wish to playback.  Once
       you have keyed in the name, press <enter> and playback
       will occur just as it would if you had pressed a
       normal macro key.

       If you request a multi-character playback while
       defining another macro and you do not have a macro
       defined with that name, the following message will be
       displayed:

       "Macro not found - save in current definition? (y/n)"


                                                            23

       If you wish to save the name in the macro definition
       even though it does not yet exist, press "y".  This
       option allows you to define multi-character macros
       which call themselves or which you plan to define
       later.

       Except for the methods of defining and playing back,
       multi-character macros will function just as regular
       macros do.

       6.3  Shorthand Mode

       An alternate method of playing back multi-character
       macros is provided by activating Newkey's shorthand
       mode.  In shorthand mode Newkey watches your
       keystrokes as you type and when they match the name of
       a multi-character macro, replaces them with the multi-
       character macro.  For example, in preparing this
       manual I defined a multi-character macro called "ne"
       to be "Newkey".  Then, whenever I typed "ne", Newkey
       was substituted for the "ne".

       Newkey will not recognize a macro name until you have
       completely typed it in and then pressed a key which
       cannot be part of a macro name to delimit it.  This
       can be any key except for the standard alphanumeric
       character set.  This ensures that Newkey will not
       interpret an imbedded character string as a macro.
       The key that you press to end the macro should be the
       key that you would normally press after the macro had
       executed.  Newkey will save the key and return it
       after the macro has finished.

       For example, if "ne" is defined as "Newkey":

       typing            yields
       plane             - no playback
       nest              - no playback
       honest            - no playback
       ne<space>         - "Newkey "
       ne is the best    - "Newkey is the best"
       I love ne.        - "I love Newkey."

       Be careful in choosing macro names if you decide to
       use the shorthand feature.  It can be very mysterious

       24

       to be typing along and all of a sudden have your
       computer take off on its own when you least expect it.

       6.3.1  Capitals in Shorthand Mode

       Multi-character macro names are case insensitive.
       They are always translated to lower case no matter how
       you enter them.  This poses a potential problem in
       shorthand mode since in many cases you might not want
       the upper case macro name to cause macro playback.
       For example, I might want to type "NE" for Nebraska
       rather than for "Newkey", yet if Newkey automatically
       translated "NE" to lower case and then executed the
       "ne" macro I would be frustrated in my intention.
       True, I could always press <ctrl2>, the playback
       bypass key, but this might get to be very tiresome
       after a while.

       To help alleviate this situation, Newkey offers the
       ability to control whether macro names with any
       capitalized letters should be treated as real macros
       or ignored.  To turn this on/off select the "Upper
       case short hand" parameter on the "Display/update
       Newkey Parameters" screen described in section 8.2.

       There is one exception to Newkey's capitalization
       rules.  If you capitalize the first character in the
       multi-character name Newkey will capitalize the first
       character in your macro.  This means that you can
       start a sentence with the macro and have the first
       word capitalized.  This feature will only work if the
       "Upper case short hand" parameter is off and only the
       first character in the macro name is capitalized.

       6.3.2  Controlling Shorthand Mode

       You may control shorthand mode as follows:

       Globally

       1.  Turning shorthand mode off/on.
       2.  Turning Newkey off/on.



                                                            25

       Locally

       3.  Pressing <ctrl2>, the playback bypass key either
       just before, during, or just after typing the macro
       will cause the macro playback to be ignored.  For
       example,

       typing            yields
       <ctrl2>ne         ne
       n<ctrl2>e         ne
       ne<ctrl2>         ne

       4.  Inactivating the macro will suppress it until you
       reactivate it again.

       6.3.3  Shorthand Mode Backspacing

       When Newkey recognizes a multi-character macro it
       causes your program to backspace back over the macro
       name by feeding it the appropriate number of backspace
       keys required to erase the macro name and then feeding
       it the contents of the macro.

       For most programs the regular backspace key works well
       enough to erase the macro name, but if it does not for
       your program Newkey offers you the ability to change
       the key that will be used for backspacing.  Just
       follow the instructions in section 8.2,
       "Display/Update Newkey Parameters", to update the
       "shorthand backspace" key.  You can even assign a
       macro to the key you select.

       6.3.4  Shorthand Mode Restrictions

       Shorthand mode will not work when you are:

       1.  Defining a macro.
       2.  Playing back a macro.
       3.  Newkey is inactive.
       4.  Shorthand mode is turned off.
       5.  Any part of the macro name is entered in upper-
       case and the shorthand capitalization feature is
       turned off.

       If you want to invoke a multi-character macro during

       26

       definition or playback you should use the standard
       method of invoking them described in Section 6.2,
       "Playing back a multi-character macro".

       6.4  Nested Macro playback

       Newkey will translate macros within macros down to 8
       levels.  For example, assume the following macros have
       been defined as follows:

              <alt1> = level 1 <alt2>
              <alt2> = level 2 <alt3>
              <alt3> = level 3 <alt4>
              <alt4> = level 4 <alt5>
              <alt5> = level 5 <alt6>
              <alt6> = level 6 <alt7>
              <alt7> = level 7 <alt8>
              <alt8> = level 8 <alt9>
              <alt9> = level 9 <alt0>

       When <alt1> is pressed, Newkey will check each
       character returned ("L", "e", "v", "e ", "l","
       ","1","<alt2>") to see if they too have been defined
       and if so, will return their translation.  Newkey will
       find that <alt2> has been defined and will check its
       definition for further translation to a depth of 8
       levels.  At the eighth level, Newkey stops checking
       and returns that translation without further checking.
       In this case, Newkey will return "level 1 level 2
       level 3 level 4 level 5 level 6 level 7 level 8
       <alt9>".

       Try it out.  Define <alta> as "calling", <altb>.  Now
       define <altb> as " altb".  Press <alta>.

       6.4.1  Recursion

       If at any time Newkey detects a recursive macro
       definition which would result in an infinite playback
       loop (a=b, b=c, c=a for example), it will display the
       following message in reverse video

        RECURSION DETECTED - TRANSLATION ENDED -
          PRESS ESC TO CONTINUE


                                                            27

       Press the ESC key to continue.  The key at which
       recursion was detected will be returned untranslated.

       6.5  Defining Macros From Within Macros

       To define a macro from within a macro, just press the
       <alt=> key and Newkey will start defining a new macro
       just as if you had not been already been defining a
       macro.  When you are done defining the new macro, end
       it as you would normally (<alt->), and you will take
       up where you left off defining the original macro.

       Now when you playback the second macro, Newkey will
       return what you just defined it to.  If you playback
       the original macro, it will stop at the point where
       you requested it to begin defining the second macro
       and start a new definition for the second macro.  This
       definition will continue until you end it (<alt->),
       just as you would if you had started it yourself.

       The only difference between defining a macro from
       within another macro's playback versus defining it in
       the normal manner is that the Newkey window and
       warning messages will not be issued if the definition
       is coming from within a playback.

       Try out the following example:

       1.  Press <alt=>.     (start <alta> definition)
       2.  Press <alta>.
       3.  Press <enter> to skip description.
       4.  Type "alta defining altb ".
       5.  Press <alt=>.     (start <altb> definition)
       6.  Press <altb>.
       7.  Press <enter> to skip description.
       8.  Type "altb here!"
       9.  Press <alt->.     (end <altb> definition)
       10. Type "- altb now defined"
       11. Press <alt->.     (end <alta> definition)

       Now press <altb>.  "altb here!" should be returned.
       Press <alta>.  "alta defining altb " will be returned
       and Newkey's macro definition mode (cursor change,
       status line) activated.  Type "new altb definition"
       followed by <alt->.  Now press <altb>.

       28

       6.6  Macro May Call Itself

       In certain special circumstances, a macro can call
       itself.  In order for this to occur, the macro must
       call itself as the last thing it does before ending.
       To invoke this feature, follow these steps:

       1.  Start defining your macro, when you reach the end,
       press the key you are defining.

       2.  Newkey will display a recursion detected message.
       Press <esc> to exit this message.

       3.  End the defining process as you would normally
       (<alt->).

       Now the recursive macro is ready to go.  Just press
       the key you defined and watch it go.  To stop the
       playback press the Newkey cancel key, <ctrlesc>.

       Warning

       Be careful how you use this feature.  If you create a
       macro without a pause, time delay, or using slow
       typing mode, you may find that you have created a
       monster.  Newkey will feed keys to your program at a
       rate beyond your ability to control.  You can always
       stop the playback using the cancel key, but your
       reaction time will probably not be fast enough to stop
       at the point you wish.

       For this reason, we recommend that all recursive
       macros include a pause or turn on slow typing mode for
       a portion of the macro (Most of the time you will
       probably want to do this anyway.)

       Try it out.  Define <alta> as "<alta calling <alta -
       press enter key to continue", <ctrl[>, <ctrl[>,
       <alta>, <esc>.  Press <alta> followed by <enter> a few
       times.  Press the cancel key, <ctrlesc>, to cancel
       playback.


                                                            29

       6.7  Invoking Newkey From its Own Macros

       Subject to the limitations discussed below in section
       6.7.2, "Scope of Macro Definition and Playback",
       Newkey and Newkeysp can be called from Newkey's own
       macros.

       To invoke Newkey's pop-up menu features follow these
       steps:

       1.  Start your macro definition.
       2.  Call up the pop-up menu (<ctrl/>).
       3.  Toggle the "Record mode" option on.

       Now your keystrokes will be captured in the macro.

       6.7.1  Turning Newkey Parameters On/off Through Macros

       To turn a parameter on/off regardless of its current
       status follow these steps:

       1.  Start your macro definition (<alt=>).
       2.  Invoke Newkey's pop-up features (<ctrl/>).
       3.  Turn on "Record Mode".
       4.  Select the "Display/update Newkey parameters"
       option.
       5.  Enter the number/letter of the parameter to
       change.

          This will toggle the selected parameter to the
          opposite of its former status.

       6.  Now enter "y" to turn the parameter on or "n" to
       turn it off.

          This will set the parameter to the requested status
          regardless of its previous status.

       5.  Exit from Newkey's pop-up menus (type <esc>
       twice).

       6.  End the macro definition (<alt->).



       30

       6.7.2  Scope of Macro Definition and Playback

       Except for rare compatibility problems with other
       software (see section 15.8, "Software Compatibility")
       Newkey's macros can be used with any other application
       or program, even to do Newkey functions themselves.

       The only limitations placed accessing Newkey's
       functions are in the course of invoking certain
       features of Newkeysp and Newkey's pop-up features.
       Many of these features can be invoked through macros,
       but some cannot.

       Macro definition or playback will be canceled if these
       functions are accessed:

       - Clear current macros (Newkeysp)
       - Load File
       - Merge File

       Macro definition or playback will be suspended if
       these functions are accessed:

       - Display Directory
       - Display Directory and descriptions
       - Display Macro

       An error message will be displayed if these functions
       are accessed during macro definition

       - Clear current macros
       - Cut
       - Paste
       - Save File

       An error message will be displayed if record mode is
       on and this function is accessed:

       - Display/execute macro definition commands

       Macros can be defined to change any parameter on the
       "Display/update Newkey parameters" screen or call up
       the directory and macro display screens in one
       keystroke for example.


                                                            31

       Except for these limitations, Newkey should work with
       most software and hardware.  Some programs which usurp
       the keyboard interrupts for their own use might not
       allow macro definition and playback to operate.
       XYWrite is one example of such a program.  For more
       information on compatibility refer to section 15.4,
       "Hardware Compatibility" and section 15.8, "Software
       Compatibility".

       6.8  Cut and Paste

       Newkey allows you to "cut" information off of your
       current screen and then "paste" it into another
       application.  For example, you could cut a
       cost/benefits analysis from your spreadsheet and paste
       it into a report you are preparing on your word-
       processor.

       6.8.1  Cutting

       To cut a piece of your screen, invoke the pop-up
       features by pressing <ctrl/>.  Select the "Cut"
       option.  Newkey will redisplay your screen with a help
       block in the top right hand corner.  Move the cursor
       to the point where you wish to start cutting and press
       the <home> key to start marking.  The marked area will
       be displayed in reverse video.

       Now move the cursor to the opposite end of the screen
       block you wish to cut and press the <end> key.  Newkey
       will save the marked screen block in a special macro
       called <cutpaste> and return you to the main pop-up
       menu.

       While cutting you may also modify any portion of the
       screen just by typing over what is displayed.  This
       allows you to easily change what is being cut if it is
       not quite what you would like.

       6.8.2  Pasting

       Once you have successfully cut a part of the screen,
       you may paste it into another application by pressing
       <ctrl/> to call up the pop-up menu and select the
       "Paste" option.  Newkey will immediately paste the

       32

       saved cutting into your current application.

       Pasting is identical to playing back a macro, since
       the cutting has actually been saved in a special macro
       called <cutpaste>.  This macro can also be played
       back, deleted, and displayed by pressing Newkey's
       special paste key, alt left-shift p.

       A cutting can use up to 2k of your macro buffer, so
       you may find it useful to delete the <cutpaste> macro
       once you are done with it (see section 5.5, "Deleting
       a Macro").

                                                            33

         CHAPTER 7 - KEYBOARD AND SCREEN CONTROL FEATURES

       7.1  Screen Saver Mode

       The screen saver feature will blank your screen after
       five minutes of inactivity.  The screen will be
       restored whenever you press a key or your program
       writes to the screen.  This feature protects your
       video terminal from "burn in" caused by prolonged
       display of the same text over a long period of time.
       Now you do not have to worry about turning down your
       video when you leave your PC.

       The screen saver may be turned off by changing the
       "Blank screen" option.  This option and all of the
       other Screen saver options described below may be
       changed by selecting the "Display/update Newkey
       parameters" option from the Newkey pop-up menu or the
       Newkeysp main menu.

       If you are have trouble restoring the screen, try
       pressing the alt, ctrl, left shift, or right shift
       keys.

       7.1.1  Blank Delay Time

       The screen saver comes set up to wait 5 minutes before
       blanking the screen, but you can change this to be any
       time between 1 second and 1 hour by changing the
       "Blank screen delay" option.  The screen saver feature
       offers several options which allow you to tailor it to
       your software and hardware.  These are described
       below.

       7.1.2  Blank By Saving Screen

       The screen saver normally works by turning off your
       video display, but this will not work with some video
       boards.  In this case you may turn on the "Blank by
       saving screen" option.  When this option is active,
       Newkey will actually save your screen in memory and
       then write blanks on the screen.  Then, when your
       screen is activated, Newkey will restore the saved
       screen image.


       34

       Since Newkey only checks this option when it is first
       started up, to activate it you must follow these
       steps:

       1. Turn it on.
       2. Make the change permanent.
       3. Unload Newkey  (newkeysp/u).
       4. Reload Newkey.

       This option has its drawbacks.  First, it requires an
       additional 4k of memory in which to save the screen.
       Second, programs which write directly to the screen
       instead of using the IBM video BIOS calls, will not be
       detected by Newkey.  Then, when you do something to
       activate the screen, Newkey will restore the old
       screen image completely overwriting the new one.

       7.1.3  Video I/O Restore Screen

       Normally any type of video i/o will cause Newkey to
       restore your blanked screen.  But some programs are
       constantly writing to your screen, even when they are
       not writing anything new.  This keeps the screen saver
       from working when you would usually want it to.  If
       you use programs like these, you should try turning
       off the "Video i/o restore screen" option.  PC-Write
       and Word Perfect are two such programs.

       If you are unsure about whether your program falls
       into this category, start it up and then let it sit
       for more than 5 minutes (or whatever you have set the
       blank delay time to).  If the screen does not blank,
       turn the "Video i/o restore screen" option off and
       repeat the process.  If the screen still does not
       blank you may have an incompatible video board.  Try
       the "Blank by saving screen" option described above.

       Please note that this option is incompatible with the
       "Blank by saving screen" option and will be ignored if
       the "Blank by saving screen" option is turned on.  In
       this case, video i/o will always restore the screen.


                                                            35

       7.2  Extended Keyboard Buffer

       This option increases the size of DOS's type-ahead
       buffer from 16 to 128 keystrokes.  Although it has
       been designed for maximum compatibility, it's possible
       that it may cause problems when run with other
       software, especially other memory-resident programs.
       If you are having trouble using Newkey, try turning
       the "Extended Buffer" option off causing Newkey to use
       DOS's normal buffer.  This option may be found by
       selecting the "Display/update Newkey parameters" on
       the main pop-up menu or Newkeysp.

       7.3  Fast Key Parameters

       Newkey will allow you to dramatically increase the
       speed at which your keyboard will repeat a key which
       is pressed and then held down.  You may set both the
       delay before repetition will begin and the rate at
       which repetition will occur.

       To activate this feature select the "Fast key" option
       on the "Display/update Newkey parameters" menu and set
       the rate and delay parameters described below.  The
       best way to choose settings for these options is to
       try various combinations out.

       Newkey helps you control this option by monitoring the
       state of your keyboard buffer and refusing to insert
       any additional keys if your program has not already
       dealt with the previous ones.  This helps to prevent
       the overrun which might otherwise occur as your
       keyboard buffer fills up with keystrokes that your
       program cannot process.  This means that when you
       release the key, your program will not receive any
       more unwanted keystrokes.

       7.3.1  Fast Key Delay

       The time Newkey will wait before beginning repetition
       may be set to be between 1/4 - 1 second in 1/4 second
       intervals.  To do this select the "Fast key delay"
       option on the "Display/update Newkey parameters" menu.



       36

       7.3.2  Fast Key Rate

       The rate at which Newkey will repeat may be set to
       between 1 - 99 characters per second.  To do this
       select the "Fast key rate" option on the
       "Display/update Newkey parameters" menu.  Note that
       because of Newkey's overrun prevention feature the
       actual rate is likely to be about 30 characters per
       second for most programs no matter how high a rate you
       specify.  This is because few programs can handle more
       than about 30 characters per second.

       7.3.3  AT Keyboard Parameters (IBM AT only)

       In addition to or instead of Newkey's fast key option,
       Newkey will also program your IBM AT's keyboard delay
       and rate parameters.  The advantages of using this
       option instead of the fast key option are twofold:
       first, key repetition may be smoother; second, a
       potential source of incompatibility with other
       software will be avoided by deactivating the normal
       fast key option.

       The "Fast key delay" and "Fast key rate" parameters
       will be used to program your keyboard.  The maximum
       number of characters per second that will be used is
       31, even if the fast key rate is higher.  To invoke
       this option you must turn on the "AT fast key" option
       found by selecting the "Display/update Newkey
       parameters" menu.

       7.4  Keyboard Click

       Newkey now offers an optional keyboard feature that
       will cause a click each time you press a key.  To turn
       it off/on, select the "keyboard click" option on the
       "Display/update Newkey parameters" screen.

       7.5  Cap/Num Lock Indicators

       Newkey will display the status of your Caps and Num
       lock keys in the top right hand corner of your screen.
       To turn this feature off select the "Cap/Num Lock
       Indicators" option on the "Display/update Newkey
       Parameters" menu.

                                                            37

                  CHAPTER 8 - CUSTOMIZING NEWKEY


       Virtually every aspect of Newkey's operation can be
       customized to accommodate your own unique hardware and
       software environment.  This chapter describes how to
       change Newkey's "hot" keys and parameters.

       8.1  Display/Update Control Keys

       The Newkey control keys are those keys which have a
       special meaning to Newkey and are used to control
       Newkey's operation.  These keys are:

          <alt=>       Begin macro definition
          <alt->       End macro definition
          <ctrlesc>    Cancel Newkey processing
          <ctrlh>      Backspace and delete during macro
                       definition
          <ctrl]>      Begin/end fixed length pause
          <ctrl[>      Begin/end variable length pause
          <ctrl/>      Pop-up features request
          <ctrl->      Time delay of 1/2 second
          <ctrl2>      Do not translate next key
          <ctrl3>      Turn on slow typing mode
          <ctrl4>      Turn off slow typing mode
          <ctrl6>      Newkey on/off toggle
          <enter>      End variable length pause
                       during playback

       You have complete control over which keys will be used
       for these functions.  You can even deactivate them
       completely if you wish! To change them, select the
       "Display/update newkey control keys" option on the
       menu screen, or type in "Newkeysp /x" and press
       <enter>.  This will display the control keys and allow
       you to change or completely deactivate them if
       desired.  Any changes will take effect immediately.
       You will then have the option of making them permanent
       by updating the Newkey.exe program.

       IMPORTANT NOTE:  Users of IBM's enhanced keyboard
       please refer to section 15.5, "IBM's Enhanced
       Keyboard", for important information on the set of
       control keys used for the enhanced keyboard.

       38


       8.2  Display/Update Newkey Parameters

       Newkey operates in several modes which are controlled
       by various parameters.  These settings may be
       customized to meet your needs.  These modes and their
       parameters are:

         Options                   Messages
        - Newkey status        - Macro already defined
        - Shorthand            - Defining alpha character
        - Upper case Shorthand - Enter description request
        - Slow Typing Mode     - Defining status line
        - Slow Typing Delay    - Status line position
        - Disk wait            - Beep while defining
        - Singe Step           - Change cursor in def/play
        - Shift Status Reset   - Load/save file overwrite
        - Black & White        - Cap/Num lock indicators
        - Fast key             - Blank Screen Options
        - Fast key delay       - Blank screen
        - Fast key rate        - Blank by saving screen
        - AT fast key          - Video i/o restore screen
        - Keyboard Click       - Blank screen delay

       To change them, select the "Display/update Newkey
       parameters" option on the menu screen.  This will
       display the parameters and allow you to change them.
       To make a change select the number/letter of the
       parameter you want to change and press it.  If it is a
       mode parameter, the status will be toggled on/off.

       8.2.1 Making Absolute Parameter Changes On/Off

       Assuming that you have just changed a parameter as
       described above, at this point you will be requested
       to enter "y" to turn the parameter on or "n" to turn
       it off.  Unless you are defining a macro to always
       turn this mode on or off you may ignore this request.
       If you are defining macro and you want to make an
       absolute change to this parameter, then enter "y" or
       "n".  If you enter "y" the parameter will be turned on
       even if it is already turned on, "n" will function
       similarly, but will turn the parameter off.  In this
       way your macro will always turn the parameter on or
       off as you desire.

                                                            39


       Any changes will take effect immediately.  You will
       then have the option of making them permanent by
       updating the Newkey.exe program.

       8.3  Black and White Mode

       The colors Newkey normally uses were chosen for their
       compatibility with monitors (amber, for example) which
       use the graphics card, but display in one color.  But,
       just in case the colors do not display on your
       monitor, a new option has been added to Newkey.  To
       invoke this option, load newkey and then type in the
       following:

          newkeysp/b

       and press <enter>.  This will cause Newkey to toggle
       its display mode into black & white.  Entering the
       command again will cause the black & white mode to be
       toggled off.  To make these changes permanent, use the
       "Display/update Newkey parameters" option in Newkeysp.

       An alternative method is to use Newkeysp's color
       customization described in section 8.6, "Customizing
       Newkey's Colors".

       8.4  Customizing Macro Definition Messages

       Much of the macro definition processing (the presence
       of the window, warning messages, the description
       request, and status line) can be customized to suit
       your preferences.  If you do not need these aids or
       protections you can eliminate them and the additional
       keystrokes they require.  These options are described
       below.

       8.4.1  Macro Already Defined Warning Switch

       Newkey will warn you when you are about to define a
       macro which has already been defined.  You will be
       requested to confirm that you wish to reuse this key
       for a new macro.  This warning will only be issued if
       the "Macro definition window" switch is also turned
       on.

       40

       Newkey comes with this option turned on, but you may
       change it by selecting the "Macro already defined"
       option on the "Display/update Newkey parameters" menu.

       8.4.2  Defining Alpha Character Warning Switch

       Newkey will warn you when you are about to define a
       normal letter (a-z) or number (0-9).  You will be
       requested to confirm that you wish to actually use
       this key for a macro.  This warning will only be
       issued if the "Display Macro Definition Window" option
       is also turned on.

       Newkey comes with this option turned on, but you may
       change it by selecting the "Defining alpha character"
       option on the "Display/update Newkey parameters" menu.

       8.4.3  Enter Description Request Switch

       You have the option to turn off the "Description ="
       request in the macro definition window.  When turned
       off, Newkey will display the macro definition window,
       but after you have entered the key to be defined,
       Newkey will automatically close the window after
       waiting about one second.  But you do not have to wait
       for the window to close before you begin keying in
       your definition.  Any keystrokes entered while the
       window is open will be passed on to your program.

       Newkey is designed to save you keystrokes and even
       that one additional keystroke at macro definition time
       can be annoying to some people.  To turn this off,
       select the "Enter description request" option on the
       "Display/update Newkey parameters" menu.

       8.4.4  Status Line Position

       The macro definition status line's position may be
       moved to any line on the screen by selecting the
       "Status line position" option on the "Display/update
       Newkey parameters" menu and choosing a number between
       0 - 24.  Usually you will want to move it to the
       bottom of the screen, especially when using a program
       such as Lotus 123 which uses the top line as its
       status line.

                                                            41

       8.5  Preventing Key Creation

       Newkey creates several new keys which are not normally
       supported by IBM.  For example, pressing shift and
       enter together will normally return the same keystroke
       as just pressing the enter key.  Newkey, however,
       returns a new key code, <capsent>, when you press
       shift and enter together.  This allows you to assign a
       macro to shift enter and extends the number of keys to
       which you can assign macros.  Sometimes this can cause
       problems because some programs will recognize that an
       enter key has been struck, check to see if the shift
       key is being  pressed, and if so, treat shift enter as
       a separate key.  But since Newkey has already given
       the shift enter its own code, the program will never
       recognize that shift enter has been pressed, leaving
       you without a way to create a shift enter for the
       program.

       Newkey now offers you the chance to specify a list of
       ignored keys.  Any key specified on this list will be
       ignored by Newkey when it is creating new key codes
       causing the key to revert to its original meaning.  To
       put a key on the ignore list follow these steps:

       1.  Run Newkeysp.
       2.  Select the "Display/update ignored keys" option.
       3.  Select a line number and press the key you wish to
       ignore.

       When you exit you will be given the option of making
       the change permanent.

       For example, assume that your IBM AT compatible used
       alt ctrl / to switch back and forth between turbo and
       normal mode.  Since Newkey will normally create a new
       key code for both <alt/> and <ctrl/> you will need to
       put both of these keys on the ignored list.  This will
       let your computer recognize the alt ctrl /
       combination.

       Another possible solution in some cases is to just use
       Newkey to redefine shift enter as enter.  This will
       work in many cases.  For a list of key codes created
       by Newkey refer to Appendix B of the User's Guide.

       42

       8.6  Customizing Newkey's Colors

       Newkey now offers you the ability to customize its
       menu and message colors.  To change Newkey's colors
       follow these steps:

       1.  Run Newkeysp.
       2.  Select the "Display/update message colors" option.
       3.  Follow the instructions on the screen.

       When you exit you will be given the option of making
       the change permanent.


                                                            43

           CHAPTER 9 - LOADING, SAVING & CLEARING MACROS


       This chapter describes Newkey's many options that
       allow you to control the contents of your macro
       buffer.


       9.1  Save File

       This function will save your current macros from
       memory in a disk file, which may be loaded later.
       If you are about to overwrite an existing file Newkey
       will warn you and request a confirmation.

       Select the "Save file" option on the menu screen and
       another screen will be displayed requesting a file
       name.

       To execute in batch mode use the following command:

       newkeysp filename.ext/s

       where "Filename.ext" is the name of the macro file in
       which you wish to save your current macros.

       9.2  Load File

       This function will load macros from a disk file into
       memory where they can be used by Newkey.  Any previous
       macros in memory will be erased (unless they have been
       "guarded" by Newkey's guard function).  If you have
       created any new macros, Newkey will warn you and
       request confirmation before continuing.

       Select the "Load file" option on the menu screen
       Another screen will be displayed requesting a file
       name.

       To execute in batch mode use the following command:

       newkeysp filename.ext/l

       where "Filename.ext" is the name of the macro file in
       from which you wish to load a new set of macros.

       44

       9.3  Merge File

       This function will merge macros from a disk file into
       memory, where they can be used by Newkey.  The
       previous macros in memory will be kept.  If the same
       macro is defined both in memory and in the merge file,
       the in-memory definition will be retained, unless the
       overwrite option is specified.  If you have created
       any new macros, Newkey will warn you and request
       confirmation before continuing.

       To merge, select the "Merge file" option on the menu
       screen.  Another screen will be displayed requesting a
       file name and whether you want to use the overwrite
       option.

       To execute in batch mode use the following command:

       newkeysp filename.ext/m          - or -
       newkeysp filename.ext/m/o

       "Filename.ext" is the name of the macro file you wish
       to merge into memory.  The second form, ending in
       "/o", will invoke the overwrite option.


       9.4  Clear Current Macros

       This function will clear all current macros from
       memory.

       To invoke it select the "Clear current macros" option
       on the menu screen.  You will be asked to confirm the
       clear.  To execute in batch mode type in "Newkeysp /c"
       and press enter.


                                                            45

       9.5  Guarded Macros

       To protect a macro in your macro buffer from being
       overwritten when loading a new macro file or from
       being deleted when clearing macros from your macro
       buffer you can guard it.  This will protect those
       macros you want to always be present from being
       accidently deleted.  To guard a macro follow these
       steps:

       1. Edit the macro
       2. Press F2.
       3. Select the guard option.
       4. Stop editing.

       Guarded macros will be marked by a 'G' in the status
       field when displaying the macro directory.  To unguard
       a guarded macro just edit it and delete the <guard>
       function.  If at some time you want to remove the
       guarded macro just display the macro and press 'd' to
       delete it.



       46

                  CHAPTER 10 - NEWKEYSP OVERVIEW


       Newkeysp, the Newkey Support Program, provides many
       features to complement Newkey functions.  You will
       need to use Newkeysp in the following situations:

       - To execute Newkey functions from batch files
       - To execute Newkey functions not available in the
       small version of Newkey
       - To access customization features only available in
       Newkeysp

       10.1  Invoking Newkeysp

       Newkeysp may be invoked in one of two ways:

          1. Type Newkeysp and press <enter>.  A menu of
          options will be displayed.

          2. Type Newkeysp plus one or more parameters, and
          Newkeysp will perform the requested functions.
          This option is particularly useful in a batch file
          invoked at system initialization.  See the file
          "example.bat" for examples of Newkeysp's batch
          functions.

       10.2  Execute Multiple Newkeysp Commands

       Newkeysp will process more than one command when
       invoked in command mode.  For example,

           "newkeysp ed.key/l /on /ek=[ctrle]"

       might be used to automatically load a newkey macro
       file, turn newkey on, and then type a key to invoke
       your editor.  The only restrictions on this feature
       are that only one file oriented command may be
       executed and it must be first on the command line.

       If you should want to execute multiple commands and
       then enter Newkeysp's menu mode, place "/run" at the
       end of the command string.


                                                            47

       10.3  Newkeysp batch commands

       To execute Newkeysp in command mode, type "newkeysp" +
       one of the parameters below.

       Command           Function
       /b                Toggle black & white mode
       /c                Clear current macros from memory
       /d                Display macro directory
       /eb               Clear Keyboard buffer
       /ek=[macro]       Execute macro (see section 10.4)
       /k                Display macro screen
       filename/l        Load macros from filename
       filename/m        Merge macros from filename
       /off              Turn Newkey off
       /on               Turn Newkey on
       filename/s        Save macros to filename
       /t                Toggle Newkey on/off
       /u                Unload Newkey and reclaim memory
       /x                Display control keys
       /zoff             Turn off slow typing mode
       /zon              Turn on slow typing mode

       For example,
       newkeysp ws.key/l         - Load Wordstar macro file
       newkeysp /off             - Turn off Newkey

       10.4  Executing Macros From a Batch File

       This feature allows you to enter macros from a batch
       file just as if you were typing them yourself.  To
       invoke this feature issue the following command:

         "newkeysp /ek="

       followed by the key you wish to type as described in
       appendix A.  For example:

        "newkeysp /ek=h /ek=e /ek=l /ek=l /ek=o /ek=[altn]"

       would type "hello<altn>".  If any of these keys has a
       macro associated with it, that macro will be invoked.
       "ek" stands for "enter key".  Be sure to use "[" and
       "]" instead of "<" and ">".  DOS uses the carats for
       its own special purposes.

       48

               CHAPTER 11 - NOTES ON KEYS SUPPORTED

       Newkey supports all of the keys normally supported on
       the IBM PC, plus many others not supported (For a
       detailed list of the keys supported refer to appendix
       A.)  These include most keys in ctrl, alt or shift
       modes, but not combinations of these modes.  For
       example, <ctrlins> is supported, but <alt ctrl ins> is
       not.

       Newkey gives these new keys their own unique scan and
       ascii codes and treats them just as if they were
       normal keys.  This means that, if they have not been
       defined, they will be passed back to the requesting
       program.

       This should not cause any problems if the requesting
       program ignores unknown keys, as most do.  But, some
       programs do not handle strange keys well, and you
       should be aware of this as a potential problem,
       especially since you may accidently press one of these
       keys.  See appendix B for a detailed list of these
       keys and their codes.

       11.1  Enhanced Keyboard

       Because of the greatly increased complexity of working
       with IBM's new keyboard, Newkey supports a slightly
       different set of keys.  This also affects the Newkey's
       set of control keys.  For more information see section
       15.5, "IBM's Enhanced Keyboard".

       11.2  Synonyms - Different Keys, Same Ascii Codes

       There are several keys which generate the same ascii
       code, but with a different scan code.  These keys have
       been separated.  Only the original key will be
       translated and not its synonym.  This provides more
       flexibility in defining macros and eliminates a
       potential source of confusion.  A full listing of
       synonyms can be found in appendix C.





                                                            49

       11.3  Generating Extended Ascii Codes

       Normally pressing <alt> plus some number(s) on the
       numeric keypad will generate the key code equal to the
       numbers pressed.  For example, to generate the <enter>
       key (ascii code = 13), you would press <alt>, 1, and 3
       on the numeric keypad and then release the alt key
       with the same effect as pressing the <enter> key.  But
       Newkey treats the same sequence as two different
       keystrokes, <altend> and <altpgdn>.

       In order to invoke this function, press the left
       shift key at the same time as the alt key and hold
       until you release the alt key.

       NOTE:  If you are working with the new enhanced
       keyboard this section does not apply.  Generating
       extended ascii codes will operate as if Newkey was not
       present.  See section 15.5, "IBM's Enhanced Keyboard",
       for further information.

       50

                 CHAPTER 12 - TIPS ON USING NEWKEY


       12.1  Use Your Autoexec.bat File

       Put the commands to load Newkey and your macro files
       in your autoexec.bat file.  This will cause Newkey and
       your macros to be automatically loaded whenever you
       boot.  If you have disks for different purposes, each
       disk could contain a copy of Newkey, Newkeysp, and
       your macro files.

       An example of the statements you would want to use can
       be found in LOADNEW.BAT, a batch file supplied with
       Newkey.  Use your editor to copy these statements into
       your autoexec.bat file and change the parameters as
       appropriate.

       12.2  Setting the Macro Buffer Size Parameter

       When you first install Newkey, you will be actively
       defining macros.  This will require a lot more space
       in the macro buffer than you will normally use.
       During these early sessions set the macro buffer size
       parameter to a large number, 5000 for example.  This
       will enable you to define macros using up to 5000
       characters without running out of space.

       Later, when you have finished creating your macro
       files, lower the number to a level which will support
       your normal macro definition needs during a session.
       Remember that you must also allow enough space to load
       your macro files in addition to supporting your normal
       macro needs during a session

       Newkey uses 1000 as a default, but you can set the
       number as low as 5.  Of course you may set the define
       area size at any level you wish, but remember, that
       area is not available to any other programs.

       The macro buffer size parameter is specified when you
       load Newkey.  For more information refer to section
       2.1.1, "Buffer Size".



                                                            51

       12.3  Do Not Forget to Save Your Macros

       Do not forget to save your macros at the end of a
       session.  Unless you save the macros you have defined
       during the current session, they will be lost when you
       re-boot or turn off the computer.

       It is suggested that as soon as you have finished
       defining a set of macros you wish to keep, that you
       save them immediately.  It is very easy to start a
       session defining new macros, proceed to use them for
       the rest of the session, and then turn off the
       computer.  If this happens, you will have to redefine
       each macro again.  For information on saving your
       macros refer to section 9.1, "Save File".

       12.4  Combining Macro Files

       Occasionally, you may wish to combine two macro files.
       This may be done by loading one of the files into
       memory, merging the second into memory, and then
       saving the macros to disk.

       You may also use your text editor to combine the two
       macro files.

       12.5  Multiple Macro Files

       You may wish to define multiple macro files based on
       function.  This would allow you to easily build
       different macro files without redefining each
       function's macros for each macro file.

       For example, you could define a file for your word
       processor, spreadsheet, general DOS commands, etc.
       and then merge various combinations of them together
       to create one file.  They could also be used to create
       in-memory macros at boot time (using the merge
       function), without combining them all into one macro
       file.

       52

             CHAPTER 13 - COMMON PROBLEMS WITH NEWKEY

       13.1  Keys That Used to Work No Longer Work

       Several reasons why keys that used to work no longer
       work follow:

       - You are trying to use one of the synonym keys that
       Newkey has been forced to assign a different key code
       to.

       - The program you are using is trying to assign its
       own key code to one of the unused key combinations not
       supported by IBM, yet Newkey has already intercepted
       that key combination and assigned it a different code.
       See section 8.5,"Preventing Key Creation" and
       "Appendix C" for more information on how to correct
       this problem.

       13.2  Other Memory-resident programs hang

       When invoked it appears that other memory-resident
       programs have hung up or will not read certain
       keystrokes.  Try turning off the extended keyboard
       buffer feature and/or changing the load order.

       13.3  Monitor Does Not Clearly Display Newkey Menus

       You are probably using an amber or other monochrome
       monitor with a graphics card.  In this case you should
       turn on Newkey's black and white option.  See section
       8.3, "Black and White Mode" for more information on
       how to correct this problem.

       13.4  Screen Does Not Blank

       There are many reasons why your screen may not blank
       depending on the hardware and software you are using.
       Newkey provides several screen blanking options
       designed to work with these configurations.  Before
       trying these options, please read the full description
       of them in section 7.1, "Screen Saver Mode".  It is
       not always obvious exactly how they work.  Possible
       reasons include:


                                                            53

       1.  You are using a non-IBM display card which does
       not respond to the same hardware commands.  In this
       case try turning the "Blank by Saving Screen" option.

       2.  Your software is continually writing to the
       screen, redisplaying the same exact screen, even
       though you have not touched a key for several minutes.
       In this case try turning the "Video I/O Restore Screen
       Option" off.  PC-Write and Word Perfect are two such
       programs.

       13.5  Cannot Restore Blanked Screen

       Normally any keystroke or video i/o will restore the
       screen.  However, some programs completely takeover
       the interrupts Newkey uses to determine when the
       screen should be restored.  If you are having trouble
       restoring the screen, try pressing the alt, ctrl, left
       shift, or right shift keys.

       If you are still unable to restore your screen then
       you may find it easiest to turn off the screen saver
       mode before using the problem program (see section
       7.1, "Screen Saver Mode").

       13.6  Newkey Does Not Work Right With Certain Programs

       Some programs throw away parts of Newkey and you will
       notice that certain Newkey features have ceased to
       function.  When these discourteous programs are
       running, they completely takeover the interrupts
       Newkey uses.  When this happens, these parts of Newkey
       are lost until the guilty program stops running.
       Fortunately only a few applications programs such as
       XYWrite and Smartcom are guilty of this.

       Newkey has been designed to work around these
       programs, but it cannot protect itself completely.
       Rather than fight with these programs, Newkey lets
       them take over, but tries to make sure that the
       disappearance of one part will not affect another
       part's functioning.  Otherwise, you will have to live
       without the missing Newkey functions while running
       these programs.


       54

       13.7  Cannot Access Extended Ascii (upper 128) codes

       See section 11.2, "Generating Extended Ascii Codes".

       13.8  Losing Part of Macro Definition

       If your macro definition does not include all of the
       keystrokes you originally typed you have probably used
       Newkey's error correction key, the <ctrlh> key.  If
       you wish to use the <ctrlh> key with its normal
       meaning, you must either redefine or deactivate
       Newkey's error correction key.  For more information,
       see section 2.5, "Error Correction".

       Another reason part of your definition may seem to be
       lost during playback is that some programs ignore keys
       which are returned faster than they expect.  For more
       information on resolving this problem refer to section
       4.6, "Slow Typing Mode", and section 3.4, "Time
       Delay".

       13.9  Limited Memory Considerations

       If you are running into memory problems consider using
       Newkeysm, which will save you 26K at the cost of the
       pop-up features.  See also section 15.1, "Newkey
       Requirements."

       13.10 Computer Hangs up and Must be Rebooted

       Check to make sure that you are not using an old
       version of Newkeysp with a new version of Newkey or
       vice-versa.   If you are not mixing versions then
       refer to section 16.2, "Reporting Newkey Bugs" for
       more information on how to notify us of the problem.
       With the ever-increasing number of memory-resident
       programs conflicts are inevitable and are a likely
       cause of these types of problems.


                                                            55

              CHAPTER 14 - FILES SUPPLIED WITH NEWKEY

       14.1  Sample Macro Files

       Several sample macro files are supplied with Newkey to
       illustrate its use and provide you with a starting
       point.  These files are described below.  Many have
       associated documentation files, which may be obtained
       by issuing the associated print command described for
       each file.  We recommend that you print the
       documentation before using these files.

       Date.key - Date & Time Macros

       Demonstrates use of the date and time macro functions.

       Demo.key

       This macro file is used to take you on a guided tour
       designed to illustrate Newkey's major features and
       requires 192k of memory.  To take the tour, issue the
       command "demo".

       Dvorak.key - Dvorak keyboard customization

       This file contains the macros necessary to redefine
       your keyboard to the Dvorak layout.  There is one
       minor problem in using the Dvorak layout with the Caps
       Lock feature.  Caps Lock will only lock the standard
       alphabet into shift mode.  Since the Dvorak layout
       uses some non-alphabetic keys, the Caps Lock feature
       will not automatically capitalize these keys, although
       normal shifting will.

       Test.key

       This macro file illustrates many Newkey features.  For
       more information, print the documentation file
       "TESTKEY.DOC" by issuing the command "printest".

       Ws.key - Wordstar macro file

       This file contains many macros designed to simplify
       and enhance Wordstar's command structure.  For more
       information on this file print the documentation file

       56

       "WSKEY.DOC" by issuing the command "printws".

       14.2  Files on the Newkey Disk

       Cls.com - This clears the screen and is used by the
       demonstration.

       Convedit.exe - Program to convert internal format
       files to edit format.  You must use version 2.4 of
       Newkey.

       Conv1to2.exe - Program to convert version 1.0 internal
       format files to version 2.0 internal format files.
       You must use version 2.4 of Newkey.

       Conv3to4.exe - Program to convert version 3.0 files to
       version 4.0 internal format files.

       Demo.bat - This batch file will give you a
       demonstration of Newkey.  It requires 192k of memory.

       Example.bat - examples of how to use Newkeysp and
       Newkey in batch mode.

       Loadnew.bat - This sample batch file will load Newkey
       and the sample Wordstar macro file, WS.KEY.

       Newkey.doc - Documentation to introduce unregistered
       users to Newkey.  To print, issue the command
       "printdoc".

       Newkey.exe - This program actually replaces IBM's
       keyboard interrupts (x'9' and x'16').  It is always
       present while other programs execute and unless called
       upon to translate, will be transparent.

       Newkey.eva - Full-power evaluation version of
       Newkey.exe.

       Newkeysm.exe - This is the small version of
       Newkey.exe.  It lacks the pop-up features and is about
       26k smaller.

       Newkeysm.eva - Full-power evaluation version of
       Newkeysm.exe.

                                                            57


       Newkeysp.exe - This program provides several functions
       necessary to effectively use Newkey and is described
       further in this document.

       Newkeysp.eva - Full-power evaluation version of
       Newkeysp.exe.

       Order.frm - Current Newkey prices and order form.

       Printdoc.bat - This prints the Newkey documentation
       from disk.

       Printest.bat - This prints the test macro file
       documentation from disk.

       Printws.bat - This prints Wordstar macro file
       documentation from disk.

       Readme - This file will contain any Newkey updates
       that may have come up since this manual was printed.

       Testkey.doc - Documentation for TEST.KEY.  To print,
       issue the command "printest".

       Wskey.doc - Documentation for WS.KEY.  To print, issue
       the command "printws".

       All files ending in "key" are described in section
       14.1, "Sample Macro Files".


       58

                  CHAPTER 15 - TECHNICAL OVERVIEW


       15.1  Newkey Requirements

       Newkey requires PC-DOS or MS-DOS 2.0 or greater and
       will run on either a monochrome or color monitor.
       Newkey comes in two versions, the normal full power
       version and Newkeysm, which lacks the pop-up features
       of the full-power version, but also requires 26K of
       memory less.  Newkey requires approximately 50K (24K
       for the small version) of memory, plus an additional 2
       bytes per character of translation and reserved macro
       buffer.  If memory usage is a problem, consider
       ordering an earlier version of Newkey which can use as
       little as 6K and still offer many advanced features.

       15.2  How Does Newkey Work?

       The Newkey keyboard enhancer consists of two programs,
       Newkey.exe and Newkeysp.exe.  Newkey.exe, when invoked
       will replace the normal keyboard interrupts (x'9' and
       x'16') plus the video (x'10') and timer (x'8')
       interrupts of the BIOS.  Newkey will gain control when
       you press a key (x'9') and will check to see if this
       is a key it supports that IBM does not.  If so, Newkey
       will place its own special code in the keyboard buffer
       (see appendix B for a full listing).  Otherwise,
       Newkey will pass control to the original keyboard
       interrupt.

       Then, when a program requests a key, Newkey will read
       the keyboard buffer and return the key to the
       requesting program, except that Newkey will first
       check the key against its in-memory macros, and if it
       finds an entry for that key, it will return the
       corresponding translation.

       15.3  Newkey's Limitations

       Newkey allows redefinition of almost any key,
       including an extended set of keys beyond those
       supported by IBM (except ctrl break, and on the AT,
       SysReq).  Newkey will handle up to approximately 64k
       of macros, and any macro may be as long as you wish up

                                                            59

       to this maximum.  The 64k maximum includes 16 bytes
       for overhead and two bytes per character of
       translation.

       15.4  Hardware Compatibility

       Newkey is compatible with IBM PC, XT, Jr, AT, and all
       true compatibles, including Compaq, Hyperion, Leading
       Edge, Zenith, Wyse, Tandy, and others.  Users of amber
       or similar monitors that display in two colors only,
       but use the graphics card should consult section 8.3,
       "Black and White Mode".

       15.5  IBM's Enhanced Keyboard

       Newkey now recognizes and supports IBM's new enhanced
       keyboard.  But, because of the substantially increased
       complexity of working with the new keyboard, Newkey
       will not generate new key codes for the alt numeric
       keypad numbers and other keys Newkey supports on the
       old keyboard.  As a result, you will have to redefine
       the following Newkey control keys (see section 8.1
       Display/update control keys" option).  Please refer to
       the readme file on the Newkey disk for updated
       information on the enhanced keyboard.

       current  suggested     Description
                replacement

       <alt,>     <alt >      Playback multi-character macro
       <ctrl/>    <alt/>      Pop-up features
       <ctrl3>    <alt[>      Slow typing on request
       <ctrl4>    <alt]>      Slow typing off request
       <ctrlesc>  <ctrl >     Cancel macro playback

       15.6  Hercules Graphics boards

       Newkey has been designed to recognize Hercules cards
       and use a different method of saving your screen.
       This method was provided by the Hercules Technology
       Corporation for use with their cards so it should be
       safe.  Please note that the Hercules Technology
       Corporation has not tested my implementation and does
       not approve or endorse it.  I have tested it and found
       no problems.

       60


       Newkey offers a completely safe screen saver feature
       which works by actually saving your screen and then
       writing blanks on your screen.  This option runs no
       risk of damaging your VDT or graphics board, but does
       take an extra 4k in memory.  For more information
       refer to the "Blank by Saving Screen" option in the
       Newkey manual.

       15.7  Graphics Modes

       Newkey is now able to pop-up in the middle of programs
       using IBM's standard graphics modes for the CGA and
       EGA boards.  Upon returning it will restore your
       screen to its previous state.  Sometimes when using
       the EGA, some "dirt" will be left on your screen.
       This problem, experienced by other pop-ups, appears to
       be caused by a bug in the EGA software.  But, whatever
       its cause, it will not affect the functioning of your
       program.  Just ignore it and the next time you cause
       the screen to be refreshed it will disappear.

       15.8  Software Compatibility

       More and more programs are operating at Newkey's
       level, including a new host of memory-resident ones.
       For the most part these programs work very well with
       each other, but inevitably problems arise.  As a
       result, it has become impossible to give guidelines
       for which programs should be loaded in what order and
       which of Newkey's options should be used with which
       programs.

       If you are having trouble, try loading your memory-
       resident programs one at a time in several different
       orders until you isolate which programs are causing
       your problems.  Once you have determined which
       programs are causing the problem and found that
       changing their order of loading does not solve the
       problem, try changing the Newkey parameters,
       especially:

       - Extended keyboard buffer
       - Defining status line
       - Blank screen

                                                            61

       - Fast key

       For the most part you will have to use trial and error
       to determine these for yourself.  We have included a
       section on problems with some of the more popular
       software that we are aware of.

       PC-Write

       Programs, such as PC-Write, which check the shift
       status flags when they read certain characters have
       mild compatibility problems, which may be largely
       eliminated.  PC-Write for example, uses the shift
       enter key (<capsent>), a key which it "creates",
       because it is not normally supported by the IBM PC, by
       reading the shift status flags when the <enter> key is
       struck.  Newkey, however, creates its own shift enter
       key by returning its own special key codes which PC-
       Write cannot interpret effectively preempting PC-
       Write's own meaning for shift enter.  In order to
       recover PC-Write's own meaning, just define shift
       enter as <enter>.

       For more information on other compatibility problems
       refer to section 15.9, "Shift Status Reset".

       Smartcom

       Smartcom illustrates a problem you may find with other
       software.  It allows the screen saver to blank your
       screen, but does not allow you to restore it.  The
       best solution is to use a batch file to turn off the
       screen saver feature before starting it up.   Many
       Newkey features will not work under Smartcom.

       Word Perfect

       The "Video I/O restore screen" option must be turned
       off if screen saver mode is to work while in Word
       Perfect.  Refer to section 7.1.3, "Video I/O Restore
       Screen" for further information.





       62

       XYWrite

       Because XYWrite usurps so many of Newkey's interrupts
       few features will work with it.

       15.9  Shift Status Reset

       Some programs check the shift status when they read
       certain characters, enabling them to effectively
       extend the character set normally supported by the IBM
       PC.  This causes problems if you have defined some of
       these characters in a macro which is invoked by a
       shift key (such as ctrl, alt, or caps), because the
       shift status will remain set as the playback occurs.
       As a result, the application program may interpret
       certain characters incorrectly.

       Newkey now has an option that which will turn the
       shift flags off during playback and restore them when
       the playback is finished.  This option comes turned
       off, but may be turned on by selecting the
       "Display/Update Newkey Parameters" option in Newkeysp
       and following instructions.  We recommend that you do
       not activate this option unless you have a specific
       need.

       Timing problems, however, may nullify some of this
       option's usefulness.  Application programs frequently
       read keys into their buffers before they are actually
       ready to process them.  When this happens, the shift
       status may have been restored before the character is
       processed.  The best way around this is to allow the
       playback to finish before continuing.

       PC-Write is one program which does this.  Whenever it
       reads a space, it checks the shift status to see if
       the alt or ctrl flags are set.  If so, it interprets
       the space differently than it would a plain space.
       For example, if you assigned your name and address to
       <altf10>, on playback you would find that they had run
       together and all the spaces had disappeared!  Shift
       status reset can help solve this problem.



                                                            63

                    CHAPTER 16 - MISCELLANEOUS

       16.1 Support

       Telephone and mail support is available to registered
       users of Newkey from FAB Software or our local
       representatives.  FAB Software provides support on the
       following basis:  Telephone support is generally
       available from 7 PM - 9 PM weekdays and 10 AM - 9 PM
       weekends.  If we are not available, a phone answering
       machine will take your message and we will return your
       call collect during the above hours.  For mail
       support, enclose a self-addressed stamped envelope for
       a faster response.

         FAB Software
         P.O. Box 336
         Wayland, MA 01778

         Phone number: (617) 358-6357










       16.2 Reporting Newkey Bugs

       It is our intention to provide a high quality product
       at very reasonable prices.  To this end we do our best
       to make our products as error free and compatible with
       other software as we can.  Please notify us of any
       problems that you find, so that we can provide you
       with as high a quality product possible.

       To encourage this, if you are the first person to
       notify us of a particular problem, we will send you a
       free update when the problem is corrected (and if not,
       you will receive a letter explaining why.)  This offer
       applies only to bugs in the Newkey programs and not to
       incompatibilities with specific other programs or

       64

       non-IBM hardware.

       We have had few true user reported bugs since
       introducing Newkey in March 1984, so we do not expect
       you to have any problems, but if you believe you have
       discovered a Newkey bug, follow these steps:

       1.  Create a disk which may be used to recreate the
       problem.  This disk should include the following:

        - Your copy of Newkey
        - Your macro files
        - Any other programs, memory-resident (EBL, Sidekick,
        etc) and otherwise, that must be present when the
       problem occurs (if legally possible).
        - A batch file that recreates your environment
        - A readme file which describes the problem and how
       to recreate it.  Mention which version of DOS you are
       using and your phone number.

       2.  Enclose a self-addressed stamped disk mailer.  If
       you have discovered a true bug we will put a corrected
       version on your disk and return it.  Otherwise we will
       return your disk with a note explaining why the
       problem is not a bug.  Unless accompanied by a
       self-addressed stamped disk mailer, all materials
       become the property of FAB Software and will not be
       acknowledged.

       3.  Send the above items to the address listed in
       section 16.1, "Support".

       16.3 FAB Software

       FAB Software was founded by Frank A. Bell in 1984 when
       Newkey was first offered to the public, the
       culmination of many months of effort while earning an
       MBA from the University of Michigan.  Previously
       manager of a systems programming group working on
       large IBM mainframes, Newkey represented Frank's first
       foray into the world of micro-computers and
       entrepreneurship.

       In addition to offering high-quality software products
       we also offer consulting services in the areas of:

                                                            65


       - IBM PC applications and systems software analysis,
       design, and programming in 8086 assembler and C.

        - IBM 370 series applications and systems software
       analysis, design, and programming in BAL, COBOL, PL/I,
       and C using a wide variety of operating systems and
       products including:

           - OS/MVS
           - OS/VS1
           - DOS/VSE
           - CICS
           - IMS

       - WANG VS series applications and systems software
       analysis, design, and programming.

       16.4 Restricted Permission to Copy

       With the release of version 4.0 we are providing a
       special full-power evaluation copy of Newkey which may
       be copied subject to the restrictions listed below.
       The only difference between the evaluation version and
       the version available to registered users is a special
       "evaluation notice" screen that is displayed when
       Newkey or Newkeysp is first started up.

       16.4.1 What May be Copied

       To create an evaluation disk execute the batch file
       "makeeval.bat" and follow instructions.

       The files which may be copied are:

       cls.com
       newkey.doc
       newkey.eva   (evaluation version of Newkey)
       newkeysm.eva (evaluation version of Newkeysm)
       newkeysp.eva (evaluation version of Newkeysp)
       order.frm
       readme
       all files ending in "bat".
       all files ending in "key".


       66

       16.4.2 Rules For Copying Evaluation Version

       Individuals are granted permission to freely copy the
       Newkey disk for their own evaluation or for others to
       evaluate, so long as no price or other consideration
       is charged.

       Computer clubs and other non-profit organizations are
       granted permission to freely copy the Newkey disk and
       share it with their members for the purposes of
       evaluation, so long as:

       1.  No price or other consideration is charged.
       However, a distribution cost may be charged for the
       cost of the diskette, so long as it is not more than
       US $7 total.  This includes shipping, handling, and
       all other charges.

       2.  Club members who receive the programs are informed
       in writing of the user-supported concept and
       encouraged to support it with their payments.

       3.  The programs and documentation are not modified in
       any way and are distributed together.

       4.  The Newkey disk may not be packaged together with
       any other programs or materials.  It may not be
       bundled and sold as part of some other more inclusive
       package.

       5.  The programs may not be "rented" to others.

       6.  The printed manual is not copied or reproduced in
       any way.

       Companies, schools, universities, government, and
       other organizations are granted permission to copy the
       Newkey programs for use on other computers and at
       other locations in the company, so long as:

       1.  The full registration fee has been paid for each
       and every system on which the program will be used.

       2.  The printed manual is not copied or reproduced in
       any way.

                                                            67


       16.5 Price List and Order Form

       For a detailed price list and order form print the
       file "order.frm".  Dealers and resellers please write
       or call for latest prices.

       16.6 The User-Supported Concept

       User-supported Software

       User-supported software is an experiment in
       distributing computer programs, based on these
       beliefs:

       1.  That the value and utility of software is best
       assessed by the user on his/her own system.

       2.  That the creation of personal computer software
       can and should be supported by the computing
       community.

       3.  That copying of programs should be encouraged,
       rather than restricted.

       Subject to the rules described in section 16.4,
       "Restricted Permission to Copy" above, anyone may
       legally obtain an evaluation copy of the program from
       a friend or computer club.  After you have had a
       chance to use and evaluate the program in your own
       environment, you are trusted to either forward a
       payment to the FAB Software, or to discontinue use of
       the program.

       Free distribution of software and voluntary payment
       for its use eliminates costs for advertising and copy
       protection schemes.  Users obtain quality software at
       greatly reduced cost.  They can try it out before
       buying, and do so at their own pace and in the comfort
       of their own home or office.  The best programs will
       survive, based purely on their quality and usefulness.


       68

                    APPENDIX A - KEYS SUPPORTED

       Newkey supports all keys supported by IBM, plus many
       more.  For a list of additional keys supported by
       Newkey and not by IBM, refer to appendix B.

       The following list includes all keys supported by
       Newkey.  The list is the same format as used by Newkey
       to load from.

       <a>          <A>          <alta>          <ctrla>
       <b>          <B>          <altb>          <ctrlb>
       <c>          <C>          <altc>          <ctrlc>
       <d>          <D>          <altd>          <ctrld>
       <e>          <E>          <alte>          <ctrle>
       <f>          <F>          <altf>          <ctrlf>
       <g>          <G>          <altg>          <ctrlg>
       <h>          <H>          <alth>          <ctrlh>
       <i>          <I>          <alti>          <ctrli>
       <j>          <J>          <altj>          <ctrlj>
       <k>          <K>          <altk>          <ctrlk>
       <l>          <L>          <altl>          <ctrll>
       <m>          <M>          <altm>          <ctrlm>
       <n>          <N>          <altn>          <ctrln>
       <o>          <O>          <alto>          <ctrlo>
       <p>          <P>          <altp>          <ctrlp>
       <q>          <Q>          <altq>          <ctrlq>
       <r>          <R>          <altr>          <ctrlr>
       <s>          <S>          <alts>          <ctrls>
       <t>          <T>          <altt>          <ctrlt>
       <u>          <U>          <altu>          <ctrlu>
       <v>          <V>          <altv>          <ctrlv>
       <w>          <W>          <altw>          <ctrlw>
       <x>          <X>          <altx>          <ctrlx>
       <y>          <Y>          <alty>          <ctrly>
       <z>          <Z>          <altz>          <ctrlz>

       <1>          <!>          <alt1>          <ctrl1>
       <2>          <@>          <alt2>          <ctrl2>
       <3>          <#>          <alt3>          <ctrl3>
       <4>          <$>          <alt4>          <ctrl4>
       <5>          <%>          <alt5>          <ctrl5>
       <6>          < >          <alt6>          <ctrl6>
       <7>          <&>          <alt7>          <ctrl7>
       <8>          <*>          <alt8>          <ctrl8>

                                                            69

       <9>          <(>          <alt9>          <ctrl9>
       <0>          <)>          <alt0>          <ctrl0>

       <->          <_>          <alt->          <ctrl->
       <=>          <+>          <alt=>          <ctrl=>
       <[>          < >          <alt[>          <ctrl[>
       <]>          < >          <alt]>          <ctrl]>
       <;>          <:>          <alt;>          <ctrl;>
       <'>          <">          <alt'>          <ctrl'>
       < >          < >          <alt >          <ctrl >
       < >          < >          <alt >          <ctrl >
       <,>          <caps,>      <alt,>          <ctrl,>
       <.>          <caps.>      <alt.>          <ctrl.>
       </>          <?>          <alt/>          <ctrl/>
       <esc>        <capsesc>    <altesc>        <ctrlesc>
       <tab>        <capstab>    <alttab>        <ctrltab>
       <bks>        <capsbks>    <altbks>        <ctrlbks>
       <enter>      <capsent>    <altent>        <ctrlent>
       <prt>                     <altprt>        <ctrlprt>

       <f1>         <capsf1>     <altf1>         <ctrlf1>
       <f2>         <capsf2>     <altf2>         <ctrlf2>
       <f3>         <capsf3>     <altf3>         <ctrlf3>
       <f4>         <capsf4>     <altf4>         <ctrlf4>
       <f5>         <capsf5>     <altf5>         <ctrlf5>
       <f6>         <capsf6>     <altf6>         <ctrlf6>
       <f7>         <capsf7>     <altf7>         <ctrlf7>
       <f8>         <capsf8>     <altf8>         <ctrlf8>
       <f9>         <capsf9>     <altf9>         <ctrlf9>
       <f10>        <capsf10>    <altf10>        <ctrlf10>

       <home>       <num7>       <althom>        <ctrlhom>
       <up>         <num8>       <altup>         <ctrlup>
       <pgup>       <num9>       <altpgup>       <ctrlpgu>
       <rgt>        <num6>       <altrgt>        <ctrlrgt>
       <ctr>        <num5>       <altctr>        <ctrlctr>
       <lft>        <num4>       <altlft>        <ctrllft>
       <end>        <num1>       <altend>        <ctrlend>
       <dn>         <num2>       <altdn>         <ctrldn>
       <pgdn>       <num3>       <altpgdn>       <ctrlpgd>
       <ins>        <num0>       <altins>        <ctrlins>
       <del>        <num.>       <altdel>        <ctrldel>
       <num->       <capsnu->    <altnu->        <ctrlnu->
       <num+>       <capsnu+>    <altnu+>        <ctrlnu+>


       70

           Enhanced Keyboard Entries for separated keys

       <f11>        <capsf11>    <altf11>        <ctrlf11>
       <f12>        <capsf12>    <altf12>        <ctrlf12>

       <shom>       <shom>       <altshom>       <ctrlshom>
       <sup>        <sup>        <altsup>        <ctrlsup>
       <spgu>       <spgu>       <altspgup>      <ctrlspgu>
       <srgt>       <srgt>       <altsrgt>       <ctrlsrgt>
       <slft>       <slft>       <altslft>       <ctrlslft>
       <send>       <send>       <altsend>       <ctrlsend>
       <sdn>        <sdn>        <altsdn>        <ctrlsdn>
       <spgd>       <spgd>       <altspgdn>      <ctrlspgd>
       <sins>       <sins>       <altsins>       <ctrlsins>
       <sdel>       <sdel>       <altsdel>       <ctrlsdel>
       </>          </>          <altnum/>       <ctrlnum/>
       <nument>     <nument>     <nument>        <ctlnuent>

       All keys in IBM's extended ascii set, those with
       values in the 128 - 255 range, may be entered as a
       single character in the same manner as any character
       in the alphabet.  See "Generating Extended Ascii
       Codes" for information on accessing the extended set.

       Special Newkey Control Fields

       The following special Newkey control fields are used
       in editable macro definitions.  Refer to Chapter 5,
       "Editing Macros", for further information on their
       use.

       <beep>       beep
       <begdef>     begin macro definition
       <begdes>     begin description function
       <cls>        clear screen
       <cmd>        call up the pop-up menu
       <cutpaste>   paste from clipboard (alt caps p)
       <date>       date function template follows
       <diskoff>    turn off disk wait
       <diskon>     turn on disk wait
       <endcmd>     exit pop-up menu
       <enddate>    end date function template
       <enddef>     end macro definition
       <enddes>     end description function
       <endtime>    end time function template

                                                            71

       <ffld>       begin/end fixed length field
       <guard>      guard function
       <notr>       bypass translation of next key
                    (no-translate)
       <scroff>     turn off screen
       <scron>      turn on screen
       <slowoff>    turn slow typing mode off
       <slowon>     turn slow typing mode on
       <time>       time function template follows
       <vfld>       begin/end variable length field
       <wait>       wait for 1/2 second (time delay)

       Undefinable Keys

       These keys (including any combination such as ctrl
       break) cannot be redefined:

           Alt
           Break
           Caps Lock
           Ctrl
           Num Lock
           Scroll Lock
           Shift (left and right)
           Shift-Prtsc
           Sys Req

       72

           APPENDIX B - EXTENDED CODES, ADDITIONAL KEYS

       Second code    Function

         1(@)         ALT Esc
         2(*)         CTRL 1
         3            CTRL 2
         4-6(*)       CTRL 3,4,5
         7(*)         CTRL =
         8-11(*)      CTRL 7,8,9,0
         12(*)
         13(*)        CAPS Bksp
         14(@)        ALT Bksp
         15           Back Tab
         16-25        ALT Q,W,E,R,T,Y,U,I,O,P
         26-28(@)     ALT [ ] Enter
         29(*)        CTRL ;
         30-38        ALT A,S,D,F,G,H,J,K,L
         39-41(@)     ALT ; '
                 (semi-colon, apostrophe, back apostrophe)
         42(*)        CTRL ' (apostrophe)
         43(@)        ALT    (back slash)
         44-50        ALT Z,X,C,V,B,N,M
         51-53(@)     ALT , .  / (comma, period, slash)
         54(*)        CTRL    (back apostrophe)
         55(@)        ALT Prtsc
         56-58(*)     CTRL , .  /
         59-68        F1-F10
         69(*)        CTRL Esc
         70(*)        CAPS Esc
         71           Home
         72           Up cursor
         73           PG UP
         74(@)        ALT NU-
         75           Left cursor
         76(@)        CTR
         77           Right cursor
         78(@)        ALT NU+
         79           End
         80           Down cursor
         81           PG DN
         82           INS
         83           DEL
         84-93        F1-F10 (Upper case)
         94-103       F1-F10 (CTRL)

                                                            73

         104-113      F1-F10 (ALT)
         114          CTRL Prtsc
         115          CTRL left cursor
         116          CTRL right cursor
         117          CTRL End
         118          CTRL PG DN
         119          CTRL Home
         120-131      ALT 1,2,3,4,5,6,7,8,9,0,-,=
                        (Top of keyboard)
         132          CTRL PG UP
         133(#)       F11
         134(#)       F12
         135(#)       CAPS F11
         136(#)       CAPS F12
         137(#)       CTRL F11
         138(#)       CTRL F12
         139(#)       ALT F11
         140(#)       ALT F12
         141(@)       CTRL UP
         142(@)       CTRL NU-
         143(@)       CTRL CTR
         144(@)       CTRL NU+
         145(@)       CTRL down cursor
         146(@)       CTRL INS
         147(@)       CTRL DEL
         148(@)       CTRL TAB
         149(#)       CTRL NU/
         150(#)       CTRL NU+
         151(@)       ALT home
         152(@)       ALT UP
         153(@)       ALT PGUP
         154(@)       Cutpaste, Alt Left-shift P
         155(@)       ALT left cursor
         156(*)       ALT CTR
         157(@)       ALT right cursor
         158(*)
         159(@)       ALT END
         160(@)       ALT down cursor
         161(@)       ALT PGDN
         162(@)       ALT INS
         163(@)       ALT DEL
         164(@)       ALT NU/
         165(@)       ALT TAB
         166(@)       ALT ENTER (keypad)
         167(*)       CAPS NU-

       74

         168(*)       CAPS NU+
         169(*)       CAPS ENTER

       These keys are part of IBM's keyboard extended
       functions in which an ascii code = 0 and a scan code
       equal to the number in the list above is returned to
       the program.

       (*) - Keys with this next to their number have been
       added by  Newkey and will be returned to your program
       if a translation is not found.  This might cause
       problems, if your program does not ignore unknown
       keys.  Most programs do ignore unrecognizable keys. If
       you are having this problem, try redefining the key to
       a space or use the 'ignore' keys feature.

       (@) - Keys with this next to their number are created
       by IBM's new keyboard or by Newkey if you are not
       using the new keyboard.

       (#) - Keys with this next to their number are created
       by IBM's new keyboard, but not by Newkey.


                                                            75

                       APPENDIX C - SYNONYMS


       These synonyms are keystrokes which return the same
       ascii value and sometimes with different scan codes.
       In most programs, they are treated the same.  Newkey
       now allows you to redefine these synonyms individually
       without redefining its mate.  This provides you with
       greater flexibility and a wider range of keys which
       can be redefined.

       To do this Newkey must give some of these synonyms
       (those with both identical ascii and scan codes) their
       own unique key codes.  These are the keys in the right
       hand column in the table below.  These keys will not
       act as they did before Newkey was loaded.  For
       example, the caps enter key will not act like an
       <enter> key as it used to.  If it has not been given a
       macro it will probably be ignored by your programs.
       If you want them to act like they used to just define
       them using their native meaning.  Following our
       previous example, you would define the caps enter key
       as enter.

                                               Synonyms With
                            SYNONYMS           New Codes

            0-9             numeric 0-9
            +               numeric +         caps numeric +
            -               numeric -         caps numeric -
            period          numeric period
            *               prtsc *
            enter           ctrl m            caps enter
            backspace       ctrl h            caps backspace
            ctrl enter      ctrl j
            fwd tab         ctrl i
            esc             ctrl [            caps & ctrl esc

       The only synonyms which Newkey does not give their own
       separate key codes are alt, caps, and ctrl space.
       Although it goes against our native inclinations, we
       have decided to play Big Brother in this case and
       protect you from yourselves.  If you believe we have
       sinned too much, let us know and we will attempt to
       atone for it.

       76

                  APPENDIX D - SUMMARY OF CHANGES


       Important conversion information for users of earlier
       versions is highlighted.

       Version 4.0 (April 1987)

       The version 4.0 macro file format is slightly
       different than version 3.0.  For instructions on how
       to convert your files run the program CONV3TO4.

       - Full featured macro editor
         - Easily change any macro
         - Copy/Move one macro to another
         - Move keyboard buffer into macro
       - Load, merge and save macro files from within other
       applications
       - Shorthand mode for easy macro execution
       - Date/time macro function
       - Fast key option enhanced to prevent run on
       - Use Newkey's pop-up features in graphics mode
       - Guarded macros
       - Inactivate macros
       - Save/load file overwrite warning messages
       - Disk wait during macro playback
       - Screen on/off macro function
       - Enhanced compatibility with other programs
         - Prevent collision over common usage of keys
         - compatible with Popular Program's 'pop-ups'
       - Keyboard click
       - Beep during macro definition
       - Cursor change during macro definition/playback made
       optional
       - Customize Newkey's menu colors
       - Compatible with new IBM's new 'enhanced keyboard'.

       Version 3.0 (March 1986)

       - Several Newkey control keys have been changed

          - Use <alt-> instead of <alt=> to end macro
          definition
          - Use <ctrlh> instead of <lft> to backspace and
          delete during macro definition

                                                            77

          - Use <ctrl/> instead of <ctrl > to invoke the pop-
          up features
          - Use <ctrl[> instead of <alt-> to start a variable
          length field
          - Use <ctrl]> instead of <ctrl-> to start a fixed
          length field
          - Use <ctrl-> instead of <ctrl]> to insert a time
          delay
          - Use <ctrlesc> instead of <'> (back apostrophe) to
          cancel macro definition/playback

       - DOS 1.1 support dropped

       The following features have been added:

       - Improved screen saver mode and options
          - Blank by saving screen option
          - Prevent video i/o from restoring screen
       - Multi-character macros
       - Macro descriptions/titles
       - Define macro from within macro
       - Defining Help/status line
       - Cut & paste
       - DOS 2.0 path support
       - Unload under DOS 2.0
       - 128 keystroke extended buffer
       - Menu invocation of Newkey commands
       - Cap/Num lock status display
       - Clear screen macro function
       - Beep macro function
       - Speed up keyboard repetition rate
       - Call Newkey & Newkeysp through their own macros
       - Set any Newkey parameter through Newkey macros
       (absolutely or toggled)
       - User-friendly macro definition
          - Key already defined warning message
          - Defining alphabetic key warning message
          - Enter description request
       - Single-step macro execution mode
       - Delete macros from display translation display
       - Support for true synonyms as separate keys
       - Improved buffer space management reclaims deleted
       macro space
       - Improved compatibility


       78

       Version 2.4 (July 1985)

       - Screen saver feature will blank video display after
       two minutes of inactivity (use "Display/update Newkey
       parameters" menu selection to change screen saver
       parameters)
       - Newkeysp will now load in command mode using the
       number '1' as well as the letter 'l'

       Version 2.3 (May 1985)

       - Save and load from ascii macro files rather than
       internal format files

        Note to users of prior versions:

         Prior to 2.3:

       Users of Newkey versions prior to 2.3 will have to
       convert their internal format files using the
       "convedit" program.  This program is self-explanatory,
       just type "convedit", press <enter>, and you will be
       prompted for the files to converted.  Be sure to use
       the "New24.exe" version of Newkey.

         Prior to 2.0:

       Users of Newkey versions prior to 2.0 will have to
       first convert their internal format files to version
       2.0 internal format files using the "conv1to2"
       program, before they can use the "convedit" program.
       Be sure to use the "New24.exe" version of Newkey.

       - Direct screen I/O
       - Clear requests now require confirmation
       - Free space displayed on main menus of Newkeysp and
       on-line display feature, and on file loads and merges
       - Convert 1.1 to 2.0 format option removed from
       Newkeysp and made into separate program
       - Translate from internal format to Prokey edit format
       removed from Newkeysp and made into separate program
       for one-time file conversion
       - Translate from Prokey edit format to internal format
       removed from Newkeysp (because of direct save to and
       load from edit format now available)

                                                            79

       - Newkeysp program size cut from 30K to 19K

       Version 2.2 (April 1985)

       - Execute macros from a batch file
       - Absolute on/off function in addition to toggle
       - Slow typing mode
         - user defined wait between returned keystrokes
         - turn slow typing on/off in a macro definition
         - cancel playback on demand
       - Cancel macro to immediately cancel current Newkey
       processing
       - Enhanced compatibility with other programs
       (Microsoft Word)
       - Macro can call itself
       - True time delay
       - Newkeysp command mode will execute more than one
       command at a time
       - Variable length pauses may be ended by another macro
       - Clear keyboard buffer from batch file
       - Newkey unload option removed from Newkeysp menu

       Version 2.1 (January 1, 1985)

       - Newkey1's name changed to Newkeysp to avoid
       confusion with Newkey.  Users of earlier versions may
       need to change references to Newkey1 in batch files to
       Newkeysp.
       - Recursion signaled during macro definition as well
       as playback.

       Version 2.0 (December 17, 1984)

       - Macro definition file format changed.  All
       pre-version 2.0 macro definition files must be
       converted to version 2.0 format.  See the Version 2.3
       Summary of Changes for more information.
       - Newkey now comes in two versions, small (5k) and
       large (14k).  The large version supports several
       features which may be invoked without leaving your
       current program:
         - display of current macro directory
         - display of current macros
         - display and modification of Newkey control keys
         - clearing of current macro definitions

       80

       - Translation of macro definition files into a text
       editable Prokey-like format and back.
       - Extension of number of macros supported.  Newkey 1.1
       only supported keys that were supported by the IBM PC.
       Version 2.0 extends the number to include almost every
       ctrl, alt and shift key
       - Easy user modification of the control keys
       - Supports 64k of macro definitions (approximately
       32,000 characters) vs 27k (13,500)
       - Addition of a time delay key
       - Color added to display functions, enhanced error
       checking and more


                                                            81

                               INDEX

                              -- A --

       absolute  38, 77, 79
       alt-  5, 9, 10, 11, 20, 27, 28, 29, 76, 77
       alt=  4, 8, 10, 11, 20, 27, 29, 37, 69, 76
       AT, IBM  36, 38, 58, 59
       autoexec.bat  50

                              -- B --

       backspace  25, 37, 75, 76
       batch file  2, 15, 43, 44, 46, 47, 50, 56, 61, 64,
            65, 79
       beep  5, 11, 13, 16, 21, 38, 70, 76, 77
       BIOS  34, 58
       black and white mode  38, 39, 47, 52, 59
       blank  8, 9, 13, 33, 34, 38, 52, 53, 60, 61, 77, 78
          see also screen saver
       boiler plate  1
       boot  5, 50, 51, 54
       buffer, keyboard  15, 19, 35, 47, 58, 76, 79
         clearing, 44, 47
         copying, 19
         see also extended keyboard buffer
       buffer, macro
         clearing, 30, 44, 45, 77
         size, 3, 6, 50
         usage, 32, 43, 45, 58, 77
       bugs  54, 63, 64
       bypass translation  10, 11, 14, 24, 25, 71

                              -- C --

       cancel  6, 14, 15, 28, 30, 37, 59, 77, 79
       cap/num lock indicators  36, 38
       clear
         see buffer, keyboard; buffer, macro; screen
       click, keyboard  36, 38, 76
       colors, customizing  2, 39, 42, 58, 59, 76, 80
       combining  51
       Compaq  59
       compatibility  4, 30, 31, 35, 36, 39, 59, 60, 61,
            76, 77, 79

       82

       control fields  21, 70
       control keys  2, 7, 19, 37, 47, 48, 59, 76, 79, 80
       converting macro files, 76, 78, 80
       copying a macro, see editing
       copying, rules for  4, 5, 66, 67
       ctrl break  58, 71
       ctrl h  73, 75
       ctrl [  8, 19, 28, 37, 69, 75, 77
       ctrl ]  9, 10, 37, 69, 77
       ctrl -  77
       ctrl /  7, 29, 31, 37, 59, 69, 77
       ctrl 2  10, 11, 14, 24, 25, 37, 68
       ctrl 6  14, 37, 68
       ctrl h  7, 37, 54, 68, 69, 76
       cursor  5, 8, 9, 10, 11, 19, 27, 31, 38, 72, 73, 76
       cut  30-32, 70, 73, 77

                              -- D --

       date function  8, 12-13, 19, 55, 70, 76
       deactivate  14, 37, 54
       defining  4-6, 25, 40, 50
         multi-character macro, 22-23
         macro in macro, 27
         recursive macro, 28
       deleting a macro  7, 19, 20, 32, 37, 45, 76, 77
       demo  2, 55, 56
       description  4-5, 18, 30, 38-40, 70, 77
       directory  14, 18, 30, 45, 47, 79
       disk wait function  17, 38, 70, 76
       displaying macros  18, 30, 47
       documentation  55, 56, 57, 66
       DOS 1.1  77
       DOS 2.0  58, 77
       dvorak  55
       dynamic display features, see pop-up features

                              -- E --

       editing  18-21
         commands, 19
         copying keyboard buffer, 20
         copying macro, 20
         escaping editor commands, 20
         inserting macro functions, 19

                                                            83

         moving macro, 20
         text, 21
       EGA  60
       enhanced keyboard  37, 48, 49, 59, 70, 76
       error correction  7, 54
       escape macro translation, see bypass translation
       extended ascii codes  49, 54, 70
       extended keyboard buffer  1, 35, 52, 60

                              -- F --

       fast key  35, 36, 38, 61, 76
       fill-in-the-blanks  8
       fixed fill-in-the-blanks  9-10, 71, 77

                              -- G --

       graphics mode  39, 52, 59, 60, 76
       guarded macro  14, 43, 45, 71, 76

                              -- H --

       hardware  31, 33, 37, 52, 53, 59, 64
       Hercules graphics card  59

                              -- I --

       ignoring keys  40
       inactivated macros  14, 25, 76
       interrupt  4, 14, 31, 53, 56, 58, 62

                              -- K --

       key creation, preventing  41, 52
       keyboard buffer, see buffer, keyboard
       keys supported  41, 48-49, 52, 58, 59, 62, 68-75
       keys undefinable, see undefinable keys

                              -- L --

       limitations  29, 30, 31, 58
       loading Newkey  3-4, 50, 60, 76, 78
       loading macro files 30, 43, 45, 47



       84

                              -- M --

       macro  1
       macro file  30, 43, 45, 47
       macro functions  8-13
       memory  6, 15, 52, 54
       merging macro files  30, 44, 47, 51, 76, 78
       messages  6, 27, 38, 39, 76
       monitor  52
       moving a macro, see editing
       multi-character macro  18, 22-26, 59, 77

                              -- N --

       nested macros 26
       Newkey.exe  37, 39, 56, 58
       Newkey1  79
       Newkeysm.exe  7, 54, 56
       Newkeysp
         batch functions, 47
         invoking from macros, 29-30
         multiple commands, 46
         overview, 46
       Newkeysp.exe  57, 58

                              -- O --

       on-line features, see pop-up features
       order form  67
       overwriting
         macro files, 43, 76
         macros, 44-45

                              -- P --

       parameters  16, 24, 25, 29, 35, 36, 38, 62
       paste  1, 30, 31, 32, 70, 73, 77
       path  2, 77
       pause  1, 6, 9, 28, 37, 79
       PC-Write  34, 53, 61
       permission to copy  65, 66, 67
       playback  1
         see also bypass, cancel, multi-character
       pop-up features  7, 29, 30, 37, 54, 56, 58, 59, 60,
            70, 77

                                                            85

       preventing key creation  41
       price list  57, 63, 66, 67
       problems  16, 20, 30, 35, 41, 48, 52, 54, 59, 60,
            61, 62, 63, 64, 74
       Prokey  78, 80

                              -- R --

       readme  2, 57, 59, 64, 65
       record mode  29, 30
       recursion  26, 27, 28, 79
       requirements  54, 58
       rules  4, 20, 24, 66, 67

                              -- S --

       sample macro files 55-57
       saving macro files, 5, 30, 43, 47, 51, 76, 78
       scan codes  75
       scope  29, 30
       screen, clearing  13, 21, 70, 77
       screen on/off function  13, 76
       screen saver  2, 33, 34, 52, 53, 60, 61, 77, 78
       shift key  33, 41, 49, 53, 62, 80
       shift status reset  61-62
       shorthand mode  1, 23, 24, 25, 38, 76
       single step mode  16
       size  3, 6, 35, 50, 79
       slow typing mode  2, 14, 15, 16, 28, 37, 38, 47, 54,
            59, 71, 79
       Smartcom  53, 61
       space, see buffer size
       status line  5, 6, 8, 10, 39, 40, 60
       status, macro  14, 45
       status, Newkey  14
       status, parameter 29, 38
       support  63
       suspend, see turning Newkey on/off, inactivated
            macros
       synonym  48, 52, 75, 77



       86

                              -- T --

       time delay  11, 15, 16, 19, 28, 37, 54, 71, 77, 79, 80
       tips  2, 50
       title  1, 77
         see also description
       translation  18, 26, 58, 59, 74
       turning Newkey on/off  14, 47

                              -- U --

       undefinable keys  71
       undefining  20, 71
       unload  6, 14, 15, 34, 47, 77, 79

                              -- V --

       variable fill-in-the-blanks  8-9, 71, 77, 79

                              -- W --

       warnings, see messages
       window  4, 5, 22, 27, 39, 40
       Word Perfect  34, 53, 61
       Wordstar  47, 55, 56, 57

                              -- X --

       XYWrite  31, 53, 62




