10     CLS
20     KEY OFF
30  REM
40     LOCATE 5,18
50     PRINT  "---------- KEPLER'S EQUATION ----------"
60     LOCATE 7,25
70     PRINT " BY CHRIS SPRATT --- 1985"
80     PRINT TAB(28) "   VICTORIA, BC."
90  REM
100     GOSUB 950
110     LOCATE 24,25 : PRINT  "PRESS ANY KEY TO CONTINUE"
120     IF INKEY$ = "" THEN 120
130     CLS
140  REM
150     PRINT: PRINT:
160  REM
170     GOSUB 920
180  REM  PICK UP CONSTANTS
190     LOCATE 5,23
200     PRINT " DATE OF PERIHELION"
210     PRINT
220     INPUT "                              YEAR";Y
230     INPUT "                             MONTH";M
240     INPUT "                               DAY";D
250     GOSUB 610:T6 = JD
260     PRINT
270     PRINT  TAB(25)  "ENTER DATE OF INTEREST"
280    INPUT  "                              YEAR";Y
290    INPUT  "                             MONTH";M
300    INPUT  "                               DAY";D
310    PRINT
320    GOSUB 610: DD = JD
330 REM   ADJUSTED JULIAN DATE OF PERIHELION
340    PRINT  TAB(25)  "ENTER  ELEMENTS ---"
350 REM
360 REM
370    INPUT  "                         DISTANCE Q (A.U.)";Q
380    INPUT  "                            ECCENTRICITY E";E0
390    N0 = K/((Q/(1-E0))^1.5)
400     T = (JD+24980)/36525!: REM CENTURIES SINCE JAN 0, 1900, 12H UT
410    JD = JD + 2440000#
420    ET = ((JD - 2444239#)/365.2421987#)*.0000119 + .00059
430    JD = JD + ET - 2440000#
440  GOTO 720
450  REM
460  REM      CALENDAR ROUTINE
470  REM
480  REM      ENTER WITH JD = ADJUSTED JULIAN DATE OF INTEREST
490  REM      (= TRUE JULIAN DATE - 2440000.0)
500    D7 = INT(JD+719019!)
510    IF JD<-24921 THEN D7=D7-1
520    Y7 = INT((D7-122.1)/365.25)
530    M7 = INT((D7-INT(365.25*Y7))/30.6001)
540    D6 = D7-INT(365.25*Y7)-INT(30.6001*M7)
550    M6 = M7-1
560    IF M7 > 13 THEN M6 = M6 - 12
570    Y6 = Y7
580    IF M6 <3 THEN Y6=Y6+1
590    M$ = MID$ (M1$,3*M6-2,3)
600  REM
610  REM    JULIAN DATE ROUTINE
620  REM
630  REM    ENTER WITH D, M, Y OF INTEREST
640    IF M>=3 THEN 660
650    M = M+12:Y=Y-1
660    F = INT(Y/100)-INT(Y/400)
670    A = INT(365.25*(Y+4712))
680    B = INT((367*(M-1)+5)/12)
690    J = A+B-F-2440000.5#
700    JD= J+D
710    RETURN
720  REM
730  REM   TO SOLVE KEPLER'S EQUATION
740    T7 = JD - T6
750    F = 0
760    M5 = N0*(T7)
770    E5 = M5
780    E6 = M5+E0*SIN(E5)
790    IF ABS(E6-E5) < .0000001 THEN F=1
800    E5 = E6
810    IF F = 0 THEN GOTO 780
820    E5 = E5 * R0
830    IF E5 >360 THEN E5 = 360 - E5
840    IF E5 < 360 THEN E5 = 360 + E5
850    CLS
860    LOCATE  8,18
870    PRINT "ECCENTRIC ANOMALY = " ; E5  ;"DEGREES"
880    PRINT :PRINT :PRINT TAB(20)
890    INPUT "DO YOU WANT ANOTHER Y/N";A$
900    IF A$ = "Y" THEN GOTO 130 ELSE 910
910    END
920    R1 = 3.1415926536#/180: K = .01720209895#
930    R0 = 1/R1
940    RETURN
950   LOCATE 15,12
960   PRINT "NOTE:  PROGRAM FAILS WHEN ECCENTRICITY OF OBJECT IS CLOSE TO 1"
970   RETURN
